<?php
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.
| -------------------------------------------------------------------------
| This script may be only used and modified in accordance to the license
| agreement attached (license.txt) except where expressly noted within
| commented areas of the code body. This copyright notice and the
| comments above and below must remain intact at all times.  By using this
| code you agree to indemnify JROX Technologies, Inc, its corporate agents
| and affiliates from any liability that might arise from its use.
|
| Selling the code for this program without prior written consent is
| expressly forbidden and in violation of Domestic and International
| copyright laws.
|
| -------------------------------------------------------------------------
| FILENAME - updates.php
| -------------------------------------------------------------------------
|
| This file is used for running db schema updates in JEM
|
*/

$update_version = JROX_VERSION;

//add email template for member affiliate downline signup
$update_array[0] = array(

	'update_type' => 'insert',

	'check_sql' => 'SELECT * FROM jem_email_templates WHERE email_template_name = \'member_affiliate_downline_signup\'',

	'update_sql' => "INSERT INTO `jem_email_templates` (`email_template_type`, `email_template_html`, `email_template_group`, `email_template_name`, `email_template_from_name`, `email_template_from_email`, `email_template_cc`, `email_template_bcc`, `email_template_subject`, `email_template_body_text`, `email_template_body_html`, `email_template_description`) VALUES
	('member', 'html', '', 'member_affiliate_downline_signup', '{config_store_name}', 'store@{config_domain_name}', '', '', 'You just referred someone!', 'Hello {fname},\n\nYou have just referred someone in your downline!\n\n{downline_name}\n{downline_email}\n', '<p>Hello {fname},<br />\n<br />\nYou have just referred someone in your downline!<br />\n<br />\n{downline_name}<br />\n{downline_email}<br />\n&nbsp;</p>', 'Notifies the user that someone signed up in their downline')",
);

//update the content article table to include a description field
$update_array[1] = array(

	'update_type' => 'column',
	'column_name' => 'content_description',
	'check_sql' => 'SHOW columns FROM jem_content_articles',

	'update_sql' => "ALTER TABLE `jem_content_articles` ADD `content_description` VARCHAR( 255 ) NOT NULL",
);

//update for wordpress metaweblog API support

$update_array[2] = array(
	'update_type' => 'config',
	'config_key' => 'sts_content_enable_wordpress_publishing',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key` ,`settings_value` ,`settings_module` ,`settings_type` , `settings_group` ,`settings_sort_order` ,`settings_function`) VALUES ('sts_content_enable_wordpress_publishing', '0', 'settings', 'dropdown', '4', '44', 'boolean')",
);

$update_array[3] = array(
	'update_type' => 'config',
	'config_key' => 'sts_content_wordpress_url',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_content_wordpress_url', '', 'settings', 'text', '4', '46', 'none')",
);

$update_array[4] = array(
	'update_type' => 'config',
	'config_key' => 'sts_content_wordpress_username',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_content_wordpress_username', '', 'settings', 'text', '4', '48', 'none')",
);

$update_array[5] = array(
	'update_type' => 'config',
	'config_key' => 'sts_content_wordpress_password',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_content_wordpress_password', '', 'settings', 'text', '4', '50', 'none')",
);

$update_array[6] = array(

	'update_type' => 'column',
	'column_name' => 'remote_blog_id',
	'check_sql' => 'SHOW columns FROM jem_content_articles',

	'update_sql' => "ALTER TABLE `jem_content_articles` ADD `remote_blog_id` VARCHAR( 25 ) NOT NULL",
);

//add installation ID support

$update_array[7] = array(
	'update_type' => 'config',
	'config_key' => 'sts_store_jem_installation_id',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_store_jem_installation_id', 'jem0608', 'settings', 'text', '4', '50', 'none')",
);

//add membership payment type to members_memberships

$update_array[8] = array(

	'update_type' => 'column',
	'column_name' => 'membership_payment_type',
	'check_sql' => 'SHOW columns FROM jem_members_memberships',

	'update_sql' => "ALTER TABLE `jem_members_memberships` ADD `membership_payment_type` VARCHAR( 255 ) NOT NULL",
);

//add tos checkbox option
$update_array[9] = array(
	'update_type' => 'config',
	'config_key' => 'sts_form_enable_tos_checkbox',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_form_enable_tos_checkbox', '0', 'settings', 'dropdown', '19', '15', 'boolean')",
);

//add disqus support
$update_array[10] = array(
	'update_type' => 'config',
	'config_key' => 'sts_content_enable_disqus_form',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_content_enable_disqus_form', '', 'settings', 'textarea', '4', '2', 'base64_decode')",
);

$update_array[11] = array(

	'update_type' => 'column',
	'column_name' => 'tracking_id',
	'check_sql' => 'SHOW columns FROM jem_invoices',

	'update_sql' => "ALTER TABLE `jem_invoices` ADD `tracking_id` INT( 10 ) NOT NULL DEFAULT '0';",
);

$update_array[12] = array(

	'update_type' => 'table',
	'table_name' => 'tracking',

	'update_sql' => "CREATE TABLE IF NOT EXISTS `jem_tracking` (
					  `id` int(10) NOT NULL auto_increment,
					  `name` varchar(255) NOT NULL,
					  `mid` int(10) NOT NULL,
					  `url` varchar(255) NOT NULL,
					  PRIMARY KEY  (`id`)
					) ENGINE=MyISAM;",
);

$update_array[13] = array(

	'update_type' => 'table',
	'table_name' => 'tracking_referrals',

	'update_sql' => "CREATE TABLE IF NOT EXISTS `jem_tracking_referrals` (
					  `id` int(10) NOT NULL auto_increment,
					  `tid` int(10) NOT NULL,
					  `mid` int(10) NOT NULL,
					  `date` varchar(50) NOT NULL,
					  `referrer` varchar(255) NOT NULL,
					  PRIMARY KEY  (`id`)
					) ENGINE=MyISAM;",
);

$update_array[14] = array(
	'update_type' => 'config',
	'config_key' => 'sts_tracking_auto_prune_days',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_tracking_auto_prune_days', '365', 'settings', 'text', '13', '67', 'none')",
);

$update_array[15] = array(
	'update_type' => 'config',
	'config_key' => 'sts_admin_disable_thickbox_popups',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_admin_disable_thickbox_popups', '0', 'settings', 'dropdown', '8', '25', 'boolean')",
);

$update_array[16] = array(
	'update_type' => 'config',
	'config_key' => 'sts_email_bounce_server',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_email_bounce_server', '', 'settings', 'text', '5', '77', 'none')",
);

$update_array[17] = array(
	'update_type' => 'config',
	'config_key' => 'sts_email_bounce_username',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_email_bounce_username', '', 'settings', 'text', '5', '78', 'none')",
);

$update_array[18] = array(
	'update_type' => 'config',
	'config_key' => 'sts_email_bounce_password',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_email_bounce_password', '', 'settings', 'text', '5', '79', 'none')",
);

$update_array[19] = array(
	'update_type' => 'config',
	'config_key' => 'sts_email_bounce_port',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_email_bounce_port', '110', 'settings', 'text', '5', '80', 'none')",
);

$update_array[20] = array(
	'update_type' => 'config',
	'config_key' => 'sts_email_bounce_service_flags',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_email_bounce_service_flags', '/pop3/notls', 'settings', 'text', '5', '81', 'none')",
);

$update_array[21] = array(

	'update_type' => 'table',
	'table_name' => 'email_bounces',

	'update_sql' => "CREATE TABLE IF NOT EXISTS `jem_email_bounces` (
				  `id` int(10) NOT NULL auto_increment,
				  `email` varchar(255) collate utf8_unicode_ci NOT NULL default '',
				  `date` varchar(25) collate utf8_unicode_ci NOT NULL default '',
				  `body` longtext collate utf8_unicode_ci NOT NULL,
				  PRIMARY KEY  (`id`)
				) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1;",
);

$update_array[22] = array(
	'update_type' => 'module',
	'module_type' => 'data_export',
	'module_file_name' => 'invoices',
	'config_key' => 'module_data_export_invoices_starting_date',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('module_data_export_invoices_starting_date', '', 'data_export', 'text', '{module_id}', '4', 'none')",
);

$update_array[23] = array(
	'update_type' => 'module',
	'module_type' => 'data_export',
	'module_file_name' => 'invoices',
	'config_key' => 'module_data_export_invoices_ending_date',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('module_data_export_invoices_ending_date', '', 'data_export', 'text', '{module_id}', '5', 'none')",
);

$update_array[24] = array(
	'update_type' => 'module',
	'module_type' => 'data_export',
	'module_file_name' => 'invoice_payments',
	'config_key' => 'module_data_export_invoice_payments_starting_date',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('module_data_export_invoice_payments_starting_date', '', 'data_export', 'text', '{module_id}', '4', 'none')",
);

$update_array[25] = array(
	'update_type' => 'module',
	'module_type' => 'data_export',
	'module_file_name' => 'invoice_payments',
	'config_key' => 'module_data_export_invoice_payments_ending_date',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('module_data_export_invoice_payments_ending_date', '', 'data_export', 'text', '{module_id}', '5', 'none')",
);

$update_array[26] = array(
	'update_type' => 'module',
	'module_type' => 'advertising',
	'module_file_name' => 'ad_blocks',
	'config_key' => 'module_advertising_ad_block_content_ad_1',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('module_advertising_ad_block_content_ad_1', '', 'advertising', 'textarea', '{module_id}', '1', 'none')",
);

$update_array[27] = array(
	'update_type' => 'module',
	'module_type' => 'advertising',
	'module_file_name' => 'ad_blocks',
	'config_key' => 'module_advertising_ad_block_content_ad_2',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('module_advertising_ad_block_content_ad_2', '', 'advertising', 'textarea', '{module_id}', '1', 'none')",
);

$update_array[28] = array(

	'update_type' => 'column',
	'column_name' => 'status_update',
	'check_sql' => 'SHOW columns FROM jem_content_articles',

	'update_sql' => "ALTER TABLE `jem_content_articles` ADD `status_update` VARCHAR( 255 ) NOT NULL AFTER `modified_by` ;",
);

$update_array[29] = array(
	'update_type' => 'config',
	'config_key' => 'sts_content_enable_ping_fm',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_content_enable_ping_fm', '0', 'settings', 'dropdown', '4', '67', 'boolean')",
);

$update_array[30] = array(
	'update_type' => 'config',
	'config_key' => 'sts_content_ping_fm_app_key',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_content_ping_fm_app_key', '', 'settings', 'text', '4', '68', 'none')",
);

$update_array[31] = array(
	'update_type' => 'config',
	'config_key' => 'sts_content_enable_tweetmeme_code',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_content_enable_tweetmeme_code', '0', 'settings', 'dropdown', '4', '69', 'boolean')",
);

$update_array[32] = array(
	'update_type' => 'config',
	'config_key' => 'sts_content_enable_facebook_share',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_content_enable_facebook_share', '0', 'settings', 'dropdown', '4', '70', 'boolean')",
);

$update_array[33] = array(
	'update_type' => 'config',
	'config_key' => 'sts_products_random_home_page',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_products_random_home_page', '0', 'settings', 'dropdown', '12', '4', 'boolean')",
);

$update_array[34] = array(
	'update_type' => 'config',
	'config_key' => 'sts_affiliate_enable_auto_affiliates',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_affiliate_enable_auto_affiliates', '1', 'settings', 'dropdown', '2', '45', 'boolean')",
);

$update_array[35] = array(
	'update_type' => 'config',
	'config_key' => 'sts_affiliate_admin_approval_required',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_affiliate_admin_approval_required', '0', 'settings', 'dropdown', '2', '47', 'boolean')",
);

$update_array[36] = array(
	'update_type' => 'config',
	'config_key' => 'sts_content_translate_menus',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_content_translate_menus', '0', 'settings', 'dropdown', '4', '72', 'boolean')",
);

$update_array[37] = array(

	'update_type' => 'insert',

	'check_sql' => 'SELECT * FROM jem_email_templates WHERE email_template_name = \'member_affiliate_marketing_approval_template\'',

	'update_sql' => "INSERT INTO `jem_email_templates` (`email_template_type`, `email_template_html`, `email_template_group`, `email_template_name`, `email_template_from_name`, `email_template_from_email`, `email_template_cc`, `email_template_bcc`, `email_template_subject`, `email_template_body_text`, `email_template_body_html`, `email_template_description`) VALUES
	('member', 'html', '', 'member_affiliate_marketing_approval_template', '{config_store_name}', 'store@{config_domain_name}', '', '', 'Affiliate Registration Approval', 'Hello {fname},\n\nYour affiliate registration has been approved!\n\n{config_store_name}\n{config_url}', '<p>Hello {fname},<br />\n<br />\nYour affiliate registration has been approved!<br />\n<br />{config_store_name}<br />\n{config_url}</p>', 'Notifies the user that their affiliate account has been approved')",
);

$update_array[38] = array(

	'update_type' => 'insert',

	'check_sql' => 'SELECT * FROM jem_email_templates WHERE email_template_name = \'admin_affiliate_marketing_activation_template\'',

	'update_sql' => "INSERT INTO `jem_email_templates` (`email_template_type`, `email_template_html`, `email_template_group`, `email_template_name`, `email_template_from_name`, `email_template_from_email`, `email_template_cc`, `email_template_bcc`, `email_template_subject`, `email_template_body_text`, `email_template_body_html`, `email_template_description`) VALUES
	('member', 'html', '', 'admin_affiliate_marketing_activation_template', '{config_store_name}', 'store@{config_domain_name}', '', '', 'Affiliate Activation Request', 'Hello,\n\n{member_name} is requesting that you activate his affiliate account.\n\nPlease login to your admin area to confirm\n\n{config_store_name}\n{config_url}', '<p>Hello,<br />\n<br />\n{member_name} is requesting that you activate his affiliate account.<br />\n<br />Please login to your admin area to confirm<br /><br />{config_store_name}<br />\n{config_url}</p>', 'Notifies the admin to approve an affiliate activation request')",
);

$update_array[39] = array(

	'update_type' => 'column',
	'column_name' => 'layout_box_show_affiliate',
	'check_sql' => 'SHOW columns FROM jem_layout_boxes',

	'update_sql' => "ALTER TABLE `jem_layout_boxes` ADD `layout_box_show_affiliate`  ENUM( '0', '1' ) NOT NULL DEFAULT '0';",
);

$update_array[40] = array(

	'update_type' => 'column',
	'column_name' => 'require_membership',
	'check_sql' => 'SHOW columns FROM jem_content_articles',

	'update_sql' => "ALTER TABLE `jem_content_articles` ADD `require_membership`  ENUM( '0', '1' ) NOT NULL DEFAULT '0';",
);

$update_array[41] = array(

	'update_type' => 'column',
	'column_name' => 'membership_id',
	'check_sql' => 'SHOW columns FROM jem_content_articles',

	'update_sql' => "ALTER TABLE `jem_content_articles` ADD `membership_id`  int(10) NOT NULL DEFAULT '0';",
);

$update_array[42] = array(
	'update_type' => 'config',
	'config_key' => 'sts_store_thank_you_page_code',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_store_thank_you_page_code', '', 'settings', 'textarea', '3', '52', 'base64_decode')",
);

$update_array[43] = array(

	'update_type' => 'column',
	'column_name' => 'product_sort',
	'check_sql' => 'SHOW columns FROM jem_products',

	'update_sql' => "ALTER TABLE `jem_products` ADD `product_sort`  int(10) NOT NULL DEFAULT '0';",
);

$update_array[44] = array(

	'update_type' => 'column',
	'column_name' => 'product_title',
	'check_sql' => 'SHOW columns FROM jem_products',

	'update_sql' => "ALTER TABLE `jem_products` ADD `product_title` VARCHAR( 255 ) NOT NULL DEFAULT '';",
);

$update_array[45] = array(

	'update_type' => 'column',
	'column_name' => 'product_meta_description',
	'check_sql' => 'SHOW columns FROM jem_products',

	'update_sql' => "ALTER TABLE `jem_products` ADD `product_meta_description` TEXT NOT NULL DEFAULT '';",
);

$update_array[46] = array(

	'update_type' => 'column',
	'column_name' => 'add_to_membership',
	'check_sql' => 'SHOW columns FROM jem_products',

	'update_sql' => "ALTER TABLE `jem_products` ADD `add_to_membership` int(10) NOT NULL DEFAULT '0';",
);
$update_array[47] = array(
	'update_type' => 'config',
	'config_key' => 'sts_content_enable_related_articles',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_content_enable_related_articles', '0', 'settings', 'dropdown', '4', '12', 'boolean')",
);

$update_array[48] = array(
	'update_type' => 'config',
	'config_key' => 'sts_content_document_charset',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_content_document_charset', 'ISO-8859-1', 'settings', 'text', '4', '90', 'none')",
);

$update_array[49] = array(

	'update_type' => 'table',
	'table_name' => 'content_permissions',

	'update_sql' => "CREATE TABLE IF NOT EXISTS `jem_content_permissions` (
						`article_id` INT( 10 ) NOT NULL default '0',
						`group_id` INT( 10 ) NOT NULL default '0'
						) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;",
);

$update_array[50] = array(

	'update_type' => 'column',
	'column_name' => 'enable_affiliate_group_permissions',
	'check_sql' => 'SHOW columns FROM jem_content_articles',

	'update_sql' => "ALTER TABLE `jem_content_articles` ADD `enable_affiliate_group_permissions`  ENUM( '0', '1' ) NOT NULL DEFAULT '0';",
);

$update_array[51] = array(

	'update_type' => 'column',
	'column_name' => 'menu_options',
	'check_sql' => 'SHOW columns FROM jem_layout_menus',

	'update_sql' => "ALTER TABLE `jem_layout_menus` ADD `menu_options` VARCHAR( 255 ) NOT NULL DEFAULT ''",
);

$update_array[52] = array(

	'update_type' => 'column',
	'column_name' => 'manufacturer_status',
	'check_sql' => 'SHOW columns FROM jem_manufacturers',

	'update_sql' => "ALTER TABLE `jem_manufacturers` ADD `manufacturer_status` ENUM( '0', '1' ) NOT NULL DEFAULT '1';",
);

$update_array[53] = array(

	'update_type' => 'column',
	'column_name' => 'product_sale_price',
	'check_sql' => 'SHOW columns FROM jem_products',

	'update_sql' => "ALTER TABLE `jem_products` ADD `product_sale_price` DECIMAL( 14, 2 ) NOT NULL DEFAULT '0.00';",
);

$update_array[54] = array(
	'update_type' => 'config',
	'config_key' => 'sts_cart_minimum_purchase_checkout',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_cart_minimum_purchase_checkout', '0', 'settings', 'text', '3', '25', 'none')",
);

$update_array[55] = array(
	'update_type' => 'config',
	'config_key' => 'sts_form_require_initial_fee_checkout',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_form_require_initial_fee_checkout', '', 'settings', 'text', '19', '78', 'none')",
);

$update_array[56] = array(

	'update_type' => 'column',
	'column_name' => 'initial_fee',
	'check_sql' => 'SHOW columns FROM jem_members',

	'update_sql' => "ALTER TABLE `jem_members` ADD `initial_fee` ENUM( '0', '1' ) NOT NULL DEFAULT '0';",
);

$update_array[57] = array(

	'update_type' => 'column',
	'column_name' => 'video_description',
	'check_sql' => 'SHOW columns FROM jem_products_videos',

	'update_sql' => "ALTER TABLE `jem_products_videos` ADD `video_description` TEXT NOT NULL DEFAULT '';",
);

$update_array[58] = array(

	'update_type' => 'column',
	'column_name' => 'video_image',
	'check_sql' => 'SHOW columns FROM jem_products_videos',

	'update_sql' => "ALTER TABLE `jem_products_videos` ADD `video_image` VARCHAR( 255 ) NOT NULL DEFAULT '';",
);

$update_array[59] = array(

	'update_type' => 'column',
	'column_name' => 'tax_zone',
	'check_sql' => 'SHOW columns FROM jem_products',

	'update_sql' => "ALTER TABLE `jem_products` ADD `tax_zone` INT( 10 ) NOT NULL DEFAULT '0';",
);

$update_array[60] = array(

	'update_type' => 'column',
	'column_name' => 'shipping_amount',
	'check_sql' => 'SHOW columns FROM jem_products',

	'update_sql' => "ALTER TABLE `jem_products` ADD `shipping_amount` DECIMAL( 14, 2 ) NOT NULL DEFAULT '0.00';",
);

$update_array[61] = array(
	'update_type' => 'module',
	'module_type' => 'shipping',
	'module_file_name' => 'UPS',
	'config_key' => 'module_shipping_UPS_gateway_url',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('module_shipping_UPS_gateway_url', 'https://www.ups.com/ups.app/xml/Rate', 'shipping', 'text', '{module_id}', '1', 'none')",
);

$update_array[62] = array(
	'update_type' => 'module',
	'module_type' => 'shipping',
	'module_file_name' => 'UPS',
	'config_key' => 'module_shipping_UPS_access_key',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('module_shipping_UPS_access_key', '', 'shipping', 'text', '{module_id}', '2', 'none')",
);

$update_array[63] = array(
	'update_type' => 'module',
	'module_type' => 'shipping',
	'module_file_name' => 'UPS',
	'config_key' => 'module_shipping_UPS_username',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('module_shipping_UPS_username', '', 'shipping', 'text', '{module_id}', '3', 'none')",
);

$update_array[64] = array(
	'update_type' => 'module',
	'module_type' => 'shipping',
	'module_file_name' => 'UPS',
	'config_key' => 'module_shipping_UPS_password',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('module_shipping_UPS_password', '', 'shipping', 'text', '{module_id}', '4', 'none')",
);

$update_array[65] = array(
	'update_type' => 'module',
	'module_type' => 'shipping',
	'module_file_name' => 'UPS',
	'config_key' => 'module_shipping_UPS_gateway_url',

	'update_sql' => "INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('module_shipping_UPS_enable_debug', '0', 'shipping', 'dropdown', '{module_id}', '13', 'boolean')",
);


$update_array[66] = array(

	'update_type' => 'table',
	'table_name' => 'global_discounts',

	'update_sql' => "CREATE TABLE IF NOT EXISTS `jem_global_discounts` (
					  `id` int(10) NOT NULL auto_increment,
					  `status` enum('0','1') NOT NULL default '0',
					  `min_amount` varchar(25) NOT NULL default '0',
					  `max_amount` varchar(25) NOT NULL default '0',
					  `discount_amount` varchar(25) NOT NULL default '0',
					  `discount_type` enum('flat','percent') NOT NULL default 'percent',
					  PRIMARY KEY  (`id`)
					) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;",
);

$update_array[67] = array(

	'update_type' => 'column',
	'column_name' => 'status',
	'check_sql' => 'SHOW columns FROM jem_members_memberships',

	'update_sql' => "ALTER TABLE `jem_members_memberships` ADD `status` ENUM( '0', '1' ) NOT NULL DEFAULT '1';",
);

$update_array[68] = array(

	'update_type' => 'column',
	'column_name' => 'mailing_list_id',
	'check_sql' => 'SHOW columns FROM jem_affiliate_groups',

	'update_sql' => "ALTER TABLE `jem_affiliate_groups` ADD `mailing_list_id` INT( 10 ) NOT NULL DEFAULT '0';",
);

$update_array[69] = array(

	'update_type' => 'column',
	'column_name' => 'enable_recurring_coupon',
	'check_sql' => 'SHOW columns FROM jem_coupons',

	'update_sql' => "ALTER TABLE `jem_coupons` ADD `enable_recurring_coupon` ENUM( '0', '1' ) NOT NULL DEFAULT '0';",
);



//INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_affiliate_enable_mlm_forced_matrix', '0', 'settings', 'dropdown', '2', '5', 'boolean');
//INSERT INTO `jem_settings` (`settings_key`, `settings_value`, `settings_module`, `settings_type`, `settings_group`, `settings_sort_order`, `settings_function`) VALUES ('sts_affiliate_mlm_matrix_width', '5', 'settings', 'dropdown', '2', '6', 'numbers_5');
?>