

DROP TABLE IF EXISTS `jem_admin_users`;
CREATE TABLE IF NOT EXISTS `jem_admin_users` (
  `admin_id` int(10) NOT NULL auto_increment,
  `status` enum('active','inactive') NOT NULL default 'inactive',
  `fname` varchar(255) NOT NULL default '',
  `lname` varchar(255) NOT NULL default '',
  `username` varchar(255) NOT NULL default '',
  `apassword` varchar(255) NOT NULL default '',
  `primary_email` varchar(255) NOT NULL default '',
  `sms_contact` varchar(255) NOT NULL default '',
  `last_login_date` varchar(25) NOT NULL default '',
  `last_login_ip` varchar(50) NOT NULL default '',
  `admin_photo` varchar(255) NOT NULL default '',
  `alert_affiliate_signup` enum('0','1') NOT NULL default '0',
  `alert_affiliate_commission` enum('0','1') NOT NULL default '0',
  `alert_store_order` enum('0','1') NOT NULL default '0',
  `alert_store_inventory` enum('0','1') NOT NULL default '0',
  `alert_admin_failed_login` enum('0','1') NOT NULL default '0',
  `alert_admin_article_comment` enum('0','1') NOT NULL default '0',
  `alert_admin_product_review` enum('0','1') NOT NULL default '0',
  `show_assigned_tickets_only` enum('0','1') NOT NULL default '0',
  `alert_ticket_response` enum('0','1') NOT NULL default '0',
  `send_admin_sms_alerts` enum('0','1') NOT NULL default '0',
  `permissions` text NOT NULL,
  `rows_per_page` int(10) NOT NULL default '25',
  PRIMARY KEY  (`admin_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=2 ;



INSERT INTO `jem_admin_users` (`admin_id`, `status`, `fname`, `lname`, `username`, `apassword`, `primary_email`, `sms_contact`, `last_login_date`, `last_login_ip`, `admin_photo`, `alert_affiliate_signup`, `alert_affiliate_commission`, `alert_store_order`, `alert_store_inventory`, `alert_admin_failed_login`, `alert_admin_article_comment`, `alert_admin_product_review`, `show_assigned_tickets_only`, `alert_ticket_response`, `send_admin_sms_alerts`, `permissions`, `rows_per_page`) VALUES
(1, 'active', '{{admin_fname}}', '{{admin_lname}}', '{{admin_username}}', '{{admin_password}}', '{{admin_email}}', '', '', '', '', '1', '1', '1', '1', '1', '1', '1', '0', '1', '1', '', 25);



DROP TABLE IF EXISTS `jem_affiliate_article_ads`;
CREATE TABLE IF NOT EXISTS `jem_affiliate_article_ads` (
  `id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `article_ad_title` text NOT NULL,
  `article_ad_body` text NOT NULL,
  `enable_redirect` enum('0','1') NOT NULL default '0',
  `redirect_custom_url` varchar(255) NOT NULL default '',
  `sort_order` int(10) NOT NULL default '0',
  `notes` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `article_ad_name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_affiliate_banners`;
CREATE TABLE IF NOT EXISTS `jem_affiliate_banners` (
  `id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `rotator_group` enum('0','1') NOT NULL default '0',
  `enable_redirect` enum('0','1') NOT NULL default '0',
  `redirect_custom_url` varchar(255) NOT NULL default '',
  `banner_height` int(10) NOT NULL default '0',
  `banner_width` int(10) NOT NULL default '0',
  `use_external_image` enum('0','1') NOT NULL default '0',
  `banner_file_name` varchar(255) NOT NULL default '',
  `sort_order` int(10) NOT NULL default '0',
  `notes` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `banner_name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_affiliate_commissions`;
CREATE TABLE IF NOT EXISTS `jem_affiliate_commissions` (
  `comm_id` int(20) NOT NULL auto_increment,
  `member_id` int(20) unsigned NOT NULL default '0',
  `invoice_id` varchar(50) NOT NULL default '',
  `comm_status` varchar(20) NOT NULL default '',
  `approved` enum('0','1') NOT NULL default '0',
  `date` varchar(25) NOT NULL default '',
  `commission_amount` decimal(14,2) default NULL,
  `sale_amount` decimal(14,2) default NULL,
  `commission_level` mediumint(3) unsigned NOT NULL default '1',
  `referrer` text NOT NULL,
  `trans_id` varchar(50) NOT NULL default '',
  `ip_address` varchar(100) NOT NULL default '',
  `date_paid` varchar(25) NOT NULL default '',
  `commission_notes` text,
  `performance_paid` enum('0','1') NOT NULL default '0',
  `email_sent` enum('0','1') NOT NULL default '1',
  `tool_type` varchar(25) NOT NULL default '0',
  `tool_id` int(25) NOT NULL default '0',
  PRIMARY KEY  (`comm_id`),
  KEY `member_id` (`member_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_affiliate_email_ads`;
CREATE TABLE IF NOT EXISTS `jem_affiliate_email_ads` (
  `id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `email_ad_title` text NOT NULL,
  `email_ad_body` text NOT NULL,
  `enable_redirect` enum('0','1') NOT NULL default '0',
  `redirect_custom_url` varchar(255) NOT NULL default '',
  `sort_order` int(10) NOT NULL default '0',
  `notes` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `email_ad_name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_affiliate_groups`;
CREATE TABLE IF NOT EXISTS `jem_affiliate_groups` (
  `group_id` int(10) NOT NULL auto_increment,
  `tier` int(10) NOT NULL default '1',
  `aff_group_name` varchar(50) NOT NULL default '',
  `aff_group_description` text NOT NULL,
  `commission_type` enum('percent','flat') NOT NULL default 'percent',
  `commission_level_1` varchar(20) NOT NULL default '0',
  `commission_level_2` varchar(20) NOT NULL default '0',
  `commission_level_3` varchar(20) NOT NULL default '0',
  `commission_level_4` varchar(20) NOT NULL default '0',
  `commission_level_5` varchar(20) NOT NULL default '0',
  `commission_level_6` varchar(20) NOT NULL default '0',
  `commission_level_7` varchar(20) NOT NULL default '0',
  `commission_level_8` varchar(20) NOT NULL default '0',
  `commission_level_9` varchar(20) NOT NULL default '0',
  `commission_level_10` varchar(20) NOT NULL default '0',
  `mailing_list_id` int(10) NOT NULL default '0',
  PRIMARY KEY  (`group_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=2 ;



INSERT INTO `jem_affiliate_groups` (`group_id`, `tier`, `aff_group_name`, `aff_group_description`, `commission_type`, `commission_level_1`, `commission_level_2`, `commission_level_3`, `commission_level_4`, `commission_level_5`, `commission_level_6`, `commission_level_7`, `commission_level_8`, `commission_level_9`, `commission_level_10`, `mailing_list_id`) VALUES
(1, 1, 'Default Affiliate Program - Do Not Delete', 'default affiliate group', 'percent', '.10', '', '', '', '', '', '', '', '', '', '0');



DROP TABLE IF EXISTS `jem_affiliate_html_ads`;
CREATE TABLE IF NOT EXISTS `jem_affiliate_html_ads` (
  `id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `html_ad_type` text NOT NULL,
  `html_ad_body` text NOT NULL,
  `enable_redirect` enum('0','1') NOT NULL default '0',
  `redirect_custom_url` varchar(255) NOT NULL default '',
  `sort_order` int(10) NOT NULL default '0',
  `notes` text NOT NULL,
  `border_color` varchar(25) NOT NULL default '',
  `bg_title_color` varchar(25) NOT NULL default '',
  `font_title_color` varchar(25) NOT NULL default '',
  `bg_body_color` varchar(25) NOT NULL default '',
  `font_body_color` varchar(25) NOT NULL default '',
  `html_ad_width` int(10) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `html_ad_name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_affiliate_payments`;
CREATE TABLE IF NOT EXISTS `jem_affiliate_payments` (
  `id` int(50) NOT NULL auto_increment,
  `member_id` int(10) NOT NULL default '0',
  `payment_date` varchar(25) NOT NULL default '',
  `payment_amount` decimal(14,2) NOT NULL default '0.00',
  `payment_details` text,
  PRIMARY KEY  (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_affiliate_text_ads`;
CREATE TABLE IF NOT EXISTS `jem_affiliate_text_ads` (
  `id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `text_ad_title` text NOT NULL,
  `text_ad_body` text NOT NULL,
  `enable_redirect` enum('0','1') NOT NULL default '0',
  `redirect_custom_url` varchar(255) NOT NULL default '',
  `sort_order` int(10) NOT NULL default '0',
  `notes` text NOT NULL,
  `border_color` varchar(25) NOT NULL default '',
  `bg_title_color` varchar(25) NOT NULL default '',
  `font_title_color` varchar(25) NOT NULL default '',
  `bg_body_color` varchar(25) NOT NULL default '',
  `font_body_color` varchar(25) NOT NULL default '',
  `text_ad_width` int(10) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `text_ad_name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_affiliate_text_links`;
CREATE TABLE IF NOT EXISTS `jem_affiliate_text_links` (
  `id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `text_link_title` text NOT NULL,
  `enable_redirect` enum('0','1') NOT NULL default '0',
  `redirect_custom_url` varchar(255) NOT NULL default '',
  `sort_order` int(10) NOT NULL default '0',
  `notes` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_affiliate_viral_pdfs`;
CREATE TABLE IF NOT EXISTS `jem_affiliate_viral_pdfs` (
  `id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `viral_pdf_title` text NOT NULL,
  `viral_pdf_body` text NOT NULL,
  `enable_redirect` enum('0','1') NOT NULL default '0',
  `redirect_custom_url` varchar(255) NOT NULL default '',
  `sort_order` int(10) NOT NULL default '0',
  `notes` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `viral_pdf_name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_affiliate_viral_videos`;
CREATE TABLE IF NOT EXISTS `jem_affiliate_viral_videos` (
  `id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `viral_video_link` text NOT NULL,
  `enable_redirect` enum('0','1') NOT NULL default '0',
  `redirect_custom_url` varchar(255) NOT NULL default '',
  `sort_order` int(10) NOT NULL default '0',
  `notes` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `viral_video_name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_content_articles`;
CREATE TABLE IF NOT EXISTS `jem_content_articles` (
  `article_id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `content_tags` varchar(255) NOT NULL default '',
  `content_type` enum('1','2','3') NOT NULL default '1',
  `content_path` varchar(255) NOT NULL default '',
  `category_id` int(10) NOT NULL default '0',
  `content_title` varchar(255) NOT NULL default '',
  `content_body` longtext NOT NULL,
  `date_published` varchar(25) NOT NULL default '',
  `modified_by` varchar(25) NOT NULL default '',
  `status_update` varchar(255) NOT NULL default '',
  `ping` enum('0','1') NOT NULL default '0',
  `content_description` varchar(255) NOT NULL default '',
  `remote_blog_id` varchar(25) NOT NULL default '',
  `require_membership` enum('0','1') collate utf8_unicode_ci NOT NULL default '0',
  `membership_id` int(10) NOT NULL default '0',
  `enable_affiliate_group_permissions` enum('0','1') collate utf8_unicode_ci NOT NULL default '0',
  PRIMARY KEY  (`article_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=2 ;



DROP TABLE IF EXISTS `jem_content_categories`;
CREATE TABLE IF NOT EXISTS `jem_content_categories` (
  `category_id` int(10) NOT NULL auto_increment,
  `category_name` varchar(255) NOT NULL default '',
  `category_type` varchar(25) NOT NULL default 'custom',
  PRIMARY KEY  (`category_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=7 ;



INSERT INTO `jem_content_categories` (`category_id`, `category_name`, `category_type`) VALUES
(1, 'default', 'custom'),
(2, 'privacy policy', 'public'),
(3, 'terms and conditions', 'public'),
(4, 'about us', 'public'),
(5, 'members content', 'members_content'),
(6, 'members main menu', 'members_main_menu');



DROP TABLE IF EXISTS `jem_content_comments`;
CREATE TABLE IF NOT EXISTS `jem_content_comments` (
  `id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `article_id` int(10) NOT NULL default '0',
  `member_id` int(10) NOT NULL default '0',
  `date` varchar(25) NOT NULL default '',
  `comment` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `article_id` (`article_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS `jem_content_permissions`;
CREATE TABLE IF NOT EXISTS `jem_content_permissions` (
	`article_id` INT( 10 ) NOT NULL default '0',
	`group_id` INT( 10 ) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


DROP TABLE IF EXISTS `jem_content_to_categories`;
CREATE TABLE IF NOT EXISTS `jem_content_to_categories` (
  `article_id` int(10) NOT NULL default '0',
  `category_id` int(10) NOT NULL default '0',
  PRIMARY KEY  (`article_id`,`category_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;



DROP TABLE IF EXISTS `jem_countries`;
CREATE TABLE IF NOT EXISTS `jem_countries` (
  `country_id` int(10) NOT NULL auto_increment,
  `country_name` varchar(64) NOT NULL default '',
  `country_iso_code_2` char(2) NOT NULL default '',
  `country_iso_code_3` char(3) NOT NULL default '',
  `ship_to` enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (`country_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=241 ;


INSERT INTO `jem_countries` (`country_id`, `country_name`, `country_iso_code_2`, `country_iso_code_3`, `ship_to`) VALUES
(240, 'Aaland Islands', 'AX', 'ALA', '1'),
(1, 'Afghanistan', 'AF', 'AFG', '1'),
(2, 'Albania', 'AL', 'ALB', '1'),
(3, 'Algeria', 'DZ', 'DZA', '1'),
(4, 'American Samoa', 'AS', 'ASM', '1'),
(5, 'Andorra', 'AD', 'AND', '1'),
(6, 'Angola', 'AO', 'AGO', '1'),
(7, 'Anguilla', 'AI', 'AIA', '1'),
(8, 'Antarctica', 'AQ', 'ATA', '1'),
(9, 'Antigua and Barbuda', 'AG', 'ATG', '1'),
(10, 'Argentina', 'AR', 'ARG', '1'),
(11, 'Armenia', 'AM', 'ARM', '1'),
(12, 'Aruba', 'AW', 'ABW', '1'),
(13, 'Australia', 'AU', 'AUS', '1'),
(14, 'Austria', 'AT', 'AUT', '1'),
(15, 'Azerbaijan', 'AZ', 'AZE', '1'),
(16, 'Bahamas', 'BS', 'BHS', '1'),
(17, 'Bahrain', 'BH', 'BHR', '1'),
(18, 'Bangladesh', 'BD', 'BGD', '1'),
(19, 'Barbados', 'BB', 'BRB', '1'),
(20, 'Belarus', 'BY', 'BLR', '1'),
(21, 'Belgium', 'BE', 'BEL', '1'),
(22, 'Belize', 'BZ', 'BLZ', '1'),
(23, 'Benin', 'BJ', 'BEN', '1'),
(24, 'Bermuda', 'BM', 'BMU', '1'),
(25, 'Bhutan', 'BT', 'BTN', '1'),
(26, 'Bolivia', 'BO', 'BOL', '1'),
(27, 'Bosnia and Herzegowina', 'BA', 'BIH', '1'),
(28, 'Botswana', 'BW', 'BWA', '1'),
(29, 'Bouvet Island', 'BV', 'BVT', '1'),
(30, 'Brazil', 'BR', 'BRA', '1'),
(31, 'British Indian Ocean Territory', 'IO', 'IOT', '1'),
(32, 'Brunei Darussalam', 'BN', 'BRN', '1'),
(33, 'Bulgaria', 'BG', 'BGR', '1'),
(34, 'Burkina Faso', 'BF', 'BFA', '1'),
(35, 'Burundi', 'BI', 'BDI', '1'),
(36, 'Cambodia', 'KH', 'KHM', '1'),
(37, 'Cameroon', 'CM', 'CMR', '1'),
(38, 'Canada', 'CA', 'CAN', '1'),
(39, 'Cape Verde', 'CV', 'CPV', '1'),
(40, 'Cayman Islands', 'KY', 'CYM', '1'),
(41, 'Central African Republic', 'CF', 'CAF', '1'),
(42, 'Chad', 'TD', 'TCD', '1'),
(43, 'Chile', 'CL', 'CHL', '1'),
(44, 'China', 'CN', 'CHN', '1'),
(45, 'Christmas Island', 'CX', 'CXR', '1'),
(46, 'Cocos (Keeling) Islands', 'CC', 'CCK', '1'),
(47, 'Colombia', 'CO', 'COL', '1'),
(48, 'Comoros', 'KM', 'COM', '1'),
(49, 'Congo', 'CG', 'COG', '1'),
(50, 'Cook Islands', 'CK', 'COK', '1'),
(51, 'Costa Rica', 'CR', 'CRI', '1'),
(52, 'Cote D''Ivoire', 'CI', 'CIV', '1'),
(53, 'Croatia', 'HR', 'HRV', '1'),
(54, 'Cuba', 'CU', 'CUB', '1'),
(55, 'Cyprus', 'CY', 'CYP', '1'),
(56, 'Czech Republic', 'CZ', 'CZE', '1'),
(57, 'Denmark', 'DK', 'DNK', '1'),
(58, 'Djibouti', 'DJ', 'DJI', '1'),
(59, 'Dominica', 'DM', 'DMA', '1'),
(60, 'Dominican Republic', 'DO', 'DOM', '1'),
(61, 'East Timor', 'TP', 'TMP', '1'),
(62, 'Ecuador', 'EC', 'ECU', '1'),
(63, 'Egypt', 'EG', 'EGY', '1'),
(64, 'El Salvador', 'SV', 'SLV', '1'),
(65, 'Equatorial Guinea', 'GQ', 'GNQ', '1'),
(66, 'Eritrea', 'ER', 'ERI', '1'),
(67, 'Estonia', 'EE', 'EST', '1'),
(68, 'Ethiopia', 'ET', 'ETH', '1'),
(69, 'Falkland Islands (Malvinas)', 'FK', 'FLK', '1'),
(70, 'Faroe Islands', 'FO', 'FRO', '1'),
(71, 'Fiji', 'FJ', 'FJI', '1'),
(72, 'Finland', 'FI', 'FIN', '1'),
(73, 'France', 'FR', 'FRA', '1'),
(74, 'France, Metropolitan', 'FX', 'FXX', '1'),
(75, 'French Guiana', 'GF', 'GUF', '1'),
(76, 'French Polynesia', 'PF', 'PYF', '1'),
(77, 'French Southern Territories', 'TF', 'ATF', '1'),
(78, 'Gabon', 'GA', 'GAB', '1'),
(79, 'Gambia', 'GM', 'GMB', '1'),
(80, 'Georgia', 'GE', 'GEO', '1'),
(81, 'Germany', 'DE', 'DEU', '1'),
(82, 'Ghana', 'GH', 'GHA', '1'),
(83, 'Gibraltar', 'GI', 'GIB', '1'),
(84, 'Greece', 'GR', 'GRC', '1'),
(85, 'Greenland', 'GL', 'GRL', '1'),
(86, 'Grenada', 'GD', 'GRD', '1'),
(87, 'Guadeloupe', 'GP', 'GLP', '1'),
(88, 'Guam', 'GU', 'GUM', '1'),
(89, 'Guatemala', 'GT', 'GTM', '1'),
(90, 'Guinea', 'GN', 'GIN', '1'),
(91, 'Guinea-bissau', 'GW', 'GNB', '1'),
(92, 'Guyana', 'GY', 'GUY', '1'),
(93, 'Haiti', 'HT', 'HTI', '1'),
(94, 'Heard and Mc Donald Islands', 'HM', 'HMD', '1'),
(95, 'Honduras', 'HN', 'HND', '1'),
(96, 'Hong Kong', 'HK', 'HKG', '1'),
(97, 'Hungary', 'HU', 'HUN', '1'),
(98, 'Iceland', 'IS', 'ISL', '1'),
(99, 'India', 'IN', 'IND', '1'),
(100, 'Indonesia', 'ID', 'IDN', '1'),
(101, 'Iran (Islamic Republic of)', 'IR', 'IRN', '1'),
(102, 'Iraq', 'IQ', 'IRQ', '1'),
(103, 'Ireland', 'IE', 'IRL', '1'),
(104, 'Israel', 'IL', 'ISR', '1'),
(105, 'Italy', 'IT', 'ITA', '1'),
(106, 'Jamaica', 'JM', 'JAM', '1'),
(107, 'Japan', 'JP', 'JPN', '1'),
(108, 'Jordan', 'JO', 'JOR', '1'),
(109, 'Kazakhstan', 'KZ', 'KAZ', '1'),
(110, 'Kenya', 'KE', 'KEN', '1'),
(111, 'Kiribati', 'KI', 'KIR', '1'),
(112, 'Korea, Democratic People''s Republic of', 'KP', 'PRK', '1'),
(113, 'Korea, Republic of', 'KR', 'KOR', '1'),
(114, 'Kuwait', 'KW', 'KWT', '1'),
(115, 'Kyrgyzstan', 'KG', 'KGZ', '1'),
(116, 'Lao People''s Democratic Republic', 'LA', 'LAO', '1'),
(117, 'Latvia', 'LV', 'LVA', '1'),
(118, 'Lebanon', 'LB', 'LBN', '1'),
(119, 'Lesotho', 'LS', 'LSO', '1'),
(120, 'Liberia', 'LR', 'LBR', '1'),
(121, 'Libyan Arab Jamahiriya', 'LY', 'LBY', '1'),
(122, 'Liechtenstein', 'LI', 'LIE', '1'),
(123, 'Lithuania', 'LT', 'LTU', '1'),
(124, 'Luxembourg', 'LU', 'LUX', '1'),
(125, 'Macau', 'MO', 'MAC', '1'),
(126, 'Macedonia, The Former Yugoslav Republic of', 'MK', 'MKD', '1'),
(127, 'Madagascar', 'MG', 'MDG', '1'),
(128, 'Malawi', 'MW', 'MWI', '1'),
(129, 'Malaysia', 'MY', 'MYS', '1'),
(130, 'Maldives', 'MV', 'MDV', '1'),
(131, 'Mali', 'ML', 'MLI', '1'),
(132, 'Malta', 'MT', 'MLT', '1'),
(133, 'Marshall Islands', 'MH', 'MHL', '1'),
(134, 'Martinique', 'MQ', 'MTQ', '1'),
(135, 'Mauritania', 'MR', 'MRT', '1'),
(136, 'Mauritius', 'MU', 'MUS', '1'),
(137, 'Mayotte', 'YT', 'MYT', '1'),
(138, 'Mexico', 'MX', 'MEX', '1'),
(139, 'Micronesia, Federated States of', 'FM', 'FSM', '1'),
(140, 'Moldova, Republic of', 'MD', 'MDA', '1'),
(141, 'Monaco', 'MC', 'MCO', '1'),
(142, 'Mongolia', 'MN', 'MNG', '1'),
(143, 'Montserrat', 'MS', 'MSR', '1'),
(144, 'Morocco', 'MA', 'MAR', '1'),
(145, 'Mozambique', 'MZ', 'MOZ', '1'),
(146, 'Myanmar', 'MM', 'MMR', '1'),
(147, 'Namibia', 'NA', 'NAM', '1'),
(148, 'Nauru', 'NR', 'NRU', '1'),
(149, 'Nepal', 'NP', 'NPL', '1'),
(150, 'Netherlands', 'NL', 'NLD', '1'),
(151, 'Netherlands Antilles', 'AN', 'ANT', '1'),
(152, 'New Caledonia', 'NC', 'NCL', '1'),
(153, 'New Zealand', 'NZ', 'NZL', '1'),
(154, 'Nicaragua', 'NI', 'NIC', '1'),
(155, 'Niger', 'NE', 'NER', '1'),
(156, 'Nigeria', 'NG', 'NGA', '1'),
(157, 'Niue', 'NU', 'NIU', '1'),
(158, 'Norfolk Island', 'NF', 'NFK', '1'),
(159, 'Northern Mariana Islands', 'MP', 'MNP', '1'),
(160, 'Norway', 'NO', 'NOR', '1'),
(161, 'Oman', 'OM', 'OMN', '1'),
(162, 'Pakistan', 'PK', 'PAK', '1'),
(163, 'Palau', 'PW', 'PLW', '1'),
(164, 'Panama', 'PA', 'PAN', '1'),
(165, 'Papua New Guinea', 'PG', 'PNG', '1'),
(166, 'Paraguay', 'PY', 'PRY', '1'),
(167, 'Peru', 'PE', 'PER', '1'),
(168, 'Philippines', 'PH', 'PHL', '1'),
(169, 'Pitcairn', 'PN', 'PCN', '1'),
(170, 'Poland', 'PL', 'POL', '1'),
(171, 'Portugal', 'PT', 'PRT', '1'),
(172, 'Puerto Rico', 'PR', 'PRI', '1'),
(173, 'Qatar', 'QA', 'QAT', '1'),
(174, 'Reunion', 'RE', 'REU', '1'),
(175, 'Romania', 'RO', 'ROM', '1'),
(176, 'Russian Federation', 'RU', 'RUS', '1'),
(177, 'Rwanda', 'RW', 'RWA', '1'),
(178, 'Saint Kitts and Nevis', 'KN', 'KNA', '1'),
(179, 'Saint Lucia', 'LC', 'LCA', '1'),
(180, 'Saint Vincent and the Grenadines', 'VC', 'VCT', '1'),
(181, 'Samoa', 'WS', 'WSM', '1'),
(182, 'San Marino', 'SM', 'SMR', '1'),
(183, 'Sao Tome and Principe', 'ST', 'STP', '1'),
(184, 'Saudi Arabia', 'SA', 'SAU', '1'),
(185, 'Senegal', 'SN', 'SEN', '1'),
(186, 'Seychelles', 'SC', 'SYC', '1'),
(187, 'Sierra Leone', 'SL', 'SLE', '1'),
(188, 'Singapore', 'SG', 'SGP', '1'),
(189, 'Slovakia (Slovak Republic)', 'SK', 'SVK', '1'),
(190, 'Slovenia', 'SI', 'SVN', '1'),
(191, 'Solomon Islands', 'SB', 'SLB', '1'),
(192, 'Somalia', 'SO', 'SOM', '1'),
(193, 'South Africa', 'ZA', 'ZAF', '1'),
(194, 'South Georgia and the South Sandwich Islands', 'GS', 'SGS', '1'),
(195, 'Spain', 'ES', 'ESP', '1'),
(196, 'Sri Lanka', 'LK', 'LKA', '1'),
(197, 'St. Helena', 'SH', 'SHN', '1'),
(198, 'St. Pierre and Miquelon', 'PM', 'SPM', '1'),
(199, 'Sudan', 'SD', 'SDN', '1'),
(200, 'Suriname', 'SR', 'SUR', '1'),
(201, 'Svalbard and Jan Mayen Islands', 'SJ', 'SJM', '1'),
(202, 'Swaziland', 'SZ', 'SWZ', '1'),
(203, 'Sweden', 'SE', 'SWE', '1'),
(204, 'Switzerland', 'CH', 'CHE', '1'),
(205, 'Syrian Arab Republic', 'SY', 'SYR', '1'),
(206, 'Taiwan', 'TW', 'TWN', '1'),
(207, 'Tajikistan', 'TJ', 'TJK', '1'),
(208, 'Tanzania, United Republic of', 'TZ', 'TZA', '1'),
(209, 'Thailand', 'TH', 'THA', '1'),
(210, 'Togo', 'TG', 'TGO', '1'),
(211, 'Tokelau', 'TK', 'TKL', '1'),
(212, 'Tonga', 'TO', 'TON', '1'),
(213, 'Trinidad and Tobago', 'TT', 'TTO', '1'),
(214, 'Tunisia', 'TN', 'TUN', '1'),
(215, 'Turkey', 'TR', 'TUR', '1'),
(216, 'Turkmenistan', 'TM', 'TKM', '1'),
(217, 'Turks and Caicos Islands', 'TC', 'TCA', '1'),
(218, 'Tuvalu', 'TV', 'TUV', '1'),
(219, 'Uganda', 'UG', 'UGA', '1'),
(220, 'Ukraine', 'UA', 'UKR', '1'),
(221, 'United Arab Emirates', 'AE', 'ARE', '1'),
(222, 'United Kingdom', 'GB', 'GBR', '1'),
(223, 'United States', 'US', 'USA', '1'),
(224, 'United States Minor Outlying Islands', 'UM', 'UMI', '1'),
(225, 'Uruguay', 'UY', 'URY', '1'),
(226, 'Uzbekistan', 'UZ', 'UZB', '1'),
(227, 'Vanuatu', 'VU', 'VUT', '1'),
(228, 'Vatican City State (Holy See)', 'VA', 'VAT', '1'),
(229, 'Venezuela', 'VE', 'VEN', '1'),
(230, 'Viet Nam', 'VN', 'VNM', '1'),
(231, 'Virgin Islands (British)', 'VG', 'VGB', '1'),
(232, 'Virgin Islands (U.S.)', 'VI', 'VIR', '1'),
(233, 'Wallis and Futuna Islands', 'WF', 'WLF', '1'),
(234, 'Western Sahara', 'EH', 'ESH', '1'),
(235, 'Yemen', 'YE', 'YEM', '1'),
(236, 'Yugoslavia', 'YU', 'YUG', '1'),
(237, 'Zaire', 'ZR', 'ZAR', '1'),
(238, 'Zambia', 'ZM', 'ZMB', '1'),
(239, 'Zimbabwe', 'ZW', 'ZWE', '1');


DROP TABLE IF EXISTS `jem_coupons`;
CREATE TABLE IF NOT EXISTS `jem_coupons` (
  `coupon_id` int(11) NOT NULL auto_increment,
  `coupon_type` enum('percent','flat') NOT NULL default 'percent',
  `status` enum('0','1') NOT NULL default '0',
  `coupon_code` varchar(50) NOT NULL default '',
  `coupon_amount` varchar(25) NOT NULL default '',
  `coupon_minimum_order` varchar(25) NOT NULL default '',
  `coupon_start_date` varchar(25) NOT NULL default '',
  `coupon_expire_date` varchar(25) NOT NULL default '',
  `uses_per_coupon` int(10) NOT NULL default '1',
  `member_id` varchar(25) NOT NULL default '',
  `coupon_uses` int(10) NOT NULL default '0',
  `coupon_product_type` enum('1','2') NOT NULL default '1',
  `enable_recurring_coupon` enum('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY  (`coupon_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_currencies`;
CREATE TABLE IF NOT EXISTS `jem_currencies` (
  `currency_id` int(10) NOT NULL auto_increment,
  `title` varchar(32) NOT NULL default '',
  `code` char(3) NOT NULL default '',
  `symbol_left` varchar(24) default NULL,
  `symbol_right` varchar(24) default NULL,
  `decimal_point` char(1) default NULL,
  `thousands_point` char(1) default NULL,
  `decimal_places` char(1) default NULL,
  `value` float(13,2) default NULL,
  PRIMARY KEY  (`currency_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=7 ;


DROP TABLE IF EXISTS `jem_discount_groups`;
CREATE TABLE IF NOT EXISTS `jem_discount_groups` (
  `group_id` int(10) NOT NULL auto_increment,
  `status` enum('active','inactive') NOT NULL default 'inactive',
  `discount_group_name` varchar(255) NOT NULL default '',
  `discount_group_amount` varchar(25) NOT NULL default '',
  `percentage` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`group_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=2 ;



INSERT INTO `jem_discount_groups` (`group_id`, `status`, `discount_group_name`, `discount_group_amount`, `percentage`) VALUES
(1, 'active', 'default - DO NOT DELETE', '0', '1');



DROP TABLE IF EXISTS `jem_email_archive`;
CREATE TABLE IF NOT EXISTS `jem_email_archive` (
  `id` int(10) NOT NULL auto_increment,
  `type` enum('admin','member') NOT NULL default 'admin',
  `send_date` varchar(50) NOT NULL default '',
  `from_name` varchar(255) NOT NULL default '',
  `from_email` varchar(255) NOT NULL default '',
  `recipient_name` varchar(255) NOT NULL default '',
  `recipient_email` varchar(255) NOT NULL default '',
  `recipient_group` varchar(255) NOT NULL default '',
  `cc` varchar(255) NOT NULL default '',
  `bcc` varchar(255) NOT NULL default '',
  `subject` varchar(255) NOT NULL default '',
  `html_body` longtext NOT NULL,
  `text_body` longtext NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_email_bounces`;
CREATE TABLE IF NOT EXISTS `jem_email_bounces` (
  `id` int(10) NOT NULL auto_increment,
  `email` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `date` varchar(25) collate utf8_unicode_ci NOT NULL default '',
  `body` longtext collate utf8_unicode_ci NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_email_follow_ups`;
CREATE TABLE IF NOT EXISTS `jem_email_follow_ups` (
  `follow_up_id` int(10) NOT NULL auto_increment,
  `mailing_list_id` int(10) NOT NULL default '0',
  `sequence` int(10) NOT NULL default '0',
  `days_apart` int(10) NOT NULL default '0',
  `follow_up_name` varchar(50) NOT NULL default '',
  `from_name` varchar(50) NOT NULL default '',
  `from_email` varchar(50) NOT NULL default '',
  `email_type` enum('text','html') NOT NULL default 'html',
  `email_subject` varchar(255) NOT NULL default '',
  `html_message` text NOT NULL,
  `text_message` text NOT NULL,
  PRIMARY KEY  (`follow_up_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_email_mailing_lists`;
CREATE TABLE IF NOT EXISTS `jem_email_mailing_lists` (
  `mailing_list_id` int(10) NOT NULL auto_increment,
  `mailing_list_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`mailing_list_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=4 ;


INSERT INTO `jem_email_mailing_lists` (`mailing_list_id`, `mailing_list_name`) VALUES
(1, 'default'),
(2, 'affiliates'),
(3, 'customers');



DROP TABLE IF EXISTS `jem_email_mailing_list_members`;
CREATE TABLE IF NOT EXISTS `jem_email_mailing_list_members` (
  `id` int(10) NOT NULL auto_increment,
  `mailing_list_id` int(10) NOT NULL default '0',
  `member_id` int(10) NOT NULL default '0',
  `sequence_id` int(10) NOT NULL default '0',
  `send_date` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_email_queue`;
CREATE TABLE IF NOT EXISTS `jem_email_queue` (
  `eqid` bigint(20) NOT NULL auto_increment,
  `type` enum('admin','member') NOT NULL default 'member',
  `email_type` enum('text','html') NOT NULL default 'text',
  `send_date` varchar(25) NOT NULL default '',
  `sender_name` varchar(50) NOT NULL default '',
  `sender_email` varchar(50) NOT NULL default '',
  `recipient_name` varchar(50) NOT NULL default '',
  `recipient_email` varchar(50) NOT NULL default '',
  `recipient_cc` varchar(255) NOT NULL default '',
  `recipient_bcc` varchar(255) NOT NULL default '',
  `subject` varchar(255) NOT NULL default '',
  `html_body` text NOT NULL,
  `text_body` text NOT NULL,
  `group` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`eqid`),
  KEY `sender_email` (`sender_email`),
  KEY `recipient_email` (`recipient_email`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_email_templates`;
CREATE TABLE IF NOT EXISTS `jem_email_templates` (
  `id` int(10) NOT NULL auto_increment,
  `email_template_type` varchar(255) NOT NULL default '',
  `email_template_html` enum('text','html') NOT NULL default 'text',
  `email_template_group` varchar(255) NOT NULL default '',
  `email_template_name` varchar(255) NOT NULL default '',
  `email_template_from_name` varchar(255) NOT NULL default '',
  `email_template_from_email` varchar(255) NOT NULL default '',
  `email_template_cc` varchar(255) NOT NULL default '',
  `email_template_bcc` varchar(255) NOT NULL default '',
  `email_template_subject` text NOT NULL,
  `email_template_body_text` longtext NOT NULL,
  `email_template_body_html` longtext NOT NULL,
  `email_template_description` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=26 ;





DROP TABLE IF EXISTS `jem_faq_articles`;
CREATE TABLE IF NOT EXISTS `jem_faq_articles` (
  `article_id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `content_tags` varchar(255) NOT NULL default '',
  `category_id` int(10) NOT NULL default '0',
  `content_title` varchar(255) NOT NULL default '',
  `content_body` longtext NOT NULL,
  `date_published` varchar(25) NOT NULL default '',
  `modified_by` varchar(25) NOT NULL default '',
  `ping` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`article_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_faq_categories`;
CREATE TABLE IF NOT EXISTS `jem_faq_categories` (
  `category_id` int(10) NOT NULL auto_increment,
  `category_name` varchar(255) NOT NULL default '',
  `category_type` varchar(25) NOT NULL default 'custom',
  PRIMARY KEY  (`category_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

INSERT INTO `jem_faq_categories` (`category_id`, `category_name`, `category_type`) VALUES
(1, 'Default', 'custom');


DROP TABLE IF EXISTS `jem_form_fields`;
CREATE TABLE IF NOT EXISTS `jem_form_fields` (
  `ffid` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `form_type` varchar(50) NOT NULL default '',
  `form_field_type` varchar(25) NOT NULL default '',
  `form_field_name` varchar(255) NOT NULL default '',
  `form_field_description` varchar(255) NOT NULL default '',
  `form_field_required` enum('0','1') NOT NULL default '0',
  `form_field_callback` varchar(23) NOT NULL default '',
  `form_field_values` text NOT NULL,
  `sort_order` int(10) NOT NULL default '0',
  PRIMARY KEY  (`ffid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=152 ;


INSERT INTO `jem_form_fields` (`ffid`, `status`, `form_type`, `form_field_type`, `form_field_name`, `form_field_description`, `form_field_required`, `form_field_callback`, `form_field_values`, `sort_order`) VALUES
(11, '1', 'checkout_fields', 'text', 'fname', 'first name', '1', '', '', 1),
(12, '1', 'checkout_fields', 'text', 'lname', 'last name', '1', '', '', 2),
(13, '1', 'checkout_fields', 'text', 'username', 'username', '1', '', '', 5),
(14, '1', 'checkout_fields', 'text', 'password', 'password', '1', '', '', 6),
(15, '1', 'checkout_fields', 'text', 'company', 'company', '0', '', '', 3),
(16, '1', 'checkout_fields', 'text', 'billing_address_1', 'address 1', '1', '', '', 7),
(17, '1', 'checkout_fields', 'text', 'billing_address_2', 'address 2', '0', '', '', 8),
(18, '1', 'checkout_fields', 'text', 'billing_city', 'city', '1', '', '', 9),
(19, '1', 'checkout_fields', 'text', 'billing_state', 'state', '1', '', '', 11),
(20, '1', 'checkout_fields', 'dropdown', 'billing_country', 'country', '1', '', '223', 10),
(21, '1', 'checkout_fields', 'text', 'billing_postal_code', 'postal code', '1', '', '', 12),
(29, '0', 'checkout_fields', 'text', 'home_phone', 'home phone', '0', '', '', 13),
(30, '0', 'checkout_fields', 'text', 'work_phone', 'work phone', '0', '', '', 14),
(31, '0', 'checkout_fields', 'text', 'mobile_phone', 'mobile phone', '0', '', '', 15),
(32, '0', 'checkout_fields', 'text', 'fax', 'fax', '0', '', '', 16),
(34, '1', 'checkout_fields', 'text', 'primary_email', 'primary email', '1', '', '', 4),
(41, '0', 'checkout_fields', 'text', 'website', 'website', '0', '', '', 17),
(22, '0', 'checkout_payment_fields', 'text', 'payment_name', 'payment name', '0', '', '', 1),
(23, '0', 'checkout_payment_fields', 'text', 'payment_address_1', 'payment address 1', '0', '', '', 2),
(24, '0', 'checkout_payment_fields', 'text', 'payment_address_2', 'payment address 2', '0', '', '', 3),
(25, '0', 'checkout_payment_fields', 'text', 'payment_city', 'payment city', '0', '', '', 4),
(26, '0', 'checkout_payment_fields', 'text', 'payment_state', 'payment state', '0', '', '', 6),
(27, '0', 'checkout_payment_fields', 'dropdown', 'payment_country', 'payment country', '0', '', '223', 5),
(28, '0', 'checkout_payment_fields', 'text', 'payment_postal_code', 'payment postal code', '0', '', '', 7),
(33, '0', 'checkout_payment_fields', 'text', 'payment_preference_amount', 'payment preference amount', '0', '', '', 8),
(35, '0', 'checkout_payment_fields', 'text', 'paypal_id', 'paypal id', '0', '', '', 9),
(36, '0', 'checkout_payment_fields', 'text', 'safepay_id', 'safepay id', '0', '', '', 10),
(37, '0', 'checkout_payment_fields', 'text', 'moneybookers_id', 'moneybookers id', '0', '', '', 11),
(38, '0', 'checkout_payment_fields', 'text', 'alertpay_id', 'alertpay id', '0', '', '', 12),
(39, '0', 'checkout_payment_fields', 'text', 'custom_id', 'custom id', '0', '', '', 13),
(40, '0', 'checkout_payment_fields', 'textarea', 'bank_transfer', 'bank transfer', '0', '', '', 14),
(42, '1', 'checkout_shipping_fields', 'text', 'shipping_fname', 'shipping first name', '1', '', '', 1),
(43, '1', 'checkout_shipping_fields', 'text', 'shipping_lname', 'shipping last name', '1', '', '', 2),
(44, '1', 'checkout_shipping_fields', 'text', 'shipping_address_1', 'shipping address 1', '1', '', '', 3),
(45, '1', 'checkout_shipping_fields', 'text', 'shipping_address_2', 'shipping address 2', '1', '', '', 4),
(46, '1', 'checkout_shipping_fields', 'text', 'shipping_city', 'shipping city', '1', '', '', 5),
(47, '1', 'checkout_shipping_fields', 'text', 'shipping_state', 'shipping state', '1', '', '', 7),
(48, '1', 'checkout_shipping_fields', 'dropdown', 'shipping_country', 'shipping country', '1', '', '223', 6),
(49, '1', 'checkout_shipping_fields', 'text', 'shipping_postal_code', 'shipping postal code', '1', '', '', 8),
(112, '0', 'custom_commission_fields', 'dropdown', 'custom_sale_value_1', 'custom sale value 1', '0', '', '', 1),
(113, '0', 'custom_commission_fields', 'dropdown', 'custom_sale_value_2', 'custom sale value 2', '0', '', '', 2),
(114, '0', 'custom_commission_fields', 'dropdown', 'custom_sale_value_3', 'custom sale value 3', '0', '', '', 3),
(115, '0', 'custom_commission_fields', 'dropdown', 'custom_sale_value_4', 'custom sale value 4', '0', '', '', 4),
(116, '0', 'custom_commission_fields', 'dropdown', 'custom_sale_value_5', 'custom sale value 5', '0', '', '', 5),
(117, '0', 'custom_commission_fields', 'dropdown', 'custom_sale_value_6', 'custom sale value 6', '0', '', '', 6),
(118, '0', 'custom_commission_fields', 'dropdown', 'custom_sale_value_7', 'custom sale value 7', '0', '', '', 7),
(119, '0', 'custom_commission_fields', 'dropdown', 'custom_sale_value_8', 'custom sale value 8', '0', '', '', 8),
(120, '0', 'custom_commission_fields', 'dropdown', 'custom_sale_value_9', 'custom sale value 9', '0', '', '', 9),
(121, '0', 'custom_commission_fields', 'dropdown', 'custom_sale_value_10', 'custom sale value 10', '0', '', '', 10),
(1, '0', 'custom_fields', 'text', 'jrox_custom_field_1', 'custom field 1', '0', '', '', 1),
(2, '0', 'custom_fields', 'text', 'jrox_custom_field_2', 'custom field 2', '0', '', '', 2),
(3, '0', 'custom_fields', 'text', 'jrox_custom_field_3', 'custom field 3', '0', '', '', 3),
(4, '0', 'custom_fields', 'text', 'jrox_custom_field_4', 'custom field 4', '0', '', '', 4),
(5, '0', 'custom_fields', 'text', 'jrox_custom_field_5', 'custom field 5', '0', '', '', 5),
(6, '0', 'custom_fields', 'text', 'jrox_custom_field_6', 'custom field 6', '0', '', '', 6),
(7, '0', 'custom_fields', 'text', 'jrox_custom_field_7', 'custom field 7', '0', '', '', 7),
(8, '0', 'custom_fields', 'text', 'jrox_custom_field_8', 'custom field 8', '0', '', '', 8),
(9, '0', 'custom_fields', 'text', 'jrox_custom_field_9', 'custom field 9', '0', '', '', 9),
(10, '0', 'custom_fields', 'dropdown', 'jrox_custom_field_10', 'custom field 10', '0', '', 'example_1|EXAMPLE 1,example_2|EXAMPLE 2', 10),
(122, '0', 'custom_invoice_fields', 'dropdown', 'custom_invoice_value_1', 'custom invoice value 1', '0', '', '', 1),
(123, '0', 'custom_invoice_fields', 'dropdown', 'custom_invoice_value_2', 'custom invoice value 2', '0', '', '', 2),
(124, '0', 'custom_invoice_fields', 'dropdown', 'custom_invoice_value_3', 'custom invoice value 3', '0', '', '', 3),
(125, '0', 'custom_invoice_fields', 'dropdown', 'custom_invoice_value_4', 'custom invoice value 4', '0', '', '', 4),
(126, '0', 'custom_invoice_fields', 'dropdown', 'custom_invoice_value_5', 'custom invoice value 5', '0', '', '', 5),
(127, '0', 'custom_invoice_fields', 'dropdown', 'custom_invoice_value_6', 'custom invoice value 6', '0', '', '', 6),
(128, '0', 'custom_invoice_fields', 'dropdown', 'custom_invoice_value_7', 'custom invoice value 7', '0', '', '', 7),
(129, '0', 'custom_invoice_fields', 'dropdown', 'custom_invoice_value_8', 'custom invoice value 8', '0', '', '', 8),
(130, '0', 'custom_invoice_fields', 'dropdown', 'custom_invoice_value_9', 'custom invoice value 9', '0', '', '', 9),
(131, '0', 'custom_invoice_fields', 'dropdown', 'custom_invoice_value_10', 'custom invoice value 10', '0', '', '', 10),
(132, '0', 'custom_payment_fields', 'dropdown', 'custom_payment_value_1', 'custom payment value 1', '0', '', '', 1),
(133, '0', 'custom_payment_fields', 'dropdown', 'custom_payment_value_2', 'custom payment value 2', '0', '', '', 2),
(134, '0', 'custom_payment_fields', 'dropdown', 'custom_payment_value_3', 'custom payment value 3', '0', '', '', 3),
(135, '0', 'custom_payment_fields', 'dropdown', 'custom_payment_value_4', 'custom payment value 4', '0', '', '', 4),
(136, '0', 'custom_payment_fields', 'dropdown', 'custom_payment_value_5', 'custom payment value 5', '0', '', '', 5),
(137, '0', 'custom_payment_fields', 'dropdown', 'custom_payment_value_6', 'custom payment value 6', '0', '', '', 6),
(138, '0', 'custom_payment_fields', 'dropdown', 'custom_payment_value_7', 'custom payment value 7', '0', '', '', 7),
(139, '0', 'custom_payment_fields', 'dropdown', 'custom_payment_value_8', 'custom payment value 8', '0', '', '', 8),
(140, '0', 'custom_payment_fields', 'dropdown', 'custom_payment_value_9', 'custom payment value 9', '0', '', '', 9),
(141, '0', 'custom_payment_fields', 'dropdown', 'custom_payment_value_10', 'custom payment value 10', '0', '', '', 10),
(81, '1', 'membership_fields', 'text', 'fname', 'first name', '1', '', '', 1),
(82, '1', 'membership_fields', 'text', 'lname', 'last name', '1', '', '', 2),
(83, '1', 'membership_fields', 'text', 'username', 'username', '1', '', '', 4),
(84, '1', 'membership_fields', 'text', 'password', 'password', '1', '', '', 5),
(85, '0', 'membership_fields', 'text', 'company', 'company', '0', '', '', 3),
(86, '1', 'membership_fields', 'text', 'billing_address_1', 'address 1', '1', '', '', 7),
(87, '1', 'membership_fields', 'text', 'billing_address_2', 'address 2', '0', '', '', 8),
(88, '1', 'membership_fields', 'text', 'billing_city', 'city', '1', '', '', 9),
(89, '1', 'membership_fields', 'text', 'billing_state', 'state', '1', '', '', 10),
(90, '1', 'membership_fields', 'dropdown', 'billing_country', 'country', '1', '', '223', 11),
(91, '1', 'membership_fields', 'text', 'billing_postal_code', 'postal code', '1', '', '', 12),
(99, '0', 'membership_fields', 'text', 'home_phone', 'home phone', '0', '', '', 13),
(100, '0', 'membership_fields', 'text', 'work_phone', 'work phone', '0', '', '', 14),
(101, '0', 'membership_fields', 'text', 'mobile_phone', 'mobile phone', '0', '', '', 15),
(102, '0', 'membership_fields', 'text', 'fax', 'fax', '0', '', '', 16),
(104, '1', 'membership_fields', 'text', 'primary_email', 'primary email', '1', '', '', 6),
(111, '0', 'membership_fields', 'text', 'website', 'website', '0', '', '', 17),
(92, '0', 'membership_payment_fields', 'text', 'payment_name', 'payment name', '0', '', '', 1),
(93, '0', 'membership_payment_fields', 'text', 'payment_address_1', 'payment address 1', '0', '', '', 2),
(94, '0', 'membership_payment_fields', 'text', 'payment_address_2', 'payment address 2', '0', '', '', 3),
(95, '0', 'membership_payment_fields', 'text', 'payment_city', 'payment city', '0', '', '', 4),
(96, '0', 'membership_payment_fields', 'text', 'payment_state', 'payment state', '0', '', '', 5),
(97, '0', 'membership_payment_fields', 'dropdown', 'payment_country', 'payment country', '0', '', '223', 6),
(98, '0', 'membership_payment_fields', 'text', 'payment_postal_code', 'payment postal code', '0', '', '', 7),
(103, '0', 'membership_payment_fields', 'text', 'payment_preference_amount', 'payment preference amount', '0', '', '', 8),
(105, '0', 'membership_payment_fields', 'text', 'paypal_id', 'paypal id', '0', '', '', 9),
(106, '0', 'membership_payment_fields', 'text', 'safepay_id', 'safepay id', '0', '', '', 10),
(107, '0', 'membership_payment_fields', 'text', 'moneybookers_id', 'moneybookers id', '0', '', '', 11),
(108, '0', 'membership_payment_fields', 'text', 'alertpay_id', 'alertpay id', '0', '', '', 12),
(109, '0', 'membership_payment_fields', 'text', 'custom_id', 'custom id', '0', '', '', 13),
(110, '0', 'membership_payment_fields', 'textarea', 'bank_transfer', 'bank transfer', '0', '', '', 14),
(50, '1', 'registration_fields', 'text', 'fname', 'first name', '1', '', '', 1),
(51, '1', 'registration_fields', 'text', 'lname', 'last name', '1', '', '', 2),
(52, '1', 'registration_fields', 'text', 'username', 'username', '1', '', '', 4),
(53, '1', 'registration_fields', 'text', 'password', 'password', '1', '', '', 5),
(54, '1', 'registration_fields', 'text', 'company', 'company', '0', '', '', 3),
(55, '1', 'registration_fields', 'text', 'billing_address_1', 'address 1', '1', '', '', 7),
(56, '1', 'registration_fields', 'text', 'billing_address_2', 'address 2', '0', '', '', 8),
(57, '1', 'registration_fields', 'text', 'billing_city', 'city', '1', '', '', 9),
(58, '1', 'registration_fields', 'text', 'billing_state', 'state', '1', '', '', 11),
(59, '1', 'registration_fields', 'dropdown', 'billing_country', 'country', '1', '', '223', 10),
(60, '1', 'registration_fields', 'text', 'billing_postal_code', 'postal code', '1', '', '', 12),
(68, '1', 'registration_fields', 'text', 'home_phone', 'home phone', '0', '', '', 13),
(69, '0', 'registration_fields', 'text', 'work_phone', 'work phone', '0', '', '', 14),
(70, '0', 'registration_fields', 'text', 'mobile_phone', 'mobile phone', '0', '', '', 15),
(71, '0', 'registration_fields', 'text', 'fax', 'fax', '0', '', '', 16),
(73, '1', 'registration_fields', 'text', 'primary_email', 'primary email', '1', '', '', 6),
(80, '0', 'registration_fields', 'text', 'website', 'website', '0', '', '', 17),
(61, '0', 'registration_payment_fields', 'text', 'payment_name', 'payment name', '0', '', '', 1),
(62, '0', 'registration_payment_fields', 'text', 'payment_address_1', 'payment address 1', '0', '', '', 2),
(63, '0', 'registration_payment_fields', 'text', 'payment_address_2', 'payment address 2', '0', '', '', 3),
(64, '0', 'registration_payment_fields', 'text', 'payment_city', 'payment city', '0', '', '', 4),
(65, '0', 'registration_payment_fields', 'text', 'payment_state', 'payment state', '0', '', '', 5),
(66, '0', 'registration_payment_fields', 'dropdown', 'payment_country', 'payment country', '0', '', '223', 6),
(67, '0', 'registration_payment_fields', 'text', 'payment_postal_code', 'payment postal code', '0', '', '', 7),
(72, '0', 'registration_payment_fields', 'text', 'payment_preference_amount', 'payment preference amount', '0', '', '', 8),
(74, '0', 'registration_payment_fields', 'text', 'paypal_id', 'paypal id', '0', '', '', 9),
(75, '0', 'registration_payment_fields', 'text', 'safepay_id', 'safepay id', '0', '', '', 10),
(76, '0', 'registration_payment_fields', 'text', 'moneybookers_id', 'moneybookers id', '0', '', '', 11),
(77, '0', 'registration_payment_fields', 'text', 'alertpay_id', 'alertpay id', '0', '', '', 12),
(78, '0', 'registration_payment_fields', 'text', 'custom_id', 'custom id', '0', '', '', 13),
(79, '0', 'registration_payment_fields', 'textarea', 'bank_transfer', 'bank transfer', '0', '', '', 14),
(142, '0', 'custom_contact_fields', 'dropdown', 'custom_contact_field_1', 'custom contact field 10', '0', '', 'example_1|EXAMPLE 1,example_2|EXAMPLE 2', 10),
(143, '0', 'custom_contact_fields', 'text', 'custom_contact_field_2', 'custom contact field 2', '0', '', '', 2),
(144, '0', 'custom_contact_fields', 'text', 'custom_contact_field_3', 'custom contact field 3', '0', '', '', 3),
(145, '0', 'custom_contact_fields', 'text', 'custom_contact_field_4', 'custom contact field 4', '0', '', '', 4),
(146, '0', 'custom_contact_fields', 'text', 'custom_contact_field_5', 'custom contact field 5', '0', '', '', 5),
(147, '0', 'custom_contact_fields', 'text', 'custom_contact_field_6', 'custom contact field 6', '0', '', '', 6),
(148, '0', 'custom_contact_fields', 'text', 'custom_contact_field_7', 'custom contact field 7', '0', '', '', 7),
(149, '0', 'custom_contact_fields', 'text', 'custom_contact_field_8', 'custom contact field 8', '0', '', '', 8),
(150, '0', 'custom_contact_fields', 'text', 'custom_contact_field_9', 'custom contact field 9', '0', '', '', 9),
(151, '0', 'custom_contact_fields', 'text', 'custom_contact_field_10', 'custom contact field 1', '0', '', '', 1);

DROP TABLE IF EXISTS `jem_global_discounts`;
CREATE TABLE IF NOT EXISTS `jem_global_discounts` (
  `id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `min_amount` varchar(25) NOT NULL default '0',
  `max_amount` varchar(25) NOT NULL default '0',
  `discount_amount` varchar(25) NOT NULL default '0',
  `discount_type` enum('flat','percent') NOT NULL default 'percent',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS `jem_invoices`;
CREATE TABLE IF NOT EXISTS `jem_invoices` (
  `invoice_id` int(10) NOT NULL auto_increment,
  `product_type` varchar(25) NOT NULL default '',
  `payment_status` enum('0','1') NOT NULL default '0',
  `order_status` enum('order_pending','order_processing','order_completed') NOT NULL default 'order_pending',
  `member_id` int(10) NOT NULL default '0',
  `customers_name` varchar(255) NOT NULL default '',
  `customers_company` varchar(50) NOT NULL,
  `customers_address_1` varchar(255) NOT NULL default '',
  `customers_address_2` varchar(255) NOT NULL default '',
  `customers_city` varchar(32) NOT NULL default '',
  `customers_postal_code` varchar(10) NOT NULL default '',
  `customers_state` varchar(50) NOT NULL,
  `customers_country` varchar(50) NOT NULL default '',
  `customers_telephone` varchar(50) NOT NULL default '',
  `customers_primary_email` varchar(255) NOT NULL default '',
  `shipping_name` varchar(255) NOT NULL default '',
  `shipping_company` varchar(50) NOT NULL,
  `shipping_address_1` varchar(255) NOT NULL default '',
  `shipping_address_2` varchar(255) NOT NULL default '',
  `shipping_city` varchar(50) NOT NULL default '',
  `shipping_postal_code` varchar(10) NOT NULL default '',
  `shipping_state` varchar(50) NOT NULL,
  `shipping_country` varchar(50) NOT NULL default '',
  `shipping_method` varchar(255) NOT NULL default '',
  `shipping_tracking_id` varchar(255) NOT NULL default '',
  `coupon_code` varchar(50) NOT NULL default '',
  `date_purchased` varchar(25) NOT NULL,
  `due_date` varchar(25) NOT NULL default '',
  `sub_total` decimal(14,2) NOT NULL default '0.00',
  `tax_amount` decimal(14,2) NOT NULL default '0.00',
  `shipping_amount` decimal(14,2) NOT NULL default '0.00',
  `discount_amount` decimal(14,2) NOT NULL default '0.00',
  `ip_address` varchar(96) NOT NULL default '',
  `referrer_id` int(10) NOT NULL default '0',
  `tool_type` varchar(25) NOT NULL default '',
  `tool_id` int(10) NOT NULL default '0',
  `invoice_notes` text NOT NULL,
  `tracking_id` int(10) NOT NULL default '0',
  PRIMARY KEY  (`invoice_id`),
  KEY `member_id` (`member_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_invoice_payments`;
CREATE TABLE IF NOT EXISTS `jem_invoice_payments` (
  `id` int(10) NOT NULL auto_increment,
  `invoice_id` int(10) NOT NULL default '0',
  `payment_date` varchar(25) NOT NULL default '',
  `payment_amount` varchar(25) NOT NULL default '',
  `transaction_id` varchar(50) NOT NULL default '',
  `payment_method` varchar(50) NOT NULL default '',
  `payment_type` enum('credit','refund') NOT NULL default 'credit',
  `payment_notes` text NOT NULL,
  `debug_info` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `invoice_id` (`invoice_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_invoice_products`;
CREATE TABLE IF NOT EXISTS `jem_invoice_products` (
  `invoice_id` int(10) NOT NULL default '0',
  `product_id` int(10) NOT NULL default '0',
  `invoice_product_name` varchar(255) NOT NULL default '',
  `product_notes` text NOT NULL,
  `unit_price` decimal(15,4) NOT NULL default '0.0000',
  `quantity` int(10) NOT NULL default '0',
  `weight` decimal(14,2) NOT NULL default '0.00',
  `product_sku` varchar(50) NOT NULL default '',
  KEY `invoice_id` (`invoice_id`,`product_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


DROP TABLE IF EXISTS `jem_languages`;
CREATE TABLE IF NOT EXISTS `jem_languages` (
  `language_id` int(10) NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `code` char(2) NOT NULL default '',
  `image` varchar(64) default NULL,
  PRIMARY KEY  (`language_id`),
  KEY `idx_languages_name_zen` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=2 ;


INSERT INTO `jem_languages` (`language_id`, `name`, `code`, `image`) VALUES
(1, 'english', 'US', 'us.gif');



DROP TABLE IF EXISTS `jem_layout_boxes`;
CREATE TABLE IF NOT EXISTS `jem_layout_boxes` (
  `layout_box_id` int(10) NOT NULL auto_increment,
  `layout_box_type` varchar(25) NOT NULL default '',
  `layout_box_status` enum('0','1') NOT NULL default '0',
  `layout_box_name` varchar(50) NOT NULL default '',
  `layout_box_description` varchar(255) NOT NULL default '',
  `layout_box_file_name` varchar(255) NOT NULL default '',
  `layout_box_location` enum('left','right') NOT NULL default 'left',
  `layout_box_sort_order` int(10) NOT NULL default '0',
  `layout_box_code` longtext NOT NULL,
  `layout_box_show_affiliate` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`layout_box_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=40 ;


INSERT INTO `jem_layout_boxes` (`layout_box_id`, `layout_box_type`, `layout_box_status`, `layout_box_name`, `layout_box_description`, `layout_box_file_name`, `layout_box_location`, `layout_box_sort_order`, `layout_box_code`, `layout_box_show_affiliate`) VALUES
(37, 'custom', '1', 'main_categories', 'top level product categories', 'product_categories', 'right', 3, '', '0'),
(3, 'custom', '1', 'left_ad_block', 'show ads on left block', 'ad_block_left', 'left', 7, '', '0'),
(23, 'custom', '1', 'links', 'left layout menu', 'left_layout_menu', 'left', 6, '', '0'),
(24, 'custom', '1', 'right_layout_menu', 'right layout menu', 'right_layout_menu', 'right', 7, '', '0'),
(29, 'custom', '0', 'manufacturers', 'list manufacturers', 'manufacturers', 'right', 4, '', '0'),
(30, 'custom', '1', 'content_categories', 'content categories', 'content_categories', 'left', 4, '', '0'),
(31, 'custom', '1', 'FAQ_categories', 'FAQ categories', 'faq_categories', 'left', 5, '', '0'),
(32, 'custom', '1', 'member_login', 'members login box', 'member_login', 'left', 2, '', '0'),
(33, 'custom', '0', 'currencies', 'select currencies', 'currencies', 'right', 5, '', '0'),
(34, 'custom', '1', 'referred_by', 'affiliate referral box', 'referrer_details', 'right', 1, '', '0'),
(35, 'custom', '1', 'search', 'search box', 'search', 'right', 2, '', '0'),
(36, 'custom', '1', 'list_product_categories', 'list product categories in a dropdown', 'product_categories_dropdown', 'left', 3, '', '0'),
(28, 'custom', '1', 'right_ad_block', 'show right ad blocks', 'ad_block_right', 'right', 6, '', '0'),
(38, 'custom', '1', 'your_cart', 'cart contents', 'cart_contents', 'left', 1, '', '0');



DROP TABLE IF EXISTS `jem_layout_menus`;
CREATE TABLE IF NOT EXISTS `jem_layout_menus` (
  `id` int(10) NOT NULL auto_increment,
  `menu_status` enum('0','1') NOT NULL default '0',
  `menu_name` varchar(255) NOT NULL default '',
  `menu_parent` int(10) NOT NULL default '0',
  `menu_url` varchar(255) NOT NULL default '',
  `menu_sort_order` int(10) NOT NULL default '0',
  `menu_location` int(11) NOT NULL default '2',
  `menu_options` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `menu_parent` (`menu_parent`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


INSERT INTO `jem_layout_menus` (`id`, `menu_status`, `menu_name`, `menu_parent`, `menu_url`, `menu_sort_order`, `menu_location`) VALUES
(1, '1', 'product_categories', 0, '{product_categories}', 6, 1),
(2, '1', 'blog', 0, '{content}', 5, 1),
(52, '1', 'brands', 0, '{manufacturers}', 2, 1),
(4, '1', 'members', 0, '{members_login}', 1, 2),
(5, '1', 'terms_of_service', 0, '{terms_of_service}', 1, 4),
(6, '1', 'Start Your Own Store', 0, '#', 1, 3),
(7, '1', 'privacy_policy', 0, '{privacy_policy}', 6, 4),
(9, '1', 'about_us', 0, '{about_us}', 5, 4),
(89, '1', 'support', 0, '{members_support}', 2, 5),
(54, '1', 'sitemap', 0, '{sitemap}', 3, 4),
(17, '1', 'home', 0, '{home}', 1, 1),
(53, '1', 'rss', 0, '{rss_feeds}', 4, 4),
(90, '1', 'downloads', 88, '{members_downloads}', 1, 0),
(47, '1', 'System Requirements', 0, '#', 2, 3),
(45, '1', 'View FAQs', 0, '#', 4, 3),
(46, '1', 'Browse Documentation', 0, '#', 3, 3),
(43, '1', 'store', 0, '{store}', 2, 2),
(49, '1', 'new_products', 0, '{new_products}', 4, 1),
(50, '1', 'store', 0, '{store}', 3, 1),
(55, '1', 'contact_us', 0, '{contact_us}', 2, 4),
(73, '1', 'profile', 0, '{members_details}', 5, 5),
(74, '1', 'content', 0, '{members_content}', 6, 5),
(88, '1', 'invoices', 0, '{members_invoices}', 3, 5),
(86, '1', 'dashboard', 0, '{members_home}', 1, 5),
(87, '1', 'marketing', 0, '{members_marketing}', 4, 5),
(91, '1', 'view_downline', 87, '{members_downline}', 4, 0),
(92, '1', 'affiliate_coupons', 87, '{members_coupons}', 5, 0),
(93, '1', 'memberships', 88, '{members_memberships}', 2, 0),
(94, '1', 'commissions', 87, '{members_commissions}', 3, 0),
(95, '1', 'affiliate_payments', 87, '{members_payments}', 2, 0),
(96, '1', 'email_downline', 87, '{members_email_downline}', 1, 0);


DROP TABLE IF EXISTS `jem_layout_themes`;
CREATE TABLE IF NOT EXISTS `jem_layout_themes` (
  `theme_id` int(10) NOT NULL auto_increment,
  `theme_default` enum('0','1') NOT NULL default '0',
  `theme_name` varchar(255) NOT NULL default '',
  `theme_description` text NOT NULL,
  `theme_image_preview` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`theme_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



INSERT INTO `jem_layout_themes` (`theme_id`, `theme_default`, `theme_name`, `theme_description`, `theme_image_preview`) VALUES
(1, '0', 'athletics_blue', 'Athletics Blue Theme', 'theme_preview.jpg'),
(2, '0', 'beach_blue', 'Beach Blue Travel Theme', 'theme_preview.jpg'),
(3, '0', 'beadworks_blue', 'Bead Works', 'theme_preview.jpg'),
(4, '0', 'cosmetics_theme', 'Cosmetics Theme', 'theme_preview.jpg'),
(5, '0', 'crafts_green', 'Green Crafts Theme', 'theme_preview.jpg'),
(6, '1', 'default', 'Default Theme', 'theme_preview.jpg'),
(7, '0', 'default_black', 'Black Default Theme', 'theme_preview.jpg'),
(8, '0', 'default_blue', 'Blue Default Theme', 'theme_preview.jpg'),
(9, '0', 'default_green', 'Green Default Theme', 'theme_preview.jpg'),
(10, '0', 'default_pink', 'Pink Default Theme', 'theme_preview.jpg'),
(11, '0', 'default_red', 'Red Default Theme', 'theme_preview.jpg'),
(12, '0', 'eco_blue', 'Eco Blue Theme', 'theme_preview.jpg'),
(13, '0', 'fashionlight_blue', 'Fashion Light Blue Theme', 'theme_preview.jpg'),
(14, '0', 'flowers_white', 'White Flowers', 'theme_preview.jpg'),
(15, '0', 'incorporated_blue', 'Incorporated Blue Theme', 'theme_preview.jpg'),
(16, '0', 'kitchenware_white', 'Kitchenware White Theme', 'theme_preview.jpg'),
(17, '0', 'modern_grey', 'Modern Grey Theme', 'theme_preview.jpg'),
(18, '0', 'professional_gold', 'Professional Gold Theme', 'theme_preview.jpg'),
(19, '0', 'realestate_brown', 'Real Estate Brown Theme', 'theme_preview.jpg'),
(20, '0', 'science_black', 'Black Science Theme', 'theme_preview.jpg'),
(21, '0', 'snow_blue', 'Blue Snow and Ski', 'theme_preview.jpg'),
(22, '0', 'translucent_blue', 'Translucent Blue Theme', 'theme_preview.jpg'),
(23, '0', 'translucent_green', 'Translucent Green Theme', 'theme_preview.jpg'),
(24, '0', 'transparent_grey', 'Transparent Grey Theme', 'theme_preview.jpg');



DROP TABLE IF EXISTS `jem_manufacturers`;
CREATE TABLE IF NOT EXISTS `jem_manufacturers` (
  `manufacturer_id` int(10) NOT NULL auto_increment,
  `manufacturer_name` varchar(255) NOT NULL default '',
  `manufacturer_description` varchar(255) NOT NULL default '',
  `manufacturer_image` varchar(255) NOT NULL default '',
  `manufacturer_meta_keywords` text NOT NULL,
  `manufacturer_meta_description` text NOT NULL,
  `manufacturer_status` enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (`manufacturer_id`),
  KEY `manufacturer_name` (`manufacturer_name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=2 ;



INSERT INTO `jem_manufacturers` (`manufacturer_id`, `manufacturer_name`, `manufacturer_description`, `manufacturer_image`, `manufacturer_meta_keywords`, `manufacturer_meta_description`) VALUES
(1, 'default - DO NOT DELETE', '', '', '', '');



DROP TABLE IF EXISTS `jem_members`;
CREATE TABLE IF NOT EXISTS `jem_members` (
  `member_id` int(10) NOT NULL auto_increment,
  `sponsor_id` int(10) NOT NULL default '0',
  `status` enum('0','1') NOT NULL default '0',
  `fname` varchar(50) NOT NULL default '',
  `lname` varchar(50) NOT NULL default '',
  `username` varchar(255) NOT NULL default '',
  `password` varchar(255) NOT NULL default '',
  `company` varchar(255) NOT NULL default '',
  `billing_address_1` varchar(255) NOT NULL default '',
  `billing_address_2` varchar(255) NOT NULL default '',
  `billing_city` varchar(255) NOT NULL default '',
  `billing_state` varchar(255) NOT NULL default '',
  `billing_country` varchar(255) NOT NULL default '',
  `billing_postal_code` varchar(255) NOT NULL default '',
  `payment_name` varchar(255) NOT NULL default '',
  `payment_address_1` varchar(255) NOT NULL default '',
  `payment_address_2` varchar(255) NOT NULL default '',
  `payment_city` varchar(255) NOT NULL default '',
  `payment_state` varchar(255) NOT NULL default '',
  `payment_country` varchar(255) NOT NULL default '',
  `payment_postal_code` varchar(255) NOT NULL default '',
  `home_phone` varchar(255) NOT NULL default '',
  `work_phone` varchar(255) NOT NULL default '',
  `mobile_phone` varchar(255) NOT NULL default '',
  `fax` varchar(255) NOT NULL default '',
  `payment_preference_amount` varchar(25) NOT NULL default '',
  `primary_email` varchar(255) NOT NULL default '',
  `paypal_id` varchar(255) NOT NULL default '',
  `safepay_id` varchar(255) NOT NULL default '',
  `moneybookers_id` varchar(255) NOT NULL default '',
  `alertpay_id` varchar(255) NOT NULL default '',
  `custom_id` varchar(255) NOT NULL default '',
  `bank_transfer` text NOT NULL,
  `enable_affiliate_marketing` enum('0','1','2') NOT NULL default '2',
  `enable_custom_url` enum('0','1') NOT NULL default '0',
  `custom_url_link` varchar(255) NOT NULL default '',
  `website` varchar(255) NOT NULL default '',
  `jrox_custom_field_1` text NOT NULL,
  `jrox_custom_field_2` text NOT NULL,
  `jrox_custom_field_3` text NOT NULL,
  `jrox_custom_field_4` text NOT NULL,
  `jrox_custom_field_5` text NOT NULL,
  `jrox_custom_field_6` text NOT NULL,
  `jrox_custom_field_7` text NOT NULL,
  `jrox_custom_field_8` text NOT NULL,
  `jrox_custom_field_9` text NOT NULL,
  `jrox_custom_field_10` text NOT NULL,
  `profile_description` text NOT NULL,
  `alert_downline_signup` enum('0','1','2') NOT NULL default '2',
  `alert_new_commission` enum('0','1','2') NOT NULL default '2',
  `alert_payment_sent` enum('0','1','2') NOT NULL default '2',
  `allow_downline_view` enum('0','1','2') NOT NULL default '2',
  `allow_downline_email` enum('0','1','2') NOT NULL default '2',
  `last_login_date` varchar(25) NOT NULL default '',
  `last_login_ip` varchar(50) NOT NULL default '',
  `signup_date` varchar(25) NOT NULL default '',
  `updated_on` varchar(25) NOT NULL default '',
  `updated_by` varchar(255) NOT NULL default '',
  `login_status` enum('0','1') NOT NULL default '0',
  `confirm_id` varchar(25) NOT NULL default '',
  `initial_fee` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`member_id`),
  KEY `JROX_MEMBERS_NAME` (`fname`,`username`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_members_addresses`;
CREATE TABLE IF NOT EXISTS `jem_members_addresses` (
  `id` int(10) NOT NULL auto_increment,
  `member_id` int(10) NOT NULL default '0',
  `shipping_default` enum('0','1') NOT NULL default '1',
  `shipping_fname` varchar(255) NOT NULL default '',
  `shipping_lname` varchar(255) NOT NULL default '',
  `shipping_address_1` varchar(255) NOT NULL default '',
  `shipping_address_2` varchar(255) NOT NULL default '',
  `shipping_city` varchar(255) NOT NULL default '',
  `shipping_state` varchar(255) NOT NULL default '',
  `shipping_country` varchar(255) NOT NULL default '',
  `shipping_postal_code` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_members_credits`;
CREATE TABLE IF NOT EXISTS `jem_members_credits` (
  `id` int(10) NOT NULL auto_increment,
  `member_id` int(10) NOT NULL default '0',
  `amount` varchar(25) NOT NULL default '',
  `date` varchar(25) NOT NULL default '',
  `notes` text NOT NULL,
  `invoice_id` int(10) NOT NULL default '0',
  `used` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_members_downloads`;
CREATE TABLE IF NOT EXISTS `jem_members_downloads` (
  `id` int(10) NOT NULL auto_increment,
  `product_id` int(10) NOT NULL default '0',
  `member_id` int(10) NOT NULL default '0',
  `downloads` int(10) NOT NULL default '0',
  `expires` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `product_id` (`product_id`,`member_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_members_groups`;
CREATE TABLE IF NOT EXISTS `jem_members_groups` (
  `id` int(10) NOT NULL auto_increment,
  `group_type` varchar(25) NOT NULL default '',
  `group_id` int(10) NOT NULL default '0',
  `member_id` int(10) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `group_id` (`group_id`,`member_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_members_memberships`;
CREATE TABLE IF NOT EXISTS `jem_members_memberships` (
  `id` int(10) NOT NULL auto_increment,
  `member_id` int(10) NOT NULL default '0',
  `product_id` int(10) NOT NULL default '0',
  `expires` varchar(25) NOT NULL default '',
  `invoice_date` varchar(25) NOT NULL,
  `invoice_id` int(10) NOT NULL default '0',
  `total_intervals` varchar(25) NOT NULL default '',
  `intervals_left` varchar(25) NOT NULL default '',
  `subscription_id` varchar(50) NOT NULL default '',
  `membership_payment_type` varchar(255) NOT NULL,
  `status` enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_members_photos`;
CREATE TABLE IF NOT EXISTS `jem_members_photos` (
  `photo_id` int(10) NOT NULL auto_increment,
  `member_id` int(10) NOT NULL default '0',
  `photo_file_name` varchar(255) NOT NULL default '',
  `raw_name` varchar(255) NOT NULL default '',
  `file_ext` varchar(25) NOT NULL default '',
  `file_type` varchar(255) NOT NULL default '',
  `original_file_name` varchar(255) NOT NULL default '',
  `image_resized` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`photo_id`),
  KEY `member_id` (`member_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_members_recommends`;
CREATE TABLE IF NOT EXISTS `jem_members_recommends` (
  `id` int(10) NOT NULL auto_increment,
  `member_id` int(10) NOT NULL default '0',
  `product_id` int(10) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `member_id` (`member_id`,`product_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_modules`;
CREATE TABLE IF NOT EXISTS `jem_modules` (
  `module_id` int(10) NOT NULL auto_increment,
  `module_status` enum('0','1') NOT NULL default '0',
  `module_type` varchar(50) NOT NULL default '',
  `module_name` varchar(50) NOT NULL default '',
  `module_description` varchar(255) NOT NULL default '',
  `module_file_name` varchar(255) NOT NULL default '',
  `window_height_size` int(10) NOT NULL default '400',
  `window_width_size` int(10) NOT NULL default '400',
  `module_sort_order` int(10) NOT NULL default '1',
  `can_deactivate` enum('0','1') NOT NULL default '1',
  `can_delete` enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (`module_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



INSERT INTO `jem_modules` (`module_id`, `module_status`, `module_type`, `module_name`, `module_description`, `module_file_name`, `window_height_size`, `window_width_size`, `module_sort_order`, `can_deactivate`, `can_delete`) VALUES
(1, '0', 'shipping', 'Percentage of Amount', 'charge shipping using set percentage', 'by_percent', 440, 500, 1, '1', '0'),
(9, '1', 'shipping', 'Flat Rate', 'charge flat shipping rate for entire purchase', 'flat_rate', 440, 500, 6, '1', '0'),
(12, '0', 'shipping', 'Free Shipping', 'give out free shipping when certain amount is reached', 'free_shipping', 500, 500, 7, '1', '0'),
(13, '0', 'shipping', 'Per Item', 'charge shipping rate for each item purchased', 'per_item', 500, 500, 5, '1', '0'),
(126, '1', 'payment_gateway', 'Paypal IPN', 'Paypal Standard IPN', 'paypal_standard', 600, 500, 1, '1', '1'),
(129, '0', 'payment_gateway', 'AlertPay', 'AlertPay Payment Gateway', 'alertpay', 500, 500, 3, '1', '1'),
(132, '0', 'payment_gateway', '2Checkout', '2Checkout Gateway', '2checkout', 500, 500, 4, '1', '1'),
(135, '1', 'payment_gateway', 'Offline Payment', 'Offline Payment', 'offline_payment', 500, 500, 10, '1', '1'),
(48, '0', 'shipping', 'UPS', 'use UPS online tools to calculate shipping', 'ups', 650, 500, 4, '1', '0'),
(50, '1', 'affiliate_marketing', 'text links', 'affiliate text links', 'text_links', 250, 400, 1, '1', '0'),
(59, '1', 'affiliate_marketing', 'Banners', 'affiliate banners', 'banners', 300, 500, 1, '1', '0'),
(62, '1', 'affiliate_marketing', 'Text Ads', 'affiliate text ads', 'text_ads', 500, 700, 1, '1', '0'),
(64, '1', 'affiliate_marketing', 'html ads', 'affiliate html ads', 'html_ads', 500, 700, 1, '1', '0'),
(66, '1', 'affiliate_marketing', 'viral PDFs', 'affiliate viral PDFs', 'viral_pdfs', 340, 500, 1, '1', '0'),
(67, '1', 'affiliate_marketing', 'article ads', 'affiliate article ads', 'article_ads', 250, 500, 1, '1', '0'),
(68, '1', 'affiliate_marketing', 'email ads', 'affiliate email ads', 'email_ads', 250, 500, 1, '1', '0'),
(69, '1', 'affiliate_marketing', 'viral videos', 'affiliate viral videos', 'viral_videos', 250, 500, 1, '1', '0'),
(76, '1', 'advertising', 'ad blocks', 'advertising blocks on page', 'ad_blocks', 400, 400, 1, '0', '0'),
(77, '1', 'affiliate_payment', 'Paypal Mass Payment', 'Paypal Mass Payment File', 'paypal_mass_payment', 400, 400, 1, '1', '0'),
(78, '1', 'affiliate_payment', 'Print Affiliate Invoice', 'print invoice for affiliate payment', 'print_invoice', 400, 400, 1, '0', '0'),
(80, '1', 'affiliate_payment', 'AlertPay Mass Payment', 'AlertPay Mass Payment File', 'alertpay_mass_payment', 400, 400, 1, '1', '1'),
(81, '1', 'affiliate_payment', 'Store Credits', 'Give store credits to affiliate on commissions earned', 'store_credits', 400, 400, 1, '1', '0'),
(82, '1', 'affiliate_payment', 'Moneybookers Mass Payment', 'Moneybookers Mass Payment File', 'moneybookers_mass_payment', 400, 400, 1, '1', '1'),
(83, '1', 'affiliate_payment', 'Safepay Mass Payment', 'Safepay Mass Payment File', 'safepay_mass_payment', 400, 400, 1, '1', '1'),
(84, '1', 'affiliate_payment', 'Print Affiliate Checks', 'print checks for affiliate payment', 'print_checks', 400, 400, 1, '1', '0'),
(92, '1', 'data_export', 'Export Members', 'Download an Export File of Members', 'members', 350, 400, 1, '1', '0'),
(93, '1', 'data_export', 'Export Products', 'Download an Export File of Products', 'products', 350, 400, 1, '1', '0'),
(94, '1', 'data_export', 'Export Invoices', 'Download an Export File of Invoices', 'invoices', 350, 400, 1, '1', '0'),
(95, '1', 'data_export', 'Export Commissions', 'Download an Export File of Commissions', 'commissions', 350, 400, 1, '1', '0'),
(96, '1', 'data_export', 'Export Affiliate Payments', 'Download an Export File of Affiliate Payments', 'affiliate_payments', 350, 400, 1, '1', '0'),
(97, '1', 'data_export', 'Export Invoice Payments', 'Download an Export File of Invoice Payments', 'invoice_payments', 350, 400, 1, '1', '0'),
(98, '1', 'stats_reporting', 'Monthly Sales Stats', 'Sales Stats for  Month', 'month_sales_stats', 400, 400, 1, '1', '0'),
(99, '1', 'stats_reporting', 'Monthly Commission Stats', 'Commission Stats for  Month', 'month_commission_stats', 400, 400, 1, '1', '0'),
(100, '1', 'stats_reporting', 'Monthly Invoice Payments Stats', 'Invoice Payment Stats for Month', 'month_invoice_payments_stats', 400, 400, 1, '1', '0'),
(101, '1', 'stats_reporting', 'Yearly Invoice Payments Stats', 'Invoice Payment Stats for the Year', 'year_invoice_payments_stats', 400, 400, 1, '1', '0'),
(102, '1', 'stats_reporting', 'Yearly Sales Stats', 'Sales Stats for Year', 'year_sales_stats', 400, 400, 1, '1', '0'),
(103, '1', 'stats_reporting', 'Yearly Commission Stats', 'Commission Stats for Year', 'year_commissions_stats', 400, 400, 1, '1', '0'),
(104, '1', 'stats_reporting', 'Yearly Affiliate Clicks Stats', 'Affiliate Click Stats for the Year', 'year_affiliate_clicks_stats', 400, 400, 1, '1', '0'),
(105, '1', 'stats_reporting', 'Monthly Affiliate Click Stats', 'Affiliate Click Stats for the Month', 'month_affiliate_clicks_stats', 400, 400, 1, '1', '0'),
(106, '1', 'stats_reporting', 'Monthly Support Ticket Stats', 'Support Ticket Stats for the Month', 'month_support_ticket_stats', 400, 400, 1, '1', '0'),
(107, '1', 'stats_reporting', 'Yearly Support Ticket Stats', 'Support Ticket Stats for the Year', 'year_support_ticket_stats', 400, 400, 1, '1', '0'),
(108, '1', 'stats_reporting', 'Top Affiliates By Commissions', 'Top Affiliate Earners Per Month', 'month_top_affiliate_commissions', 400, 400, 1, '1', '0'),
(109, '1', 'stats_reporting', 'Top Affiliates By Sales', 'Top Affiliate Earners By Sales Per Month', 'month_top_affiliate_sales', 400, 400, 1, '1', '0'),
(110, '1', 'stats_reporting', 'Top Affiliates By Clicks', 'Top Affiliate Earners By Clicks Per Month', 'month_top_affiliate_clicks', 400, 400, 1, '1', '0'),
(111, '1', 'stats_reporting', 'Affiliate Clickthrough Traffic', 'View Affiliate Clicks', 'affiliate_click_traffic', 400, 400, 1, '0', '0'),
(112, '1', 'stats_reporting', 'Top Product Views', 'Top Product Views by Count', 'top_product_views', 400, 400, 1, '1', '1'),
(114, '0', 'shipping', 'USPS', 'United States Postal Service Web Tools Shipping API', 'usps', 500, 500, 3, '1', '0'),
(117, '0', 'shipping', 'Per Unit', 'use zones to calculate shipping costs', 'zone_based', 700, 500, 2, '1', '1'),
(133, '0', 'payment_gateway', 'PSIGate', 'PSIGate Payment Processor', 'psigate', 500, 500, 5, '1', '1'),
(134, '0', 'payment_gateway', 'Liberty Reserve', 'Liberty Reserve Payment Gateway', 'liberty_reserve', 500, 500, 6, '1', '1'),
(140, '0', 'payment_gateway', 'NoChex', 'NoChex Payment Gateway', 'nochex', 500, 500, 7, '1', '1'),
(137, '0', 'payment_gateway', 'eWay', 'eWay - Australian Payment Gateway', 'eway', 500, 500, 8, '1', '1'),
(139, '0', 'payment_gateway', 'E-Gold', 'E-Gold Payment Gateway', 'egold', 500, 500, 9, '1', '1'),
(141, '1', 'member_reporting', 'Your Monthly Referral Commission Stats', 'Monthly Commission Stats for the Member', 'month_commission_stats', 500, 500, 1, '1', '1'),
(144, '1', 'member_reporting', 'Your Monthly Referral Sales Stats', 'Monthly Sales Stats for the Member', 'month_sales_stats', 500, 500, 1, '1', '1'),
(143, '1', 'member_reporting', 'Your Monthly Referral Click Stats', 'Monthly Click Stats for the Member', 'month_click_stats', 500, 500, 1, '1', '1'),
(145, '1', 'member_reporting', 'Your Yearly Referral Commission Stats', 'Yearly Commission Stats for the Member', 'year_commission_stats', 500, 500, 1, '1', '1'),
(146, '1', 'member_reporting', 'Your Yearly  Referral Sales Stats', 'Yearly Sales Stats for the Member', 'year_sales_stats', 500, 500, 1, '1', '1'),
(148, '1', 'member_reporting', 'Your Yearly Referral Click Stats', 'Yearly Click Stats for the Member', 'year_click_stats', 500, 500, 1, '1', '1'),
(150, '0', 'data_import', 'JAM Database Import', 'Import of JAM Database', 'jam', 600, 600, 1, '1', '1'),
(151, '1', 'data_import', 'Product Import', 'Import Products via Tab Separated File', 'products', 400, 400, 1, '1', '1'),
(152, '1', 'data_import', 'Member Import', 'Import Members via Tab Separated File', 'members', 400, 400, 1, '1', '1'),
(153, '0', 'payment_gateway', 'First Data Connect', 'First Data Connect', 'firstdata_connect', 600, 400, 11, '1', '1'),
(158, '1', 'stats_reporting', 'User Registrations', 'shows the number of users who registered on a daily basis', 'month_user_registrations', 400, 400, 1, '1', '1'),
(159, '0', 'payment_gateway', 'authorize.net sim', 'Authorize.Net SIM', 'authorize_net_sim', 500, 500, 2, '1', '1');



DROP TABLE IF EXISTS `jem_products`;
CREATE TABLE IF NOT EXISTS `jem_products` (
  `product_id` int(10) NOT NULL auto_increment,
  `product_type` varchar(25) NOT NULL default '',
  `product_sku` varchar(50) NOT NULL default '',
  `product_status` enum('0','1') NOT NULL default '0',
  `product_name` varchar(255) NOT NULL default '',
  `product_featured` enum('0','1') NOT NULL default '0',
  `upsell_product` enum('0','1') NOT NULL default '0',
  `recommended_product` enum('0','1') NOT NULL default '0',
  `product_keywords` varchar(255) NOT NULL default '',
  `product_new` enum('0','1') NOT NULL default '0',
  `product_trial_price` decimal(14,2) NOT NULL default '0.00',
  `product_price` decimal(14,2) NOT NULL default '0.00',
  `date_added` varchar(25) NOT NULL default '',
  `date_modified` varchar(25) NOT NULL default '',
  `date_available` varchar(25) NOT NULL default '',
  `date_expires` varchar(25) NOT NULL default '',
  `enable_product_trial` enum('0','1') NOT NULL default '0',
  `product_trial_interval` int(10) NOT NULL default '0',
  `product_trial_interval_type` varchar(25) NOT NULL default '',
  `recurring_onetime` enum('0','1') NOT NULL default '0',
  `recurring_interval` int(10) NOT NULL default '0',
  `recurring_interval_type` varchar(25) NOT NULL default '',
  `recurring_interval_ends` int(10) NOT NULL default '0',
  `use_video_default` enum('0','1') NOT NULL default '0',
  `download_location_1` varchar(255) NOT NULL default '',
  `download_location_2` varchar(255) NOT NULL default '',
  `download_location_3` varchar(255) NOT NULL default '',
  `download_location_4` varchar(255) NOT NULL default '',
  `download_location_5` varchar(255) NOT NULL default '',
  `download_location_6` varchar(255) NOT NULL default '',
  `download_location_7` varchar(255) NOT NULL default '',
  `download_location_8` varchar(255) NOT NULL default '',
  `download_location_9` varchar(255) NOT NULL default '',
  `download_location_10` varchar(255) NOT NULL default '',
  `download_expires_days` int(10) NOT NULL default '0',
  `max_downloads_per_user` int(10) NOT NULL default '0',
  `membership_url_redirect` varchar(255) NOT NULL default '',
  `product_weight` float NOT NULL default '0',
  `manufacturer_id` int(10) NOT NULL default '1',
  `vendor_id` int(10) NOT NULL default '1',
  `post_purchase_module_id` int(10) NOT NULL default '0',
  `signup_module_id` int(10) NOT NULL default '0',
  `expires_module_id` int(10) NOT NULL default '0',
  `add_affiliate_group` int(10) NOT NULL default '0',
  `add_discount_group` int(10) NOT NULL default '0',
  `add_mailing_list` int(10) NOT NULL default '0',
  `product_views` int(25) NOT NULL default '0',
  `enable_product_inventory` enum('0','1','2') NOT NULL default '2',
  `product_inventory` int(10) NOT NULL default '0',
  `add_cart_for_price` enum('0','1') NOT NULL default '0',
  `login_for_price` enum('0','1') NOT NULL default '0',
  `min_quantity_ordered` int(10) NOT NULL default '0',
  `max_quantity_ordered` int(10) NOT NULL default '0',
  `product_overview` text NOT NULL,
  `product_description_1` text NOT NULL,
  `product_description_2` text NOT NULL,
  `no_commission` enum('0','1') NOT NULL default '0',
  `enable_custom_commission` enum('0','1') NOT NULL default '0',
  `product_sort` int(10) NOT NULL default '0',
  `product_title` varchar(255) NOT NULL default '',
  `product_meta_description` text NOT NULL default '',
  `add_to_membership` int(10) NOT NULL default '0',
  `product_sale_price` decimal(14,2) NOT NULL default '0.00',
  `tax_zone` int(10) NOT NULL default '0',
  `shipping_amount` decimal(14,2) NOT NULL default '0.00',
  PRIMARY KEY  (`product_id`),
  KEY `idx_product_name` (`product_name`),
  KEY `idx_product_keywords` (`product_keywords`),
  FULLTEXT KEY `ftx_product_name` (`product_name`,`product_keywords`,`product_overview`,`product_description_1`,`product_description_2`),
  FULLTEXT KEY `ftx_product_keywords` (`product_keywords`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_products_attributes`;
CREATE TABLE IF NOT EXISTS `jem_products_attributes` (
  `attribute_id` int(10) NOT NULL auto_increment,
  `attribute_status` enum('0','1') NOT NULL default '0',
  `attribute_name` varchar(255) NOT NULL default '',
  `attribute_type` varchar(25) NOT NULL default '',
  `attribute_required` enum('0','1') NOT NULL default '0',
  `attribute_options` text NOT NULL,
  `attribute_callback` int(10) NOT NULL default '0',
  PRIMARY KEY  (`attribute_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=2 ;



INSERT INTO `jem_products_attributes` (`attribute_id`, `attribute_status`, `attribute_name`, `attribute_type`, `attribute_required`, `attribute_options`, `attribute_callback`) VALUES
(1, '1', 'default  DO NOT DELETE', 'text', '0', '', 0);



DROP TABLE IF EXISTS `jem_products_categories`;
CREATE TABLE IF NOT EXISTS `jem_products_categories` (
  `category_id` int(10) NOT NULL auto_increment,
  `category_name` varchar(255) NOT NULL default '',
  `category_description` varchar(255) NOT NULL default '',
  `category_image` varchar(255) default NULL,
  `category_keywords` varchar(255) NOT NULL default '',
  `parent_id` int(10) NOT NULL default '0',
  `category_status` enum('0','1') NOT NULL default '0',
  `shipping_id` int(10) NOT NULL default '0',
  PRIMARY KEY  (`category_id`),
  KEY `parent_id_cat_id_zen` (`parent_id`,`category_id`),
  KEY `category_name` (`category_name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=2 ;


INSERT INTO `jem_products_categories` (`category_id`, `category_name`, `category_description`, `category_image`, `category_keywords`, `parent_id`, `category_status`, `shipping_id`) VALUES
(1, 'default', 'default - DO NOT DELETE', '', '', 0, '1', 0);



DROP TABLE IF EXISTS `jem_products_photos`;
CREATE TABLE IF NOT EXISTS `jem_products_photos` (
  `photo_id` int(10) NOT NULL auto_increment,
  `product_id` int(10) NOT NULL default '0',
  `photo_file_name` varchar(255) NOT NULL default '',
  `raw_name` varchar(255) NOT NULL default '',
  `file_ext` varchar(25) NOT NULL default '',
  `file_type` varchar(255) NOT NULL default '',
  `original_file_name` varchar(255) NOT NULL default '',
  `image_resized` enum('0','1') NOT NULL default '0',
  `product_default` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`photo_id`),
  KEY `member_id` (`product_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_products_reviews`;
CREATE TABLE IF NOT EXISTS `jem_products_reviews` (
  `id` int(10) NOT NULL auto_increment,
  `status` enum('0','1') NOT NULL default '0',
  `product_id` varchar(25) NOT NULL default '',
  `member_id` int(10) NOT NULL default '0',
  `date` varchar(25) NOT NULL default '',
  `ratings` enum('1','2','3','4','5') NOT NULL default '1',
  `comment` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `member_comment_id` (`member_id`),
  KEY `product_id` (`product_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_products_to_aff_groups`;
CREATE TABLE IF NOT EXISTS `jem_products_to_aff_groups` (
  `id` int(10) NOT NULL auto_increment,
  `product_id` int(10) NOT NULL default '0',
  `group_id` int(10) NOT NULL default '0',
  `commission_level_1` varchar(10) NOT NULL default '',
  `commission_level_2` varchar(10) NOT NULL default '',
  `commission_level_3` varchar(10) NOT NULL default '',
  `commission_level_4` varchar(10) NOT NULL default '',
  `commission_level_5` varchar(10) NOT NULL default '',
  `commission_level_6` varchar(10) NOT NULL default '',
  `commission_level_7` varchar(10) NOT NULL default '',
  `commission_level_8` varchar(10) NOT NULL default '',
  `commission_level_9` varchar(10) NOT NULL default '',
  `commission_level_10` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `product_id` (`product_id`,`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_products_to_attributes`;
CREATE TABLE IF NOT EXISTS `jem_products_to_attributes` (
  `product_id` int(10) NOT NULL default '0',
  `attribute_id` int(10) NOT NULL default '0',
  KEY `product_id` (`product_id`,`attribute_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;




DROP TABLE IF EXISTS `jem_products_to_categories`;
CREATE TABLE IF NOT EXISTS `jem_products_to_categories` (
  `product_id` int(10) NOT NULL default '0',
  `category_id` int(10) NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`category_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;



DROP TABLE IF EXISTS `jem_products_to_disc_groups`;
CREATE TABLE IF NOT EXISTS `jem_products_to_disc_groups` (
  `id` int(10) NOT NULL auto_increment,
  `product_id` int(10) NOT NULL default '0',
  `group_id` int(10) NOT NULL default '0',
  `amount` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `product_id` (`product_id`,`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_products_videos`;
CREATE TABLE IF NOT EXISTS `jem_products_videos` (
  `id` int(10) NOT NULL auto_increment,
  `product_id` int(10) NOT NULL default '0',
  `video_name` varchar(255) NOT NULL default '',
  `video_default` enum('0','1') NOT NULL default '0',
  `use_external_embed` enum('0','1') NOT NULL default '0',
  `video_code` text NOT NULL default '',
  `video_description` text NOT NULL default '',
  `video_image` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `product_id` (`product_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_regions`;
CREATE TABLE IF NOT EXISTS `jem_regions` (
  `region_id` int(11) NOT NULL auto_increment,
  `region_country_id` int(11) NOT NULL default '0',
  `region_code` varchar(32) NOT NULL default '',
  `region_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`region_id`),
  KEY `idx_zone_country_id_zen` (`region_country_id`),
  KEY `idx_zone_code_zen` (`region_code`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=191 ;



INSERT INTO `jem_regions` (`region_id`, `region_country_id`, `region_code`, `region_name`) VALUES
(1, 223, 'AL', 'Alabama'),
(2, 223, 'AK', 'Alaska'),
(3, 223, 'AS', 'American Samoa'),
(4, 223, 'AZ', 'Arizona'),
(5, 223, 'AR', 'Arkansas'),
(6, 223, 'AF', 'Armed Forces Africa'),
(7, 223, 'AA', 'Armed Forces Americas'),
(8, 223, 'AC', 'Armed Forces Canada'),
(9, 223, 'AE', 'Armed Forces Europe'),
(10, 223, 'AM', 'Armed Forces Middle East'),
(11, 223, 'AP', 'Armed Forces Pacific'),
(12, 223, 'CA', 'California'),
(13, 223, 'CO', 'Colorado'),
(14, 223, 'CT', 'Connecticut'),
(15, 223, 'DE', 'Delaware'),
(16, 223, 'DC', 'District of Columbia'),
(17, 223, 'FM', 'Federated States Of Micronesia'),
(18, 223, 'FL', 'Florida'),
(19, 223, 'GA', 'Georgia'),
(20, 223, 'GU', 'Guam'),
(21, 223, 'HI', 'Hawaii'),
(22, 223, 'ID', 'Idaho'),
(23, 223, 'IL', 'Illinois'),
(24, 223, 'IN', 'Indiana'),
(25, 223, 'IA', 'Iowa'),
(26, 223, 'KS', 'Kansas'),
(27, 223, 'KY', 'Kentucky'),
(28, 223, 'LA', 'Louisiana'),
(29, 223, 'ME', 'Maine'),
(30, 223, 'MH', 'Marshall Islands'),
(31, 223, 'MD', 'Maryland'),
(32, 223, 'MA', 'Massachusetts'),
(33, 223, 'MI', 'Michigan'),
(34, 223, 'MN', 'Minnesota'),
(35, 223, 'MS', 'Mississippi'),
(36, 223, 'MO', 'Missouri'),
(37, 223, 'MT', 'Montana'),
(38, 223, 'NE', 'Nebraska'),
(39, 223, 'NV', 'Nevada'),
(40, 223, 'NH', 'New Hampshire'),
(41, 223, 'NJ', 'New Jersey'),
(42, 223, 'NM', 'New Mexico'),
(43, 223, 'NY', 'New York'),
(44, 223, 'NC', 'North Carolina'),
(45, 223, 'ND', 'North Dakota'),
(46, 223, 'MP', 'Northern Mariana Islands'),
(47, 223, 'OH', 'Ohio'),
(48, 223, 'OK', 'Oklahoma'),
(49, 223, 'OR', 'Oregon'),
(50, 163, 'PW', 'Palau'),
(51, 223, 'PA', 'Pennsylvania'),
(52, 223, 'PR', 'Puerto Rico'),
(53, 223, 'RI', 'Rhode Island'),
(54, 223, 'SC', 'South Carolina'),
(55, 223, 'SD', 'South Dakota'),
(56, 223, 'TN', 'Tennessee'),
(57, 223, 'TX', 'Texas'),
(58, 223, 'UT', 'Utah'),
(59, 223, 'VT', 'Vermont'),
(60, 223, 'VI', 'Virgin Islands'),
(61, 223, 'VA', 'Virginia'),
(62, 223, 'WA', 'Washington'),
(63, 223, 'WV', 'West Virginia'),
(64, 223, 'WI', 'Wisconsin'),
(65, 223, 'WY', 'Wyoming'),
(66, 38, 'AB', 'Alberta'),
(67, 38, 'BC', 'British Columbia'),
(68, 38, 'MB', 'Manitoba'),
(69, 38, 'NF', 'Newfoundland'),
(70, 38, 'NB', 'New Brunswick'),
(71, 38, 'NS', 'Nova Scotia'),
(72, 38, 'NT', 'Northwest Territories'),
(73, 38, 'NU', 'Nunavut'),
(74, 38, 'ON', 'Ontario'),
(75, 38, 'PE', 'Prince Edward Island'),
(76, 38, 'QC', 'Quebec'),
(77, 38, 'SK', 'Saskatchewan'),
(78, 38, 'YT', 'Yukon Territory'),
(79, 81, 'NDS', 'Niedersachsen'),
(80, 81, 'BAW', 'Baden-Wrttemberg'),
(81, 81, 'BAY', 'Bayern'),
(82, 81, 'BER', 'Berlin'),
(83, 81, 'BRG', 'Brandenburg'),
(84, 81, 'BRE', 'Bremen'),
(85, 81, 'HAM', 'Hamburg'),
(86, 81, 'HES', 'Hessen'),
(87, 81, 'MEC', 'Mecklenburg-Vorpommern'),
(88, 81, 'NRW', 'Nordrhein-Westfalen'),
(89, 81, 'RHE', 'Rheinland-Pfalz'),
(90, 81, 'SAR', 'Saarland'),
(91, 81, 'SAS', 'Sachsen'),
(92, 81, 'SAC', 'Sachsen-Anhalt'),
(93, 81, 'SCN', 'Schleswig-Holstein'),
(94, 81, 'THE', 'Thringen'),
(95, 14, 'WI', 'Wien'),
(96, 14, 'NO', 'Niedersterreich'),
(97, 14, 'OO', 'Obersterreich'),
(98, 14, 'SB', 'Salzburg'),
(99, 14, 'KN', 'KÃ¤rtnen'),
(100, 14, 'ST', 'Steiermark'),
(101, 14, 'TI', 'Tirol'),
(102, 14, 'BL', 'Burgenland'),
(103, 14, 'VB', 'Voralberg'),
(104, 204, 'AG', 'Aargau'),
(105, 204, 'AI', 'Appenzell Innerrhoden'),
(106, 204, 'AR', 'Appenzell Ausserrhoden'),
(107, 204, 'BE', 'Bern'),
(108, 204, 'BL', 'Basel-Landschaft'),
(109, 204, 'BS', 'Basel-Stadt'),
(110, 204, 'FR', 'Freiburg'),
(111, 204, 'GE', 'Genf'),
(112, 204, 'GL', 'Glarus'),
(113, 204, 'JU', 'Graubnden'),
(114, 204, 'JU', 'Jura'),
(115, 204, 'LU', 'Luzern'),
(116, 204, 'NE', 'Neuenburg'),
(117, 204, 'NW', 'Nidwalden'),
(118, 204, 'OW', 'Obwalden'),
(119, 204, 'SG', 'St. Gallen'),
(120, 204, 'SH', 'Schaffhausen'),
(121, 204, 'SO', 'Solothurn'),
(122, 204, 'SZ', 'Schwyz'),
(123, 204, 'TG', 'Thurgau'),
(124, 204, 'TI', 'Tessin'),
(125, 204, 'UR', 'Uri'),
(126, 204, 'VD', 'Waadt'),
(127, 204, 'VS', 'Wallis'),
(128, 204, 'ZG', 'Zug'),
(129, 204, 'ZH', 'Zrich'),
(130, 195, 'A Corua', 'A Corua'),
(131, 195, 'Alava', 'Alava'),
(132, 195, 'Albacete', 'Albacete'),
(133, 195, 'Alicante', 'Alicante'),
(134, 195, 'Almeria', 'Almeria'),
(135, 195, 'Asturias', 'Asturias'),
(136, 195, 'Avila', 'Avila'),
(137, 195, 'Badajoz', 'Badajoz'),
(138, 195, 'Baleares', 'Baleares'),
(139, 195, 'Barcelona', 'Barcelona'),
(140, 195, 'Burgos', 'Burgos'),
(141, 195, 'Caceres', 'Caceres'),
(142, 195, 'Cadiz', 'Cadiz'),
(143, 195, 'Cantabria', 'Cantabria'),
(144, 195, 'Castellon', 'Castellon'),
(145, 195, 'Ceuta', 'Ceuta'),
(146, 195, 'Ciudad Real', 'Ciudad Real'),
(147, 195, 'Cordoba', 'Cordoba'),
(148, 195, 'Cuenca', 'Cuenca'),
(149, 195, 'Girona', 'Girona'),
(150, 195, 'Granada', 'Granada'),
(151, 195, 'Guadalajara', 'Guadalajara'),
(152, 195, 'Guipuzcoa', 'Guipuzcoa'),
(153, 195, 'Huelva', 'Huelva'),
(154, 195, 'Huesca', 'Huesca'),
(155, 195, 'Jaen', 'Jaen'),
(156, 195, 'La Rioja', 'La Rioja'),
(157, 195, 'Las Palmas', 'Las Palmas'),
(158, 195, 'Leon', 'Leon'),
(159, 195, 'Lleida', 'Lleida'),
(160, 195, 'Lugo', 'Lugo'),
(161, 195, 'Madrid', 'Madrid'),
(162, 195, 'Malaga', 'Malaga'),
(163, 195, 'Melilla', 'Melilla'),
(164, 195, 'Murcia', 'Murcia'),
(165, 195, 'Navarra', 'Navarra'),
(166, 195, 'Ourense', 'Ourense'),
(167, 195, 'Palencia', 'Palencia'),
(168, 195, 'Pontevedra', 'Pontevedra'),
(169, 195, 'Salamanca', 'Salamanca'),
(170, 195, 'Santa Cruz de Tenerife', 'Santa Cruz de Tenerife'),
(171, 195, 'Segovia', 'Segovia'),
(172, 195, 'Sevilla', 'Sevilla'),
(173, 195, 'Soria', 'Soria'),
(174, 195, 'Tarragona', 'Tarragona'),
(175, 195, 'Teruel', 'Teruel'),
(176, 195, 'Toledo', 'Toledo'),
(177, 195, 'Valencia', 'Valencia'),
(178, 195, 'Valladolid', 'Valladolid'),
(179, 195, 'Vizcaya', 'Vizcaya'),
(180, 195, 'Zamora', 'Zamora'),
(181, 195, 'Zaragoza', 'Zaragoza'),
(182, 13, 'ACT', 'Australian Capital Territory'),
(183, 13, 'NSW', 'New South Wales'),
(184, 13, 'NT', 'Northern Territory'),
(185, 13, 'QLD', 'Queensland'),
(186, 13, 'SA', 'South Australia'),
(187, 13, 'TAS', 'Tasmania'),
(188, 13, 'VIC', 'Victoria'),
(189, 13, 'WA', 'Western Australia'),
(190, 168, 'CAV', 'cavite');



DROP TABLE IF EXISTS `jem_reports`;
CREATE TABLE IF NOT EXISTS `jem_reports` (
  `report_id` int(10) NOT NULL auto_increment,
  `report_type` varchar(100) NOT NULL default '',
  `report_name` varchar(255) NOT NULL default '',
  `report_description` text NOT NULL,
  `graph_type` varchar(50) NOT NULL default '',
  `report_query` text NOT NULL,
  `enable_cron` enum('0','1') NOT NULL default '0',
  `cron_schedule` varchar(50) NOT NULL default '',
  `email_report` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`report_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_report_archive`;
CREATE TABLE IF NOT EXISTS `jem_report_archive` (
  `id` int(10) NOT NULL auto_increment,
  `report_date` varchar(25) NOT NULL default '',
  `report_name` varchar(255) NOT NULL default '',
  `report_html` longtext NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_security`;
CREATE TABLE IF NOT EXISTS `jem_security` (
  `ip` varchar(25) NOT NULL default '',
  `date` varchar(25) NOT NULL default '',
  `type` varchar(25) NOT NULL default '',
  `member_id` int(10) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



DROP TABLE IF EXISTS `jem_sessions`;
CREATE TABLE IF NOT EXISTS `jem_sessions` (
  `session_id` varchar(255) NOT NULL default '0',
  `ip_address` varchar(16) NOT NULL default '0',
  `user_agent` varchar(50) NOT NULL default '',
  `last_activity` int(10) unsigned NOT NULL default '0',
  `session_data` longtext,
  PRIMARY KEY  (`session_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;



DROP TABLE IF EXISTS `jem_settings`;
CREATE TABLE IF NOT EXISTS `jem_settings` (
  `settings_key` varchar(255) NOT NULL default '',
  `settings_value` text NOT NULL,
  `settings_module` varchar(50) NOT NULL default '',
  `settings_type` varchar(10) NOT NULL default 'text',
  `settings_group` int(10) default NULL,
  `settings_sort_order` int(10) NOT NULL default '0',
  `settings_function` varchar(50) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;




DROP TABLE IF EXISTS `jem_shopping_cart`;
CREATE TABLE IF NOT EXISTS `jem_shopping_cart` (
  `cid` int(10) NOT NULL auto_increment,
  `cart_id` varchar(255) NOT NULL default '',
  `product_id` int(10) NOT NULL default '0',
  `attributes` mediumtext NOT NULL,
  `quantity` int(10) NOT NULL default '0',
  `date` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`cid`),
  KEY `cart_id` (`cart_id`,`product_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `jem_support_categories`;
CREATE TABLE IF NOT EXISTS `jem_support_categories` (
  `support_category_id` int(10) NOT NULL auto_increment,
  `category_name` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`support_category_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=4 ;

--
-- Dumping data for table `jem_support_categories`
--

INSERT INTO `jem_support_categories` (`support_category_id`, `category_name`) VALUES
(1, 'sales'),
(2, 'support'),
(3, 'billing');



DROP TABLE IF EXISTS `jem_support_tickets`;
CREATE TABLE IF NOT EXISTS `jem_support_tickets` (
  `ticket_id` int(10) NOT NULL auto_increment,
  `ticket_parent` enum('0','1') NOT NULL default '1',
  `admin_response` enum('0','1') NOT NULL default '0',
  `parent_id` int(10) NOT NULL default '0',
  `member_id` int(10) NOT NULL default '0',
  `admin_id` int(10) NOT NULL default '0',
  `support_category_id` int(10) NOT NULL default '0',
  `ticket_status` enum('0','1') NOT NULL default '0',
  `ticket_priority` enum('0','1','2') NOT NULL default '1',
  `date_added` varchar(25) NOT NULL default '',
  `date_modified` varchar(25) NOT NULL default '',
  `ticket_subject` varchar(255) NOT NULL default '',
  `ticket_body` longtext NOT NULL,
  `uploaded_file` varchar(255) NOT NULL default '',
  `last_response_made` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ticket_id`),
  KEY `member_id` (`member_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_tax_zones`;
CREATE TABLE IF NOT EXISTS `jem_tax_zones` (
  `tax_zone_id` int(10) NOT NULL auto_increment,
  `tax_zone_name` varchar(255) NOT NULL default '',
  `tax_amount` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`tax_zone_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;



INSERT INTO `jem_tax_zones` (`tax_zone_id`, `tax_zone_name`, `tax_amount`) VALUES
(1, 'default - DO NOT DELETE', '0.00');

DROP TABLE IF EXISTS `jem_tracking`;
CREATE TABLE IF NOT EXISTS `jem_tracking` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `mid` int(10) NOT NULL,
  `url` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_tracking_referrals`;
CREATE TABLE IF NOT EXISTS `jem_tracking_referrals` (
  `id` int(10) NOT NULL auto_increment,
  `tid` int(10) NOT NULL,
  `mid` int(10) NOT NULL,
  `date` varchar(50) NOT NULL,
  `referrer` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;
					

DROP TABLE IF EXISTS `jem_traffic`;
CREATE TABLE IF NOT EXISTS `jem_traffic` (
  `traffic_id` int(25) NOT NULL auto_increment,
  `date` varchar(25) NOT NULL default '',
  `member_id` int(25) NOT NULL default '0',
  `tool_type` varchar(25) NOT NULL default '0',
  `tool_id` int(25) NOT NULL default '0',
  `referrer` text NOT NULL,
  `ip_address` varchar(25) NOT NULL default '',
  `user_agent` text NOT NULL,
  `os` varchar(50) NOT NULL default '',
  `browser` varchar(50) NOT NULL default '',
  `isp` text NOT NULL,
  `tracker` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`traffic_id`),
  KEY `member_id` (`member_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `jem_vendors`;
CREATE TABLE IF NOT EXISTS `jem_vendors` (
  `vendor_id` int(10) NOT NULL auto_increment,
  `vendor_name` varchar(255) NOT NULL default '',
  `vendor_contact_email` varchar(255) NOT NULL default '',
  `vendor_address` varchar(255) NOT NULL default '',
  `vendor_city` varchar(255) NOT NULL default '',
  `vendor_state` varchar(255) NOT NULL default '',
  `vendor_country` int(3) NOT NULL default '0',
  `vendor_zip` varchar(255) NOT NULL default '',
  `vendor_send_alert` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`vendor_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=2 ;



INSERT INTO `jem_vendors` (`vendor_id`, `vendor_name`, `vendor_contact_email`, `vendor_address`, `vendor_city`, `vendor_state`, `vendor_country`, `vendor_zip`, `vendor_send_alert`) VALUES
(1, 'default - DO NOT DELETE', '', '', '', '', 240, '', '1');



DROP TABLE IF EXISTS `jem_zones`;
CREATE TABLE IF NOT EXISTS `jem_zones` (
  `tax_zone_id` int(10) NOT NULL default '0',
  `country_id` int(10) NOT NULL default '0',
  `region_id` int(10) NOT NULL default '0',
  KEY `tax_zone_id` (`tax_zone_id`,`country_id`,`region_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;



INSERT INTO `jem_zones` (`tax_zone_id`, `country_id`, `region_id`) VALUES
(1, 0, 0);
