<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');

/*
|--------------------------------------------------------------------------
| Script Limits
|--------------------------------------------------------------------------
*/
$config['script_memory_limit'] = '64M';
$config['script_time_limit'] = '0';

/*
|--------------------------------------------------------------------------
| SSL settings
|--------------------------------------------------------------------------
*/

define('SSL_PUBLIC_AREA', false);
define('SSL_MEMBERS_AREA', false);
define('SSL_ADMIN_AREA', false);

/*
|--------------------------------------------------------------------------
| Folder and License Path
|--------------------------------------------------------------------------
*/
$config['base_license_domain_name'] = 'jemtest.com';
$config['base_physical_path'] = PUBPATH;
$config['base_folder_path'] = '/site53';
$config['base_domain_name'] = 'jemtest.com';
$config['base_subdomain_name'] = 'php53';

$config['base_url']	= 'http://' . $config['base_subdomain_name'] . '.' . $config['base_domain_name'] . $config['base_folder_path'];
$config['base_SSL_url'] = 'http://' . $config['base_subdomain_name'] . '.' . $config['base_domain_name'] . $config['base_folder_path'];

$config['auto_check_current_version'] = '1';

/*
|--------------------------------------------------------------------------
| Pagination Links
|--------------------------------------------------------------------------
*/
$config['pagination_links'] = 2;

/*
|--------------------------------------------------------------------------
| Images Path and Settings
|--------------------------------------------------------------------------
*/
$config['images_admins_dir'] = 'admins';
$config['images_products_dir'] = 'products';
$config['images_members_dir'] = 'members';
$config['images_banners_dir'] = 'banners';
$config['images_manufacturers_dir'] = 'manufacturers';
$config['images_product_categories_dir'] = 'products_categories';
$config['site_replication_folder'] = 'rep';
$config['images_maintain_ratio'] = true;
$config['images_thickbox_class'] = 'thickbox';
$config['images_quality'] = '100%';
$config['rss_image_height'] = '75';
$config['rss_image_width'] = '75';
$config['member_marketing_tool_ext'] = 'png';
$config['pragma_header_cache_control'] = false;
$config['category_path_separator'] = '/';
$config['disable_db_autosorting'] = false;
$config['maximum_recommended_products_profile_page'] = '25'; //the maximum number of products to show on the affiliate profile page


/*
|--------------------------------------------------------------------------
| URL Settings
|--------------------------------------------------------------------------
*/
$config['jrox_url_separator'] = 'dash'; //dash or underscore only
$config['tracker_unique_referrals_only'] = false;
/*
|--------------------------------------------------------------------------
| Member Settings
|--------------------------------------------------------------------------
*/
$config['member_min_username_length'] = '6';
$config['members_password_function'] = 'md5'; //md5, sha1, or mcrypt
$config['member_mass_email_throttle'] = '0';
$config['member_url_login_redirect'] = '';
$config['member_url_logout_redirect'] = '';
$config['member_require_membership_registration'] = '';
$config['member_hide_mailing_list_box'] = false;
$config['member_disable_registration_email'] = false;
$config['member_list_append_unsubscribe'] = true;
$config['member_enable_group_change_registration'] = false;
$config['member_enable_bilevel_affiliate_groups'] = false;

/*
|--------------------------------------------------------------------------
| Alert Settings
|--------------------------------------------------------------------------
*/

$config['cron_send_recurring_payment_info_email'] = true;

/*
|--------------------------------------------------------------------------
| Content Settings
|--------------------------------------------------------------------------
*/
$config['content_enable_javascript_code'] = false;

/*
|--------------------------------------------------------------------------
| Product Settings
|--------------------------------------------------------------------------
*/
$config['store_min_word_length_product_overview'] = '50';

/*
|--------------------------------------------------------------------------
| Links and Customization
|--------------------------------------------------------------------------
*/
$config['customizer_theme_customization_url'] = 'http://www.jrox.com/theme_customization/';
$config['customizer_license_ordering_url'] = 'http://www.jrox.com/buy/'; //order button
$config['customizer_admin_area_help_url'] = 'http://www.jrox.com/help/'; //admin help button
$config['customizer_admin_area_forum_url'] = 'http://forums.jrox.com/';
$config['customizer_admin_area_docs_url'] = 'http://www.jrox.com/docs/';
//$config['customizer_admin_area_videos_url'] = 'http://www.jrox.com/docs/videos/';
$config['customizer_admin_area_quick_start_url'] = 'http://www.jrox.com/docs/quick_start_guide/';
$config['customizer_member_area_help_url'] = 'http://www.jrox.com/docs/member_docs/'; //members help button


/*
|--------------------------------------------------------------------------
| Index File
|--------------------------------------------------------------------------
*/
$config['index_page'] = '';
$config['admin_index_page'] = '';
$config['checkout_index_page'] = '';

/*
|--------------------------------------------------------------------------
| URI PROTOCOL
|--------------------------------------------------------------------------
| 'AUTO'			Default - auto detects
| 'PATH_INFO'		Uses the PATH_INFO
| 'QUERY_STRING'	Uses the QUERY_STRING
| 'REQUEST_URI'		Uses the REQUEST_URI
| 'ORIG_PATH_INFO'	Uses the ORIG_PATH_INFO
|
*/
$config['uri_protocol']	= 'AUTO';


/*
|--------------------------------------------------------------------------
| Default Language
|--------------------------------------------------------------------------
*/
$config['language']	= 'english';

/*
|--------------------------------------------------------------------------
| Default Character Set
|--------------------------------------------------------------------------
*/
$config['charset'] = 'UTF-8'; //ISO-8859-1 UTF-8

/*
|--------------------------------------------------------------------------
| Error Logging Threshold
|--------------------------------------------------------------------------
*/
$config['log_threshold'] = '0';

/*
|--------------------------------------------------------------------------
| Error Logging Directory Path
|--------------------------------------------------------------------------
*/
$config['log_path'] = '';

/*
|--------------------------------------------------------------------------
| Date Format for Logs
|--------------------------------------------------------------------------
*/
$config['log_date_format'] = 'Y-m-d H:i:s';

/*
|--------------------------------------------------------------------------
| Cache Directory Path
|--------------------------------------------------------------------------
*/
$config['cache_path'] = '';

/*
|--------------------------------------------------------------------------
| Encryption Key
|--------------------------------------------------------------------------
*/

//CHANGING THIS WILL INVALIDATE CURRENT ENCRYPTED DATA!
$config['encryption_key'] = '3ee9ef20b83514128930f40574c4a6ac';

/*
|--------------------------------------------------------------------------
| Session Variables
|--------------------------------------------------------------------------
*/
$config['sess_cookie_name']			= 'jrox_session';
$config['sess_expiration']			= 60 * 60 * 24;
$config['sess_expiration_pub']		= 60 * 60 * 24;
$config['sess_expiration_cart']		= 60 * 60 * 24;

$config['sess_encrypt_cookie']		= FALSE;
$config['sess_use_database']		= TRUE;
$config['sess_table_name']			= 'sessions';
$config['sess_match_ip']			= FALSE;
$config['sess_match_useragent']		= TRUE;
$config['sess_time_to_update'] 		= 300;

/*
|--------------------------------------------------------------------------
| Cookie Related Variables
|--------------------------------------------------------------------------
*/

$config['aff_cookie_name']	= 'jrox_com';
$config['cookie_prefix']	= '';
$config['cookie_domain']	= '.jemtest.com';
$config['ssl_cookie_domain']	= '.jemtest.com';
$config['cookie_path']		= '/';

/*
|--------------------------------------------------------------------------
| Output Compression
|--------------------------------------------------------------------------
*/
$config['compress_output'] = FALSE;

/*
|--------------------------------------------------------------------------
| Host IP Lookup URL
|--------------------------------------------------------------------------
*/
$config['base_hostip_location_URL'] = 'http://api.hostip.info/get_html.php?ip=';
$config['base_hostip_lookup_URL'] = 'http://www.hostip.info/index.html?spip=';

/*
|--------------------------------------------------------------------------
| Master Time Reference
|--------------------------------------------------------------------------
*/
$config['time_reference'] = 'gmt';

/*
|--------------------------------------------------------------------------
| Do Not Edit Anything Below.  It May Cause Your Site To Be Unstable
|--------------------------------------------------------------------------
*/
$config['subclass_prefix'] = 'JROX_';
$config['enable_hooks'] = TRUE;
$config['permitted_uri_chars'] = 'a-z 0-9~%.:_-';
$config['enable_query_strings'] = FALSE;
$config['directory_trigger'] = 'd';
$config['controller_trigger'] = 'c';
$config['function_trigger'] = 'm';
$config['rewrite_short_tags'] = FALSE;
$config['global_xss_filtering'] = FALSE;
$config['url_suffix'] = '';
?>