<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - db_sort.php
| -------------------------------------------------------------------------     
| 
| This file determines default sorting of data and filtered input
|
*/

//number of years to show on reports
$config['dbr_total_report_years'] = '3';

//axis range fo reports
$config['dbr_y_axis_range'] = '50';

//data input to be filtered
$config['dbi_filter'] = array('reset', 'passconf', 'member_button', 'admin_button', 'send_welcome_email', 
							  'allowed_tags', 'product_button', 'jroxVerifyField','sponsor_required', 
							  'ship_option', 'jroxEnableShipping', 'affil_option', 'jroxEnableAffiliate', 
							  'jroxSubmitPForm', 'tos_check');

//to remove certain elements in the content 
$config['dbi_content_filter'] = array('&nbsp;' => '');

//arrays not to run through xss filter
$config['dbi_arrays'] = array();

//affiliate ad categories
$config['dbs_aac_column'] = 'cat_name'; 
$config['dbs_aac_order'] = 'ASC';

//email archive
$config['dbs_arc_column'] = 'id'; 
$config['dbs_arc_order'] = 'DESC';

//admin_users
$config['dbs_au_column'] = 'admin_id'; 
$config['dbs_au_order'] = 'ASC';

//members
$config['dbs_mm_column'] = 'member_id';
$config['dbs_mm_order'] = 'DESC';

//affiliate payments
$config['dbs_afp_column'] = 'id'; 
$config['dbs_afp_order'] = 'ASC';

//custom form fields
$config['dbs_cff_column'] = 'sort_order';
$config['dbs_cff_order'] = 'ASC';

//affiliate groups
$config['dbs_ag_column'] = 'tier';
$config['dbs_ag_order'] = 'ASC';

//discount groups
$config['dbs_dg_column'] = 'group_id';
$config['dbs_dg_order'] = 'ASC';

//manufacturers
$config['dbs_man_column'] = 'manufacturer_name';
$config['dbs_man_order'] = 'ASC';

//vendors
$config['dbs_ven_column'] = 'vendor_name';
$config['dbs_ven_order'] = 'ASC';

//product categories
$config['dbs_prc_column'] = 'category_id';
$config['dbs_prc_order'] = 'ASC';

//zones
$config['dbs_zon_column'] = 'tax_zone_id';
$config['dbs_zon_order'] = 'ASC';

//countries
$config['dbs_con_column'] = 'country_name';
$config['dbs_con_order'] = 'ASC';

//regions
$config['dbs_reg_column'] = 'region_id';
$config['dbs_reg_order'] = 'ASC';

//shipping
$config['dbs_shi_column'] = 'module_sort_order';
$config['dbs_shi_order'] = 'ASC';

//attributes
$config['dbs_att_column'] = 'attribute_id';
$config['dbs_att_order'] = 'ASC';

//kb articles
$config['dbs_kb_column'] = 'article_id';
$config['dbs_kb_order'] = 'ASC';

//products
$config['dbs_pro_column'] = 'product_sort'; //SET TO product_sort to use the sorting feature
$config['dbs_pro_order'] = 'ASC';

//themes
$config['dbs_the_column'] = 'theme_default';
$config['dbs_the_order'] = 'DESC';

//modules
$config['dbs_mod_column'] = 'module_type';
$config['dbs_mod_order'] = 'ASC';

//currencies
$config['dbs_cur_column'] = 'currency_id';
$config['dbs_cur_order'] = 'ASC';

//languages
$config['dbs_lng_column'] = 'name';
$config['dbs_lng_order'] = 'ASC';

//gateways
$config['dbs_pgw_column'] = 'module_sort_order';
$config['dbs_pgw_order'] = 'ASC';

//email templates
$config['dbs_emt_column'] = 'email_template_name';
$config['dbs_emt_order'] = 'ASC';

//content articles
$config['dbs_crt_column'] = 'article_id';
$config['dbs_crt_order'] = 'ASC';

//faq articles
$config['dbs_crt_column'] = 'article_id';
$config['dbs_crt_order'] = 'ASC';

//content categories
$config['dbs_coc_column'] = 'category_id';
$config['dbs_coc_order'] = 'ASC';

//support tickets
$config['dbs_stc_column'] = 'ticket_id';
$config['dbs_stc_order'] = 'DESC';

//banners
$config['dbs_bnr_column'] = 'sort_order';
$config['dbs_bnr_order'] = 'ASC';

//affiliate marketing
$config['dbs_afm_column'] = 'module_file_name';
$config['dbs_afm_order'] = 'ASC';

//mailing lists
$config['dbs_mll_column'] = 'mailing_list_id';
$config['dbs_mll_order'] = 'ASC';

//mailing lists users
$config['dbs_mlu_column'] = 'send_date';
$config['dbs_mlu_order'] = 'ASC';

//follow ups
$config['dbs_flo_column'] = 'sequence';
$config['dbs_flo_order'] = 'ASC';

//support categories
$config['dbs_spc_column'] = 'support_category_id';
$config['dbs_spc_order'] = 'ASC';

//coupons
$config['dbs_cou_column'] = 'coupon_id';
$config['dbs_cou_order'] = 'ASC';

//credits
$config['dbs_cre_column'] = 'id';
$config['dbs_cre_order'] = 'ASC';

//queue
$config['dbs_emq_column'] = 'send_date';
$config['dbs_emq_order'] = 'DESC';

//reviews
$config['dbs_rev_column'] = 'id';
$config['dbs_rev_order'] = 'DESC';

//content comments
$config['dbs_com_column'] = 'id';
$config['dbs_com_order'] = 'DESC';

//invoices
$config['dbs_inv_column'] = 'invoice_id';
$config['dbs_inv_order'] = 'DESC';

//commissions
$config['dbs_afc_column'] = 'comm_id';
$config['dbs_afc_order'] = 'DESC';

//invoice payments
$config['dbs_ivp_column'] = 'id';
$config['dbs_ivp_order'] = 'DESC';

//affiliate payments
$config['dbs_afp_column'] = 'id';
$config['dbs_afp_order'] = 'DESC';

//affiliate make payments
$config['dbs_amp_column'] = 'comm_id';
$config['dbs_amp_order'] = 'DESC';

//data import
$config['dbs_imp_column'] = 'module_name';
$config['dbs_imp_order'] = 'ASC';

//data export
$config['dbs_exp_column'] = 'module_name';
$config['dbs_exp_order'] = 'ASC';

//reports
$config['dbs_rep_column'] = 'module_name';
$config['dbs_rep_order'] = 'ASC';

//reports archive
$config['dbs_arc_column'] = 'id';
$config['dbs_arc_order'] = 'DESC';

//traffic
$config['dbs_trf_column'] = 'traffic_id';
$config['dbs_trf_order'] = 'DESC';

//tracking
$config['dbs_trc_column'] = 'id';
$config['dbs_trc_order'] = 'DESC';

//tracking referrals
$config['dbs_trr_column'] = 'id';
$config['dbs_trr_order'] = 'DESC';

//kb categories
$config['dbs_kbg_column'] = 'category_id';
$config['dbs_kbg_order'] = 'ASC';

/*
for public side sorting
*/

//faq articles
$config['pub_dbs_faq_column'] = 'content_title';
$config['pub_dbs_faq_order'] = 'ASC';

//manufacturers
$config['pub_dbs_man_column'] = 'manufacturer_name';
$config['pub_dbs_man_order'] = 'ASC';

//products
$config['pub_dbs_pro_column'] = 'product_sort';
$config['pub_dbs_pro_order'] = 'ASC';

//product reviews
$config['pub_dbs_rev_column'] = 'id';
$config['pub_dbs_rev_order'] = 'DESC';

//product categories
$config['pub_dbs_cat_column'] = 'category_name';
$config['pub_dbs_cat_order'] = 'ASC';

//kb categories
$config['pub_kb_cat_column'] = 'category_name';
$config['pub_kb_cat_order'] = 'ASC';

/*
for members side sorting
*/

//members content
$config['mem_dbs_cnt_column'] = 'date_published';
$config['mem_dbs_cnt_order'] = 'DESC';

//members coupons
$config['mem_dbs_cou_column'] = 'coupon_id';
$config['mem_dbs_cou_order'] = 'DESC';

//members memberships
$config['mem_dbs_mem_column'] = 'product_name';
$config['mem_dbs_mem_order'] = 'ASC';

//members downloads
$config['mem_dbs_dow_column'] = 'product_name';
$config['mem_dbs_dow_order'] = 'ASC';

//members traffic
$config['mem_dbs_tff_column'] = 'traffic_id';
$config['mem_dbs_tff_order'] = 'DESC';

//members tickets
$config['mem_dbs_sup_column'] = 'ticket_id';
$config['mem_dbs_sup_order'] = 'DESC';

//members reports
$config['mem_dbs_rep_column'] = 'module_name';
$config['mem_dbs_rep_order'] = 'ASC';

//members tools
$config['mem_dbs_afm_column'] = 'module_name';
$config['mem_dbs_afm_order'] = 'ASC';
?>