<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
| 	www.your-site.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	http://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are two reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['scaffolding_trigger'] = 'scaffolding';
|
| This route lets you set a "secret" word that will trigger the
| scaffolding feature for added security. Note: Scaffolding must be
| enabled in the controller in which you intend to use it.   The reserved 
| routes must come before any wildcard or regular expression routes.
|
*/

define('PROFILE_ROUTE', 'profiles');
$route[PROFILE_ROUTE.'/([a-z0-9A-Z]+)'] = "profiles/users/$1";

//CONTENT ROUTING
define('CONTENT_ROUTE', 'content');

//CONTENT CATEGORIES ROUTING
define('CONTENT_CATEGORIES_ROUTE', 'content_categories');
$route[CONTENT_CATEGORIES_ROUTE.'/:any'] = "content_categories/$1";

//FAQ ROUTING
define('FAQ_ROUTE', 'faq');

//KB ROUTING
define('KB_ROUTE', 'kb');

//FAQ CATEGORIES
define('FAQ_CATEGORIES_ROUTE', 'faq_categories');
$route[FAQ_CATEGORIES_ROUTE.'/:any'] = "faq_categories/$1";

//AFFILIATE ROUTING
define('AFFILIATE_ROUTE', 'affiliates');
$route[AFFILIATE_ROUTE.'/:any'] = "refer/id/$1";

//AFFILIATE TOOLS ROUTING
define('AFF_TOOLS_ROUTE', 'aff_tools');
$route[AFF_TOOLS_ROUTE.'/:any'] = "refer/id/$1";

//URI ROUTING OPTION
define('AFF_ROUTE_OPTION', 'replication'); //change to regular or replication

//ADMIN ROUTING
define('ADMIN_ROUTE', 'admin');
$route[ADMIN_ROUTE] = 'admin/dashboard';

//REPLICATION ROUTING
define('REPLICATION_ROUTE', 'reps');
$route[REPLICATION_ROUTE.'/:any'] = "reps/id/$1";

//ROTATOR ROUTING
$route['rotator/:any'] = "rotator/rotate/$1/$2";

//MEMBERS ROUTING
define('MEMBERS_ROUTE', 'members');
$route[MEMBERS_ROUTE] = 'members/dashboard';

//404 ERROR ROUTING
define('ERROR_404_ROUTE', 'error');

//REGISTRATION ROUTE
$route['registration'] = "checkout/registration";
$route['registration/:any'] = "checkout/registration/$1";

//EMAIL PAYMENT LINK
$route['payments/make_payment/:any'] = 'login/general';

//REPORT ROUTE
$route[MEMBERS_ROUTE . '/([a-z0-9A-Z_]+)/report/([0-9]+)/([0-9]+)'] = "modules/$1/generate/$2/$3";

//PRODUCTS
define('PRODUCTS_ROUTE', 'products');

//MANUFACTURERS
define('MANUFACTURERS_ROUTE', 'manufacturers');
$route[MANUFACTURERS_ROUTE.'/:any'] = "manufacturers/$1";

//PRODUCT CATEGORIES ROUTING
define('CATEGORIES_ROUTE', 'product_categories');
$route[CATEGORIES_ROUTE.'/:any'] = "product_categories/index/$1";

//$route['brands'] = "manufacturers/index/$1";

//STORE HOME 
define('STORE_ROUTE', 'store');
$route[STORE_ROUTE] = "home/index/store";

//TRACKING 
$route['track/:any'] = "track/index/$1";

//DEFAULT ROUTES
$route['default_controller'] = "home";

$route['scaffolding_trigger'] = "dixlaerox2882jd92u8d43qadf82dd9aj2jd9a2j23jd8s";

?>