<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - affiliate_groups.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to manage groups
|
*/

class Affiliate_Groups extends Admin_Controller {
	
	function __construct()
	{
		parent::Admin_Controller();	
		
		//load groups model
		$this->load->model('groups_model');
		
		//load css body style
		$this->config->set_item('css_body', 'DE');
		
		//create pagination links		
		$this->config->set_item('uri', ADMIN_ROUTE. '/' . $this->uri->segment(2) . '/table');

	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		//redirect to default view
		redirect(ADMIN_ROUTE . '/affiliate_groups/view_groups');
	}
	
	// ------------------------------------------------------------------------
	
	function add_group()
	{
		/*
		| -----------------------------------------
		| add a new group
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');

		//set page title
		$data['page_title'] = $this->lang->line('add_affiliate_group');
		$data['submit_url'] = jrox_admin_url().'affiliate_groups/add_group';
		$data['update_link'] = 'affiliate_groups';
		$data['add_link'] = 'add_affiliate_group';
		
		$this->validation->group_id_redirect = '';
		$this->validation->group_id = '';
		
		//get mailing lists
		$this->load->model('mailing_lists_model');
		$lists = $this->mailing_lists_model->_get_all_mailing_lists();
		$data['lists'] = format_array($lists, 'mailing_list_id', 'mailing_list_name', true);

		//run admin validation check
		if ($this->_check_group() == false)
		{		
			//reload add group form
			if (empty($_POST))
			{
				//load template
				load_form('admin', 'tpl_adm_manage_affiliate_group', $data);
			}
			else
			{				
				//ajax form
				echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			}		
		}
		else
		{	
			//add the group into db
			$data = $this->groups_model->_add_affiliate_group();		
			
			//set flash data
			//$this->session->set_flashdata('success', $this->lang->line('add_group_success'));
			
			//ajax message
			echo '<div class="success" onclick="self.parent.location.reload(true);" style="cursor:pointer;">' .$this->lang->line('affiliate_group') . ' ' . $data . ' ' . $this->lang->line('added_successfully') . '. ' . $this->lang->line('click_to_close_or_add') . '</div>';			
			exit();	
			
			//redirect to admin details form
			/*echo '<script>self.parent.location.reload(true);</script>';*/
		}		
	}
	
	// ------------------------------------------------------------------------
	
	function delete_group()
	{
		/*
		| --------------------------------------------
		| delete the group from the db
	    | --------------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		if ($this->groups_model->_delete_aff_group((int)($this->uri->segment(4))))
		{
			//redirect if deleting from ajax table	
			if ($this->uri->segment(5) == 2)
			{
				redirect(ADMIN_ROUTE . '/affiliate_groups/table/' . $this->config->item('cache_bx') . '/' . $this->uri->segment(7,0) . '/' . $this->uri->segment(8,0) . '/' . $this->uri->segment(9,0) . '/' . $this->uri->segment(10,0) . '/' . $this->uri->segment(11,0));
			}
			else
			{
				echo '<script>self.parent.location.reload(true);</script>';		
			}	
		}
		else
		{
			redirect(ADMIN_ROUTE . '/affiliate_groups/view_groups');
		}
	}
	
	// ------------------------------------------------------------------------
	
	function view_groups()
	{
		/*
		| -----------------------------------------
		| view groups
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//set page title
		$data['page_title'] = $this->lang->line('view_affiliate_groups');
		$data['sub_title'] = $this->lang->line('manage_affiliate_groups');
		$data['add_link'] = 'add_affiliate_group';
		$data['update_link'] = 'affiliate_groups';
		
		$data['offset'] = 0;
		$data['sort_column'] = 0;
		$data['sort_order'] = 0;
		$data['next_sort_order'] = $this->uri->segment(6) == 'DESC' ? 'ASC' : 'DESC';
		$data['sort_header'] = $data['uri'] .'/' . $this->config->item('cache_bx') . '/' . $data['offset'] . '/' . $data['next_sort_order'];
		
		//check if there are any sql wheres
		$data['where_column'] = $this->uri->segment(4,0);
		$data['where_value'] =  $this->uri->segment(5,0);
		
		$data['groups_table'] = 'affiliate_groups-table-' . $data['cache_bx'] . '-' .$data['offset'] . '-' . $data['sort_order'] . '-' . $data['sort_column'] . '-' . $data['where_column'] . '-' . $data['where_value'];
		
		$data['height'] = '500';
		$data['width'] = '400';
		
		//load template
		load_admin_tpl('admin', 'tpl_adm_manage_groups', $data);	
	}
	
	// ------------------------------------------------------------------------
	
	function table()
	{	
		/*
		| ---------------------
		| get groups via ajax
		| ---------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//check for offset and sort order
		$data['offset'] = $this->uri->segment(5, 0);
		$data['sort_column'] = $this->uri->segment(7, 0);
		$data['sort_order'] = $this->uri->segment(6, 0);
		$data['next_sort_order'] = $this->uri->segment(6) == 'DESC' ? 'ASC' : 'DESC';
		$data['sort_header'] = $data['uri'] .'/' . $this->config->item('cache_bx') . '/' . $data['offset'] . '/' . $data['next_sort_order'];
		$data['sort_name'] = 'aff_group_name';
		$data['header_name'] = 'affiliate_groups';
		$data['update_link'] = 'affiliate_groups';
		$data['height'] = '500';
		$data['width'] = '400';
		
		//check if there are any sql wheres
		$data['where_column'] = $this->uri->segment(4,0);
		$data['where_value'] =  $this->uri->segment(5,0);
		
		//get groups
		$row = $this->groups_model->_get_affiliate_groups($this->session->userdata('per_page'), $data['offset'], $data['sort_column'], $data['sort_order']);
		
		
		//add the data to the array
		$data['groups'] = $row;
		
		//set pagination
		$data['pagination'] = $this->db_validation_model->_set_pagination($data['uri'], 'affiliate_groups', $this->session->userdata('per_page'), 5, $data['sort_order'], $data['sort_column']);
		
		//load template
		load_admin_tpl('admin', 'tpl_adm_groups_table', $data, false, false);

	
	}
	
	// ------------------------------------------------------------------------
	
	
	function update_group()
	{
		/*
		| -----------------------------------------
		| add a new group
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');

		//set page title
		$data['page_title'] = $this->lang->line('update_affiliate_group');
		$data['submit_url'] = jrox_admin_url().'affiliate_groups/update_group';
		$data['add_link'] = 'update_affiliate_group';
		$data['update_link'] = 'affiliate_groups';
		$data['groups_table'] = 'affiliate_groups-table';
		
		$this->validation->group_id_redirect = '<input type="hidden" id="group_id" name="group_id" value="' . (int)$this->uri->segment(4) . '" />';
		$this->validation->group_id = $this->uri->segment(4);
		
		//get mailing lists
		$this->load->model('mailing_lists_model');
		$lists = $this->mailing_lists_model->_get_all_mailing_lists();
		$data['lists'] = format_array($lists, 'mailing_list_id', 'mailing_list_name', true);
		
		//run admin validation check
		if ($this->_check_group() == false)
		{		
			//reload add group form
			if (empty($_POST))
			{
				$mdata = $this->groups_model->_get_aff_group_details((int)$this->uri->segment(4));
				
				if (!empty($mdata))
				{	
					foreach ($mdata[0] as $key => $value)
					{
						$this->validation->$key = $value;
					}
					
					//load template
					load_form('admin', 'tpl_adm_manage_affiliate_group', $data);
				}
				else
				{
					//load add member page
					redirect(ADMIN_ROUTE . '/affiliate_groups/view_groups');
					exit();
				}
							
			}
			else
			{				
				//ajax form
				echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			}		
		}
		else
		{	
			//add the group into db
			
			$data = $this->groups_model->_update_affiliate_group((int)$this->uri->segment(4));	
			
			//set flash data
			//$this->session->set_flashdata('success', $this->lang->line('add_group_success'));
			
			//ajax message
			echo '<div class="success" onclick="self.parent.location.reload(true);" style="cursor:pointer;">' . $this->lang->line('update_group_success') . '. ' . $this->lang->line('click_to_continue') . '</div>';		
			exit();	
			
			//redirect to admin details form
			/*echo '<script>self.parent.location.reload(true);</script>';*/
		}		
	}
	
	// ------------------------------------------------------------------------
	
	function update_groups()
	{
		/*
		| ---------------------------
		| mass update group tiers
		| ---------------------------
		*/
	
		if ($this->_check_tiers() == true)
		{	
			$this->groups_model->_change_aff_group_status();
			
			//set flash data
			$this->session->set_flashdata('success', $this->lang->line('add_group_success'));
			echo '<script>self.parent.location.reload(true);</script>';	
		}
		else
		{
			echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			exit();
		}
	}
	
	// ------------------------------------------------------------------------
	
	/*
	| -------------------------------------------------------------------------
	| supporting functions - these are used to support the main functions above
	| -------------------------------------------------------------------------
	*/

	// ------------------------------------------------------------------------	
	
	function _check_tiers()
	{
		$data = $this->db_validation_model->_clean_data($_POST);
	
		foreach ($data as $k => $v)
		{
			if (strstr($k, "group") == true) 
			{
				$rules[$k] = 'trim|required|numeric';
				$fields[$k] = $k ;
			}
		}
		
		$this->validation->set_rules($rules);
		
		//repopulate form
		$this->validation->set_fields($fields);
			
		if ($this->validation->run() == FALSE)	
		{
			return false;
		}
		
		return true;
	}
	
	// ------------------------------------------------------------------------	
	
	function _check_aff_number($level, $i)
	{
		if (preg_match('/^[\/.0-9]+$/', $level) == 0 ) 
		{
			$this->validation->set_message('_check_aff_number', $this->lang->line('number_forward_slash_only'));
			return false;
		}
	}
	
	// ------------------------------------------------------------------------	
	
	function _check_group()
	{
		//set form validation rules
		
		$rules['aff_group_name'] = 'trim|required|min_length[2]|max_length[50]';
		$rules['aff_group_description'] = 'trim|max_length[255]';
		$rules['commission_type'] = 'trim|required';
		$rules['tier'] = 'trim|numeric';
	
		for ($i=1;$i<=$this->config->item('sts_affiliate_commission_levels');$i++)
		{
			$level = 'commission_level_' . $i;
			
			if ($this->config->item('member_enable_bilevel_affiliate_groups') == true)
			{
				$rules[$level] = 'trim|required|callback__check_aff_number';
			}
			else
			{
				$rules[$level] = 'trim|required|numeric';	
			}
		}	
		
		$left = $this->config->item('sts_affiliate_commission_levels') + 1;
		for ($j=$left;$j<10;$j++)
		{
			$slevel = 'commission_level_' . $j;
			$rules[$slevel] = 'trim';
		}	
		
		$this->validation->set_rules($rules);

		//repopulate form

		$fields['aff_group_name'] = $this->lang->line('group_name');
		$fields['aff_group_description'] = $this->lang->line('group_description');
		$fields['commission_type'] = $this->lang->line('commission_type');
		$fields['tier'] = $this->lang->line('tier');
		for ($k=1;$k<=10;$k++)
		{
			$level = 'commission_level_' . $k;
			$fields[$level] = $this->lang->line($level);
		}	
		
		$this->validation->set_fields($fields);
			
		if ($this->validation->run() == FALSE)	
		{
			return false;
		}
		
		return true;
		
	}
	
	// ------------------------------------------------------------------------
}
?>