<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - coupons.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to manage coupons
|
*/

class coupons extends Admin_Controller {
	
	function __construct()
	{
		parent::Admin_Controller();	
		
		//load coupons model
		$this->load->model('coupons_model');
		
		//load css body style
		$this->config->set_item('css_body', 'GJ');
		
		//create pagination links		
		$this->config->set_item('uri', ADMIN_ROUTE. '/' . $this->uri->segment(2) . '/table');

	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		//redirect to default view
		redirect(ADMIN_ROUTE . '/coupons/view_coupons');
	}
	
	// ------------------------------------------------------------------------
	
	function add_coupon()
	{
		/*
		| -----------------------------------------
		| add a new coupon
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');

		//set page title
		$data['page_title'] = $this->lang->line('add_coupon');
		$data['submit_url'] = jrox_admin_url().'coupons/add_coupon';
		$data['update_link'] = 'coupons';
		$data['add_link'] = 'add_coupon';
		
		$fdate = explode(':', $this->config->item('sts_admin_date_format'));
		$data['curdate'] = $fdate[0];
		
		//run admin validation check
		if ($this->_check_coupon() == false)
		{		
			//reload add coupon form
			if (empty($_POST))
			{
				$this->validation->coupon_start_date = date($fdate[1], time());
				$this->validation->coupon_expire_date = date($fdate[1], time() + (60 * 60 * 24 * 30));
				
				//load template
				load_admin_tpl('admin', 'tpl_adm_manage_coupon', $data);
			}
			else
			{				
				//ajax form
				echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			}		
		}
		else
		{	
			//add the coupon into db
			
			$data = $this->coupons_model->_add_coupon($_POST);		

			//echo ajax message
			$this->session->set_flashdata('success', $this->lang->line('add_coupon_success'));
			echo '<script>window.location = "' . jrox_admin_url().'coupons/update_coupon/' . $data . '"</script>';
			

		}		
	}
	
	// ------------------------------------------------------------------------
	
	function delete_coupon()
	{
		/*
		| --------------------------------------------
		| delete the coupon from the db
	    | --------------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		if ($this->coupons_model->_delete_coupon((int)($this->uri->segment(4))))
		{
			//redirect if deleting from ajax table	
			if ($this->uri->segment(5) == 2)
			{
				redirect(ADMIN_ROUTE . '/coupons/table/' . $this->config->item('cache_bx') . '/' . $this->uri->segment(7,0) . '/' . $this->uri->segment(8,0) . '/' . $this->uri->segment(9,0) . '/' . $this->uri->segment(10,0) . '/' . $this->uri->segment(11,0));
			}
			else
			{
				echo '<script>self.parent.location.reload(true);</script>';		
			}	
		}
		else
		{
			redirect(ADMIN_ROUTE . '/coupons/view_coupons');
		}
	}
	
	// ------------------------------------------------------------------------
	
	function view_coupons()
	{
		/*
		| -----------------------------------------
		| view coupons
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//set page title
		$data['page_title'] = $this->lang->line('view_coupons');
		$data['height'] = '530';
		$data['width'] = '400';
		
		$data['offset'] = 0;
		$data['sort_column'] = 0;
		$data['sort_order'] = 0;
		$data['next_sort_order'] = $this->uri->segment(6) == 'DESC' ? 'ASC' : 'DESC';
		$data['sort_header'] = $data['uri'] .'/' . $this->config->item('cache_bx') . '/' . $data['offset'] . '/' . $data['next_sort_order'];
		
		//check if there are any sql wheres
		$data['where_column'] = $this->uri->segment(4,0);
		$data['where_value'] =  $this->uri->segment(5,0);
		
		//load template
		load_admin_tpl('admin', 'tpl_adm_manage_coupons', $data);	
	}
	
	// ------------------------------------------------------------------------
	
	function table()
	{	
		/*
		| ---------------------
		| get coupons via ajax
		| ---------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//check for offset and sort order
		$data['offset'] = $this->uri->segment(5, 0);
		$data['sort_column'] = $this->uri->segment(7, 0);
		$data['sort_order'] = $this->uri->segment(6, 0);
		$data['next_sort_order'] = $this->uri->segment(6) == 'DESC' ? 'ASC' : 'DESC';
		$data['sort_header'] = $data['uri'] .'/' . $this->config->item('cache_bx') . '/' . $data['offset'] . '/' . $data['next_sort_order'];
		$data['height'] = '530';
		$data['width'] = '400';
		
		//get sql wheres
		$data['where_column'] = $this->uri->segment(8,0);
		$data['where_value'] =  $this->uri->segment(9,0);
		
		//get coupons
		$row = $this->coupons_model->_get_coupons($this->session->userdata('per_page'), $data['offset'], $data['sort_column'], $data['sort_order']);

	 
		//add the data to the array
		$data['coupons'] = $row;	
		
		//set pagination
		$data['pagination'] = $this->db_validation_model->_set_pagination($data['uri'], 'coupons', $this->session->userdata('per_page'), 5, $data['sort_order'], $data['sort_column']);
		
		//load template
		load_admin_tpl('admin', 'tpl_adm_coupons_table', $data, false, false);

	
	}
	
	// ------------------------------------------------------------------------
	
	
	function update_coupon()
	{
		/*
		| -----------------------------------------
		| add a new coupon
		| -----------------------------------------
		*/

		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//set page title
		$data['page_title'] = $this->lang->line('update_coupon');
		$data['submit_url'] = jrox_admin_url().'coupons/update_coupon/' . (int)$this->uri->segment(4);
		$data['add_link'] = 'update_coupon';
		$data['update_link'] = 'coupons';
		
		//format date
		$fdate = explode(':', $this->config->item('sts_admin_date_format'));
		$data['curdate'] = $fdate[0];
		
		//run admin validation check
		if ($this->_check_coupon() == false)
		{		
			//reload add coupon form
			if (empty($_POST))
			{
				$mdata = $this->coupons_model->_get_coupon_details((int)$this->uri->segment(4));
				
				if (!empty($mdata))
				{	
					foreach ($mdata as $key => $value)
					{
						$this->validation->$key = $value;
					}
					
					//format date
					$this->validation->coupon_start_date = date($fdate[1], $mdata['coupon_start_date']);
					$this->validation->coupon_expire_date = date($fdate[1], $mdata['coupon_expire_date']);
					
					//get member_id 
					if (!empty($mdata['member_id']))
					{
						$member = $this->db_validation_model->_get_details('members', 'username', 'member_id', $mdata['member_id']);
						$this->validation->assign_to_member = $member[0]['username'];
					}
								
					//load template
					load_admin_tpl('admin', 'tpl_adm_manage_coupon', $data);
				}
				else
				{
					//load add coupon page
					redirect(ADMIN_ROUTE . '/coupons/view_coupons');
					exit();
				}
							
			}
			else
			{				
				//ajax form
				echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			}		
		}
		else
		{	
			//update the coupon into db
			if ($this->coupons_model->_update_coupon((int)$this->uri->segment(4)))
			{
				//echo ajax message
				$this->session->set_flashdata('success', $this->lang->line('update_coupon_success'));
				echo '<script>window.location = "' . jrox_admin_url().'coupons/update_coupon/' . $this->uri->segment(4) . '"</script>';
			}
		}		
	}
	
	// ------------------------------------------------------------------------
	
	function update_status()
	{
		/*
		| -----------------------------------------
		| change the status of the product
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
	
		//run change status function
		if ($this->db_validation_model->_change_status_field('coupons', 'coupon_id', (int)$this->uri->segment(4), 'status'))
		{
			//redirect if deleting from ajax table	
			if ($this->uri->segment(5) == 2)
			{
				redirect(ADMIN_ROUTE . '/coupons/table/' . $this->config->item('cache_bx') . '/' . $this->uri->segment(7,0) . '/' . $this->uri->segment(8,0) . '/' . $this->uri->segment(9,0) . '/' . $this->uri->segment(10,0) . '/' . $this->uri->segment(11,0));
			}
			else
			{
				//set flash data
				$this->session->set_flashdata('success', $this->lang->line('update_coupon_success'));
				
				redirect(ADMIN_ROUTE . '/coupons/view_coupons');
			}
		}	
	}
	
	// ------------------------------------------------------------------------
	
	/*
	| -------------------------------------------------------------------------
	| supporting functions - these are used to support the main functions above
	| -------------------------------------------------------------------------
	*/
	
	// ------------------------------------------------------------------------	
	
	function _check_coupon()
	{
		//set form validation rules
		
		$rules['status'] = 'trim|required|integer';
		$rules['coupon_type'] = 'trim|required';
		
		if ($this->uri->segment(3) == 'update_coupon')
		{
			
			$rules['coupon_code'] = 'trim|required|min_length[5]|max_length[25]|callback__check_coupon_code_update';
		}
		else
		{
			$rules['coupon_code'] = 'trim|required|min_length[5]|max_length[25]|callback__check_coupon_code_add';
		}
		
		
		$rules['coupon_amount'] = 'trim|required|numeric';
		$rules['coupon_minimum_order'] = 'trim|numeric';
		$rules['coupon_start_date'] = 'trim|required';
		$rules['coupon_expire_date'] = 'trim|required';
		$rules['uses_per_coupon'] = 'trim|integer';

		$rules['assign_to_member'] = 'trim|strtolower|callback__check_username';
		$rules['coupon_uses'] = 'trim|integer';
		$rules['coupon_product_type'] = 'trim|required|integer';
		
		$this->validation->set_rules($rules);

		//repopulate form

		$fields['status'] = $this->lang->line('status');
		$fields['coupon_type'] = $this->lang->line('coupon_type');
		$fields['coupon_code'] = $this->lang->line('coupon_code');
		$fields['coupon_amount'] = $this->lang->line('coupon_amount');
		$fields['coupon_minimum_order'] = $this->lang->line('coupon_minimum_order');
		$fields['coupon_start_date'] = $this->lang->line('coupon_start_date');
		$fields['coupon_expire_date'] = $this->lang->line('coupon_expire_date');
		$fields['uses_per_coupon'] = $this->lang->line('uses_per_coupon');

		$fields['assign_to_member'] = $this->lang->line('assign_to_member');
		$fields['coupon_uses'] = $this->lang->line('coupon_uses');
		$fields['coupon_product_type'] = $this->lang->line('coupon_product_type');
		
		$this->validation->set_fields($fields);
			
		if ($this->validation->run() == FALSE)	
		{
			return false;
		}
		
		return true;
		
	}
	
	// ------------------------------------------------------------------------
	
	function _check_coupon_code_add()
	{
		if ($this->db_validation_model->_validate_field('coupons', 'coupon_code', $this->validation->coupon_code))
		{
			$this->validation->set_message('_check_coupon_code_add', $this->lang->line('coupon_code_taken'));
			return false;
		}
	}
	
	// ------------------------------------------------------------------------
	
	function _check_coupon_code_update()
	{
		if ($this->db_validation_model->_validate_field('coupons', 'coupon_code', $this->validation->coupon_code, 'coupon_code', $this->validation->coupon_code))
		{
			$this->validation->set_message('_check_coupon_code_update', $this->lang->line('coupon_code_taken'));
			return false;
		}
	}
	
	// ------------------------------------------------------------------------
	
	function _check_username()
	{
		if ($this->db_validation_model->_validate_field('members', 'username', $this->validation->assign_to_member) == false)
		{
			
			$this->validation->set_message('_check_username', $this->lang->line('invalid_member_username'));
			return false;
		}
	}
	
	// ------------------------------------------------------------------------
}
?>