<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - dashboard.php
| -------------------------------------------------------------------------     
| 
| This controller file is used for the admin dashboard page
|
*/

class Dashboard extends Admin_Controller {
	
	function __construct()
	{
		parent::Admin_Controller();	
		
		//load dashboard model
		$this->load->model('dashboard_model', 'dash');
		
		//load css body style
		$this->config->set_item('css_body', 'AB');
	}
	
	function index()
	{
		// this function shows the admin login form
		$data = $this->security_model->_load_config('admin');
		
		//set title
		$data['page_title'] = $this->lang->line('admin_dashboard');
		
		//get RSS feed
		$data['jrox_rss'] = $this->dash->_get_jrox_rss();
		
		//get latest tweets
		//$data['jrox_tweets'] = $this->dash->_get_jrox_tweets();
		if ($_SERVER['SERVER_PORT'] != '443')
		{
			$data['jrox_tweets'] = '1';	
		}
		
		//get num options
		$this->load->helper('number');
		$data['num_options'] = get_default_currency($data['sts_store_default_currency']);
	
		$data['monthly_payments'] = $this->dash->_get_monthly_payments();
		
		$data['monthly_signups'] = $this->dash->_get_monthly_signups();
		
		$data['monthly_tickets'] = $this->dash->_get_monthly_tickets();
		
		$days = date('t') - (date('t') - date('d'));
		
		$data['monthly_avg'] = $data['monthly_payments'] / $days;
		
		$pending_invoices = $this->dash->_get_pending_invoices();
		
		if ($pending_invoices == 1)
		{
			$data['pending_invoices'] = $pending_invoices. ' ' . $this->lang->line('pending_invoice');
		}
		else
		{
			$data['pending_invoices'] = $pending_invoices. ' ' . $this->lang->line('pending_invoices');
		}
		
		$pending_commissions = $this->dash->_get_pending_commissions();
		
		if ($pending_commissions == 1)
		{
			$data['pending_commissions'] = $pending_commissions . ' ' . $this->lang->line('pending_commission');
		}
		else
		{
			$data['pending_commissions'] = $pending_commissions. ' ' . $this->lang->line('pending_commissions');
		}
		
		$pending_reviews = $this->dash->_get_pending_reviews();
		
		if ($pending_reviews == 1)
		{
			$data['pending_reviews'] = $pending_reviews . ' ' . $this->lang->line('pending_product_review');
		}
		else
		{
			$data['pending_reviews'] = $pending_reviews. ' ' . $this->lang->line('pending_product_reviews');
		}
		
		if ($this->config->item('sts_support_enable') == 1)
		{
		
			$pending_tickets = $this->dash->_get_pending_tickets();
			
			if ($pending_tickets == 1)
			{
				$data['pending_tickets'] = $pending_tickets . ' ' . $this->lang->line('pending_ticket');
			}
			else
			{
				$data['pending_tickets'] = $pending_tickets. ' ' . $this->lang->line('pending_tickets');
			}
		}
		else
		{
		
			$pending_tickets = $this->dash->_get_pending_comments();
			
			if ($pending_tickets == 1)
			{
				$data['pending_tickets'] = $pending_tickets . ' ' . $this->lang->line('comment_to_approve');
			}
			else
			{
				$data['pending_tickets'] = $pending_tickets. ' ' . $this->lang->line('comments_to_approve');
			}
			
		}
		//load template
		$template = defined('JEM_ENABLE_RESELLER_LINKS') ? 'tpl_adm_dashboard' : 'tpl_adm_dashboard2';
		
		load_admin_tpl('admin', $template, $data);
		
	}

}
?>