<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - discount_groups.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to manage discount groups
|
*/

class Discount_Groups extends Admin_Controller {
	
	function __construct()
	{
		parent::Admin_Controller();	
		
		//load groups model
		$this->load->model('groups_model');
		
		//load css body style
		$this->config->set_item('css_body', 'DE');
		
		//create pagination links		
		$this->config->set_item('uri', ADMIN_ROUTE. '/' . $this->uri->segment(2) . '/table');

	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		//redirect to default view
		redirect(ADMIN_ROUTE . '/discount_groups/view_groups');
	}
	
	// ------------------------------------------------------------------------
	
	function add_group()
	{
		/*
		| -----------------------------------------
		| add a new member
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');

		//set page title
		$data['page_title'] = $this->lang->line('add_discount_group');
		$data['submit_url'] = jrox_admin_url().'discount_groups/add_group';
		$data['update_link'] = 'discount_groups';
		$data['add_link'] = 'add_discount_group';
		$data['groups_table'] = 'discount_groups-table';
		
		$this->validation->group_id_redirect = '';
		$this->validation->group_id = '';
		
		//run admin validation check
		if ($this->_check_group() == false)
		{		
			//reload add group form
			if (empty($_POST))
			{
				//load template
				load_form('admin', 'tpl_adm_manage_discount_group', $data);
			}
			else
			{				
				//ajax form
				echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			}		
		}
		else
		{	
			//add the group into db
			$data = $this->groups_model->_add_discount_group();		
			
			//ajax message
			echo '<div class="success" onclick="self.parent.location.reload(true);" style="cursor:pointer;">' .$this->lang->line('discount_group') . ' ' . $data . ' ' . $this->lang->line('added_successfully') . '. ' . $this->lang->line('click_to_close_or_add') . '</div>';			
			exit();	
			
		}		
	}
	
	// ------------------------------------------------------------------------
	
	function delete_group()
	{
		/*
		| --------------------------------------------
		| delete the group from the db
	    | --------------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		if ($this->groups_model->_delete_discount_group((int)($this->uri->segment(4))))
		{
			//redirect if deleting from ajax table	
			if ($this->uri->segment(5) == 2)
			{
				redirect(ADMIN_ROUTE . '/discount_groups/table/' . $this->config->item('cache_bx') . '/' . $this->uri->segment(7,0) . '/' . $this->uri->segment(8,0) . '/' . $this->uri->segment(9,0) . '/' . $this->uri->segment(10,0) . '/' . $this->uri->segment(11,0));
			}
			else
			{
				echo '<script>self.parent.location.reload(true);</script>';		
			}	
		}
		else
		{
			redirect(ADMIN_ROUTE . '/discount_groups/view_groups');
		}
	}
	
	// ------------------------------------------------------------------------
	
	function view_groups()
	{
		/*
		| -----------------------------------------
		| view groups
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//set page title
		$data['page_title'] = $this->lang->line('view_discount_groups');
		$data['sub_title'] = $this->lang->line('manage_discount_groups');
		$data['add_link'] = 'add_discount_group';
		$data['update_link'] = 'discount_groups';
		
		$data['offset'] = 0;
		$data['sort_column'] = 0;
		$data['sort_order'] = 0;
		$data['next_sort_order'] = $this->uri->segment(6) == 'DESC' ? 'ASC' : 'DESC';
		$data['sort_header'] = $data['uri'] .'/' . $this->config->item('cache_bx') . '/' . $data['offset'] . '/' . $data['next_sort_order'];
		
		//check if there are any sql wheres
		$data['where_column'] = $this->uri->segment(4,0);
		$data['where_value'] =  $this->uri->segment(5,0);
		
		$data['groups_table'] = 'discount_groups-table-' . $data['cache_bx'] . '-' .$data['offset'] . '-' . $data['sort_order'] . '-' . $data['sort_column'] . '-' . $data['where_column'] . '-' . $data['where_value'];
		
		$data['height'] = '440';
		$data['width'] = '400';
		
		//load template
		load_admin_tpl('admin', 'tpl_adm_manage_groups', $data);	
	}
	
	// ------------------------------------------------------------------------
	
	function table()
	{	
		/*
		| ---------------------
		| get groups via ajax
		| ---------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//check for offset and sort order
		$data['offset'] = $this->uri->segment(5, 0);
		$data['sort_column'] = $this->uri->segment(7, 0);
		$data['sort_order'] = $this->uri->segment(6, 0);
		$data['next_sort_order'] = $this->uri->segment(6) == 'DESC' ? 'ASC' : 'DESC';
		$data['sort_header'] = $data['uri'] .'/' . $this->config->item('cache_bx') . '/' . $data['offset'] . '/' . $data['next_sort_order'];
		$data['sort_name'] = 'discount_group_name';
		$data['header_name'] = 'discount_groups';
		$data['update_link'] = 'discount_groups';
		$data['height'] = '440';
		$data['width'] = '400';
		
		//check if there are any sql wheres
		$data['where_column'] = $this->uri->segment(4,0);
		$data['where_value'] =  $this->uri->segment(5,0);
		
		//get groups
		$row = $this->groups_model->_get_discount_groups($this->session->userdata('per_page'), $data['offset'], $data['sort_column'], $data['sort_order']);

		//add the data to the array
		$data['groups'] = $row;
		
		//set pagination
		$data['pagination'] = $this->db_validation_model->_set_pagination($data['uri'], 'discount_groups', $this->session->userdata('per_page'), 5, $data['sort_order'], $data['sort_column']);
		
		//load template
		load_admin_tpl('admin', 'tpl_adm_discount_groups_table', $data, false, false);

	
	}
	
	// ------------------------------------------------------------------------
	
	
	function update_group()
	{
		/*
		| -----------------------------------------
		| update a new member
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');

		//set page title
		$data['page_title'] = $this->lang->line('update_discount_group');
		$data['submit_url'] = jrox_admin_url().'discount_groups/update_group';
		$data['add_link'] = 'update_discount_group';
		$data['update_link'] = 'discount_groups';
		$data['groups_table'] = 'discount_groups-table';
		
		$this->validation->group_id_redirect = '<input type="hidden" id="group_id" name="group_id" value="' . (int)$this->uri->segment(4) . '" />';
		$this->validation->group_id = $this->uri->segment(4);
		
		//run admin validation check
		if ($this->_check_group() == false)
		{		
			//reload add group form
			if (empty($_POST))
			{
				$mdata = $this->groups_model->_get_discount_group_details((int)$this->uri->segment(4));
				
				if (!empty($mdata))
				{	
					foreach ($mdata[0] as $key => $value)
					{	
						$this->validation->$key = $value;	
					}
					
					//load template
					load_form('admin', 'tpl_adm_manage_discount_group', $data);
				}
				else
				{
					//load add member page
					redirect(ADMIN_ROUTE . '/discount_groups/view_groups');
					exit();
				}
							
			}
			else
			{				
				//ajax form
				echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			}		
		}
		else
		{	
			//add the group into db
			
			$data = $this->groups_model->_update_discount_group((int)$this->uri->segment(4));	
			
			//set flash data
			//$this->session->set_flashdata('success', $this->lang->line('add_group_success'));
			
			//ajax message
			echo '<div class="success" onclick="self.parent.location.reload(true);" style="cursor:pointer;">' . $this->lang->line('update_group_success') . '. ' . $this->lang->line('click_to_continue') . '</div>';		
			exit();	
			
			//redirect to admin details form
			/*echo '<script>self.parent.location.reload(true);</script>';*/
		}		
	}
	
	// ------------------------------------------------------------------------
	
	function update_groups()
	{
		/*
		| ---------------------------
		| mass update group tiers
		| ---------------------------
		*/
	
		if ($this->_check_tiers() == true)
		{	
			$this->groups_model->_change_discount_group_status();
			
			//set flash data
			$this->session->set_flashdata('success', $this->lang->line('add_group_success'));
			echo '<script>self.parent.location.reload(true);</script>';	
		}
		else
		{
			echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			exit();
		}
	}
	
	// ------------------------------------------------------------------------
	
	/*
	| -------------------------------------------------------------------------
	| supporting functions - these are used to support the main functions above
	| -------------------------------------------------------------------------
	*/

	// ------------------------------------------------------------------------	
	
	function _check_group()
	{
		//set form validation rules
		
		$rules['discount_group_name'] = 'trim|required|min_length[2]|max_length[50]';
		$rules['discount_group_amount'] = 'trim|required|numeric';
		$rules['status'] = 'trim|required';
		$rules['percentage'] = 'trim|required|integer';
		
		$this->validation->set_rules($rules);

		//repopulate form

		$fields['discount_group_name'] = $this->lang->line('discount_group_name');
		$fields['discount_group_amount'] = $this->lang->line('discount_group_amount');
		$fields['status'] = $this->lang->line('status');
		$fields['percentage'] = $this->lang->line('use_percentage');
		
		$this->validation->set_fields($fields);
			
		if ($this->validation->run() == FALSE)	
		{
			return false;
		}
		
		return true;
		
	}
	
	// ------------------------------------------------------------------------
}
?>