<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - downline.php
| -------------------------------------------------------------------------     
| 
| This controller file shows the downline of the user
|
*/

class Downline extends Admin_Controller {
	
	function __construct()
	{
		parent::Admin_Controller();	

		//load admins model
		$this->load->model('downline_model');
	
		//load css body style
		$this->config->set_item('css_body', 'DE');
		
		//create pagination links		
		$this->config->set_item('uri', ADMIN_ROUTE. '/' . $this->uri->segment(2) . '/table');
	}
	
	// ------------------------------------------------------------------------	
	
	function index()
	{
		//redirect to default view
		redirect(ADMIN_ROUTE . '/downline/view_downline');
	}

	
	// ------------------------------------------------------------------------	
	
	function view_downline()
	{
		/*
		| -----------------------------------------
		| view downline members
		| -----------------------------------------
		*/
	
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//check if caching is enabled
		if ($data['sts_store_enable_downline_cache'] == 1)
		{
			$this->output->cache($data['sts_store_enable_downline_cache_minutes']);
		}
		
		//set page title
		$data['page_title'] = $this->lang->line('view_member_dowline');
		$data['submit_url'] = jrox_admin_url().'downline';
		
		$this->load->helper('country');
		
		if ((int)$this->uri->segment(4) > 0) //for the member only
		{
			$member = $this->downline_model->_get_sponsor_details((int)$this->uri->segment(4));
			
			$data['member_name'] = $member[0]['fname'] . ' ' . $member[0]['lname'];
			$data['sponsor_id'] = !empty($member[0]['sponsor_id']) ? $member[0]['sponsor_id'] : '0';
			$data['member_photo'] = !empty($member[0]['photo_file_name']) ? base_url() . 'images/' . $this->config->item('images_members_dir') . '/' . $members[0]['photo_file_name'] : base_url() . 'images/misc/downline_main_1.jpg';
		}
		else
		{
			$data['member_name'] = $this->config->item('sts_store_name');
			$data['member_photo'] = base_url() . 'images/misc/downline_main_1.jpg';
		}
		
		if ($this->config->item('sts_affiliate_use_google_visualization_api_admin'))
		{
			
			$mdata = $this->downline_model->_generate_downline((int)$this->uri->segment(4), true, 'email');
		
			$data['total_users' ] = $mdata['total_users'];
			$data['downline_table'] = $mdata['results'];
			$data['levels'] = $mdata['levels'];
		
			if ((int)$this->uri->segment(4) > '0')
			{
				$data['rows'] = '[{v:\'' . $member[0]['member_id'] . '\', f:\'' . '<div><img src="' . $data['member_photo'] . '" /><br />' . $data['member_name'] . '<div>\'}, \'\', \'' . $member[0]['username']  . '\'],'
			;
			}
			else
			{
				$data['rows'] = '[{v:\'0\', f:\'' . '<div style="font-size: 15px; font-weight: bold">Top<div>\'}, \'\', \'\'],';	
			}
			
			foreach ($mdata['results'] as $v)
			{
				$data['rows'] .= '[{v:\'' . $v['member_id'] . '\', f:\'' . '<div><a href="' . jrox_admin_url() .'downline/view_downline/' . $v['member_id'] . '"><img src="' . base_url() . 'images/misc/downline_1.gif' . '" /><br />' . $v['fname'] . ' ' . $v['lname'] . '</a><div>\'}, \'' . $v['sponsor_id'] . '\', \'' . $v['username'] . '\'],';
			}
			
			$template = 'tpl_adm_view_downline2';
		}
		else
		{
			$mdata = $this->downline_model->_generate_downline((int)$this->uri->segment(4), true);
		
			$data['total_users' ] = $mdata['total_users'];
			$data['downline_table'] = $mdata['results'];
			$data['levels'] = $mdata['levels'];
			
			$template = 'tpl_adm_view_downline';
		}
		
		//load template
		load_form('admin', $template, $data);
			
	}
	
}
?>
