<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - follow_ups.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to manage follow_ups
|
*/

class follow_ups extends Admin_Controller {
	
	function __construct()
	{
		parent::Admin_Controller();	
		
		//load follow_ups model
		$this->load->model('follow_ups_model');
		
		//load css body style
		$this->config->set_item('css_body', 'GJ');
		
		//create pagination links		
		$this->config->set_item('uri', ADMIN_ROUTE. '/' . $this->uri->segment(2) . '/table');

	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		//redirect to default view
		redirect(ADMIN_ROUTE . '/follow_ups/view_follow_ups');
	}
	
	// ------------------------------------------------------------------------
	
	function add_follow_up()
	{
		/*
		| -----------------------------------------
		| add a new follow_up
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');

		//set page title
		$data['page_title'] = $this->lang->line('add_follow_up');
		$data['submit_url'] = jrox_admin_url().'follow_ups/add_follow_up/' . (int)($this->uri->segment(4));
		$data['update_link'] = 'follow_ups';
		$data['add_link'] = 'add_follow_up';
		
		

		$this->validation->mailing_list_id = (int)($this->uri->segment(4));
		
		//run admin validation check
		if ($this->_check_follow_up() == false)
		{		
			//reload add follow_up form
			if (empty($_POST))
			{
				
				//initialize HTML editor
				$options = array(	'instance'	=> 'oEdit1',
									'type' => 'email',
									'content' => '',
									'height'	=> '400',
									'width'	=> '100%',
									'editor_type'	=> 'Default',
									'textarea'	=>	'html_message',
									'tags'	=> true,
								);
				$check_editor = _initialize_html_editor($options);
			
				$data['editor'] = $check_editor['editor'];
				$data['editor_path'] = $check_editor['editor_path'];
				
				$this->validation->from_name = $data['sts_store_name'];
				$this->validation->from_email = 'noreply@' . $this->config->item('base_domain_name'); //$data['sts_store_email'];
				
				//load template
				load_admin_tpl('admin', 'tpl_adm_manage_follow_up', $data);
				
			}
			else
			{				
				//ajax form
				echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			}		
		}
		else
		{	
			//add the follow_up into db
			$id = $this->follow_ups_model->_add_follow_up();		

			//set flash data
			$this->session->set_flashdata('success', $this->lang->line('follow_up_added_successfully'));
			
			//redirect to admin details form
			echo '<script>window.location = "' . jrox_admin_url().'follow_ups/update_follow_up/' . $id . '"</script>';

		}		
	}
	
	// ------------------------------------------------------------------------
	
	function delete_follow_up()
	{
		/*
		| --------------------------------------------
		| delete the follow_up from the db
	    | --------------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		if ($this->follow_ups_model->_delete_follow_up((int)($this->uri->segment(4))))
		{
			//redirect if deleting from ajax table	
			if ($this->uri->segment(5) == 2)
			{
				redirect(ADMIN_ROUTE . '/follow_ups/table/' . $this->config->item('cache_bx') . '/' . $this->uri->segment(7,0) . '/' . $this->uri->segment(8,0) . '/' . $this->uri->segment(9,0) . '/' . $this->uri->segment(10,0) . '/' . $this->uri->segment(11,0));
			}
			else
			{
				echo '<script>self.parent.location.reload(true);</script>';		
			}	
		}
		else
		{
			redirect(ADMIN_ROUTE . '/follow_ups/view_follow_ups');
		}
	}
	
	// ------------------------------------------------------------------------
	
	function view_follow_ups()
	{
		/*
		| -----------------------------------------
		| view follow_ups
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//get name of mailing list
		$details = $this->db_validation_model->_get_details('email_mailing_lists', '', 'mailing_list_id', (int)$this->uri->segment(4));
		
		$name = $details[0]['mailing_list_name'];
		
		$data['mailing_list_id'] = (int)($this->uri->segment(4));
		
		//set page title
		$data['page_title'] = $this->lang->line('manage_follow_ups') . ' - ' . limit_chars($name, 25);
		$data['height'] = '250';
		$data['width'] = '400';
		
		$data['offset'] = 0;
		$data['sort_column'] = 0;
		$data['sort_order'] = 0;
		$data['next_sort_order'] = $this->uri->segment(6) == 'DESC' ? 'ASC' : 'DESC';
		$data['sort_header'] = $data['uri'] .'/' . $this->config->item('cache_bx') . '/' . $data['offset'] . '/' . $data['next_sort_order'];
		
		//check if there are any sql wheres
		$data['where_column'] = $this->uri->segment(4,0);
		$data['where_value'] =  $this->uri->segment(5,0);
		
		//load template
		load_admin_tpl('admin', 'tpl_adm_manage_follow_ups', $data);	
	}
	
	// ------------------------------------------------------------------------
	
	function table()
	{	
		/*
		| ---------------------
		| get follow_ups via ajax
		| ---------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//check for offset and sort order
		$data['mailing_list_id'] = (int)($this->uri->segment(8));
		
		$data['offset'] = $this->uri->segment(5, 0);
		$data['sort_column'] = $this->uri->segment(7, 0);
		$data['sort_order'] = $this->uri->segment(6, 0);
		$data['next_sort_order'] = $this->uri->segment(6) == 'DESC' ? 'ASC' : 'DESC';
		$data['sort_header'] = $data['uri']  . '/' . $this->config->item('cache_bx') . '/' . $data['offset'] . '/' . $data['next_sort_order'];
		$data['height'] = '250';
		$data['width'] = '400';
		
		//check if there are any sql wheres
		$data['where_column'] = $this->uri->segment(4,0);
		$data['where_value'] =  $this->uri->segment(5,0);
		
		//get follow_ups
		$row = $this->follow_ups_model->_get_follow_ups($this->session->userdata('per_page'), $data['offset'], $data['sort_column'], $data['sort_order'], $data['mailing_list_id']);
		
		
	 
		//add the data to the array
		$data['follow_ups'] = $row;	
		
		//count the rows
		$total_rows = $this->db_validation_model->_get_count('email_follow_ups', 'WHERE mailing_list_id=\'' . (int)($this->uri->segment(8)) . '\'');
		
		
		//set pagination
		$data['pagination'] = $this->db_validation_model->_set_pagination($data['uri'], 'email_follow_ups', $this->session->userdata('per_page'), 5, $data['sort_order'], $data['sort_column'], $total_rows, $data['mailing_list_id']);
		
		//load template
		load_admin_tpl('admin', 'tpl_adm_follow_ups_table', $data, false, false);

	
	}
	
	// ------------------------------------------------------------------------
	
	
	function update_follow_up()
	{
		/*
		| -----------------------------------------
		| add a new follow_up
		| -----------------------------------------
		*/

		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//set page title
		$data['page_title'] = $this->lang->line('update_follow_up');
		$data['submit_url'] = jrox_admin_url().'follow_ups/update_follow_up/' . (int)$this->uri->segment(4);
		$data['add_link'] = 'update_follow_up';
		$data['update_link'] = 'follow_ups';
		
		//run admin validation check
		if ($this->_check_follow_up() == false)
		{		
			//reload add follow_up form
			if (empty($_POST))
			{
				$mdata = $this->follow_ups_model->_get_follow_up_details((int)$this->uri->segment(4));
				
				if (!empty($mdata))
				{	
					foreach ($mdata[0] as $key => $value)
					{
						$this->validation->$key = $value;
					}
					
					//initialize HTML editor
					$options = array(	'instance'	=> 'oEdit1',
										'type' => 'email',
										'content' => $this->validation->html_message,
										'height'	=> '400',
										'width'	=> '100%',
										'editor_type'	=> 'Default',
										'textarea'	=>	'html_message',
										'tags'	=> true,
									);
					$check_editor = _initialize_html_editor($options);
				
					$data['editor'] = $check_editor['editor'];
					$data['editor_path'] = $check_editor['editor_path'];
					
					//load template
					load_admin_tpl('admin', 'tpl_adm_manage_follow_up', $data);
				}
				else
				{
					//load add follow_up page
					redirect(ADMIN_ROUTE . '/follow_ups/view_follow_ups');
					exit();
				}
							
			}
			else
			{				
				//ajax form
				echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			}		
		}
		else
		{	
			//update the follow_up into db
			$data = $this->follow_ups_model->_update_follow_up((int)$this->uri->segment(4));	
			
			//set flash data
			$this->session->set_flashdata('success', $this->lang->line('follow_up_updated_successfully'));
			
			//redirect to admin details form
			echo '<script>window.location = "' . jrox_admin_url().'follow_ups/update_follow_up/' . (int)$this->uri->segment(4) . '"</script>';
	
		}		
	}
	
	// ------------------------------------------------------------------------
	
	function update_follow_ups()
	{
		/*
		| ---------------------------
		| mass update group tiers
		| ---------------------------
		*/
	
		if ($this->_check_sequence() == true)
		{	
			$this->follow_ups_model->_change_follow_up_sequence();
			
			//set flash data
			$this->session->set_flashdata('success', $this->lang->line('follow_ups_updated_successfully'));
			echo '<script>self.parent.location.reload(true);</script>';	
		}
		else
		{
			echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			exit();
		}
	}
	
	// ------------------------------------------------------------------------
	
	/*
	| -------------------------------------------------------------------------
	| supporting functions - these are used to support the main functions above
	| -------------------------------------------------------------------------
	*/
	
	// ------------------------------------------------------------------------	
	
	function _check_sequence()
	{
		$data = $this->db_validation_model->_clean_data($_POST);
	
		foreach ($data as $k => $v)
		{
			if (strstr($k, "sequence") == true) 
			{
				$rules[$k] = 'trim|required|numeric';
				$fields[$k] = $k ;
			}
			
			if (strstr($k, "days") == true) 
			{
				$rules[$k] = 'trim|required|numeric';
				$fields[$k] = $k ;
			}
		}
		
		$this->validation->set_rules($rules);
		
		//repopulate form
		$this->validation->set_fields($fields);
			
		if ($this->validation->run() == FALSE)	
		{
			return false;
		}
		
		return true;
	}
	
	// ------------------------------------------------------------------------	
	
	function _check_follow_up()
	{
		//set form validation rules
		
		$rules['follow_up_name'] = 'trim|required|min_length[2]|max_length[50]';
		$rules['from_name'] = 'trim|required|min_length[2]|max_length[50]';
		$rules['from_email'] = 'trim|required|valid_email';
		$rules['email_subject'] = 'trim|required|min_length[2]|max_length[255]';
		
		$rules['email_type'] = 'trim|required';
		
		if ($this->input->post('email_type') == 'text')
		{
			$rules['text_message'] = 'trim|required';
		}
		else
		{
			$rules['html_message'] = 'trim|required|min_length[20]';
		}
		
		$this->validation->set_rules($rules);

		//repopulate form

		$fields['follow_up_name'] = $this->lang->line('follow_up_name');
		$fields['from_name'] = $this->lang->line('from_name');
		$fields['from_email'] = $this->lang->line('from_email');
		$fields['email_subject'] = $this->lang->line('subject');
		$fields['email_type'] = $this->lang->line('email_type');
		$fields['html_message'] = $this->lang->line('html_message');
		$fields['text_message'] = $this->lang->line('text_message');
		
		$this->validation->set_fields($fields);
			
		if ($this->validation->run() == FALSE)	
		{
			return false;
		}
		
		return true;
		
	}
	
	
	
	// ------------------------------------------------------------------------
}
?>