<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - global_discounts.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to manage global_discounts
|
*/

class Global_Discounts extends Admin_Controller {
	
	function __construct()
	{
		parent::Admin_Controller();	
		
		//load global_discounts model
		$this->load->model('global_discounts_model');
		
		//load css body style
		$this->config->set_item('css_body', 'GJ');
		
		//create pagination links		
		$this->config->set_item('uri', ADMIN_ROUTE. '/' . $this->uri->segment(2) . '/table');

	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		//redirect to default view
		redirect(ADMIN_ROUTE . '/global_discounts/view_global_discounts');
	}
	
	// ------------------------------------------------------------------------
	
	function view_global_discounts()
	{
		/*
		| -----------------------------------------
		| view global_discounts
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//set page title
		$data['page_title'] = $this->lang->line('view_global_discounts');
		
		$data['global_discounts'] = $this->global_discounts_model->_get_global_discounts();
		
		//load template
		load_admin_tpl('admin', 'tpl_adm_manage_global_discounts', $data);	
	}
	
	// ------------------------------------------------------------------------
	
	function delete_global_discount()
	{
		//set data array
		$data = $this->security_model->_load_config('admin');
	
		if ($this->_check_discounts() == true)
		{
			$this->global_discounts_model->_delete_global_discount((int)$this->uri->segment(4));
			
			//set flash data
			$this->session->set_flashdata('success', $this->lang->line('delete_discount_success'));	
		}
				
		redirect(ADMIN_ROUTE . '/global_discounts/view_global_discounts');	
	}
	
	// ------------------------------------------------------------------------
	
	function update_global_discounts()
	{
		/*
		| -----------------------------------------
		| change the status of the product
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
	
		if ($this->_check_discounts() == true)
		{
			$this->global_discounts_model->_update_global_discounts($_POST);
			
			//set flash data
			$this->session->set_flashdata('success', $this->lang->line('update_discount_success'));	
		}
		
		echo '<script>window.location = "' . jrox_admin_url().'global_discounts/view_global_discounts"</script>';	
		exit();			
	}
	
	// ------------------------------------------------------------------------
	
	/*
	| -------------------------------------------------------------------------
	| supporting functions - these are used to support the main functions above
	| -------------------------------------------------------------------------
	*/
	
	// ------------------------------------------------------------------------	
	
	function _check_discounts()
	{
		$data = $this->db_validation_model->_clean_data($_POST);
		
		foreach ($data as $k => $v)
		{
			if (preg_match('/min_amount-*/', $k)) 
			{					
				//check min amount
				if (!empty($v) && !is_numeric($v))
				{
					echo '<div class="error" id="error-messages">' . $this->lang->line('all_amounts_must_be_numeric') . '</div>';
					exit();
				}
			}  
			
			//check max amount
			if (preg_match('/max_amount-*/', $k)) 
			{					
				//check form field name
				if (!empty($v) && !is_numeric($v))
				{
					echo '<div class="error" id="error-messages">' . $this->lang->line('all_amounts_must_be_numeric') . '</div>';
					exit();
				}
			}  
			
			//check discount amount
			if (preg_match('/discount_amount-*/', $k)) 
			{					
				//check form field name
				if (!empty($v) && !is_numeric($v))
				{
					echo '<div class="error" id="error-messages">' . $this->lang->line('all_amounts_must_be_numeric') . '</div>';
					exit();
				}
			}  
		}
		
		return true;	
	}
}
?>