<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - import.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to manage import import options
|
*/

class Import extends Admin_Controller {
	
	function __construct()
	{
		parent::Admin_Controller();	
		
		//load import model
		$this->load->model('import_model', 'import');
		
		//load css body style
		$this->config->set_item('css_body', 'MN');
		
		//create pagination links		
		$this->config->set_item('uri', ADMIN_ROUTE. '/' . $this->uri->segment(2) . '/table');
		
	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		//redirect to default view
		redirect(ADMIN_ROUTE . '/import/view_import_modules');
	}
	
	
	// ------------------------------------------------------------------------
	
	function view_import_modules()
	{
		/*
		| -----------------------------------------
		| view import modules
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//set page title
		$data['page_title'] = $this->lang->line('view_import_modules');
		$data['sub_title'] = $this->lang->line('manage_import_modules');
		$data['add_link'] = 'install';
		$data['update_link'] = 'import';
		$data['groups_table'] = 'import-table';
		$data['height'] = '500';
		$data['width'] = '400';
		
		//load template
		load_admin_tpl('admin', 'tpl_adm_manage_import', $data);	
	}
	
	// ------------------------------------------------------------------------
	
	function table()
	{
		/*
		| ------------------------------
		| get import modules via ajax
		| ------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//check for offset and sort order
		$data['offset'] = $this->uri->segment(5, 0);
		$data['sort_column'] = $this->uri->segment(7, 0);
		$data['sort_order'] = $this->uri->segment(6, 0);
		$data['next_sort_order'] = $this->uri->segment(6) == 'DESC' ? 'ASC' : 'DESC';
		$data['sort_header'] = $data['uri'] .'/' . $this->config->item('cache_bx') . '/' . $data['offset'] . '/' . $data['next_sort_order'];
		$data['sort_name'] = 'import_name';
		$data['header_name'] = 'import_module';
		$data['height'] = '500';
		$data['width'] = '400';
		
		//get groups
		$row = $this->import->_get_import($this->session->userdata('per_page'), $data['offset'], $data['sort_column'], $data['sort_order']);		
		
		//add the data to the array
		$data['module'] = $row;
		
		//count all rows first
		$row_count = $this->db_validation_model->_get_count('modules', 'WHERE module_type = \'data_import\'');
		
		//set pagination
		$data['pagination'] = $this->db_validation_model->_set_pagination($data['uri'], 'import', $this->session->userdata('per_page'), 5, $data['sort_order'], $data['sort_column'], $row_count);
		
		//load template
		load_admin_tpl('admin', 'tpl_adm_import_table', $data, false, false);
	}
	
	// ------------------------------------------------------------------------
	
	
	function change_status()
	{
		/*
		| -----------------------------------------
		| change the status of the module
		| -----------------------------------------
		*/
		
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		if ($this->db_validation_model->_change_status_field('modules', 'module_id', (int)$this->uri->segment(4), 'module_status'))
		{
			//redirect if deleting from ajax table	
			if ($this->uri->segment(5) == 2)
			{
				redirect(ADMIN_ROUTE . '/import/table/' . $this->config->item('cache_bx'));
			}
			else
			{
				//set flash data
				//$this->session->set_flashdata('success', $this->lang->line('update_modules_success'));
				
				redirect(ADMIN_ROUTE . '/modules/view_modules');
			}
		}
	}
	
	
}
?>