<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - comments.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to search for data
|
*/
class Search extends Admin_Controller {
	
	function __construct()
	{
		parent::Admin_Controller();
		
		//load convert library
		$this->load->library('convert');
	}
	
	// ------------------------------------------------------------------------	
	
	function index()
	{
		//redirect to default view
		redirect(ADMIN_ROUTE);
	}
	
	// ------------------------------------------------------------------------	
	
	function general()
	{
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		if ($_POST['search_term'] == 'enter search here')
		{
			redirect(ADMIN_ROUTE);
		}
		elseif (empty($_POST['search_term']))
		{
			redirect(ADMIN_ROUTE);
		}
		else
		{
			switch ($_POST['table'])
			{
				case 'invoices':
				
					redirect(ADMIN_ROUTE .'/invoices/view_invoices/search/' .  $this->convert->AsciiToHex(base64_encode($_POST['search_term'])));
				
				break;
				
				case 'commissions':
				
					redirect(ADMIN_ROUTE .'/commissions/view_commissions/search/' .  $this->convert->AsciiToHex(base64_encode($_POST['search_term'])));
				
				break;
				
				case 'members':
				
					redirect(ADMIN_ROUTE .'/members/view_members/search/' .  $this->convert->AsciiToHex(base64_encode($_POST['search_term'])));
					
				break;
				
				case 'products':
				
					redirect(ADMIN_ROUTE .'/products/view_products/search/' .  $this->convert->AsciiToHex(base64_encode($_POST['search_term'])));
					
				break;
				
				case 'invoice_payments':
				
					redirect(ADMIN_ROUTE .'/invoice_payments/view_invoice_payments/search/' .  $this->convert->AsciiToHex(base64_encode($_POST['search_term'])));
					
				break;
			}
		}
		
	}
	
	// ------------------------------------------------------------------------	
	
	function ajax_members() 
	{		
		//set data array
		$data = $this->security_model->_load_config('admin');

		//set page title
		$data['page_title'] = $this->lang->line('search');
		
		
		$q = $this->input->xss_clean(strtolower(($this->uri->segment(4))));
		
		if (!$q) return;
		
		$this->db->select('username');
		$this->db->limit('25');
		$this->db->like('username',  $q, 'after'); 
		
		$sponsors = $this->db->get('members');
		if ($sponsors->num_rows() > 0)
		{
			$sp = $sponsors->result_array();
			
			foreach ($sp as $v)
			{
				echo $v['username']."\n";
			}
		}
	}
	
	// ------------------------------------------------------------------------	
	
	function ajax_categories() 
	{		
		//set data array
		$data = $this->security_model->_load_config('admin');

		//set page title
		$data['page_title'] = $this->lang->line('search');
		
		
		$q = $this->input->xss_clean(strtolower(($this->uri->segment(4))));
		
		if (!$q) return;
		
		$this->db->select('category_name');
		$this->db->limit('25');
		$this->db->like('category_name',  $q, 'after'); 
		
		$sponsors = $this->db->get('products_categories');
		if ($sponsors->num_rows() > 0)
		{
			$sp = $sponsors->result_array();
			
			foreach ($sp as $v)
			{
				echo $v['category_name']."\n";
			}
		}
	}
	
	// ------------------------------------------------------------------------	
}
?>