<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - site_map.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to notify google for an updated site map
|
*/

class Site_Map extends Admin_Controller {

	function __construct()
	{
		parent::Admin_Controller();	
		
		//load languages model
		$this->load->model('sitemap_model', 'sitemap');
		
		//load css body style
		$this->config->set_item('css_body', 'GJ');
		
		//create pagination links		
		$this->config->set_item('uri', ADMIN_ROUTE. '/' . $this->uri->segment(2) . '/table');

	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		//redirect to default view
		redirect(ADMIN_ROUTE . '/sitemap/generate_sitemap');
	}
	
	// ------------------------------------------------------------------------
	
	function generate_site_map()
	{
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//set page title
		$data['page_title'] = $this->lang->line('site_map_notify');
		$data['sub_title'] = $this->lang->line('manage_affiliate_marketing_modules');
		$data['add_link'] = 'install';
		$data['update_link'] = 'affiliate_marketing';
		$data['groups_table'] = 'affiliate_marketing-table';
		$data['height'] = '500';
		$data['width'] = '400';
		
		//load template
		load_form('admin', 'tpl_adm_notify_google_sitemap', $data);	
	}
	
	// ------------------------------------------------------------------------
	
	function notify()
	{
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		$sitemaps = array('products', 'product_categories', 'content_articles', 'content_categories', 
							'faq_categories', 'faq_articles', 'profiles', 'affiliates');
							
		//ping google
		$response = '';
		
		foreach ($sitemaps as $v)
		{
			$url = urlencode(_jrox_public_url() . '/sitemap/' . $v . '/sitemap.xml');
			$resp = connect_curl('www.google.com/webmasters/tools/ping?sitemap=' . $url);
			
			$response .= '<div class="success">' . _jrox_public_url() . '/sitemap/' . $v . '/sitemap.xml<br />';
			
			$response .=  $resp . '</div>';
		}
		
		echo $response;
	}
}
?>