<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - error.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to show 404 errors
|
*/


class Error extends Public_Controller {

	function __construct()
	{
		parent::Public_Controller();	
		
		//load required models
		$this->load->model('init_model', 'init');
	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		$this->security_model->_load_session('public');
			
		//set data array
		$data = $this->security_model->_load_config('public');
		
		//initialize site with required db config
		$sdata = $this->init->_initialize(__CLASS__,  __FUNCTION__);
		
		//set up the languages array
		$data['languages'] = $sdata['languages'];
		
		//set all text
		foreach ($sdata['text'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		//set referral info
		foreach ($sdata['aff_cfg'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		//set page title
		$data['page_title'] = $this->lang->line('error_page_not_found');
		$data['meta_keywords'] = '';
		$data['lang_heading'] = $this->lang->line('error_page_not_found');
		$data['show_message'] = str_replace('-', '/', $this->uri->segment(3));
		$data['show_message'] .= '<p>' . $this->lang->line('error_404') . '</p>';
		
		header("HTTP/1.1 404 Not Found");
		$this->parser->_JROX_load_view('tpl_error_message', 'error', $data);
	}
	
	// ------------------------------------------------------------------------
	
	function custom()
	{
		$this->security_model->_load_session('public');
		
		$this->load->library('convert');
		
		//set data array
		$data = $this->security_model->_load_config('public');
		
		//initialize site with required db config
		$sdata = $this->init->_initialize(__CLASS__,  __FUNCTION__);
		
		//set up the languages array
		$data['languages'] = $sdata['languages'];
		
		//set all text
		foreach ($sdata['text'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		//set referral info
		foreach ($sdata['aff_cfg'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		//set page title
		$data['page_title'] = $this->lang->line('error');
		$data['meta_keywords'] = '';
		$data['lang_heading'] = $this->lang->line('error');
		$data['lang_go_back'] = $this->lang->line('go_back');
		$data['show_message'] = base64_decode($this->convert->HexToAscii($this->uri->segment(3)));

		$this->parser->_JROX_load_view('tpl_error_message', 'error', $data);
	}
}

?>