<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - Manufacturers.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to generate Manufacturers
|
*/

class Manufacturers extends Public_Controller {

	function __construct()
	{
		parent::Public_Controller();	
		
		//load css body style
		$this->config->set_item('css_body', 'jroxManufacturers');
		
		//load required models
		$this->load->model('init_model', 'init');
		$this->load->model('manufacturers_model', 'man');
		
		//create pagination links		
		$this->config->set_item('uri', $this->config->slash_item('base_folder_path') . $this->config->slash_item('site_index_page') . $this->uri->segment(1));
			
	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{	
		//set data array
		$data = $this->security_model->_load_config('public');
		$data['parent_id'] = $this->uri->segment(2, 0);
		
		//set the meta tags
		$data['page_title'] = $this->config->item('sts_products_manufacturer_category_name');
		$data['meta_keywords'] = $data['sts_store_default_keywords'];
		$data['meta_description'] = $data['sts_store_description'];
		$data['product_categories_dir'] = $data['images_product_categories_dir'];
		
		//initialize site with required db config
		$sdata = $this->init->_initialize(__CLASS__,  __FUNCTION__);
		
		//set up the languages array
		$data['languages'] = $sdata['languages'];
		
		//set all text
		foreach ($sdata['text'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		//set referral info
		foreach ($sdata['aff_cfg'] as $key => $val)
		{
			$data[$key] = $val;
		}
					
		$row = $this->man->_get_all_manufacturers($this->config->item('pub_dbs_man_column'), $this->config->item('pub_dbs_man_order'), true);
		
		if (empty($row))
		{
			$data['manufacturers'] = '';
			$data['no_manufacturers'] = '1';
			$data['lang_no_manufacturers_found'] = $this->lang->line('no_manufacturers_found');
		}
		else
		{
			//format the array with proper images
			$fdata = array();
			
			foreach ($row as $k => $v)
			{
				if (empty($v['manufacturer_image']))
				{
					$v['manufacturer_image'] = base_url(). 'themes/main/' . $this->config->item('layout_design_site_theme') . '/images/no_manufacturer_photo.png';
				}
				else
				{
					$v['manufacturer_image'] = base_url(). 'images/' . $this->config->item('images_manufacturers_dir')  . '/' . $v['manufacturer_image'];
				}
				
				$v['manufacturer_name_url'] = url_title($v['manufacturer_name']);
				
				$v['total'] = $v['total'] > 1 ? $v['total'] . ' ' . $this->lang->line('products') : $v['total'] . ' ' . $this->lang->line('product');
				
				if ($v['total'] == 0) $v['total'] = $this->lang->line('no_products');
				
				array_push($fdata, $v);
			}	
			
			$data['manufacturers'] = $fdata;
			$data['no_manufacturers'] = '0';
		}
		
		//text for this page
		$data['lang_manufacturers'] = $this->config->item('sts_products_manufacturer_category_name');
		
		$this->parser->_JROX_load_view('tpl_manufacturers', 'store', $data);
	}
}

?>