<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - mailing_lists.php
| -------------------------------------------------------------------------     
| 
| This controller file shows what mailing lists the user is on and how to
| remove themselves from that list
|
*/

class Mailing_Lists extends Member_Controller {
	
	function __construct()
	{
		parent::Member_Controller();	
		
		//load members model	
	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		redirect();
		exit();
	}
	
	// ------------------------------------------------------------------------
	
	function update()
	{
		//set data array
		$data = $this->security_model->_load_config('members');
		
		//initialize site with required db config
		$sdata = $this->init->_initialize(__CLASS__,  __FUNCTION__);
		
		//set up the languages array
		$data['languages'] = $sdata['languages'];
		
		//set all text
		foreach ($sdata['text'] as $key => $val)
		{
			$data[$key] = $val;
		}
				
		//set referral info
		foreach ($sdata['aff_cfg'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		//update the list

		//first get all the lists this user belongs to
		$this->db->where('member_id', $this->session->userdata('userid'));
		$query = $this->db->get('email_mailing_list_members');
		
		$lists = array();
		
		if ($query->num_rows() > 0)
		{
			$mlists = $query->result_array();
			
			$lists = format_array($mlists, 'mailing_list_id');		
			
		}	
		//first delete the lists required
		if (!empty($_POST['lists']))
		{
			if (!empty($lists))
			{
				foreach ($lists as $v)
				{
					if (in_array($v, $_POST['lists']))
					{	
						continue;
					}
					else
					{
						//delete the list
						$this->db->where('member_id', $this->session->userdata('userid'));
						$this->db->where('mailing_list_id', $v);
						$this->db->delete('email_mailing_list_members');
					}
				}
			}
			
			//now add rows into table
			foreach ($_POST['lists'] as $value)
			{			
				if (in_array($value, $lists)) //check if the list is already in the db
				{
					continue;
				}
				else //add the list to the db
				{
					$d = array('mailing_list_id' => $value,
							   'member_id' => $this->session->userdata('userid'),
							   'sequence_id' => 1,
							   'send_date'	=>	_generate_timestamp());
					
					if (!$this->db->insert('email_mailing_list_members', $d))
					{
						show_error($this->lang->line('could_not_add_member'));
					
						//log error
						log_message('error', 'Could not update mailing_lists for member ID ' .  $this->session->userdata('userid') . ' in email_mailing_list_members table');
					}
					else
					{
						//log success
						log_message('info', 'Member ID '. $this->session->userdata('userid') . ' updated in email_mailing_list_members table');
					}
				}
			}
		}	
		else
		{
			$this->db->where('member_id', $this->session->userdata('userid'));
			$this->db->delete('email_mailing_list_members');
		}
		
		switch ($this->uri->segment(4))
		{
			case 'account':
			
				redirect(MEMBERS_ROUTE . '/account');
			
			break;
			
			default:
			
				redirect(MEMBERS_ROUTE);
			
			break;
		
		}

	}
}
?>