<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - marketing.php
| -------------------------------------------------------------------------     
| 
| This controller file shows any marketing made by the user
|
*/

class Marketing extends Member_Controller {
	
	function __construct()
	{
		parent::Member_Controller();	
		
		$this->config->set_item('css_body', 'jroxMembersMarketing');
		
		$this->load->model('modules_model', 'modules');
		
		//create pagination links		
		$this->config->set_item('uri', $this->config->slash_item('base_folder_path') . $this->config->slash_item('site_index_page') . $this->uri->segment(1));
		$this->config->set_item('uri_string', str_replace('/', ':', trim_slashes($this->uri->uri_string())));
	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		redirect(MEMBERS_ROUTE . '/marketing/view');
	}
	
	// ------------------------------------------------------------------------
	
	function view()
	{
		//set data array
		$data = $this->security_model->_load_config('members');
		
		//initialize site with required db config
		$sdata = $this->init->_initialize(__CLASS__,  __FUNCTION__);
		
		//set up the languages array
		$data['languages'] = $sdata['languages'];
		
		//set all text
		foreach ($sdata['text'] as $key => $val)
		{
			$data[$key] = $val;
		}
				
		//set referral info
		foreach ($sdata['aff_cfg'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		$text_array = array('tools', 'no_tools_found', 'marketing_tools');
		
		foreach ($text_array as $txt)
		{
			$data['lang_' . $txt] = $this->lang->line($txt);
		}
		
		$data['page_title'] = $this->lang->line('marketing_tools');
		$data['meta_keywords'] = $data['sts_store_default_keywords'];
		$data['meta_description'] = $data['sts_store_description'];

		$tools = $this->aff->_get_user_tools();

		$data['show_tools'] = 0;
		
		if (!empty($tools))
		{
			$data['show_tools'] = 1;
			$data['tools'] = $tools ;
		}


		//load the template
		$this->parser->_JROX_load_view('tpl_members_tools', 'members', $data);
	}
	
	// ------------------------------------------------------------------------
	
	function preview()
	{
		//set data array
		$data = $this->security_model->_load_config('members');
		
		//initialize site with required db config
		$sdata = $this->init->_initialize(__CLASS__,  __FUNCTION__);
		
		//set up the languages array
		$data['languages'] = $sdata['languages'];
		
		//set all text
		foreach ($sdata['text'] as $key => $val)
		{
			$data[$key] = $val;
		}
				
		//set referral info
		foreach ($sdata['aff_cfg'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		$text_array = array('tools', 'no_tools_found', 'marketing_tools', 'sales', 'clicks', 
							'commissions', 'tool_name', 'actions', 'view', 'get_code', 'note_code');
		
		foreach ($text_array as $txt)
		{
			$data['lang_' . $txt] = $this->lang->line($txt);
		}
		
		$data['page_title'] = $this->lang->line('preview');
		$data['meta_keywords'] = $data['sts_store_default_keywords'];
		$data['meta_description'] = $data['sts_store_description'];
		
		//load the model
		$this->load->model('modules/module_affiliate_marketing_' . $this->uri->segment(4) . '_model', 'tools');
		
		$sdata = $this->tools->_preview_code($this->uri->segment(5));
		
		$data['preview_title'] = $sdata['s_title'];
		$data['preview_code'] = $sdata['tool_code'];
		
		$data['lang_title'] = $sdata['subject_title'];
		$data['lang_body'] = $sdata['body_title'];
		$data['lang_html_code'] = $this->lang->line('html_code');
		
		//load the template
		echo $this->parser->_JROX_parse($sdata['template'], APPPATH . 'views/members', $data, true, true);
	}
	
	// ------------------------------------------------------------------------
	
	function download()
	{
		//load the model
		$this->load->model('modules/module_affiliate_marketing_' . $this->uri->segment(4) . '_model', 'tools');
		
		$sdata = $this->tools->_download_tool($this->uri->segment(5));
	}
	
	// ------------------------------------------------------------------------
	
	function tools()
	{
		//set data array
		$data = $this->security_model->_load_config('members');
		
		//initialize site with required db config
		$sdata = $this->init->_initialize(__CLASS__,  __FUNCTION__);
		
		//set up the languages array
		$data['languages'] = $sdata['languages'];
		
		//set all text
		foreach ($sdata['text'] as $key => $val)
		{
			$data[$key] = $val;
		}
				
		//set referral info
		foreach ($sdata['aff_cfg'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		$text_array = array('tools', 'no_tools_found', 'marketing_tools', 'sales', 'clicks', 'banner_rotator', 
							'commissions', 'tool_name', 'actions', 'view', 'get_code', 'note_code');
		
		foreach ($text_array as $txt)
		{
			$data['lang_' . $txt] = $this->lang->line($txt);
		}
		
		$data['page_title'] = $this->lang->line($this->uri->segment(4));
		$data['meta_keywords'] = $data['sts_store_default_keywords'];
		$data['meta_description'] = $data['sts_store_description'];
		
		$uri = $data['uri'] . '/marketing/tools/' . $this->uri->segment(4) . '/' . $this->uri->segment(5);

		$data['offset'] = $this->uri->segment(6, '0');
		$data['sort_column'] = $this->uri->segment(8, 0);
		$data['sort_order'] = $this->uri->segment(7, 0);
		$data['next_sort_order'] = $this->uri->segment(7) == 'DESC' ? 'ASC' : 'DESC';
		
		//load the model
		$this->load->model('modules/module_affiliate_marketing_' . $this->uri->segment(4) . '_model', 'tools');
		
		//get currency options
		$num_options = get_default_currency($this->config->item('sts_store_default_currency'));
		
		$sdata = $this->tools->_generate_tools($data['sts_affiliate_tools_per_page'], $data['offset'], $data['sort_column'], $data['sort_order'], $this->session->userdata('userid'), $num_options);
		
		$data['show_tools'] = !empty($sdata['tool_rows']) ? 1 : 0;
		
		if (!empty($sdata['use_pagination']))
		{
			$pagination = $this->db_validation_model->_set_pagination($uri, $this->uri->segment(4), $data['sts_affiliate_tools_per_page'], 6, $data['sort_order'], $data['sort_column'],  $sdata['row_count'], '', '', 'public');
		
			$data['pagination_rows'] = $pagination['rows'];
				
			$data['num_pages'] = $pagination['num_pages'];
				
			$data['no_pages'] = $data['num_pages'] > 1 ? 1 : 0;
		}
		
		//get the tool title
		$tool = $this->modules->_get_module_details((int)$this->uri->segment(5));
		
		$data['tool_title'] = $tool[0]['module_name'];
		$data['tool_type'] = $tool[0]['module_file_name'];
		$data['tool_rows'] = $sdata['tool_rows'];
		$data['rotator_code'] = '';
		
		$data['lang_html_code'] = $this->lang->line('html_code');
		
		if (!empty($sdata['enable_rotator']))
		{
			$data['rotator_code'] = '<table cellspacing="0" border="0" id="jroxMembersToolsTable" class="jroxMembersTable">

      <col width="800" />
      <col width="20" />


      <thead>
        <tr>
          <th colspan="2" >' . $this->lang->line($this->uri->segment(4) . '_rotator') . '</th>
        </tr>
      </thead>
      <tbody>
      </tbody>
      
      <tr class="{row_style}">
        <td>' . $this->lang->line($this->uri->segment(4) . '_rotator_code') . '</td>
        <td class="jroxCenter jroxEndTable">        
        <a href="javascript:ShowDetails(\'0\')" class="jroxMembersSetting jroxMembersImageLinks" title="' . $this->lang->line('get_code') . '"><span>' . $this->lang->line('view') . '</span></a>        </td>
      </tr>
      
      <tr class="jroxHide" id="view-0">
      	<td colspan="2" class"jroxEndTable">
        <p class="jroxSmall jroxTextAlignRight jroxCapitalize">' . $this->lang->line($this->uri->segment(4) . '_rotator_description') . '</p>

        
        <p class="jroxCapitalize"><br />
        <textarea class="jroxMembersToolsCodePane" onClick="this.select()">&lt;script language="JavaScript" type="text/javascript" src="' . $this->_generate_rotator_link($this->session->userdata('m_username'), $this->uri->segment(4)) . '"&gt;&lt;/script&gt;</textarea>
        </p>   	    </td>
      </tr>
      
      
	   <tfoot><tr class="">
              <th colspan="2" class="jroxEndTable">&nbsp;</td>            
              </th>
	   </tfoot>	
    </table>';
		}
		
		
		$data['lang_title'] = $sdata['subject_title'];
		$data['lang_body'] = $sdata['body_title'];
	
		//load the template
		$this->parser->_JROX_load_view($sdata['template'], 'members', $data);
	}
	
	// ------------------------------------------------------------------------
	
	function _generate_rotator_link($id = '', $type = '')
	{
		return _jrox_public_url() . 'rotator/' . $type . '/' . $id;
	}
}

?>