<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - memberships.php
| -------------------------------------------------------------------------     
| 
| This controller file shows any memberships made by the user
|
*/

class memberships extends Member_Controller {
	
	function __construct()
	{
		parent::Member_Controller();	
		
		$this->config->set_item('css_body', 'jroxMembersMemberships');
		
		//create pagination links		
		$this->config->set_item('uri', $this->config->slash_item('base_folder_path') . $this->config->slash_item('site_index_page') . $this->uri->segment(1));
		$this->config->set_item('uri_string', str_replace('/', ':', trim_slashes($this->uri->uri_string())));
	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		redirect(MEMBERS_ROUTE . '/memberships/view');
	}
	
	// ------------------------------------------------------------------------
	
	function view()
	{
		//set data array
		$data = $this->security_model->_load_config('members');
		
		//initialize site with required db config
		$sdata = $this->init->_initialize(__CLASS__,  __FUNCTION__);
		
		//set up the languages array
		$data['languages'] = $sdata['languages'];
		
		//set all text
		foreach ($sdata['text'] as $key => $val)
		{
			$data[$key] = $val;
		}
				
		//set referral info
		foreach ($sdata['aff_cfg'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		$text_array = array('memberships', 'no_memberships_found', 'expires', 'login', 'product_name');
		
		foreach ($text_array as $txt)
		{
			$data['lang_' . $txt] = $this->lang->line($txt);
		}
		
		$data['page_title'] = $this->lang->line('memberships');
		$data['meta_keywords'] = $data['sts_store_default_keywords'];
		$data['meta_description'] = $data['sts_store_description'];

		
		$memberships = $this->members->_get_member_memberships($this->session->userdata('userid'));

		$data['show_memberships'] = 0;
		
		if (!empty($memberships))
		{
			$data['show_memberships'] = 1;
			$data['memberships'] = array();
		
			foreach ($memberships as $row)
			{
				$row['s_expires'] = _show_date($row['expires']);
				$row['row_style'] = alternator('jroxRowStyle1', 'jroxRowStyle2');
				
				$row['s_membership_url_redirect'] = empty($row['membership_url_redirect']) ? '#' : $row['membership_url_redirect'];
				
				array_push($data['memberships'], $row);
			}
		}

		//load the template
		$this->parser->_JROX_load_view('tpl_members_memberships', 'members', $data);
	}
	
}

?>