<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - reports.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to show members reports
|
*/

class Reports extends Member_Controller {
	
	function __construct()
	{
		parent::Member_Controller();	
		
		$this->config->set_item('css_body', 'jroxMembersReports');
		
		$this->load->model('reports_model', 'reports');
		
		//create pagination links		
		$this->config->set_item('uri', $this->config->slash_item('base_folder_path') . $this->config->slash_item('site_index_page') . $this->uri->segment(1));
		$this->config->set_item('uri_string', str_replace('/', ':', trim_slashes($this->uri->uri_string())));
	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		redirect(MEMBERS_ROUTE . '/reports/view');
	}
	
	// ------------------------------------------------------------------------
	
	function view()
	{
		//show invoices made by the user
		//set data array
		$data = $this->security_model->_load_config('members');
		
		//initialize site with required db config
		$sdata = $this->init->_initialize(__CLASS__,  __FUNCTION__);
		
		//set up the languages array
		$data['languages'] = $sdata['languages'];
		
		//set all text
		foreach ($sdata['text'] as $key => $val)
		{
			$data[$key] = $val;
		}
				
		//set referral info
		foreach ($sdata['aff_cfg'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		if ($this->session->flashdata('show_message')) 
		{
			$data['show_message'] = $this->session->flashdata('show_message');
		}
		else
		{
			$data['show_message'] = '';
		}
		
		$text_array = array('reports', 'member_reports', 'reports_and_stats', 'no_reports_found', 'no_data_found', 'report_name', 'view');
		
		foreach ($text_array as $txt)
		{
			$data['lang_' . $txt] = $this->lang->line($txt);
		}
		
		$data['page_title'] = $this->lang->line('reports_and_stats');
		$data['meta_keywords'] = $data['sts_store_default_keywords'];
		$data['meta_description'] = $data['sts_store_description'];
		
		$uri = $data['uri'] . '/reports/view/';

		$data['offset'] = $this->uri->segment(4, '0');
		$data['sort_column'] = $this->uri->segment(6, 0);
		$data['sort_order'] = $this->uri->segment(5, 0);
		$data['next_sort_order'] = $this->uri->segment(5) == 'DESC' ? 'ASC' : 'DESC';
		
		//get reports
		$row = $this->reports->_get_member_reports(MEMBERS_REPORTS_PER_PAGE, $data['offset'], $data['sort_column'], $data['sort_order']);

	 	$data['show_reports'] = 0;
		$data['current_month'] = date('m');
		$data['current_year'] = date('Y');
		
		if (!empty($row))
		{
			//add the data to the array
			$data['reports'] = $row;	
			$data['show_reports'] = 1;
		}
		
		//count all rows first
		$row_count = $this->db_validation_model->_get_count('modules', 'WHERE module_type = \'member_reporting\' AND module_status = \'1\'');
		
		$pagination = $this->db_validation_model->_set_pagination($uri, 'modules', MEMBERS_REPORTS_PER_PAGE, 4, $data['sort_order'], $data['sort_column'],  $row_count, '', '', 'public');
		
		$data['pagination_rows'] = $pagination['rows'];
			
		$data['num_pages'] = $pagination['num_pages'];
			
		$data['no_pages'] = $data['num_pages'] > 1 ? 1 : 0;

		//load the template
		$this->parser->_JROX_load_view('tpl_members_reports', 'members', $data);
	}	
}

?>