<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - traffic.php
| -------------------------------------------------------------------------     
| 
| This controller file shows any traffic made by the user
|
*/

class Traffic extends Member_Controller {
	
	function __construct()
	{
		parent::Member_Controller();	
		
		$this->config->set_item('css_body', 'jroxMembersTraffic');
		
		//create pagination links		
		$this->config->set_item('uri', $this->config->slash_item('base_folder_path') . $this->config->slash_item('site_index_page') . $this->uri->segment(1));
		$this->config->set_item('uri_string', str_replace('/', ':', trim_slashes($this->uri->uri_string())));
	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		redirect(MEMBERS_ROUTE . '/traffic/view');
	}
	
	// ------------------------------------------------------------------------
	
	function view()
	{
		//show invoices made by the user
		//set data array
		$data = $this->security_model->_load_config('members');
		
		//initialize site with required db config
		$sdata = $this->init->_initialize(__CLASS__,  __FUNCTION__);
		
		//set up the languages array
		$data['languages'] = $sdata['languages'];
		
		//set all text
		foreach ($sdata['text'] as $key => $val)
		{
			$data[$key] = $val;
		}
				
		//set referral info
		foreach ($sdata['aff_cfg'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		if ($this->session->flashdata('show_message')) 
		{
			$data['show_message'] = $this->session->flashdata('show_message');
		}
		else
		{
			$data['show_message'] = '';
		}
		
		$text_array = array('traffic', 'date', 'referring_url', 'os', 'browser', 'referral_traffic', 'no_traffic_found');
		
		foreach ($text_array as $txt)
		{
			$data['lang_' . $txt] = $this->lang->line($txt);
		}
		
		$data['page_title'] = $this->lang->line('traffic');
		$data['meta_keywords'] = $data['sts_store_default_keywords'];
		$data['meta_description'] = $data['sts_store_description'];
		
		$uri = $data['uri'] . '/traffic/view/';

		$data['offset'] = $this->uri->segment(4, '0');
		$data['sort_column'] = $this->uri->segment(6, 0);
		$data['sort_order'] = $this->uri->segment(5, 0);
		$data['next_sort_order'] = $this->uri->segment(5) == 'DESC' ? 'ASC' : 'DESC';
		
		
		//get currency options
		$num_options = get_default_currency($this->config->item('sts_store_default_currency'));
		
		$sdata = $this->aff->_get_user_traffic($this->session->userdata('userid'),  MEMBERS_TRAFFIC_PER_PAGE, $data['offset'], $data['sort_column'], $data['sort_order']);

		$data['show_traffic'] = 0;
		
		if (!empty($sdata['traffic']))
		{
			$data['show_traffic'] = 1;
			$data['traffic'] = $sdata['traffic'];
		}

		$pagination = $this->db_validation_model->_set_pagination($uri, 'traffic', MEMBERS_TRAFFIC_PER_PAGE, 4, $data['sort_order'], $data['sort_column'],  $sdata['total_rows'], '', '', 'public');
		
		$data['pagination_rows'] = $pagination['rows'];
		
		$data['num_pages'] = $pagination['num_pages'];
			
		$data['no_pages'] = $data['num_pages'] > 1 ? 1 : 0;

		//load the template
		$this->parser->_JROX_load_view('tpl_members_traffic', 'members', $data);
	}
}

?>