<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - module_data_import_jam.php
| -------------------------------------------------------------------------     
| 
| This controller file is for importing JAM data
|
*/


class Module_Data_Import_Jam extends Admin_Controller {
	
	function __construct()
	{
		parent::Admin_Controller();	
		
		//load general export model
		$this->load->model('import_model', 'import');
		
		//load export members model
		$this->load->model('modules/module_data_import_jam_model', 'data_import');
		
		//load css body style
		$this->config->set_item('css_body', 'MN');
		
		//module name
		$this->config->set_item('module_name', 'module_data_import_jam');
		
	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		//redirect to default view
		redirect('modules/module_data_import_jam/run_module');
	}
	
	// ------------------------------------------------------------------------	
	
	function run_module()
	{
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//set page title
		$data['page_title'] = $this->lang->line('import_jam_database');
		$data['submit_url'] = base_url() . $data['site_index_page'] . 'modules/module_data_import_jam/run_module/'.(int)$this->uri->segment(4);	
		$data['show_message'] = '';
		
		if ($this->_check_module() == false)
		{		
			if (!empty($_POST))
			{
				$data['show_message'] = '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			}
		}
		else
		{	
			//run import
			$sdata = $this->data_import->_import_data($_POST);	
			
			$data['show_message'] = '<div class="success" onclick="self.parent.location.reload(true);" style="cursor:pointer;">' . $sdata . ' ' . $this->lang->line('users_imported_successfully') . '. ' . $this->lang->line('click_to_continue') . '</div>';
		}	
		
		//load template
		load_admin_tpl('modules', 'tpl_adm_manage_data_import_jam', $data, false, false);		
	}
	
	// ------------------------------------------------------------------------	
	
	function update()
	{
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//set page title
		$data['page_title'] = $this->lang->line('import_jam_database');
		
		$data['submit_url'] = base_url() . $data['site_index_page'] . 'modules/module_data_import_jam/update/'.(int)$this->uri->segment(4);
	
		//run check
		
		if ($this->_check_update() == false)
		{		
			
			//reload add group form
			if (empty($_POST))
			{
				$mdata = $this->import->_get_import_details((int)$this->uri->segment(4));
				
				if (!empty($mdata))
				{	
					foreach ($mdata[0] as $key => $value)
					{	
						$this->validation->$key = $value;	
					}
					
					
					$data['sts_config'] = array();
					
					foreach ($mdata[0]['sts_config'] as  $v)
					{
						$this->validation->$v['settings_key'] = $v['settings_value'];
		
						array_push($data['sts_config'], $v);
					
					}	
				}
				else
				{
					//ajax form
				echo '<div class="error" id="error-messages">' . $this->lang->line('no_settings_available') . '</div>';
				}
				
				//load template
				load_admin_tpl('modules', 'tpl_adm_manage_data_import_settings', $data, false, false);
							
			}
			else
			{				
				//ajax form
				echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			}		
		}
		else
		{	
			//update shipping config
			$data = $this->import->_update_import((int)$this->uri->segment(4));	
			
			//ajax message
			echo '<div class="success" onclick="self.parent.location.reload(true);" style="cursor:pointer;">' . $this->lang->line('update_module_success') . '. ' . $this->lang->line('click_to_continue') . '</div>';		
			exit();	
		}		
	}
	
	// ------------------------------------------------------------------------	
	
	function _check_module()
	{
	
		$rules['module_data_import_jam_server'] = 'trim|required|callback__check_jam_db_connect';
		$rules['module_data_import_jam_database'] = 'trim|required';
		$rules['module_data_import_jam_username'] = 'trim|required';
		$rules['module_data_import_jam_password'] = 'trim';
		$rules['module_data_import_jam_last_id'] = 'trim';
		
		$this->validation->set_rules($rules);
		
		//repopulate form
		$fields['module_data_import_jam_server'] = $this->lang->line('module_data_import_jam_server');
		$fields['module_data_import_jam_database'] = $this->lang->line('module_data_import_jam_database');
		$fields['module_data_import_jam_username'] = $this->lang->line('module_data_import_jam_username');
		$fields['module_data_import_jam_password'] = $this->lang->line('module_data_import_jam_password');
		$fields['module_data_import_jam_last_id'] = $this->lang->line('module_data_import_jam_last_id');
		
		$this->validation->set_fields($fields);
			
		if ($this->validation->run() == FALSE)	
		{
			return false;
		}

	
		return true;
	}
	
	// ------------------------------------------------------------------------	
	
	function _check_update()
	{
	
		$rules['module_data_import_jam_segment_affiliates'] = 'trim|required';
		$rules['module_data_import_jam_affiliate_limit'] = 'trim|integer|required';
		$rules['module_data_import_jam_affiliate_offset'] = 'trim|integer|required';
		
		$rules['module_data_import_jam_segment_commissions'] = 'trim|required';
		$rules['module_data_import_jam_commission_limit'] = 'trim|integer|required';
		$rules['module_data_import_jam_commission_offset'] = 'trim|integer|required';
		
		$rules['module_data_import_jam_segment_payments'] = 'trim|required';
		$rules['module_data_import_jam_payment_limit'] = 'trim|integer|required';
		$rules['module_data_import_jam_payment_offset'] = 'trim|integer|required';
		
		$rules['module_data_import_jam_segment_traffic'] = 'trim|required';
		$rules['module_data_import_jam_traffic_limit'] = 'trim|integer|required';
		$rules['module_data_import_jam_traffic_offset'] = 'trim|integer|required';
		
		$this->validation->set_rules($rules);
		
		//repopulate form
		$fields['module_data_import_jam_segment_affiliates'] = $this->lang->line('module_data_import_jam_segment_affiliates');
		$fields['module_data_import_jam_affiliate_limit'] = $this->lang->line('module_data_import_jam_affiliate_limit');
		$fields['module_data_import_jam_affiliate_offset'] = $this->lang->line('module_data_import_jam_affiliate_offset');
		
		$fields['module_data_import_jam_segment_commissions'] = $this->lang->line('module_data_import_jam_segment_commissions');
		$fields['module_data_import_jam_commission_limit'] = $this->lang->line('module_data_import_jam_commission_limit');
		$fields['module_data_import_jam_commission_offset'] = $this->lang->line('module_data_import_jam_commission_offset');
		
		$fields['module_data_import_jam_segment_payments'] = $this->lang->line('module_data_import_jam_segment_payments');
		$fields['module_data_import_jam_payment_limit'] = $this->lang->line('module_data_import_jam_payment_limit');
		$fields['module_data_import_jam_payment_offset'] = $this->lang->line('module_data_import_jam_payment_offset');
		
		$fields['module_data_import_jam_segment_traffic'] = $this->lang->line('module_data_import_jam_segment_traffic');
		$fields['module_data_import_jam_traffic_limit'] = $this->lang->line('module_data_import_jam_traffic_limit');
		$fields['module_data_import_jam_traffic_offset'] = $this->lang->line('module_data_import_jam_traffic_offset');
		
		$this->validation->set_fields($fields);
			
		if ($this->validation->run() == FALSE)	
		{
			return false;
		}

	
		return true;
	}
	
	// ------------------------------------------------------------------------	
	
	function _check_jam_db_connect()
	{
		$con = @mysql_connect($this->validation->module_data_import_jam_server,$this->validation->module_data_import_jam_username,$this->validation->module_data_import_jam_password);
		if (!$con)
		{
			$this->validation->set_message('_check_jam_db_connect', $this->lang->line('could_not_connect_database_server'));
			return FALSE;
		}
		else
		{
			if (!mysql_select_db($this->validation->module_data_import_jam_database, $con))
			{
				$this->validation->set_message('_check_jam_db_connect', $this->lang->line('could_not_connect_database'));
				return false;
			}
		}
		
		
		return true;
	}
	
	// ------------------------------------------------------------------------	
	
	
}
?>