<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - Module_Adm_Shipping_fedex.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to manage fedex shipping
|
*/

class Module_Shipping_Fedex extends Admin_Controller {
	
	function __construct()
	{
		parent::Admin_Controller();	
		
		//load shipping model
		$this->load->model('shipping_model', 'ship');
		
		//load required model
		$this->load->model('modules/module_shipping_fedex_model', 'ship_fedex');
		
		//load css body style
		$this->config->set_item('css_body', 'CF');
		
		//create pagination links		
		$this->config->set_item('uri', ADMIN_ROUTE. '/' . $this->uri->segment(2) . '/table');
		
	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		//redirect to default view
		redirect(ADMIN_ROUTE . '/shipping/view_shipping');
	}
	
	// ------------------------------------------------------------------------	
	
	function update()
	{
		//set data array
		$data = $this->security_model->_load_config('admin');
		
		//set page title
		$data['page_title'] = $this->lang->line('charge_shipping_fedex');
		
		$data['submit_url'] = base_url() . $data['site_index_page'] . 'modules/module_shipping_fedex/update/'.(int)$this->uri->segment(4);
	
		//run check
		
		if ($this->_check_update() == false)
		{		
			
			//reload add group form
			if (empty($_POST))
			{
				$mdata = $this->ship->_get_shipping_details((int)$this->uri->segment(4));
				
				if (!empty($mdata))
				{	
					foreach ($mdata[0] as $key => $value)
					{	
						$this->validation->$key = $value;	
					}
					
					
					$data['sts_config'] = array();
					
					foreach ($mdata[0]['sts_config'] as  $v)
					{
						$this->validation->$v['settings_key'] = $v['settings_value'];
		
						array_push($data['sts_config'], $v);
					
					}
					
					//load template
					load_admin_tpl('modules', 'tpl_adm_manage_shipping_fedex', $data, false, false);
	
				}
				else
				{
					//load add page
					redirect(ADMIN_ROUTE . '/shipping/view_shipping');
					exit();
				}
							
			}
			else
			{				
				//ajax form
				echo '<div class="error" id="error-messages">' . $this->validation->error_string . '</div>';
			}		
		}
		else
		{	
			//update shipping config
			$data = $this->ship_fedex->_update_shipping((int)$this->uri->segment(4));	
			
			//ajax message
			echo '<div class="success" onclick="self.parent.location.reload(true);" style="cursor:pointer;">' . $this->lang->line('update_module_success') . '. ' . $this->lang->line('click_to_continue') . '</div>';		
			exit();	
		}		
	}
	
	// ------------------------------------------------------------------------	
	
	function _check_update()
	{
		$rules['module_name'] = 'trim|required';
		$rules['module_shipping_fedex_handling_fee'] = 'trim|numeric';
		
		$this->validation->set_rules($rules);
		
		//repopulate form
		$fields['module_name'] = $this->lang->line('module_name');
		$fields['module_shipping_fedex_handling_fee'] = $this->lang->line('module_shipping_fedex_handling_fee');
		
		$this->validation->set_fields($fields);
			
		if ($this->validation->run() == FALSE)	
		{
			return false;
		}

	
		return true;
	}
	
	// ------------------------------------------------------------------------	
	
}
?>