<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - Product_Categories.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to generate product categories
|
*/

class Product_Categories extends Public_Controller {

	function __construct()
	{
		parent::Public_Controller();	
		
		//load css body style
		$this->config->set_item('css_body', 'jroxProductCategories');
		
		//load required models
		$this->load->model('init_model', 'init');
		
		//create pagination links		
		$this->config->set_item('uri', $this->config->slash_item('base_folder_path') . $this->config->slash_item('site_index_page') . $this->uri->segment(1));
			
	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{	
		//set data array
		$data = $this->security_model->_load_config('public');
		$data['parent_id'] = $this->uri->segment(2, 0);
		
		//set the meta tags
		$data['page_title'] = $this->lang->line('product_categories');
		$data['meta_keywords'] = $data['sts_store_default_keywords'];
		$data['meta_description'] = $data['sts_store_description'];
		$data['product_categories_dir'] = $data['images_product_categories_dir'];
		
		//initialize site with required db config
		$sdata = $this->init->_initialize(__CLASS__,  __FUNCTION__);
		
		//set up the languages array
		$data['languages'] = $sdata['languages'];
		
		//set all text
		foreach ($sdata['text'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		//set referral info
		foreach ($sdata['aff_cfg'] as $key => $val)
		{
			$data[$key] = $val;
		}
					
		$row = $this->prod_cat->_get_top_level_categories($this->uri->segment(2, 0));
		
		if (empty($row))
		{
			$data['categories'] = '';
			$data['no_categories'] = '1';
			$data['lang_no_categories_found'] = $this->lang->line('no_categories_found');
		}
		else
		{
			//format the array with proper images
			$fdata = array();
			
			foreach ($row as $k => $v)
			{
				if (empty($v['category_image']))
				{
					$v['category_image'] = base_url(). 'themes/main/' . $this->config->item('layout_design_site_theme') . '/images/no_cat_photo.png';
				}
				else
				{
					$v['category_image'] = base_url(). 'images/' . $this->config->item('images_product_categories_dir')  . '/' . $v['category_image'];
				}
				
				$v['category_name_url'] = url_title($v['category_name']);
				
				$v['total'] = $v['total'] > 1 ? $v['total'] . ' ' . $this->lang->line('products') : $v['total'] . ' ' . $this->lang->line('product');
				
				if ($v['total'] == 0) $v['total'] = $this->lang->line('no_products');
				
				array_push($fdata, $v);
			}	
			
			$data['categories'] = $fdata;
			$data['no_categories'] = '0';
		}
		
		//text for this page
		$data['lang_product_categories'] = $this->lang->line('product_categories');
		
		$this->parser->_JROX_load_view('tpl_product_categories', 'store', $data);
	}
}

?>