<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - subscribe.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to subscribe users to mailing lists
|
*/

class Subscribe extends Public_Controller {
	
	function __construct()
	{
		parent::Public_Controller();	

		
		//load required models
		$this->load->model('init_model', 'init');
		$this->load->model('emailing_model');
		$this->load->model('members_model');
		$this->load->library('convert');
	}

	// ------------------------------------------------------------------------
	
	function index()
	{
		//subscribe a user from mailing list
		//set data array
		$data = $this->security_model->_load_config('public');
		
		//initialize site with required db config
		$sdata = $this->init->_initialize(__CLASS__,  __FUNCTION__);
		
		//set up the languages array
		$data['languages'] = $sdata['languages'];
		
		//set all text
		foreach ($sdata['text'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		//set referral info
		foreach ($sdata['aff_cfg'] as $key => $val)
		{
			$data[$key] = $val;
		}
		
		//set page title
		$data['page_title'] = $this->lang->line('subscribe');
		$data['meta_keywords'] = '';
		$data['lang_heading'] = $this->lang->line('subscribe');
		
		$data['show_message'] = $this->lang->line('mailing_list_subscription');
		$data['sub_message'] = '';
		
		if ($this->_check_email_subscribe() == false)
		{
			redirect('error/custom/' . $this->convert->AsciiToHex(base64_encode($this->validation->error_string)));
		}
		else
		{
			//get the member info 
			
			if ($this->members_model->_add_member_list($_POST) == true)
			{
				$data['sub_message'] = $this->input->post('primary_email') . ' ' . $this->lang->line('user_subscribed_successfully');
				
				$this->parser->_JROX_load_view('tpl_general_message', 'none', $data);
			}
			else
			{
				show_error('invalid_data');
			}
		}		
	}
	
	// ------------------------------------------------------------------------
	
	/*--------------------------------
	| supporting functions are below
	---------------------------------*/
	
	// ------------------------------------------------------------------------
	
	function _check_email_subscribe()
	{
		$rules['fname'] = 'trim|required|min_length[2]';
		$rules['primary_email'] = 'trim|required|strtolower|valid_email|callback__check_email_add';

		$this->validation->set_rules($rules);

		//repopulate form

		$fields['comment'] = $this->lang->line('comment');
		$fields['primary_email'] = $this->lang->line('primary_email');
		
		$this->validation->set_fields($fields);
			
		if ($this->validation->run() == FALSE)	
		{
			return false;
		}
		
		return true;	
	}
	
	// ------------------------------------------------------------------------		
	
	function _check_email_add()
	{

		if ($this->security_model->_check_free_email_accounts($this->validation->primary_email) == true)
		{
			$this->validation->set_message('_check_email_add', $this->lang->line('free_email_accounts_not_allowed'));
			return false;
		}
		elseif ($this->db_validation_model->_validate_field('members', 'primary_email', $this->validation->primary_email))
		{
			$this->validation->set_message('_check_email_add', $this->lang->line('member_email_taken'));
			return false;
		}
	}
}

?>