<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - template_js.php
| -------------------------------------------------------------------------     
| 
| This controller file houses javascript functions for templates
|
*/

class Template_Js extends Controller {

	function __construct()
	{
		parent::Controller();
		
		$this->load->library('session');
		$this->session->sess_run('public');
				
		//header("Content-type: application/x-javascript");
		
		//set the default time zone
		if ($this->config->item('sts_default_php_timezone'))
		{
			date_default_timezone_set($this->config->item('sts_default_php_timezone'));
		}
		else
		{
			date_default_timezone_set('GMT');	
		}
	}
	
	// ------------------------------------------------------------------------
	
	function index()
	{
		redirect();	
	}
	
	// ------------------------------------------------------------------------
	
	function type()
	{
		//check language
		if ($this->session->userdata('user_language_set'))
		{
			$this->config->set_item('sts_store_default_language', $this->session->userdata('user_language_set'));
		}
		
		$this->lang->load('common', $this->config->item('sts_store_default_language'));
		
		switch ($this->uri->segment(3))
		{
			case 'blog_details':
				
				echo '$().ready(function() { $("#jroxPostCommentForm").validate(
						{
							rules: {
								article_comment: "required",
								jroxVerifyField: "required"
								
							},
							messages: {
								article_comment: "' . $this->lang->line('required_field') . '",
								jroxVerifyField:"' . $this->lang->line('required_field') . '"
							}
						}
					);});';
				
			break;
			
			case 'cart';
				
				echo '$().ready(function() { 
			$("#loading").ajaxStart(function(){ $(this).show(); }).ajaxStop(function(){ $(this).hide(); }); 
			$("#jroxUpdateCartForm").validate();
			$("#jroxUpdateCouponForm").validate();
			$("#jroxEstimateShippingForm").validate 
			({submitHandler: function(form) {
				$(form).ajaxSubmit({
					target: "#ajaxContent"
				});}}
			);
			$("#jroxCartCountryDropdown").change(onSelectChange);

		});

		function onSelectChange(){
			var selected = $("#jroxCartCountryDropdown option:selected");		
			var output = "";
			if(selected.val() != 0){
				$.post("cart/load_regions", { id: $(this).val() },
		  function(data){
			process(data);
		  }, "json");
			}
		}
		
		function process(j){
		 var options = \'\';
		  for (var i = 0; i < j.length; i++) {
			options += \'<option value="\' + j[i].optionValue + \'">\' + j[i].optionDisplay + \'</option>\';
		  }
		  $("select#jroxCartRegionDropdown").html(options);
		}
		
		function RemoveCoupon(){
			var answer=confirm("' . $this->lang->line('remove_coupon_text') . '")
			if(answer) {
				window.location.href="' . _jrox_public_url() . 'cart/remove_coupon";	
			} 
		}';
			
			break;
			
			case 'checkout':
			
				echo '$(function() { 
			$(".loading").ajaxStart(function(){ $(this).show(); }).ajaxStop(function(){ $(this).hide(); }); 
			
			$("#jroxCheckoutLoginForm").validate();';
			
			if ($this->config->item('member_registration_disable_ajax') == true)
			{
				echo '$("#jroxCheckoutPaymentForm").validate();';		
			}
			else
			{
			
			echo '$("#jroxCheckoutPaymentForm").validate({submitHandler: function(form) {
					$(form).ajaxSubmit({
						target: "#ajaxContent",
						beforeSubmit:  hideAjaxButton,
						success: showAjaxButton
					});
					}}
				);';			
			}
					
			
			echo '$("input[@name=\'ship_option\']").click(function(){
				if ($("input[@name=\'ship_option\']:checked").val() == 1)
				{
					$("#jroxCheckoutShippingBox").show(400);
					{js_shipping_show}
				}
				else
				{
					$("#jroxCheckoutShippingBox").hide(400);
					{js_shipping_hide}
				}
				}
			);
			
												
			$("input[@name=\'affil_option\']").click(function(){
				if ($("input[@name=\'affil_option\']:checked").val() == 1)
				{
					$("#jroxCheckoutAffiliateBox").show(400);
					{js_payment_show}
				}
				else
				{
					$("#jroxCheckoutAffiliateBox").hide(400);
					{js_payment_hide}
				}
				}
			);
		});
		
		function hideAjaxButton() {
			 $("#submit_button").hide();
			 $("#please_wait").show();
		}
		
		function showAjaxButton() {
			$("#submit_button").show();
			$("#please_wait").hide();
			showResponse();
		}
			
		function onSelectChange(id, select) {
			var index;
			
			for(index=0; index<select.options.length; index++)
			if(select.options[index].selected)
			{
				if(select.options[index].value!="")
					cid = select.options[index].value;
					
					if (id == \'billing_country\')
					{
						 $("#jroxCheckoutPaymentFieldInput_billing_state").load("' . $this->config->item('checkout_index_page') . 'checkout/load_regions/" + cid + "/billing_state"); 
					}
					else if (id == \'shipping_country\')
					{
						 $("#jroxCheckoutPaymentFieldInput_shipping_state").load("' . $this->config->item('checkout_index_page') . 'checkout/load_regions/" + cid + "/shipping_state");
					}
					else if (id == \'payment_country\')
					{
						 $("#jroxCheckoutPaymentFieldInput_payment_state").load("' . $this->config->item('checkout_index_page') . 'checkout/load_regions/" + cid + "/payment_state"); 
					}
					
				break;
			}
		}';
			
			break;
			
			case 'checkout_membership':
			
				echo '$(function() { 
			$(".loading").ajaxStart(function(){ $(this).show(); }).ajaxStop(function(){ $(this).hide(); }); 
			
			$("#jroxCheckoutLoginForm").validate();';
					
			if ($this->config->item('member_registration_disable_ajax') == true)
			{
				echo '$("#jroxCheckoutPaymentForm").validate();';		
			}
			else
			{
			
			echo '$("#jroxCheckoutPaymentForm").validate({submitHandler: function(form) {
					$(form).ajaxSubmit({
						target: "#ajaxContent",
						beforeSubmit:  hideAjaxButton,
						success: showAjaxButton
					});
					}}
				);';			
			}	
			
		
			
			echo '$("input[@name=\'ship_option\']").click(function(){
				if ($("input[@name=\'ship_option\']:checked").val() == 1)
				{
					$("#jroxCheckoutShippingBox").show(400);
					{js_shipping_show}
				}
				else
				{
					$("#jroxCheckoutShippingBox").hide(400);
					{js_shipping_hide}
				}
				}
			);
			
												
			$("input[@name=\'affil_option\']").click(function(){
				if ($("input[@name=\'affil_option\']:checked").val() == 1)
				{
					$("#jroxCheckoutAffiliateBox").show(400);
					{js_payment_show}
				}
				else
				{
					$("#jroxCheckoutAffiliateBox").hide(400);
					{js_payment_hide}
				}
				}
			);
		});
		
		function hideAjaxButton() {
			 $("#submit_button").hide();
			 $("#please_wait").show();
		}
		
		function showAjaxButton() {
			$("#submit_button").show();
			$("#please_wait").hide();
			showResponse();
		}
			
		function onSelectChange(id, select) {
			var index;
			
			for(index=0; index<select.options.length; index++)
			if(select.options[index].selected)
			{
				if(select.options[index].value!="")
					cid = select.options[index].value;
					
					if (id == \'billing_country\')
					{
						 $("#jroxCheckoutPaymentFieldInput_billing_state").load("' . $this->config->item('checkout_index_page') . 'checkout/load_regions/" + cid + "/billing_state"); 
					}
					else if (id == \'payment_country\')
					{
						 $("#jroxCheckoutPaymentFieldInput_payment_state").load("' . $this->config->item('checkout_index_page') . 'checkout/load_regions/" + cid + "/payment_state"); 
					}
					
				break;
			}
		}

		function RemoveCoupon(){
			var answer=confirm("' . $this->lang->line('remove_coupon_text') . '")
			if(answer) {
				window.location.href="' . $this->config->item('checkout_url') . 'membership/remove_coupon/registration/' . $this->uri->segment(4) . '";	
			} 
		}';
			
			break;
			
			case 'contact':
			
				echo '$().ready(function() { $("#jroxContactForm").validate();});';
			
			break;
			
			case 'login':
				
				echo '$().ready(function() { $("#jroxMemberLogin").validate(
					{
						rules: {
							username: {
								required: true,
								email: true
							},
							password: "required"
							
						},
						messages: {
							username: "' . $this->lang->line('invalid_email') . '",
							password:"' . $this->lang->line('required_field') . '"
						}
					}
				);});
				
				$().ready(function() { $("#jroxMemberResetPass").validate();});';
			
			break;
			
			case 'membership_invoice':
			
				echo '$(function() { 
			$(".loading").ajaxStart(function(){ $(this).show(); }).ajaxStop(function(){ $(this).hide(); }); 

			$("#jroxCheckoutPaymentForm").validate({submitHandler: function(form) {
				$(form).ajaxSubmit({
					target: "#ajaxContent",
					beforeSubmit:  hideAjaxButton,
					success: showAjaxButton
				});
				}}
			);					
		});
		
		function onSelectChange(select) {
			var index;
			
			for(index=0; index<select.options.length; index++)
			if(select.options[index].selected)
			{
					cid = select.options[index].value;
					
					$(".jroxGatewayOption").hide(400);
					$("#jrox-" + cid).show(400);
					
				break;
			}
		}
		
		function hideAjaxButton() {
			 $("#submit_button").hide();
			 $("#please_wait").show();
		}
		
		function showAjaxButton() {
			$("#submit_button").show();
			$("#please_wait").hide();
			showResponse();
		}
			';
			
			break;
			
			case 'membership_payment':
			
				echo '$(function() { 
			$(".loading").ajaxStart(function(){ $(this).show(); }).ajaxStop(function(){ $(this).hide(); }); 

			$("#jroxCheckoutPaymentForm").validate({submitHandler: function(form) {
				$(form).ajaxSubmit({
					target: "#ajaxContent",
					beforeSubmit:  hideAjaxButton,
					success: showAjaxButton
				});
				}}
			);					
		});
		
		function onSelectChange(select) {
			var index;
			
			for(index=0; index<select.options.length; index++)
			if(select.options[index].selected)
			{
					cid = select.options[index].value;
					
					$(".jroxGatewayOption").hide(400);
					$("#jrox-" + cid).show(400);
					
				break;
			}
		}
		
		function hideAjaxButton() {
			 $("#submit_button").hide();
			 $("#please_wait").show();
		}
		
		function showAjaxButton() {
			$("#submit_button").show();
			$("#please_wait").hide();
			showResponse();
		}';
			
			break;
			
			case 'payment':
			
				echo '$(function() { 
			$(".loading").ajaxStart(function(){ $(this).show(); }).ajaxStop(function(){ $(this).hide(); }); 

			$("#jroxCheckoutPaymentForm").validate({submitHandler: function(form) {
				$(form).ajaxSubmit({
					target: "#ajaxContent",
					beforeSubmit:  hideAjaxButton,
					success: showAjaxButton
				});
				}}
			);			
		});
		
		function onSelectChange(select) {
			var index;
			
			for(index=0; index<select.options.length; index++)
			if(select.options[index].selected)
			{
				
					cid = select.options[index].value;
					
					$(".jroxGatewayOption").hide(400);
					$("#" + cid).show(400);
					
				break;
			}
		}
		
		function hideAjaxButton() {
			 $("#submit_button").hide();
			 $("#please_wait").show();
		}
		
		function showAjaxButton() {
			$("#submit_button").show();
			$("#please_wait").hide();
			showResponse();
		}';
			
			break;
			
			case 'payment_invoice':
			
				echo '$(function() { 
			$(".loading").ajaxStart(function(){ $(this).show(); }).ajaxStop(function(){ $(this).hide(); }); 

			$("#jroxCheckoutPaymentForm").validate({submitHandler: function(form) {
				$(form).ajaxSubmit({
					target: "#ajaxContent",
					beforeSubmit:  hideAjaxButton,
					success: showAjaxButton
				});
				}}
			);			
		});
		
		function onSelectChange(select) {
			var index;
			
			for(index=0; index<select.options.length; index++)
			if(select.options[index].selected)
			{
				
					cid = select.options[index].value;
					
					$(".jroxGatewayOption").hide(400);
					$("#" + cid).show(400);
					
				break;
			}
		}
		
		function hideAjaxButton() {
			 $("#submit_button").hide();
			 $("#please_wait").show();
		}
		
		function showAjaxButton() {
			$("#submit_button").show();
			$("#please_wait").hide();
			showResponse();
		}';
				
			break;
			
			case 'product_details':
			
				echo '$(function() {$(\'#jroxTabs > ul\').tabs(); });
			$().ready(function() { $("#jroxProductDetailsForm").validate();});
			
			function jroxConfirmRecommend(){
				var answer=confirm("' . $this->lang->line('add_to_profile_recommended') . '")
				if(answer) {
					window.location.href="' . base_url() . $this->config->slash_item('index_page') .  PRODUCTS_ROUTE.'/recommend/' . $this->uri->segment(4) . '";	
				} 
			}';
				
			break;
			
			case 'profile':
			
				echo 'function jroxConfirmDelete(id){
				var answer=confirm("' . $this->lang->line('delete_profile_recommended') . '")
				if(answer) {
					window.location.href="' . base_url() . $this->config->slash_item('index_page') . PRODUCTS_ROUTE.'/recommend/" + id + "/delete";	
				} 
			}';
			
			break;
			
			case 'registration':
			
				echo '$(function() { 
			$(".loading").ajaxStart(function(){ $(this).show(); }).ajaxStop(function(){ $(this).hide(); });';
			
			if ($this->config->item('member_registration_disable_ajax') == true)
			{
				echo '$("#jroxCheckoutPaymentForm").validate();';		
			}
			else
			{
			
			echo '$("#jroxCheckoutPaymentForm").validate({submitHandler: function(form) {
					$(form).ajaxSubmit({
						target: "#ajaxContent",
						beforeSubmit:  hideAjaxButton,
						success: showAjaxButton
					});
					}}
				);';			
			}
			
		echo '});
		
		function hideAjaxButton() {
			 $("#submit_button").hide();
			 $("#please_wait").show();
		}
		
		function showAjaxButton() {
			$("#submit_button").show();
			$("#please_wait").hide();
			showResponse();
		}
			
		function onSelectChange(id, select) {
			var index;
			
			for(index=0; index<select.options.length; index++)
			if(select.options[index].selected)
			{
				if(select.options[index].value!="")
					cid = select.options[index].value;
					
					if (id == \'billing_country\')
					{
						$("#jroxCheckoutPaymentFieldInput_billing_state").load("' . $this->config->item('checkout_index_page') . 'checkout/load_regions/" + cid + "/billing_state"); 
					}
					else if (id == \'payment_country\')
					{
						 $("#jroxCheckoutPaymentFieldInput_payment_state").load("' . $this->config->item('checkout_index_page') . 'checkout/load_regions/" + cid + "/payment_state"); 
					}
					
				break;
			}
		}';
			
			break;
			
			case 'reset_password':
			
				echo '$().ready(function() { $("#jroxMemberResetPass").validate();});';
			
			break;
			
			case 'review_product':
			
				echo '$().ready(function() { $("#jroxPostReviewForm").validate();});';
			
			break;
			
			case 'boxes_member_login':
			
				echo '	$().ready(function() { $("#layout_box_member_login").validate(
		{
			rules: {
				username: {
					required: true,
					email: true
				},
				password: "required"
				
			},
			messages: {
				username: "' . $this->lang->line('invalid_email') . '",
				password:"' . $this->lang->line('required_field') . '"
			}
		}
	);});';
			
			break;
			
			case 'boxes_list_subscribe':
			
				echo '	$().ready(function() { $("#layout_box_list_subscribe").validate(
		{
			rules: {
				primary_email: {
					required: true,
					email: true
				},
				fname: "required"
				
			},
			messages: {
				primary_email: "' . $this->lang->line('invalid_email') . '",
				fname:"' . $this->lang->line('required_field') . '"
			}
		}
	);});';
			
			break;
			
		}
	}
	
	function members()
	{
		switch($this->uri->segment(3))
		{
			case 'account':
			
				echo '$(function() { 
			$(".loading").ajaxStart(function(){ $(this).show(); }).ajaxStop(function(){ $(this).hide(); }); 
					
			$("#jroxMembersAccountDetailsForm").validate({submitHandler: function(form) {
				$(form).ajaxSubmit({
					target: "#ajaxContent",
					beforeSubmit:  hideAjaxButton,
					success: showAjaxButton
				});
				}}
			);			
			
			
		});
		
		function hideAjaxButton() {
			 $("#submit_button").hide();
			 $("#please_wait").show();
		}
		
		function showAjaxButton() {
			$("#submit_button").show();
			$("#please_wait").hide();
			showResponse();
		}
			
		function onSelectChange(id, select) {
			var index;
			
			for(index=0; index<select.options.length; index++)
			if(select.options[index].selected)
			{
				if(select.options[index].value!="")
					cid = select.options[index].value;
					
					if (id == \'billing_country\')
					{
						 $("#jroxCheckoutPaymentFieldInput_billing_state").load("' . $this->config->item('index_page') . 'members/account/load_regions/" + cid + "/billing_state"); 
					}
					else if (id == \'payment_country\')
					{
						 $("#jroxCheckoutPaymentFieldInput_payment_state").load("' . $this->config->item('index_page') . 'members/account/load_regions/" + cid + "/payment_state"); 
					}
					
				break;
			}
		}';
			
			break;
			
			case 'bar_graph_report':
			
				echo '$(document).ready(function(){
	$(".jroxMembersTable tr").mouseover(function() {$(this).addClass("over");}).mouseout(function() {$(this).removeClass("over");});
});';
			
			break;
			
			case 'table':
			
				echo '$(document).ready(function(){
	$(".jroxMembersTable tr").mouseover(function() {$(this).addClass("over");}).mouseout(function() {$(this).removeClass("over");});
});

function ShowDetails(id) {
	$("#view-"+id+"").toggle();
}';
			
			break;
			
			case 'invoice':
			
				echo '$(function() { 
			$(".loading").ajaxStart(function(){ $(this).show(); }).ajaxStop(function(){ $(this).hide(); }); 

			$("#jroxCheckoutPaymentForm").validate({submitHandler: function(form) {
				$(form).ajaxSubmit({
					target: "#ajaxContent",
					beforeSubmit:  hideAjaxButton,
					success: showAjaxButton
				});
				}}
			);			
		});
		
		function onSelectChange(select) {
			var index;
			
			for(index=0; index<select.options.length; index++)
			if(select.options[index].selected)
			{
				
					cid = select.options[index].value;
					
					$(".jroxGatewayOption").hide(400);
					$("#" + cid).show(400);
					
				break;
			}
		}
		
		function hideAjaxButton() {
			 $("#submit_button").hide();
			 $("#please_wait").show();
		}
		
		function showAjaxButton() {
			$("#submit_button").show();
			$("#please_wait").hide();
			showResponse();
		}';
			
			break;
			
			case 'manage_ticket':
			
				echo '$(function() { 			
			$("#jroxMembersSupportForm").validate();
		});';
			
			break;
		}
	}
}
?>