<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME: JROX_string_helper.php
| -------------------------------------------------------------------------     
| 
| This file extends the string_helper
|
*/

// ------------------------------------------------------------------------

function jrox_string_replace($data = '', $replace = '', $type = '')
{
	$data = str_replace($replace, $type, $data);

	return $data;
}

// ------------------------------------------------------------------------

function limit_chars($word = '', $total = 20)
{
	if (strlen($word) > $total)
	{
		$word = substr($word, 0, $total).'...';
	}
	
	return $word;
}

// ------------------------------------------------------------------------

function _generate_random_string($num = 8, $upcase = true)
{

	$string = random_string('alnum', $num);	

	if ($upcase == true)
	{
		return strtoupper($string);
	}
	else
	{
		return strtolower($string);
	}
	
	return $string;
}

// ------------------------------------------------------------------------

function _make_alphanum($str = '')
{
	return preg_replace('/[^a-zA-Z0-9\s]/', '', $str);
}

// ------------------------------------------------------------------------

function _generate_random_username($prepend = '', $append = '')
{
	$CI =& get_instance();
	
	$prepend = url_title(strtolower($prepend), '_');
	
	$prepend =  str_replace('_', '', $prepend);
	
	//first check if the first name is less than 6 characters
	if (strlen($prepend) < 5)
	{
		$left = 5 - strlen($prepend);
		$gen = _generate_random_string($left, false);
		$prepend = $prepend . $gen;
	}
	
	//now check if the username is being used
	$check = true;
	
	while ($check == true)
	{
		$CI->db->select('username');
		$CI->db->from('members');
		$CI->db->where('username', $prepend);
		
		$cquery = $CI->db->get();
		
		if ($cquery->num_rows > 0)
		{
			//get the last row ID from db
			$CI->db->select('member_id');
			$CI->db->from('members');
			$CI->db->order_by('member_id', 'DESC');
			$CI->db->limit('1');
			
			$query = $CI->db->get();
			
			if ($query->num_rows() > 0)
			{
				$num = $query->row();
				$a = $num->member_id;
			}
			else
			{
				$a = 1;
			}
			
			$prepend = substr($prepend, 0, 5);
			
			$prepend = $prepend . $a;
		}
		else
		{
			$check = false;
		}
	}
	
	return strtolower($prepend);
}

?>