<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME: template_helper.php
| -------------------------------------------------------------------------     
| 
| This file loads the template for JEM
|
*/

function _generate_report_graph($graph = '')
{
	$CI =& get_instance();
	
	$show_graph = '<script type="text/javascript">
	var flashvars = {};
	var params = {
					menu: "false",
					wmode: "transparent"
				 };
	var attributes = {};

	swfobject.embedSWF(	"' . $CI->config->item('base_url') . 'js/flashcharts/open-flash-chart.swf", 
						"stats-graph", "' . JROX_CHARTS_GRAPH_WIDTH . '", "' . JROX_CHARTS_GRAPH_HEIGHT . '", "9.0.0",
						"expressInstall.swf", flashvars, params, attributes);
	</script>

';

	if (!empty($graph))
	{
		$show_graph .= '<script type="text/javascript">
	function ofc_ready(){}
	
	function open_flash_chart_data()
	{
		return JSON.stringify(data);
	}
	
	function findSWF(movieName) {
	  if (navigator.appName.indexOf("Microsoft")!= -1) {
		return window[movieName];
	  } else {
		return document[movieName];
	  }
	}
		
	var data = ' . $graph . ';
	</script>
	'; 
	
	}	

	return $show_graph;
}

// ------------------------------------------------------------------------

function _check_ssl($url = '')
{
	if ($_SERVER['SERVER_PORT'] == '443')
	{
		return 'https://' . $url;	
	}
	
	return 'http://' . $url;
}

// ------------------------------------------------------------------------

function _content_filter($body = '')
{
	$CI =& get_instance();
	
	if (is_array($CI->config->item('dbi_content_filter')))
	{
		foreach ($CI->config->item('dbi_content_filter') as $k => $v)
		{
			$body = str_replace($k, $v, $body);	
		}
	}
	
	return $body;
}

// ------------------------------------------------------------------------

function _generate_year_dropdown($select = '', $class = 'select2 text-upper', $onchange = 'ChangeReportStatus(this)')
{
	$CI =& get_instance();

	$options = array();
	
	$total_years = $CI->config->item('dbr_total_report_years');
	
	$month = '1';
	
	$current_year = date('Y');
	
	$last_year = $current_year - $total_years;
	
	for ($i = $current_year; $i > $last_year; $i = $i - '1')
	{	
		$options[$month .'/'.$i] = $CI->lang->line('year'). ' ' . date('Y', mktime(0, 0, 0, '1'  , '1', $i));
	}
		  			   
	return form_dropdown('change_status', $options, $select, 'class="' . $class . '" onchange="' . $onchange . '"'); 
}

// ------------------------------------------------------------------------

function change_content_type($value = '')
{
	$CI =& get_instance();
	
	switch ($value)
	{
		case '1':
			
			return $CI->lang->line('blog');
			
		break;
		
		case '2':
		
			return $CI->lang->line('standard');
		
		break;
		
		case '3':
		
			return $CI->lang->line('advanced');
		
		break;
	}
}

// ------------------------------------------------------------------------

function _generate_month_dropdown($select = '', $class = 'select2 text-upper', $onchange = 'ChangeReportStatus(this)')
{
	$CI =& get_instance();
	
	$options = array();
	
	$total_years = $CI->config->item('dbr_total_report_years');
	
	$current_year = date('Y');
	
	$last_year = $current_year - $total_years;
	
	for ($i = $current_year; $i > $last_year; $i = $i - '1')
	{	
		for ($j = 12; $j >= 1; $j = $j - '1')
		{
			$options[date('m/Y', mktime(0, 0, 0, $j  , '1', $i))] = date('F Y', mktime(0, 0, 0, $j  , '1', $i));
		}
		
		$j = 1;
	}
		  			   
	return form_dropdown('change_status', $options, $select, 'class="' . $class . '" onchange="' . $onchange . '"'); 
}

// ------------------------------------------------------------------------

function load_form($type = '', $file ='', $data = '', $stream = false)
{
	$CI =& get_instance();
	
	if (file_exists(APPPATH . '/views/' . $type . '/' . '/custom_templates/' . $file . '.php' ))
	{
		$body = '/custom_templates/' . $file;
			
	}
	else 
	{
		$body = $file;
	}
	
	if ($stream == true)
	{
		return $CI->load->view($type . '/' . $body, $data, true);
	}
	else
	{
		echo header('Content-type: text/html; charset=' . $CI->config->item('charset'));
		$CI->load->view($type . '/' . $body, $data);
	}
}

// ------------------------------------------------------------------------

function _show_ratings($num = '', $avg = false)
{
	
	// Get fractional part of the rank
	$num = round($num,1);
    $partial = ($num - floor($num)) * 10;
	
    $path = base_url() . 'images/misc/stars';

    $stars = '<span title="' . $num . '">';
    
	for($i=1; $i<=($num);$i++)
    {
        $stars .= '<img src="' . $path . '/star.png" alt=""/>';
    }

    if ($partial > 0)
    {
        $stars .= '<img src="' . $path . '/star' . $partial . '.png" alt=""/>';
    }

    $stars .= '</span>';
	
    return $stars;

}

// ------------------------------------------------------------------------

function load_admin_tpl($type = '', $file = '', $data = '', $top = true, $bottom = true)
{
	$CI =& get_instance();
	
	$template = '';
	
	if ($top == true)
	{
		//load header file
		$template .= $CI->load->view('admin/tpl_adm_header', $data, true);
	}
	
	//load content
	$template .= $CI->load->view($type . '/' . $file, $data, true);
	
	if ($bottom == true)
	{
		//load footer
		$template .= $CI->load->view('admin/tpl_adm_footer', $data, true);
	}
	
	echo header('Content-type: text/html; charset=' . $CI->config->item('charset'));
	echo $template;
}

// ------------------------------------------------------------------------

function _get_bread_crumbs($type = '')
{
	$CI = & get_instance();
	
	if ($type == 'admin')
	{
		$a = '<a href="' . jrox_admin_url() . '" class="bread_crumbs">' . $CI->lang->line('home') . '</a> ';
		
		if (!$CI->uri->segment(2))
		{
			$a .= '| ' . $CI->lang->line('logged_in_as') .' ' . $CI->session->userdata('username') . ' | ' . $CI->lang->line('last_login') . ': ' . $CI->session->userdata('ll_date') . ' | ' . $CI->session->userdata('ll_ip') ;
		}
		else
		{
			$a .= ' &gt; ' . $CI->uri->segment(2);
		}
		
		if ($CI->uri->segment(3))
		{
			$a .= ' &gt; ' . $CI->uri->segment(3);
		}
	}

	$a = str_replace("_", " ", $a);
	
	return $a;
}

// ------------------------------------------------------------------------

function _load_custom_form_fields($type = '') //load the custom fields for use on forms
{
	$CI = & get_instance();
	
	$CI->db->order_by($CI->config->item('dbs_cff_column'), $CI->config->item('dbs_cff_order')); 	
	$CI->db->where('form_type', $type);
	$query = $CI->db->get('form_fields');
	
	if ($query->num_rows() > 0)
	{
		return $query->result_array();
	}
	 
	return  false;
}

// ------------------------------------------------------------------------

function _initialize_js_header($type = '', $exclude_array = array())
{
	$CI = & get_instance();
	
	/*
	<script language="JavaScript" type="text/javascript" src="<?=base_url();?>/js/jquery.js"></script>
	<script language="JavaScript" type="text/javascript" src="<?=base_url();?>/js/tabs/ui.tabs.pack.js"></script>
	<script language="JavaScript" type="text/javascript" src="<?=base_url();?>/js/forms/jquery.form.js"></script>
	<script language="JavaScript" type="text/javascript" src="<?=base_url();?>/js/dimensions/jquery.dimensions.js"></script>
	<script language="JavaScript" type="text/javascript" src="<?=base_url();?>/js/accordion/jquery.accordion.js"></script>
	<script language="JavaScript" type="text/javascript" src="<?=base_url();?>/js/autocomplete/jquery.autocomplete.js"></script>
	<script language="JavaScript" type="text/javascript" src="<?=base_url();?>/js/thickbox/thickbox.js"></script>
	<script language="JavaScript" type="text/javascript" src="<?=base_url();?>/js/popupwindow/jquery.popupwindow.js"></script>
	<script language="JavaScript" type="text/javascript" src="<?=base_url();?>/js/scrollto/jquery.scrollto.js"></script>
	<script language="JavaScript" type="text/javascript" src="<?=base_url();?>/js/common.js"></script>
	*/
	
	$a = array('jquery.js', 'tabs/ui.tabs.pack.js', 'forms/jquery.form.js', 'dimensions/jquery.dimensions.js', 
			   'accordion/jquery.accordion.js', 'autocomplete/jquery.autocomplete.js', 'thickbox/thickbox.js', 
			   'popupwindow/jquery.popupwindow.js', 'scrollto/jquery.scrollto.js', 'jqueryslidemenu.js', 'common.js'
			   );
	
	switch ($type)
	{
		case '':
		
		break;
		
		default:
		
			$options = $a;
		
		break;
	}
	
	$js = '';
	
	foreach ($options as $v)
	{
		if (in_array($v, $exclude_array))
		{
			continue;
		}
		else
		{			
			$js .= '<script language="JavaScript" type="text/javascript" src="' . base_url() . 'js/' . $v . '"></script>';
			$js .= "\n";
		}
	}
	
	return $js;
}

// ------------------------------------------------------------------------

function load_field_type($type = '', $options = '', $selected = '', $class = '', $mod = 'public')
{
	switch ($type)
	{
		case "text":
			
			$data = '<input name="' . $options['form_field_name'] . '" type="text" id="' . $options['form_field_name'] . '" value="' . $selected . '" class="' . $class .'"/>';
			
		break;
		
		case "hidden":
			
			if ($mod == 'admin')
			{
				$data = '<input name="' . $options['form_field_name'] . '" type="text" id="' . $options['form_field_name'] . '" value="' . $selected . '" class="' . $class .'"/>';
			}
			else
			{
			
				$data = '<div>' . $selected . '<input name="' . $options['form_field_name'] . '" type="hidden" id="' . $options['form_field_name'] . '" value="' . $selected . '" class="' . $class .'"/></div>';
			}
			
		break;
		
		case "textarea":
		
			$data = '<textarea name="' . $options['form_field_name'] . '" id="' . $options['form_field_name'] . '" cols="45" rows="5" class="' . $class .'">' . $selected . '</textarea>';
		
		break;
		
		case "dropdown":
		
			$data = '<select name="' . $options['form_field_name'] . '" class="' . $class .'">';
			
			//explode the field values
			$values = explode(",", $options['form_field_values']);
			
			foreach ($values as $v)
			{
				//explode the name value pairs
				$value = explode("|", $v);
				
				if (!empty($value[0]))
				{
					if ($value[0] == $selected)
					{
						$data .= '<option value="' . trim($value[0]) . '" selected="selected">' . trim($value[1]) . '</option>';
					}
					else
					{
						$data .= '<option value="' . $value[0] . '">' . $value[1] . '</option>';
					}
				}
			}

			$data .= '</select>';
		
		break;
	}
	
	return $data; 
}

// ------------------------------------------------------------------------

function _generate_form_dropdown($form_type = '', $form_name = '', $form_values = '', $form_selected = '', $form_options = '', $value = '', $name = '', $selected = '')
	{
		/*
		|------------------------------------------------------
		| this generates the form input such as text / textarea
		|
		| -----------------------------------------------------
		| 
		| $form_type = type of form such as text or dropdown
		| $form_name = the name / id for the form field
		| $form_values = options for the form
		| $form_selected = the selected values if Any.
		| $form_options = extra form field code
		| $value = form dropdown value
		| $name = form dropdown name
		| $selected = the selected id in the dropdown
		|
		|------------------------------------------------------
		*/
		
		$CI = & get_instance();
		
		//first format the form_values array...
		$options = format_array($form_values, $value, $name);
		
		//and the form_selected array
		$selected_options = format_array($form_selected, $selected);
		
		switch ($form_type)
		{
			case "dropdown":
				$m = form_dropdown($form_name, $options, $selected_options, $form_options);
			break;
			
			case "multiple-dropdown":
				$m = form_dropdown($form_name.'[]', $options, $selected_options, 'multiple="multiple" id="' . $form_name . '"' . $form_options . '"');
			break;

		}
		
		return $m;
		
	}
	
// ------------------------------------------------------------------------

function _format_invoice_balance($amount = '', $options = '')
{
	$CI = & get_instance();
	
	if ($amount >= 0)
	{
		$a = $CI->lang->line('print_invoice_balance_due') . ': &nbsp;&nbsp;';
	}
	else
	{
		
		$a = $CI->lang->line('print_invoice_credit_invoice') . ': &nbsp;&nbsp;';
	}
	
	$a .= format_amounts($amount, $options);
	$a = str_replace('-', '+', $a);
	if ($amount > 0)
	{
		$a = '<span class="amount-due">' . $a . '</span>';
	}
	else
	{
		$a = '<span class="invoice-paid">' . $a . '</span>';
	}
	


	return $a;
}

// ------------------------------------------------------------------------

function _generate_settings_field($v = '', $value = '', $attributes = '')
{
	$CI = & get_instance();
	
	switch ($v['settings_type'])
	{
		case 'textarea':
			
		switch ($v['settings_function'])
		{
			case 'base64_decode';
			
				$value = base64_decode($value);
				
			break;
		}
		
		$data = array(
						  'name'	=> $v['settings_key'],
						  'id'	=> $v['settings_key'],
						  'value'	=> $value,
						  'class'	=> 'settingsField'
						 );

			return form_textarea($data);
				
		
		break;
		
		case 'text':
		
			switch ($v['settings_function'])
			{
				case 'license_id':
				
					if (defined('JEM_ENABLE_RESELLER_LINKS'))
					{
						return '<a href="' . $this->config->item('customizer_reseller_direct_url') .'">' . $this->config->item('customizer_reseller_company_name') . '</a>';
					}
				
				break;
			}
			
			$data = array(
						  'name'	=> $v['settings_key'],
						  'id'	=> $v['settings_key'],
						  'value'	=> $value,
						  'class'	=> 'settingsField'
						 );

			return form_input($data);
			
		break;
		
		case 'readonly':
		
			return $value;
		
		break;
		
		case 'dropdown':
			
			$attributes = array('id' => $v['settings_key'], 'class' => 'select');
			
			switch ($v['settings_function'])
			{
				case 'cc_auth_type':
				
					$options = array('AUTH_CAPTURE' => 'Authorization and Capture',
									 'AUTH_ONLY' => 'Authorization Only');
				
				break;
				
				case 'timezone_menu':
				
					$CI->load->helper('date');
					
					return timezone_menu($v['settings_value'], 'timezones', 'sts_store_default_timezone');
					
				break;
				
				case 'paper_size':
				
					$options = array(	'letter' => 'letter',
										'legal'	=> 'legal',
										'11x17' => '11x17');
										
				break;
				
				case 'paper_orientation':
					
					$options = array(	'landscape' => 'landscape',
										'portrait'	=> 'portrait');
										
				break;
				
				case 'order_status':
				
					$options = array(	'order_pending' => $CI->lang->line('order_pending'),
									 	'order_processing' => $CI->lang->line('order_processing'),
										'order_completed' => $CI->lang->line('order_completed')
									 
									 );
					
				break;
				
				case 'editor':
					
					$options = array(	'innovaeditor' => 'innovaeditor');
										
				break;
				
				case 'affiliate_performance_bonus_required':
					
					$options = array(	'commission_amount' => $CI->lang->line('commission_amount'),
										'sales_amount' => $CI->lang->line('sales_amount'));
				
				break;
				
				case 'homepage_redirect':
				
					$options = array(	'homepage' => 'homepage',
										'content'	=> 'content',
										'store'	=> 'store',
										);
					
				break;
					
				break;
				
				case 'cart_commissions':
					$options = array(	'total_sale' => $CI->lang->line('total_sale'),
										'per_product'	=> $CI->lang->line('per_product'));
				break;
				
				case 'affiliate_group':
					
					$array = $CI->db_validation_model->_get_details('affiliate_groups');
					$options = format_array($array, 'group_id', 'aff_group_name');
					
				break;
				
				case 'commission_refund_option':
				
					$options = array(	'none'	=>	$CI->lang->line('do_nothing'),
										'delete'	=>	$CI->lang->line('delete'),
										'pending'	=>	$CI->lang->line('pending')
									);
				
				break;
				
				case 'affiliate_link_type':
				
					$options = array('regular' => $CI->lang->line('regular'), 'subdomain' => $CI->lang->line('subdomain'), 'replicated_site' => $CI->lang->line('replicated_site'));
				
				break;
				
				case 'affiliate_link_username_id':
					
					$options = array('username' => $CI->lang->line('username'), 'id' => $CI->lang->line('id'));
				
				break;
				
				case 'video_control_bar':
					
					$options = array('bottom' => 'bottom', 'over' => 'over', 'none' => 'none');
					
				break;
				
				case 'affiliate_performance_bonus':
				
					$options = array('group_upgrade' => $CI->lang->line('group_upgrade'), 'payment_amount' => $CI->lang->line('payment_amount'));
				
				break;
				
				case 'affiliate_program_type':
				
					$options = array(	'pay-per-sale' => $CI->lang->line('pay-per-sale'), 
										//'pay-per-lead' => $CI->lang->line('pay-per-lead'), 
										//'pay-per-click' => $CI->lang->line('pay-per-click')
										);
					
				break;
				
				case 'delimiter':
				
					$options = array('comma' => 'comma', 'tab' => 'tab', 'semicolon' => 'semicolon');
				
				break;
				
				case 'product_listing_style':
					
					$options = array('grid' => 'grid', 'list' => 'list');
				
				break;
				
				case 'backup_option':
				
					$options = array('daily' => $CI->lang->line('daily'), 'weekly' => $CI->lang->line('weekly'), 'monthly' => $CI->lang->line('monthly'));
				
				break;
				
				case 'boolean':
					
            		$options = array('1' => $CI->lang->line('enable'), '0' => $CI->lang->line('disable'));
            		
				break;
				
				case 'commission_type':
					$options = array('flat' => $CI->lang->line('flat'), 'percent' => $CI->lang->line('percent'));
				break;
				
				case 'countries':
					
					$CI->load->helper('country');		
		
					$options = _load_countries_dropdown($countries = _load_countries_array());

				break;
				
				case 'currencies':	
				
					$currency_array = $CI->db_validation_model->_get_details('currencies');
					$options = format_array($currency_array, 'code', 'title');
				
				break;
				
				case 'date_format':
				
					$options = array(
										'mm/dd/yyyy:m/d/Y:M d Y' => 'mm/dd/yyyy',
										//'dd/mm/yyyy' => 'dd/mm/yyyy',
										//'yyyy/mm/dd' => 'yyyy/mm/dd',
									);
				
				break;
				
				
				case 'image_library':
				
					$options = array('GD' => 'GD', 'GD2' => ' GD2', 'ImageMagick' => 'ImageMagick', 'NetPBM' => 'NetPBM');
					
				break;
				
				case 'language':
					
					$lang_array = $CI->db_validation_model->_get_details('languages');

					$lang_admin_array = array();
					
					foreach ($lang_array as $lang_value)
					{
						$lang_value_path = APPPATH . 'language/' . $lang_value['name'] . '/adm_main_lang.php';
		
						if (file_exists($lang_value_path))
						{
							array_push($lang_admin_array, $lang_value);
						}
					}
					
					$options = format_array($lang_admin_array, 'name', 'name');
			
				break;
				
				case 'pending_commission':
					$options = array('no_pending' => $CI->lang->line('pending_no_email'), 
									 'alert_pending' => $CI->lang->line('pending_send_email'), 
									 'no_unpaid' => $CI->lang->line('unpaid_no_email'), 
									 'alert_unpaid' => $CI->lang->line('unpaid_send_email'));
				break;
				
				case 'mailer_type':
					
					$options = array('php' => 'php', 'smtp' => 'smtp', 'sendmail' => 'sendmail', 'qmail' => 'qmail');
				
				break;
				
				case 'player_link':
					
					$options = array('play'	=> 'play', 'link'	=> 'link');
				
				break;
				
				case 'ssl_tls':
					
					$options = array('none' => 'none', 'ssl' => 'ssl', 'tls' => 'tls');
					
				break;
				
				case 'mailing_list':
				
					$list_array = $CI->db_validation_model->_get_details('email_mailing_lists');
					$options = format_array($list_array, 'mailing_list_id', 'mailing_list_name', true, 'none');	
				
				break;
				
				case 'numbers_5':
					
					$options = array(1 => 1, 2 => 2, 3 => 3, 4 => 4, 5 => 5);
				
				break;
				
				case 'numbers_10':
					
					$options = array(1 => 1, 2 => 2, 3 => 3, 4 => 4, 5 => 5, 6 => 6, 7 => 7, 8 => 8, 9 => 9, 10 => 10);
				
				break;
				
				case 'matrix_width':
				
					for ($i=2; $i <=5; $i++)
					{
						$options[$i] = $i;
					}
				
				break;
				
				case 'numbers_30':
				
					$i = 1;
					while ($i <=30)
					{
						$options[$i] = $i;
						$i++;
					}
				break;
				
				case 'numbers_50':

					$options = array(50 => 50, 100 => 100, 250 => 250, 500 => 500, 1000 => 1000);
					
				break;
				
				case 'enable':
				
					$options = array(0 => $CI->lang->line('disable'), 1 => $CI->lang->line('enable'));
				
				break;
				
				case 'theme':
					
					$template_array = $CI->db_validation_model->_get_details('layout_themes');
					$options = format_array($template_array, 'template_id', 'template_name');
					
				break;
				
				case 'weight':
					
					$options = array('lbs' => $CI->lang->line('lbs'), 'kg' => $CI->lang->line('kg'));
				
				break;
				
				case 'tax_zone':
				
					$array = $CI->db_validation_model->_get_details('tax_zones');
					$options = format_array($array, 'tax_zone_id', 'tax_zone_name');	
					
				break;
				
				case 'zone_calc':
				
					$options = array('item' => $CI->lang->line('item'), 'price' => $CI->lang->line('price'), 'weight' => $CI->lang->line('weight'));
					
				break;
				
				case 'address_type':
				
					$options = array('billing' => $CI->lang->line('billing'), 'shipping' => $CI->lang->line('shipping'));
				
				break;
			}
			
			return form_dropdown($v['settings_key'], $options, $value, 'class="select"');
	
		break;
	}
	
}

// ------------------------------------------------------------------------

function _check_close_buttons($type = '')
{
	$CI = & get_instance();
	
	if ($CI->config->item('sts_admin_disable_thickbox_popups') == '1')
	{
		if ($type == 'click')
		{
			return 'javascript:self.parent.location.reload(true);';
		}
		else
		{
			return 'href="javascript:self.parent.location.reload(true);"';
		}
	}
	else
	{
		if ($type == 'click')
		{
			return 'window.opener.location.reload();self.close();return false;';
		}
		else
		{
			return 'href="javascript:void(0);" onClick="window.opener.location.reload();self.close();return false;"';
		}
	}
}

// ------------------------------------------------------------------------

function _check_admin_popups($url = '', $name = '', $height = '300', $width = '500', $class = '', $style = '')
{
	$CI = & get_instance();
	
	if ($CI->config->item('sts_admin_disable_thickbox_popups') == '1')
	{
		return '<a href="' . $url . '/?height=' . $height . '&width=' . $width . '&KeepThis=true&TB_iframe=true&modal=true" class="' . $class . ' thickbox" style="' . $style . '
">' . $name . '</a>';
	}
	else
	{
		$atts = array(
              'width'      => $width,
              'height'     => $height,
              'scrollbars' => 'yes',
              'status'     => 'no',
              'resizable'  => 'yes',
              'screenx'    => '50',
              'screeny'    => '50'
            );

		return anchor_popup( $url , $name, $atts, $class, $style);
		
		
	}	
}

// ------------------------------------------------------------------------

function _check_thickbox()
{
	$CI = & get_instance();
	
	if ($CI->config->item('sts_image_enable_thickbox') == 1)
	{
		if ($CI->config->item('images_thickbox_class'))
		{
			return 'class="' . $CI->config->item('images_thickbox_class') . '"';
		}
		else
		{
			return 'class="thickbox"';
		}
		
		
		//return 'class="MagicZoom MagicThumb"';
		//return 'class="MagicZoom MagicThumb" rel="zoom-width: 400px; zoom-position: bottom';
	}
	else
	{
		return 'class="popupwindow" rel="windowCenter" target="name"';
	}
}

// ------------------------------------------------------------------------

function _check_image_thumbnail($type = '', $v = '', $resize = 1, $height = '', $width = '', $thickbox = true, $rel = true, $class = 'thumb-images')
{
	$CI = & get_instance();
	
	if ($resize == 1)
	{
		$a = base_url() . 'images/' .  $type . '/' . $v['raw_name'].'_jrox'.$v['file_ext'];
	}
	else
	{
		$a = base_url() . 'images/' .  $type . '/' . $v['photo_file_name'];
	}
	
	if ($thickbox == true)
	{
		$rel_code = $rel == true ? 'rel="products"' : '';
		
		$b = base_url() . 'images/' .  $type . '/' . $v['photo_file_name'];
		$thickbox_code = _check_thickbox();
		$url = '<a href="' . $b . '" ' . $thickbox_code . ' ' . $rel_code . '>';
		$url .=  '<img src="' . $a . '" class="' . $class . '" alt="" />';
	    $url .= '</a>';
		
	}
	else
	{
		$url = '<img src="' . $a . '" class="' . $class . '" alt=""/>';
	}
	
	

	return $url;  
}

// ------------------------------------------------------------------------

function _generate_dynamic_tags($textarea = '', $url = false, $dynamic_tags = true)
{
	$CI =& get_instance();
	
	if ($dynamic_tags == true)
	{
		//setup dynamic tags
		$data = '<div style="float:left; margin-top: 1em;">';
		$data .= '<select id="allowed_tags" class="select" name="allowed_tags" style="font-size: 10px; color: #666;">';
		$data .= '<option>' . $CI->lang->line('allowed_tags') . '</option>';	
			
		if ($url == true) //use for menu maker
		{
			$options = array(	'home', 'store', 'members_login', 'view_cart', 'product_categories', 'manufacturers', 'new_products', 'content',
								'terms_of_service', 'privacy_policy', 'about_us', 'contact_us'
							);
			
			sort($options);
			foreach ($options as $v)
			{
				$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
			}	
		}
		else
		{
		
				
			$data .= '<option value="{store_name}">' . $CI->lang->line('store_name') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {store_name}&nbsp;&nbsp;&nbsp; </option>';
			$data .= '<option value="{login_url}">' . $CI->lang->line('login_url') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {login_url}&nbsp;&nbsp;&nbsp; </option>';
			
			switch ($textarea)
			{
				case 'member_payment_invoice_template':
				
					$options = array('customers_name' , 'customers_company', 'invoice_date', 'due_date',
									 'customers_address_1', 'customers_address_2', 'customers_city',
									 'customers_state', 'customers_country', 'customers_postal_code',
									 'shipping_name', 'shipping_address_1', 'shipping_address_2', 'shipping_company',
									 'shipping_city', 'shipping_state', 'shipping_country', 'order_status',
									 'shipping_postal_code', 'customers_telephone', 'payment_link',
									 'tax_amount', 'shipping_amount', 'customers_primary_email',
									 'products_html', 'products_text', 'payments_html', 'payments_text',
									 'total_amount', 'subtotal_amount', 'total_payments', 'balance_due', 'invoice_id',
									 'store_name', 'store_shipping_address', 'store_shipping_city',
									 'store_shipping_state', 'store_shipping_postal_code','store_shipping_country',
									 'jrox_custom_field_1', 'jrox_custom_field_2',
									 'jrox_custom_field_3', 'jrox_custom_field_4',
									 'jrox_custom_field_5', 'jrox_custom_field_6',
									 'jrox_custom_field_7', 'jrox_custom_field_8',
									 'jrox_custom_field_9', 'jrox_custom_field_10');
									 
									 
									 
									
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}	
					
				break;
				
				case 'admin_alert_comment_moderation_template':
				
					$options = array('article_id', 'article_url' ,'article_comment');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'admin_affiliate_commission_generated_template':
				
					$options = array('member_username', 'commission_amount' ,'fname', 'current_date', 'admin_login_url');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
				
				break;
				
				case 'admin_alert_contact_us_template':
					
					$options = array('current_time', 'contact_email' ,'contact_message_html', 'contact_message_text');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'admin_alert_new_content_comment_template':
				
					$options = array('article_id', 'article_url' ,'article_comment');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
				
				break;
				
				case 'admin_alert_new_order_template':
					
					$options = array('fname', 'customer_name' ,'invoice_id', 'invoice_amount', 'transaction_id', 'payment_method');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'admin_alert_new_signup_template':
					
					$options = array('member_name', 'member_username' ,'signup_ip', 'current_time');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'admin_alert_product_review_template':
					
					$options = array('product_id', 'product_url' ,'review_comment');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'admin_alert_support_ticket_response':
					
					$options = array('current_time', 'ticket_id' ,'ticket_priority', 'ticket_subject', 'ticket_message');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
								
				case 'admin_failed_login_template';
				
					$options = array('admin_login_url', 'username' ,'password', 'date', 'ip_address');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
				
				break;
				
				case 'admin_product_inventory_alert_template';
				
					$options = array('product_name', 'inventory_alert_level' ,'product_id', 'product_sku', 'current_inventory');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
				
				break;
				
				case 'admin_reset_password_template':
					
					$options = array('username', 'new_password');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'admin_ticket_deletion_template':
					
					$options = array('fname', 'ticket_id');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'admin_vendor_alert_template':
					
					$options = array('invoice_id', 'product_name', 'product_sku', 'quantity', 'shipping_fname', 'shipping_lname', 'shipping_address_1', 'shipping_address_2', 'shipping_city', 'shipping_state', 'shipping_postal_code', 'shipping_country');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'assign_support_ticket_alert_template':
					
					$options = array('fname', 'ticket_id');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'member_affiliate_downline_signup':
					
					$options = array('downline_name', 'downline_email', 'fname');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'member_affiliate_commission_generated_template':
				
					$options = array('commission_amount', 'current_date',
									'store_link', 'affiliate_link', 
									 'fname' , 'lname', 'username', 'company',
									 'billing_address_1', 'billing_address_2', 'billing_city',
									 'billing_state', 'billing_country', 'billing_postal_code',
									 'payment_name', 'payment_address_1', 'payment_address_2',
									 'payment_city', 'payment_state', 'payment_country', 
									 'payment_postal_code', 'home_phone', 'work_phone',
									 'mobile_phone', 'fax', 'website',
									 'jrox_custom_field_1', 'jrox_custom_field_2',
									 'jrox_custom_field_3', 'jrox_custom_field_4',
									 'jrox_custom_field_5', 'jrox_custom_field_6',
									 'jrox_custom_field_7', 'jrox_custom_field_8',
									 'jrox_custom_field_9', 'jrox_custom_field_10');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'member_affiliate_payment_sent_template':
				
					$options = array('payment_amount', 'affiliate_note');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'member_affiliate_performance_bonus_amount_template':
				
					$options = array('bonus_amount','store_link', 'affiliate_link', 
									 'fname' , 'lname', 'username', 'company',
									 'billing_address_1', 'billing_address_2', 'billing_city',
									 'billing_state', 'billing_country', 'billing_postal_code',
									 'payment_name', 'payment_address_1', 'payment_address_2',
									 'payment_city', 'payment_state', 'payment_country', 
									 'payment_postal_code', 'home_phone', 'work_phone',
									 'mobile_phone', 'fax', 'website',
									 'jrox_custom_field_1', 'jrox_custom_field_2',
									 'jrox_custom_field_3', 'jrox_custom_field_4',
									 'jrox_custom_field_5', 'jrox_custom_field_6',
									 'jrox_custom_field_7', 'jrox_custom_field_8',
									 'jrox_custom_field_9', 'jrox_custom_field_10');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'member_affiliate_performance_group_upgrade_template':
				
					$options = array('upgraded_affiliate_group','store_link', 'affiliate_link', 
									 'fname' , 'lname', 'username', 'company',
									 'billing_address_1', 'billing_address_2', 'billing_city',
									 'billing_state', 'billing_country', 'billing_postal_code',
									 'payment_name', 'payment_address_1', 'payment_address_2',
									 'payment_city', 'payment_state', 'payment_country', 
									 'payment_postal_code', 'home_phone', 'work_phone',
									 'mobile_phone', 'fax', 'website',
									 'jrox_custom_field_1', 'jrox_custom_field_2',
									 'jrox_custom_field_3', 'jrox_custom_field_4',
									 'jrox_custom_field_5', 'jrox_custom_field_6',
									 'jrox_custom_field_7', 'jrox_custom_field_8',
									 'jrox_custom_field_9', 'jrox_custom_field_10');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'member_affiliate_send_downline_email':
					
					$options = array('downline_sponsor_name', 'downline_sponsor_email', 'downline_sponsor_affiliate_link',
									 'downline_member_name', 'downline_member_username', 'downline_member_email',
									 'downline_member_id', 'downline_member_affiliate_link', 'downline_message_html',
									 'downline_message_text');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'member_email_confirmation_template':
					
					$options = array('fname', 'confirm_link');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'member_login_details_template':
					
					$options = array('store_link','affiliate_link', 
									 'fname' , 'lname', 'username', 'company',
									 'billing_address_1', 'billing_address_2', 'billing_city',
									 'billing_state', 'billing_country', 'billing_postal_code',
									 'payment_name', 'payment_address_1', 'payment_address_2',
									 'payment_city', 'payment_state', 'payment_country', 
									 'payment_postal_code', 'home_phone', 'work_phone',
									 'mobile_phone', 'fax', 'website',
									 'jrox_custom_field_1', 'jrox_custom_field_2',
									 'jrox_custom_field_3', 'jrox_custom_field_4',
									 'jrox_custom_field_5', 'jrox_custom_field_6',
									 'jrox_custom_field_7', 'jrox_custom_field_8',
									 'jrox_custom_field_9', 'jrox_custom_field_10');
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'member_order_status_change_template':
					
					$options = array('fname', 'invoice_id', 'new_order_status', 
									 'product_type', 'member_id', 'customers_name',
									 'customers_company', 'customers_address_1',
									 'customers_address_2', 'customers_city',
									 'customers_postal_code', 'customers_state',
									 'customers_country', 'customers_telephone',
									 'customers_primary_email', 'shipping_name',
									 'shipping_company', 'shipping_address_1',
									 'shipping_address_2', 'shipping_city',
									 'shipping_state', 'shipping_country',
									 'shipping_method', 'shipping_tracking_id');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'member_reset_password_template':
					
					$options = array('fname', 'new_password' );
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
								
				case 'support_ticket_response_template':
					
					$options = array('fname', 'ticket_id', 'admin_fname', );
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
					
				case 'email_send-member':
				case 'email_send-mailing_list':
				
					$options = array('affiliate_link', 
									 'fname' , 'lname', 'username', 'company',
									 'billing_address_1', 'billing_address_2', 'billing_city',
									 'billing_state', 'billing_country', 'billing_postal_code',
									 'payment_name', 'payment_address_1', 'payment_address_2',
									 'payment_city', 'payment_state', 'payment_country', 
									 'payment_postal_code', 'home_phone', 'work_phone',
									 'mobile_phone', 'fax', 'website',
									 'jrox_custom_field_1', 'jrox_custom_field_2',
									 'jrox_custom_field_3', 'jrox_custom_field_4',
									 'jrox_custom_field_5', 'jrox_custom_field_6',
									 'jrox_custom_field_7', 'jrox_custom_field_8',
									 'jrox_custom_field_9', 'jrox_custom_field_10');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}	
					
				break;
				
				case 'followups':
					
					$options = array('affiliate_link', 
									 'fname' , 'lname', 'username', 'company',
									 'billing_address_1', 'billing_address_2', 'billing_city',
									 'billing_state', 'billing_country', 'billing_postal_code',
									 'payment_name', 'payment_address_1', 'payment_address_2',
									 'payment_city', 'payment_state', 'payment_country', 
									 'payment_postal_code', 'home_phone', 'work_phone',
									 'mobile_phone', 'fax', 'website',
									 'store_address', 'store_city', 'store_state', 
									 'store_country', 'store_postal_code', 'store_phone',
									 'current_date', 'current_time', 'signup_ip',
									 'jrox_custom_field_1', 'jrox_custom_field_2',
									 'jrox_custom_field_3', 'jrox_custom_field_4',
									 'jrox_custom_field_5', 'jrox_custom_field_6',
									 'jrox_custom_field_7', 'jrox_custom_field_8',
									 'jrox_custom_field_9', 'jrox_custom_field_10',
									 'member_id', 'mailing_list_id', 'unsubscribe_link');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}	
					
				break;
				
				case 'textads':
				case 'articleads':
				case 'htmlads':
				case 'emailads':
					
					$options = array('store_link', 'affiliate_link', 'fname' , 'lname', 'username', 'primary_email',
									 'custom_field_1','custom_field_2','custom_field_3', 'custom_field_4','custom_field_5',
									 'custom_field_6','custom_field_7','custom_field_8', 'custom_field_9', 'custom_field_10',
									);
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}		
					
				break;
				
				case 'email_template_body_html':
				case 'send_member_email':			
				
					$options = array('username', 'fname' , 'lname');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}				
				break;
				
				case 'product_overview':
				case 'product_description_1':
				case 'product_description_2':
					
					$options = array('product_name', 'product_price' , 'product_type', 'product_sku', 
									 'product_weight', 'product_inventory', 'min_quantity_ordered', 
									 'max_quantity_ordered');
					
					foreach ($options as $v)
					{
						$data .= '<option value="{' . $v . '}">' . $CI->lang->line($v) . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {' . $v . '}&nbsp;&nbsp;&nbsp; </option>';
					}	
					
					for ($i = 1; $i<=$CI->config->item('sts_affiliate_commission_levels'); $i ++)
					{
					$data .= '<option value="{custom_commission_value_'.$i.'}">' . $CI->lang->line('custom_commission_value_'.$i.'') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {custom_commission_value_'.$i.'}&nbsp;&nbsp;&nbsp; </option>';
					}
								
				break;
			}
		}
		
		$data .= '</select>';
					
		$data .= '</div>';
		
		return $data;
	}
		
	return false;
}

// ------------------------------------------------------------------------

function _check_language_translation($name = '')
{
	$CI =& get_instance();
	
	if ($CI->config->item('sts_content_translate_menus') == 1)
	{
		if (!$CI->config->item('cfg_disable_capitalize_title_headings'))
		{
			//return ucfirst($CI->lang->line($name));
		}
		
		//set spaces to underscros for language translation
		
		$name = str_replace(' ', '_', $name);
		
		if ($CI->lang->line(strtolower($name)))
		{							   
			return $CI->lang->line(strtolower($name));
		}
	}
	
	//if no translation just replace underscores
	$name = str_replace('_', ' ', $name);
	
	if (!$CI->config->item('cfg_disable_capitalize_title_headings'))
	{
		return ucfirst($name);
	}
	return $name;
}

// ------------------------------------------------------------------------

function _htmlentities($text = '')
{
	$CI =& get_instance();
	
	if (!$CI->config->item('jem_set_disable_htmlentities'))
	{
		$text = htmlentities($text);
	}
	
	return $text;
}

// ------------------------------------------------------------------------

function _generate_html_menu($data = '', $class = 'sf-menu', $id = 'nav-one', $type = 'horizontal', $aff_mark = '')
{

	//generates the menus for the site
	
	if (empty($data)) { return false; }
	
	$a = unserialize($data);
	
	$aff_array = array('{members_marketing}', '{members_email_downline}',
						'{members_payments}', '{members_commissions}',
						'{members_downline}', '{members_coupons}'
						);
	$html = '<ul id="' . $id . '" class="' . $class . '">';
	
	$i = 1;
	$j = 1;
	
	//check for correct class
	switch ($id)
	{
		case 'footer':
			$link_class = 'Bottom'; 
		break;
		
		case 'left-menu':
			$link_class = 'Left';
		break;
		
		case 'jroxRightMenu':
			$link_class = 'Right';
		break;
		
		default:
			$link_class = 'Top';
		break;
	}

	foreach ($a as $k => $v)
	{
		$uri_class ='';
		if ($link_class == 'Top') { $uri_class = _check_menu_class($v['menu_url']); }
		
		if (is_array($v['subs']) && count($v['subs']) > 0)
		{
			if ($aff_mark == 0 && in_array($v['menu_url'], $aff_array)) continue;
			
			$html .= ' <li id="' . $id . '-nav-' . $i . '" class="jroxMenu' . $link_class . 'Links"><a href="' . _generate_site_urls($v['menu_url']) . '" ' . html_entity_decode($v['menu_options']). ' class="' . $uri_class . '"><span class="jroxMenuLink' . $link_class . '" id="' . $uri_class . '">' . _check_language_translation($v['menu_name']) . '</span></a>';
			
			if ($type == 'vertical') $html .= '<span class="sf-sub-indicator"> &#187;</span>';
			
			$html .= '  <ul>';
				
			//generate the submenus 
			foreach ($v['subs'] as $c)
			{
				if ($aff_mark == 0 && in_array($c['menu_url'], $aff_array)) continue;
				
				$html .= '    <li id="' . $id . '-subnav-' . $j . '" class="jroxMenuSubLinks"><a href="' . _generate_site_urls($c['menu_url']) . '" ' . html_entity_decode($c['menu_options']) . '><span>' . _check_language_translation($c['menu_name']) . '</span></a></li>';
				$j++;
				
			}
			
			$html .= '  </ul>';
		}
		else
		{
			if ($aff_mark == 0 && in_array($v['menu_url'], $aff_array)) continue;
			
			$html .= ' <li id="' . $id . '-nav-one-' . $i . '" class="jroxMenu' . $link_class . 'Links"><a href="' . _generate_site_urls($v['menu_url']) . '" ' . html_entity_decode($v['menu_options']) . ' class="' . $uri_class . '"><span class="jroxMenuLink' . $link_class .  '" id="' . $uri_class . '">' . _check_language_translation($v['menu_name']) . '</span></a>';
		}
		
		$html .= '</li>';
		
		$i++;
	}
	
	$html .= '</ul>';
	
	return $html;

}

// ------------------------------------------------------------------------

function _check_menu_class($url = '')
{
	$CI =& get_instance();
	
	if (!$CI->uri->segment(1) && $url == '{home}') { return 'jroxMenuLink_home'; }
	
	if ($url == '{' . $CI->uri->segment(1) . '}' || $url == '{' . $CI->uri->segment(2) . '}')
	{
		return 'jroxMenuLink_' . $CI->uri->segment(1);
	}
	
	if (function_exists('parse_url'))
	{
		//parse the url
		$seg = parse_url($url);
		
		$path = '/';
		$path .= !empty($seg['path']) ? $seg['path'] : '';
		
		$seg2 = $CI->uri->uri_string();
		
		if ($path == $seg2)
		{
			return 'jroxMenuLink_' . $CI->uri->segment(1);	
		}
	}
	
	//try to match to other segments
	$str = $CI->uri->segment(1) . '/' . $CI->uri->segment(2);
	
	$url = str_replace('{', '', $url);
	$url = str_replace('}', '', $url);
	switch ($url)
	{
		case 'store':
			
			if ($str == 'products/details') return 'jroxMenuLink_' . $url;
			if ($str == 'products/category') return 'jroxMenuLink_' . $url;
		
		break;
		
		case 'members_home':
			
			if ($str == 'members/') return 'jroxMenuLink_members_home';
		
		break;
		
		case 'members_support':
			if ($str == 'members/support') return 'jroxMenuLink_members_support';
		break;
		
		case 'members_invoices': 
			if ($str == 'members/invoices') return 'jroxMenuLink_members_invoices';
		break;
		
		case 'members_marketing':
			if ($str == 'members/marketing') return 'jroxMenuLink_members_marketing';
		break;
		
		case 'members_details':
			if ($str == 'members/account') return 'jroxMenuLink_members_details';
		break;
		
		case 'members_content':
			if ($str == 'members/content') return 'jroxMenuLink_members_content';
		break;

	}
	
	return false;
}

// ------------------------------------------------------------------------

function _generate_site_urls($url = '')
{
	//change the dynamic tags for URLs {link}
	
	switch ($url)
	{
		case '{about_us}':
			
			$url = str_replace("{about_us}", site_url() . CONTENT_ROUTE . '/view/about_us' , $url);
			return $url;
		
		break;
		
		case '{contact_us}':
			
			$url = str_replace("{contact_us}", site_url() . 'forms/contact_us', $url);
			return $url;
		
		break;
		
		case '{checkout}':
			
			$url = str_replace("{checkout}", site_url() . 'checkout', $url);
			return $url;
		
		break;
		
		case '{content}':
			
			$url = str_replace("{content}", site_url() . CONTENT_ROUTE , $url);
			return $url;
		
		break;
		
		case '{faq}':
			
			$url = str_replace("{faq}", site_url() . FAQ_ROUTE , $url);
			return $url;
		
		break;
		
		case '{home}':

			$url = str_replace("{home}", site_url(), $url);
			return $url;
		
		break;
		
		case '{rss_feeds}':
			
			$url = str_replace("{rss_feeds}", site_url() . 'rss', $url);
			return $url;
		
		break;

		case '{new_products}':
			
			$url = str_replace("{new_products}", site_url() . PRODUCTS_ROUTE . '/new_products', $url);
			return $url;
		
		break;
		
		case '{store}':
			
			$url = str_replace("{store}", site_url() . 'store' , $url);
			return $url;
		
		break;
		
		case '{members_login}':
			
			$url = str_replace("{members_login}", site_url() . 'login' , $url);
			return $url;
		
		break;
		
		case '{view_cart}':
			
			$url = str_replace("{view_cart}", site_url() . 'cart' , $url);
			return $url;
		
		break;
		
		case '{product_categories}':		
			
			$url = str_replace("{product_categories}", site_url() . CATEGORIES_ROUTE , $url);
			return $url;
		
		break;
		
		case '{manufacturers}':
			
			$url = str_replace("{manufacturers}", site_url() . 'manufacturers' , $url);
			return $url;
		
		break;
		
		case '{vendors}':
			
			$url = str_replace("{vendors}", site_url() . 'vendors' , $url);
			return $url;
		
		break;
		
		case '{sitemap}':
			
			$url = str_replace("{sitemap}", site_url() . 'sitemap' , $url);
			return $url;
		
		break;
		
		case '{terms_of_service}':
			
			$url = str_replace("{terms_of_service}", site_url() . CONTENT_ROUTE . '/view/tos' , $url);
			return $url;
		
		break;
		
		case '{privacy_policy}':
			
			$url = str_replace("{privacy_policy}", site_url() . CONTENT_ROUTE . '/view/privacy_policy' , $url);
			return $url;
		
		break;
		
		case '{members_support}':
		
			$url = str_replace("{members_support}", site_url() . MEMBERS_ROUTE . '/support/view' , $url);
			return $url;
		
		break;
		
		case '{members_invoices}':
		
			$url = str_replace("{members_invoices}", site_url() . MEMBERS_ROUTE . '/invoices/view' , $url);
			return $url;
		
		break;
		
		case '{members_payments}':
		
			$url = str_replace("{members_payments}", site_url() . MEMBERS_ROUTE . '/payments/view' , $url);
			return $url;
		
		break;
		
		case '{members_commissions}':
		
			$url = str_replace("{members_commissions}", site_url() . MEMBERS_ROUTE . '/commissions/view' , $url);
			return $url;
		
		break;
		
		case '{members_home}':
		
			$url = str_replace("{members_home}", site_url() . MEMBERS_ROUTE , $url);
			return $url;
		
		break;
		
		case '{members_marketing}':
		
			$url = str_replace("{members_marketing}", site_url() . MEMBERS_ROUTE . '/marketing/view' , $url);
			return $url;
		
		break;
		
		case '{members_details}':
		
			$url = str_replace("{members_details}", site_url() . MEMBERS_ROUTE . '/account' , $url);
			return $url;
		
		break;
		
		case '{members_content}':
		
			$url = str_replace("{members_content}", site_url() . MEMBERS_ROUTE . '/content/view' , $url);
			return $url;
		
		break;
		
		case '{members_downline}':
		
			$url = str_replace("{members_downline}",  'javascript:void(window.open(\''. site_url() . MEMBERS_ROUTE . '/downline/view\', \'popup\', \'width=700,height=500, location=no, menubar=no, status=no,toolbar=no, scrollbars=yes, resizable=yes\'))', $url);
			return $url;
		
		break;
		
		case '{members_email_downline}':
			$url = str_replace("{members_email_downline}", site_url() . MEMBERS_ROUTE . '/downline/email' , $url);
			return $url;
		break;
		
		case '{members_coupons}':
		
			$url = str_replace("{members_coupons}", site_url() . MEMBERS_ROUTE . '/coupons/view' , $url);
			return $url;
		
		break;
		
		case '{members_downloads}':
		
			$url = str_replace("{members_downloads}", site_url() . MEMBERS_ROUTE . '/downloads/view' , $url);
			return $url;
		
		break;
		
		case '{members_memberships}':
		
			$url = str_replace("{members_memberships}", site_url() . MEMBERS_ROUTE . '/memberships/view' , $url);
			return $url;
		
		break;
		
		
		default:
			return $url;
		break;
	}

}

// ------------------------------------------------------------------------

function _check_wysiwyg_disable($redirect = '')
{
	$CI = & get_instance();
	
	if ($CI->config->item('sts_admin_enable_wysiwyg_content') == '1')
	{
		if ($CI->session->userdata('admin_disable_wysiwyg') == true)
		{
			return '<a class="button" href="' . jrox_admin_url() . 'content_articles/update_wysiwyg/enable/' . $redirect . '">
  <img src="' . base_url() . 'themes/admin/' . $CI->config->item('sts_admin_layout_theme') . '/images/key.png" alt=""/>' . $CI->lang->line('enable_wysiwyg') .'</a>';
		}
		else
		{
			return '<a class="button" href="' . jrox_admin_url() . 'content_articles/update_wysiwyg/disable/' . $redirect . '">
  <img src="' . base_url() . 'themes/admin/' . $CI->config->item('sts_admin_layout_theme') . '/images/key.png" alt=""/>' . $CI->lang->line('disable_wysiwyg') .'</a>';
		}
	}
	else
	{
		return false;
	}	
}
	
// ------------------------------------------------------------------------

function _initialize_html_editor($options = array(	'type' => 'content',
										'content' => '',
										'height'	=> '400',
										'width'	=> '100%',
										'editor_type'	=> 'description',
										'textarea'	=>	'txtContent',
										'instance'	=>	'oEdit1',
										'tags'	=> true,
									))
{
	$CI = & get_instance();
	
	$enable_html = $CI->config->item('sts_admin_enable_wysiwyg_content');
	
	if ($CI->session->userdata('admin_disable_wysiwyg') == true)
	{
		$enable_html = 0;	
	}
							   
							   
	
	//load plugins
	$CI->load->plugin($CI->config->item('sts_content_html_editor'));

	if ($CI->config->item('sts_content_html_editor') == 'fckeditor')
	{
		if ($enable_html == '1')
		{
			$data['editor_path'] =  _generate_javascript($areas = array($options['textarea']), $options['editor_type'], $options['height'], $options['width']);
		}
	}
	else
	{
		$data['editor_path'] =  '<script language="Javascript" src="' . base_url() . 'js/scripts/language/' . $CI->config->item('sts_admin_default_language') . '/editor_lang.js"></script>
								 <script language="Javascript" type="text/javascript" src="' . base_url() . 'js/scripts/innovaeditor.js"></script>';
	}
	
	if ($CI->config->item('sts_content_html_editor') == 'innovaeditor')
	{
		$html_type = $enable_html;
	}
	else
	{
		$html_type = 0;
	}
	
	$data['editor'] = HTML_Editor(	$options['instance'], 
									$html_type,  
									$options['editor_type'], 
									$options['content'], 
									$options['textarea'], 
									$options['height'], 
									$options['width'], 
									$options['tags']);
	
	return $data;
}

?>