<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - boxes_cart_contents_model.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to show shopping cart contents
|
*/

class Boxes_Cart_Contents_Model extends Model {

	
	// ------------------------------------------------------------------------

	function _generate_box()
	{
		//get shopping cart contents
		
		$num_options = get_default_currency($this->config->item('sts_store_default_currency'));
		
		$cart_items = $this->cart->_get_cart_items($num_options);
		$data['total_conversion'] = '';
		$data['lang_no_items_in_cart'] = $this->lang->line('no_items_in_cart');
		$data['lang_subtotal'] = $this->lang->line('subtotal');
		$data['lang_checkout'] = $this->lang->line('checkout');
		$data['cart_url'] = _jrox_public_url() .  $this->config->slash_item('index_page') . 'cart';
		
		if (empty($cart_items['items'])) 
		{ 
			$data['cart_contents'] = $this->lang->line('cart_is_empty');
			$data['checkout_items'] = array();
			$data['subtotal_cart_price'] = '';
			$data['show_cart_contents'] = 0;
		}
		else
		{
			$i=0;
			foreach ($cart_items['items'] as $item)
			{
				$cart_items['items'][$i]['s_product_name'] = limit_chars($cart_items['items'][$i]['product_name'], 20);
				$i++;
			}
			
			$data['checkout_items'] = $cart_items['items'];
			$data['subtotal_cart_price'] = format_amounts($cart_items['subtotal_cart_price'], $num_options);
			$data['show_cart_contents'] = 1;
			
			//check for currency total conversion
			$site_currency = get_site_currency();
			
			if ($this->config->item('sts_store_default_currency') != $site_currency['settings_value'])
			{
				$default_num = get_default_currency($site_currency['settings_value']);
					
				$data['total_conversion'] = '(' . format_amounts($cart_items['subtotal_cart_price'], $default_num) . ')';
			}
		}	
		
		return $data;
	}
}

?>