<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - boxes_content_categories_model.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to show layout box for content categories
|
*/

class Boxes_Content_Categories_Model extends Model {
	
	function __construct()
	{
		 $this->CI =& get_instance();
	
	}
	
	// ------------------------------------------------------------------------

	function _generate_box()
	{
	
		//get all categories
		$total = $this->_get_content_categories();
		
		if (!empty($total))
		{
			//lets format the data
			
			for ($i = 0; $i < count($total); $i++)
			{
				$total[$i]['category_name_url'] = url_title($total[$i]['category_name'], $this->CI->config->item('jrox_url_separator'));
			}
			
			
			$data = array('content_categories' => $total);
			//add any extra variables needed
			$data['base_url'] = _jrox_public_url();
			$data['content_route'] = $this->config->slash_item('index_page') . CONTENT_ROUTE;
			$data['please_select'] = $this->CI->lang->line('please_select');
		
			return $data;
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_content_categories()
	{
		$this->CI->db->where('category_type', 'custom');
		//$this->CI->db->or_where('category_type', 'public'); 
		$this->CI->db->order_by('category_name', 'ASC');
		$query = $this->CI->db->get('content_categories');
	
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		
		return false;
	}

}

?>