<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - boxes_content_latest_posts_model.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to show the latest blog posts
|
*/

class Boxes_Content_Latest_Posts_Model extends Model {
	
	function __construct()
	{
		 $this->CI =& get_instance();
	}
	
	// ------------------------------------------------------------------------

	function _generate_box()
	{
		//get latest posts
		$sql = 'SELECT ' . $this->db->dbprefix('content_articles') . '.*, ' . $this->db->dbprefix('content_categories') . '.*
					FROM ' . $this->db->dbprefix('content_articles') . '
					LEFT JOIN ' . $this->db->dbprefix('content_categories') . ' 
					ON ' . $this->db->dbprefix('content_articles') . '.category_id = ' . $this->db->dbprefix('content_categories') . '.category_id

					WHERE ' . $this->db->dbprefix('content_categories') . '.category_type = \'custom\'
					AND date_published <=' . now() . '
					AND ' . $this->db->dbprefix('content_articles') . '.status = \'1\' 
					AND ' . $this->db->dbprefix('content_articles') . '.content_type = \'1\' 
					GROUP BY ' . $this->db->dbprefix('content_articles') . '.article_id
					ORDER BY ' . $this->db->dbprefix('content_articles') . '.article_id DESC LIMIT 0,5';
		
		$query = $this->db->query($sql);
		
		if ($query->num_rows > 0)
		{
			//lets format the data
			$total = array();
			foreach ($query->result_array() as $row)
			{
				$row['content_title_url'] = url_title($row['content_title']);
				
				$row['content_title_url'] = url_title($row['content_title']);
				$row['content_date'] = _show_date($row['date_published']);
				array_push($total, $row);
			}
			
			
			$data['articles'] = $total;
			//add any extra variables needed
			$data['base_url'] = _jrox_public_url();
			$data['content_route'] = $this->config->slash_item('index_page') . CONTENT_ROUTE;
			
			return $data;
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
}

?>