<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - boxes_manufacturers_model.php
| -------------------------------------------------------------------------     
| 
| This controller file is used to show layout box for manufacturers
|
*/

class Boxes_Manufacturers_Model extends Model {
	
	function __construct()
	{
		 $this->CI =& get_instance();
	}
	
	// ------------------------------------------------------------------------

	function _generate_box()
	{
	
		//get all manufacturers
		$total = $this->_get_all_manufacturers();
		
		if (count($total) > 0)
		{
			//lets format the data
			
			for ($i = 0; $i < count($total); $i++)
			{
				$total[$i]['manufacturer_name_url'] = url_title($total[$i]['manufacturer_name'], $this->CI->config->item('jrox_url_separator'));
				$total[$i]['row_style'] = alternator('jroxManufacturersBoxListItem1', 'jroxManufacturersBoxListItem2');
			}
			
			
			$data = array('manufacturers' => $total);
			//add any extra variables needed
			$data['base_url'] = _jrox_public_url();
			$data['products_route'] = $this->config->slash_item('index_page') . PRODUCTS_ROUTE;
			$data['please_select'] = $this->CI->lang->line('please_select');
		
			return $data;
		}
		
		return false;

	}
	
	// ------------------------------------------------------------------------
	
	function _get_all_manufacturers()
	{
		$this->CI->db->order_by('manufacturer_name', 'ASC');
		$query = $this->CI->db->get('manufacturers');
	
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		
		return false;
	}

}

?>