<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - Boxes_Referrer_Details_Model.php
| -------------------------------------------------------------------------     
| 
| This controller file shows the member referral sponsor
|
*/

class Boxes_Referrer_Details_Model extends Model {
	
	function __construct()
	{
		 $this->CI =& get_instance();
	}
	
	// ------------------------------------------------------------------------

	function _generate_box()
	{
		//first check if the user is logged in
		//check if logged in
		
		if ($this->config->item('sts_affiliate_lifetime_sponsor') == 1 && $this->session->userdata('userid') && $this->session->userdata('lf_sponsor_data')) 
		{
			$get = $this->session->userdata('lf_sponsor_data');
		}
		elseif ($this->session->userdata('jrox_site_referral_regular'))
		{
			$get = $this->session->userdata('jrox_site_referral_regular');
		}
		else
		{
			$get = get_cookie($this->config->item('aff_cookie_name'));
			
		}
		
		//if there is sponsor info
		if (!empty($get))
		{
			if ($this->session->userdata($get))
			{
				$sponsor = unserialize($this->session->userdata($get));
			}
			else
			{
				$user = explode('-', $this->CI->encrypt->decode($get, JROX_COOKIE_ENCRYPT));
				
				$sponsor = $this->aff->_validate_user($user[1]);
			}
			
			//format the array
			$data['name'] = $sponsor['fname']. ' ' . $sponsor['lname'];
			$data['username'] = $sponsor['username'];
			$data['sponsor_text'] = _check_language_translation($this->CI->config->item('sts_affiliate_intro_text'));
			
			
			
			
			if ($this->CI->config->item('sts_affiliate_enable_profiles') == 1)
			{
				$data['profile_url'] = base_url(). $this->CI->config->slash_item('index_page') .  PROFILE_ROUTE . '/' . $sponsor['username'];
				$data['enable_profiles'] = '1';
				$data['lang_view_profile'] = $this->lang->line('view_profile');
			}
			else
			{
				$data['profile_url'] = '';
				$data['enable_profiles'] = '0';
				$data['lang_view_profile'] = '';
			}
			
			//check for image
			$data['sponsor_image'] = base_url() . 'images/misc/sponsor.png';
			
			if (!empty($sponsor['photo_file_name']))
			{
				if ($sponsor['image_resized'] == 1)
				{
					$filename = $sponsor['raw_name'] . '_jrox' . $sponsor['file_ext'];
				}
				else
				{
					$filename = $sponsor['photo_file_name'];
				}
				
				$data['sponsor_image'] = base_url() . 'images/' . $this->CI->config->item('images_members_dir') . '/' . $filename;
			}
			
			return $data;
		}
		
		return false;
	}

}

?>