<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - dashboard_model.php
| -------------------------------------------------------------------------     
| 
| This model handles the functions for managing the dashboard
|
*/

class Dashboard_Model extends Model {	

	function _get_pending_invoices()
	{
		
		$this->db->where('order_status', 'order_pending');
		$this->db->from('invoices');
		
		return $this->db->count_all_results();
		
	}
	
	// ------------------------------------------------------------------------
	 
	function _get_monthly_payments()
	{
		$start = mktime(0, 0, 0, date("m")  , '1', date("Y"));
		$end = mktime(23, 59, 59, date("m")  , date("t"), date("Y"));

		$sql .= 'SELECT SUM(payment_amount) as amount
				  FROM ' . $this->db->dbprefix('invoice_payments') . ' 
				  WHERE payment_date > \'' . $start . '\' 
				  AND payment_date < \'' . $end . '\'';
	
		
		
		$query = $this->db->query($sql);
		
		if ($query->num_rows() > 0)
		{
			$row = $query->row_array();
			
			return $row['amount'];
		}
		
		return false;
	}
	
	
	// ------------------------------------------------------------------------
	
	function _get_monthly_signups()
	{
		$start = mktime(0, 0, 0, date("m")  , '1', date("Y"));
		$end = mktime(23, 59, 59, date("m")  , date("t"), date("Y"));

		$sql .= 'SELECT COUNT(*) as amount
				  FROM ' . $this->db->dbprefix('members') . ' 
				  WHERE signup_date > \'' . $start . '\' 
				  AND signup_date < \'' . $end . '\'';
	
		
		
		$query = $this->db->query($sql);
		
		if ($query->num_rows() > 0)
		{
			$row = $query->row_array();
			
			return $row['amount'];
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_monthly_tickets()
	{
		$start = mktime(0, 0, 0, date("m")  , '1', date("Y"));
		$end = mktime(23, 59, 59, date("m")  , date("t"), date("Y"));

		$sql .= 'SELECT COUNT(*) as amount
				  FROM ' . $this->db->dbprefix('support_tickets') . ' 
				  WHERE ticket_parent = \'1\' AND date_added > \'' . $start . '\' 
				  AND date_added < \'' . $end . '\'';
	
		
		
		$query = $this->db->query($sql);
		
		if ($query->num_rows() > 0)
		{
			$row = $query->row_array();
			
			return $row['amount'];
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_pending_commissions()
	{
		
		$this->db->where('comm_status', 'pending');
		$this->db->from('affiliate_commissions');
		
		return $this->db->count_all_results();
		
	}
	
	
	// ------------------------------------------------------------------------
	
	function _get_pending_reviews()
	{
		
		$this->db->where('status', '0');
		$this->db->from('products_reviews');
		
		return $this->db->count_all_results();
		
	}
	
	
	// ------------------------------------------------------------------------
	
	function _get_jrox_rss()
	{
		if (!defined('JEM_ENABLE_RESELLER_LINKS'))
		{
			require_once APPPATH .'/libraries/magpie/rss_fetch.inc';
			$rss = @fetch_rss("http://www.jrox.com/rss/feed/random_content");
			
			$data['jrox_rss'] = array();
			
			if(count($rss->items)>0)
			{
				foreach ($rss->items as $rss)
				{
					//if (count($data['jrox_rss']) >= 3) break;
					$rss['description'] = word_limiter(strip_tags($rss['description']), 20);
					
					array_push($data['jrox_rss'], $rss);
					$i++;
				}
				
				return $data['jrox_rss'];
				/*
				$sdata['jrox_rss'] = array();
				for ($i = 0; $i<=2; $i++)
				{
					$j = rand('0', count($data['jrox_rss']));
					array_push($sdata['jrox_rss'], $data['jrox_rss'][$j]);
					unset($data['jrox_rss'][$j]);
				}
				*/
				
			}
		}
	
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_jrox_tweets()
	{
		if (!defined('JEM_ENABLE_RESELLER_LINKS'))
		{
			require_once APPPATH .'/libraries/magpie/rss_fetch.inc';
			$rss = fetch_rss("http://twitter.com/statuses/user_timeline/22250965.rss");
			
			$data['jrox_tweets'] = array();
			$i = 0;
			if(count($rss->items)>0)
			{
				foreach ($rss->items as $rss)
				{
					if (count($data['jrox_tweets']) >= 3) break;
					$rss['title'] = str_replace('jrox_com:', '', $rss['title']);
					$rss['description'] = word_limiter(strip_tags($rss['description']), 25);
					$rss['date'] = date('M d Y', $rss['date_timestamp']);
					array_push($data['jrox_tweets'], $rss);
					$i++;
				}
				
				return $data['jrox_tweets'];
				/*
				$sdata['jrox_rss'] = array();
				for ($i = 0; $i<=2; $i++)
				{
					$j = rand('0', count($data['jrox_rss']));
					array_push($sdata['jrox_rss'], $data['jrox_rss'][$j]);
					unset($data['jrox_rss'][$j]);
				}
				*/
				
			}
		}
	
		return false;
	}
	
	function _get_pending_comments()
	{
		
		$this->db->where('status', '0');
		$this->db->from('content_comments');
		
		
		return $this->db->count_all_results();
		
	}
	
	
	// ------------------------------------------------------------------------
	
	function _get_pending_tickets()
	{
		$this->db->where('ticket_status', '0');
		$this->db->where('ticket_parent', '1');
		
		$this->db->from('support_tickets');
		
		
		return $this->db->count_all_results();
	}
}
?>