<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - invoices_model.php
| -------------------------------------------------------------------------     
| 
| This model handles the functions for managing invoices
|
*/

class Invoices_Model extends Model {	
	
	function _send_invoice_format($mdata = '', $num_options = '')
	{
		//add invoice info to array
		foreach ($mdata['inv'] as $k => $v)
		{
			$sdata[$k] = $v;
		}
		
		//format order status
		switch ($sdata['order_status'])
		{
			case 'order_pending':
				
				$sdata['order_status'] = $this->lang->line('pending');
				
			break;
			
			case 'order_processing':
				
				$sdata['order_status'] = $this->lang->line('processing');
				
			break;
			
			case 'order_completed':
				
				$sdata['order_status'] = $this->lang->line('completed');
				
			break;
		}
		
		//loop through the products
		$sdata['products_html'] = '<table width="100%" cellpadding="8" cellspacing="0">';
		$sdata['products_text'] = "\n";
		
		foreach ($mdata['prod'] as $k => $v)
		{
			$sdata['products_html'] .= '<tr>
											<td width="10%"><font face="' . $this->lang->line('send_invoice_font_family') . '" size="' . $this->lang->line('send_invoice_font_size') . '">' . $v['product_sku'] . '</font></td>
											<td width="43%"><font face="' . $this->lang->line('send_invoice_font_family') . '" size="' . $this->lang->line('send_invoice_font_size') . '">' . $v['product_name'] . '</font></td>
											<td width="20%"><font face="' . $this->lang->line('send_invoice_font_family') . '" size="' . $this->lang->line('send_invoice_font_size') . '">' . format_amounts($v['unit_price'], $num_options) . '</font></td>
											<td width="12%"><font face="' . $this->lang->line('send_invoice_font_family') . '" size="' . $this->lang->line('send_invoice_font_size') . '">' . $v['quantity'] . '</font></td>
											<td width="15%"><font face="' . $this->lang->line('send_invoice_font_family') . '" size="' . $this->lang->line('send_invoice_font_size') . '">' . format_amounts($v['unit_price'] * $v['quantity'], $num_options) . '</font></td>
										</tr>';
		
			$sdata['products_text'] .= $this->lang->line('print_invoice_sku') ." - " . $v['product_sku'] . "\n"; 
			$sdata['products_text'] .= $this->lang->line('print_invoice_product_name') ." - " . $v['product_name'] . "\n";
			$sdata['products_text'] .= $this->lang->line('print_invoice_unit_price') ." - " . format_amounts($v['unit_price'], $num_options) . "\n";
			$sdata['products_text'] .= $this->lang->line('print_invoice_quantity') ." - " . $v['quantity'] . "\n";
			$sdata['products_text'] .= $this->lang->line('print_invoice_quantity_amount') ." - " . format_amounts($v['unit_price'] * $v['quantity'], $num_options) . "\n\n\n";
		}
		
		$sdata['products_html'] .= '</table>';
		
		//loop through the payments
		$sdata['payments_html'] = '<table width="100%" cellpadding="8" cellspacing="0">';
		$sdata['payments_text'] = "\n";
		
		if (!empty($mdata['payments']))
		{
			foreach ($mdata['payments'] as $k => $v)
			{
				$sdata['payments_html'] .= '<tr>
												<td width="16%"><font face="' . $this->lang->line('send_invoice_font_family') . '" size="' . $this->lang->line('send_invoice_font_size') . '">' . _show_date($v['payment_date']) . '</font></td>
												<td width="31%"><font face="' . $this->lang->line('send_invoice_font_family') . '" size="' . $this->lang->line('send_invoice_font_size') . '">' . $v['payment_method'] . ' - ' . $v['payment_type'] . '</font></td>
												
												<td width="37%"><font face="' . $this->lang->line('send_invoice_font_family') . '" size="' . $this->lang->line('send_invoice_font_size') . '">' . $v['transaction_id'] . '</font></td>
												<td width="16%"><font face="' . $this->lang->line('send_invoice_font_family') . '" size="' . $this->lang->line('send_invoice_font_size') . '">' . format_amounts($v['payment_amount'], $num_options) . '</font></td>
											</tr>';
			
				$sdata['payments_text'] .= $this->lang->line('print_invoice_payment_date') ." - " . _show_date($v['payment_date']) . "\n"; 
				$sdata['payments_text'] .= $this->lang->line('print_invoice_payment_method') ." - " . $v['payment_method'] . " - " . $v['payment_type'] . "\n";
				$sdata['payments_text'] .= $this->lang->line('print_invoice_transaction_id') ." - " . $v['transaction_id'] . "\n";
				$sdata['payments_text'] .= $this->lang->line('print_invoice_payments') ." - " . format_amounts($v['payment_amount'], $num_options) . "\n\n\n";
			}
		}
		
		$sdata['payments_html'] .= '</table>';
		
		$sdata['payment_link_html'] = $this->lang->line('print_invoice_has_been_paid');
		$sdata['payment_link_text'] = $this->lang->line('print_invoice_has_been_paid');
		
		if ($mdata['total_payments'] < $sdata['total_amount'])
		{
			$sdata['payment_link_html'] = anchor('login/general', $this->lang->line('print_invoice_click_here_to_make_payment'));
			$sdata['payment_link_text'] = $this->lang->line('print_invoice_click_here_to_make_payment') . "\n" . site_url('login/general');
		}
		
		//format the rest of the template
		$sdata['primary_email'] = $sdata['customers_primary_email'];
		$sdata['fname'] = $sdata['customers_name'];
		$sdata['invoice_date'] = _show_date($sdata['date_purchased']);
		$sdata['due_date'] = _show_date($sdata['due_date']);
		$sdata['store_shipping_address'] = $this->config->item('sts_store_shipping_address');
		$sdata['store_shipping_city'] = $this->config->item('sts_store_shipping_city');
		$sdata['store_shipping_state'] = $this->config->item('sts_store_shipping_state');
		$sdata['store_shipping_postal_code'] = $this->config->item('sts_store_shipping_zip');
		$sdata['store_shipping_country'] = _get_country_name($this->config->item('sts_store_shipping_country'), 'country_name');
		
		$sdata['shipping_country'] = _get_country_name($sdata['shipping_country'], 'country_name');
		$sdata['customers_country'] = _get_country_name($sdata['customers_country'], 'country_name');
		
		$sdata['total_payments'] = format_amounts($mdata['total_payments'], $num_options);
		$sdata['tax_amount'] = format_amounts($sdata['tax_amount'], $num_options);
		$sdata['shipping_method'] = strtoupper($sdata['shipping_method']);
		 
		$sdata['shipping_amount'] = format_amounts($sdata['shipping_amount'], $num_options);
		$sdata['discount_amount'] = format_amounts($sdata['discount_amount'], $num_options);
		$sdata['subtotal_amount'] = format_amounts($sdata['sub_total'], $num_options);
		$sdata['balance_due'] = _format_invoice_balance($sdata['total_amount'] - $mdata['total_payments'], $num_options);
		$sdata['order_prefix'] = $this->config->item('sts_store_order_id_prefix');
		
		return $sdata;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_recurring_invoices($type = '')
	{
		$this->db->where('payment_status', '0');
		$this->db->where('product_type', 'membership');
		$this->db->where('date_purchased <=', now());
		$this->db->where('membership_payment_type', $type);
		$this->db->join('members', 'invoices.member_id = members.member_id', 'left');
		$this->db->join('members_memberships', 'members_memberships.invoice_id = invoices.invoice_id', 'left');

		$query = $this->db->get('invoices');
		
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_membership_invoice($mid = '', $pid = '')
	{
		$this->db->where('members_memberships.member_id', $mid);
		$this->db->where('members_memberships.product_id', $pid);
		$this->db->join('invoices', 'invoices.invoice_id = members_memberships.invoice_id');
	
		$query = $this->db->get('members_memberships');
		
		if ($query->num_rows() > 0)
		{
			return $query->row_array();
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _format_order_info($data = '')
	{
		$fdate = explode(':', $this->config->item('sts_admin_date_format'));
		
		if ($data['jrox_product_type'] == 'products')
		{
			$subtotal = $data['cart_items']['subtotal_cart_price'];
		}
		else
		{
			$subtotal = $data['s_product_price'];
			
			if ($data['jrox_enable_product_trial'] == 1)
			{
				$subtotal = $data['jrox_trial_amount'];
				$data['jrox_discounts'] = 0;
				$data['invoice_notes'] = $this->lang->line('free_trial') . ': ' . $data['invoice_notes'];
			}
		}
		
		//check the product type
		if ($data['jrox_product_type'] != 'membership')
		{
			$product_type = 'digital';
			
			foreach ($data['cart_items']['items'] as $item)
			{	
				if ($item['product_type'] == 'physical') $product_type = 'physical';
			}
		}
		else
		{
			$product_type = 'membership';
		}
		
		//get affiliate cookie data
		$tool_type = '0';
		$tool_id = '0';
		$referrer_id = '0';
		
		if ($this->config->item('sts_affiliate_lifetime_sponsor') == '1' && !empty($data['sponsor_id']))
		{
			$referrer_id = $data['sponsor_id'];
		}
		else
		{
			//check coupon code set
			if (!empty($data['jrox_coupon_referral_name']))
			{
				$aff = explode('-', $data['jrox_coupon_referral_name']);
				$referrer_id = $aff[0];
			}
			elseif (!empty($data['jrox_tracking_cookie']))
			{
				//check the affiliate cookie
				$aff = $data['jrox_tracking_cookie'];
				
				if (!empty($aff))
				{
					$referrer_id = $aff[0];
					$tool_type = empty($aff[2]) ? 0 : $aff[2];
					$tool_id = empty($aff[3]) ? 0 : $aff[3];
				}
			}
			elseif ($this->session->userdata('jrox_site_referral_regular'))
			{
				$user = explode('-', $this->encrypt->decode($this->session->userdata('jrox_site_referral_regular'), JROX_COOKIE_ENCRYPT));

				$referrer_id = $user[0];
			}
			
			//now check for self restricted commissions
			if ($this->config->item('sts_affiliate_restrict_self_commission') == 1)
			{
				if ($data['member_id'] == $referrer_id) 
				{
					$referrer_id = '0';
				}
			}
		}

		//format the array
		if ($data['jrox_product_type'] == 'membership')
		{
			$sdata = array(
						'product_type' => $product_type,
						'payment_status' => $data['jrox_payment_status'],
						'order_status' => 'order_pending',	
						'member_id' => $data['member_id'],
						'customers_name' => $data['fname'] . ' ' . $data['lname'],
						'customers_company' => $data['company'],
						'customers_address_1' => $data['billing_address_1'],
						'customers_address_2' => $data['billing_address_2'],
						'customers_city' => $data['billing_city'],
						'customers_postal_code' => $data['billing_postal_code'],
						'customers_state' => $data['billing_state'],
						'customers_country' => $data['billing_country'],
						'customers_telephone' => $data['home_phone'],
						'customers_primary_email' => $data['primary_email'],
						'coupon_code' => $data['jrox_coupon'],
						'date_purchased' => _generate_timestamp(),
						'due_date' => now() + (3600 * 24 * $this->config->item('sts_invoice_due_date_days')),
						'sub_total' => $subtotal,
						'ip_address' => $this->input->ip_address(),
						'referrer_id' => $referrer_id,
						'tool_type' => $tool_type,
						'tool_id' => $tool_id,
						'invoice_notes' => $data['invoice_notes'],
						'discount_amount' => $data['jrox_discounts'],
						'tax_amount' => '0',
						'shipping_amount' => '0',
						'tracking_id' => get_cookie('jrox_tracker_id'),
						);
		}
		else
		{
			$sdata = array(
						'product_type' => $product_type,
						'payment_status' => $data['jrox_payment_status'],
						'order_status' => 'order_pending',	
						'member_id' => $data['member_id'],
						'customers_name' => $data['fname'] . ' ' . $data['lname'],
						'customers_company' => $data['company'],
						'customers_address_1' => $data['billing_address_1'],
						'customers_address_2' => $data['billing_address_2'],
						'customers_city' => $data['billing_city'],
						'customers_postal_code' => $data['billing_postal_code'],
						'customers_state' => $data['billing_state'],
						'customers_country' => $data['billing_country'],
						'customers_telephone' => $data['home_phone'],
						'customers_primary_email' => $data['primary_email'],
						'coupon_code' => $data['jrox_coupon'],
						'date_purchased' => _generate_timestamp(),
						'due_date' => now() + (3600 * 24 * $this->config->item('sts_invoice_due_date_days')),
						'sub_total' => $subtotal,
						'ip_address' => $this->input->ip_address(),
						'referrer_id' => $referrer_id,
						'tool_type' => $tool_type,
						'tool_id' => $tool_id,
						'invoice_notes' => $data['invoice_notes'],
						'discount_amount' => $data['jrox_discounts'],
					  	'shipping_name' => $data['shipping_fname'] . ' ' . $data['shipping_lname'],
						'shipping_company' => $data['company'],
						'shipping_address_1' => $data['shipping_address_1'],
						'shipping_address_2' => $data['shipping_address_2'],
						'shipping_city' => $data['shipping_city'],
						'shipping_postal_code' => $data['shipping_postal_code'],
						'shipping_state' => $data['shipping_state'],
						'shipping_country' => $data['shipping_country'],
						'shipping_method' => empty($data['jrox_shipping_name']) ? '' : $data['jrox_shipping_name'],
						'tax_amount' => empty($data['jrox_taxes']) ? '' : $data['jrox_taxes'],
						'shipping_amount' => $data['jrox_shipping_amount'],
						'tracking_id' => get_cookie('jrox_tracker_id'),
					  );	
		}
		
		
		$sdata['jrox_product_type'] = $product_type;
		
		return $sdata;
	
	}
	
	// ------------------------------------------------------------------------
	
	function _change_invoice($id = '', $invoice_data = array(), $data = array())
	{
		$product_type = $invoice_data['jrox_product_type'];
		unset ($invoice_data['jrox_product_type']);
		
		$this->db->where('invoice_id', $id);
		$this->db->update('invoices', $invoice_data);
		
		//first delete all invoice products
		$this->db->where('invoice_id', $id);
		$this->db->delete('invoice_products');
	
		//now add the products for the invoice
		if ($product_type == 'membership')
		{
			//initialize the array
			$sdata = array('invoice_id' => $id,
						   'product_id' => $data['pid'],
						   'invoice_product_name' => $data['product_name'],
						   'unit_price' => $invoice_data['sub_total'],
						   'quantity' => '1',
						   'product_notes' => '',
						   'product_sku' => $data['product_sku'],
						   );
						   
			//insert products for invoice
			$this->db->insert('invoice_products', $sdata);
		}
		else
		{
			foreach ($data['cart_items']['items'] as $p)
			{
				//initialize the array
				$sdata = array('invoice_id' => $id,
							   'product_id' => $p['pid'],
							   'invoice_product_name' => $p['product_name'],
							   'unit_price' => $p['s_product_price'],
							   'quantity' => $p['quantity'],
							   'product_notes' => $p['attribute_list_text'],
							   'product_sku' => $p['product_sku'],
							   );
							   
				//insert products for invoice
				$this->db->insert('invoice_products', $sdata);
			}
		}
	}
	
	// ------------------------------------------------------------------------
	
	function _generate_invoices($day = '')
	{
		//first get any memberships
		$time = now() + ($this->config->item('sts_invoice_auto_generate_invoice_day') * 60 * 60 * 24);
		
		$sql = 'SELECT *, ' . $this->db->dbprefix('members_memberships') . '.member_id AS mid
				FROM ' . $this->db->dbprefix('members_memberships') . '
				LEFT JOIN ' . $this->db->dbprefix('products') . ' ON ' .
				$this->db->dbprefix('members_memberships') . '.product_id = ' . $this->db->dbprefix('products') . '.product_id
				LEFT JOIN ' . $this->db->dbprefix('members') . ' ON ' .
				$this->db->dbprefix('members_memberships') . '.member_id = ' . $this->db->dbprefix('members') . '.member_id
				LEFT JOIN ' . $this->db->dbprefix('invoices') . ' ON ' .
				$this->db->dbprefix('members_memberships') . '.invoice_id = ' . $this->db->dbprefix('invoices') . '.invoice_id
				WHERE invoice_date <= \'' . $time . '\'';
		
		$total_invoices = 0;
		
		$query = $this->db->query($sql);
		
		if ($query->num_rows() > 0)
		{
			
			
			//calculate invoice due date			
			$invoice_due_date = $time + (3600 * 24 * $this->config->item('sts_invoice_due_date_days'));
			
			//loop through each membership
			foreach ($query->result_array() as $row)
			{
				if (empty($row['invoice_date']) || $row['status'] == '0') { continue; }

				//calculate the invoice amount
				
				//set the discount
				$discount = empty($row['discount_amount']) ? '0' : $row['discount_amount'];
				
				//check for coupons
				if (!empty($row['coupon_code']))
				{
					$cdata = $this->db_validation_model->_get_details('coupons', '*', 'coupon_code', $row['coupon_code']);
					
					if (!empty($cdata))
					{
						if ($cdata[0]['enable_recurring_coupon'] == '0')
						{
							$discount = '0';	
						}
					}
				}
			
				//calculate invoice expiration date
				$interval_type = $row['recurring_interval_type'];
				$interval_num = $row['recurring_interval'];
				
				switch ($interval_type)
				{
					case 'day':
					
						$next_invoice_date = mktime(12, 0, 0, date('m'),   date('d') + $interval_num,   date('Y'));
			
					break;
					
					case 'week':
						
						$interval_num = $interval_num * 7;
						
						$next_invoice_date = mktime(12, 0, 0, date('m'),   date('d') + $interval_num,   date('Y'));
					
					break;
					
					case 'month':
					
						$next_invoice_date = mktime(12, 0, 0, date('m') + $interval_num,   date('d'),   date('Y'));
					
					break;
					
					case 'year':
					
						$next_invoice_date = mktime(12, 0, 0, date('m'),   date('d'),   date('Y') + $interval_num);
					
					break;
				}			
				
				//lets add the invoice
				$invoice_array = array('payment_status' => '0',
										'product_type' => 'membership',
										'order_status' => 'order_pending',
										'customers_name' => $row['fname'] . ' ' . $row['lname'],
										'customers_company' => $row['company'],
										'customers_address_1' => $row['billing_address_1'],
										'customers_address_2' => $row['billing_address_2'],
										'customers_city' => $row['billing_city'],
										'customers_postal_code' => $row['billing_postal_code'],
										'customers_state' => $row['billing_state'],
										'customers_country' => $row['billing_country'],
										'customers_telephone' => $row['home_phone'],
										'customers_primary_email' => $row['primary_email'],
										'coupon_code' => empty($row['coupon_code']) ? '' : $row['coupon_code'],
										'date_purchased' => $time,
										'due_date' => $invoice_due_date,
										'sub_total' => $row['product_price'],
										'tax_amount' => empty($row['tax_amount']) ? '' : $row['tax_amount'],
										'member_id' => $row['mid'],
										'shipping_amount' => '0',
										'discount_amount' => $discount,
										'ip_address' => empty($row['ip_address']) ? '' : $row['ip_address'],
										'referrer_id' => empty($row['referrer_id']) ? '' : $row['referrer_id'],
										'tool_type' => empty($row['tool_type']) ? '' : $row['tool_type'],
										'tool_id' => empty($row['tool_id']) ? '' : $row['tool_id'],
										'invoice_notes' => empty($row['invoice_notes']) ? '' : $row['invoice_notes'],
										'jrox_product_type' => 'membership',
										);
										
				$product_array = array('product_name' => $row['product_name'],
										'pid'	=> $row['product_id'],
										'product_sku' => $row['product_sku'], 
										);
				
				 $invoice_id = $this->_insert_invoice($invoice_array, $product_array);
				 
				 //now update the membership with new info
				 $mem_array = array('invoice_date' => $next_invoice_date + ($this->config->item('sts_invoice_auto_generate_invoice_day') * 60 * 60 * 24),
				 					'invoice_id' => $invoice_id,
									);
				
				$this->db->where('id', $row['id']);
				$this->db->update('members_memberships', $mem_array);
				
				
				//update the total number of invoices generated
				$total_invoices++;
			}
	
		}
		
		return $total_invoices .' invoices generated';
	}
	
	// ------------------------------------------------------------------------
	
	function _update_invoice_products($id = '', $invoice_data = array(), $data = array())
	{
		$product_type = $invoice_data['jrox_product_type'];
		unset ($invoice_data['jrox_product_type']);
		
		$this->db->where('invoice_id', $id);
		$this->db->update('invoices', $invoice_data);
		
		//now update the products
		
		//first, delete all products for this invoice
		$this->db->where('invoice_id', $id);
		$this->db->delete('invoice_products');
		
		//now add the current items in the cart
		foreach ($data['cart_items']['items'] as $p)
		{
			//initialize the array
			$sdata = array('invoice_id' => $id,
						   'product_id' => $p['pid'],
						   'invoice_product_name' => $p['product_name'],
						   'unit_price' => $p['s_product_price'],
						   'quantity' => $p['quantity'],
						   'product_notes' => $p['attribute_list_text'],
						   'product_sku' => $p['product_sku'],
						   );
						   
			//insert products for invoice
			$this->db->insert('invoice_products', $sdata);
		}
	}
	
	// ------------------------------------------------------------------------
	
	function _insert_invoice($invoice_data = array(), $data = array())
	{
		//insert into db
		
		$product_type = $invoice_data['jrox_product_type'];
		unset ($invoice_data['jrox_product_type']);
		
		if (!$this->db->insert('invoices', $invoice_data))
		{
			show_error($this->lang->line('could_not_add_payment'));
			
			//log error
			log_message('error', 'Could not insert invoice into invoices table');
			
			return false;
		}
		
		$invoice_id = $this->db->insert_id();
		
		//now add the products for the invoice
		if ($product_type == 'membership')
		{
			//initialize the array
			$sdata = array('invoice_id' => $invoice_id,
						   'product_id' => $data['pid'],
						   'invoice_product_name' => $data['product_name'],
						   'unit_price' => $invoice_data['sub_total'],
						   'quantity' => '1',
						   'product_notes' => '',
						   'product_sku' => $data['product_sku'],
						   );
						   
			//insert products for invoice
			$this->db->insert('invoice_products', $sdata);
		}
		else
		{
			foreach ($data['cart_items']['items'] as $p)
			{
				//initialize the array
				$sdata = array('invoice_id' => $invoice_id,
							   'product_id' => $p['pid'],
							   'invoice_product_name' => $p['product_name'],
							   'unit_price' => $p['s_product_price'],
							   'quantity' => $p['quantity'],
							   'product_notes' => $p['attribute_list_text'],
							   'product_sku' => $p['product_sku'],
							   );
							   
				//insert products for invoice
				$this->db->insert('invoice_products', $sdata);
			}
		}
		
		return $invoice_id;
	}
	
	// ------------------------------------------------------------------------
	
	function _add_invoice($type = '', $id = '', $postdata = array())
	{
		$data = $this->db_validation_model->_clean_data($postdata);
		
		//get all products for the invoice
		$product_id = $data['product_id'];
		$invoice_product_name = $data['invoice_product_name'];
		$quantity = $data['quantity'];
		$unit_price = $data['unit_price'];
		$product_notes = $data['product_notes'];
		$referring_affiliate = $data['referring_affiliate'];
		$product_type = $data['product_type'];
		
		//unset it now cuz we don't need it
		unset ($data['product_id']);
		unset ($data['invoice_product_name']);
		unset ($data['quantity']);
		unset ($data['unit_price']);
		unset ($data['referring_affiliate']);
		unset ($data['product_notes']);
		
		//set the member id
		$data['member_id'] = $id;
		
		//set up dates
		$fdate = explode(':', $this->config->item('sts_admin_date_format'));
		switch ($fdate[0])
		{
			case 'mm/dd/yyyy':
					
				if (!empty($data['date_purchased']))
				{
					//format date
					$pub = explode('/', $data['date_purchased']);
					$data['date_purchased'] = mktime(date('H'),date('i'),date('s'), $pub[0], $pub[1], $pub[2]);
				}
				else
				{
					$data['date_purchased'] = _generate_timestamp();
				}
				
				if (!empty($data['due_date']))
				{
					//format date
					$pub = explode('/', $data['due_date']);
					$data['due_date'] = mktime(date('H'),date('i'),date('s'), $pub[0], $pub[1], $pub[2]);
				}
				else
				{
					$data['due_date'] = _generate_timestamp();
				}
				
			break;
		}
				
		//get affiliate id if any and generate the commission
		if (!empty($referring_affiliate))
		{
			$member = $this->db_validation_model->_get_details('members', 'member_id', 'username', $referring_affiliate);
			$data['referrer_id'] = $member[0]['member_id'];
		}
		else
		{
			$data['referrer_id'] = '0';
		}
		
		//insert into db
		if (!$this->db->insert('invoices', $data))
		{
			show_error($this->lang->line('could_not_add_invoice'));
			
			//log error
			log_message('error', 'Could not insert invoice into invoices table');
			
			return false;
		}
		else
		{
			$data['invoice_id'] = $this->db->insert_id();
			
			//invoice total
			$price['sub_total'] = '';
			
			//check what the product type is
			if ($product_type == 'membership')
			{
				$products[0] = $product_id[0];
			}
			else
			{
				$products = $product_id;
			}
			
			//check each product
			foreach($products as $k =>$v)
			{
				//get product names
				$product = $this->db_validation_model->_get_details('products', '*', 'product_id', $v);

				//check product name
				$sproduct_name = empty($invoice_product_name[$k]) ? $product[0]['product_name'] : $invoice_product_name[$k];
						
				//check quantity
				if ($product_type == 'membership')
				{
					$squantity = '1';
				}
				else
				{
					$squantity = empty($quantity[$k]) ? '1' : $quantity[$k];
				}
				
				$sproduct_notes = empty($product_notes[$k]) ? '' : $product_notes[$k];
				
				//check unit price
				$sunit_price = empty($unit_price[$k]) ? $product[0]['product_price'] : $unit_price[$k];
				
				//initialize the array
				$sdata = array('invoice_id' => $data['invoice_id'],
							   'product_id' => $v,
							   'invoice_product_name' => $sproduct_name,
							   'unit_price' => $sunit_price,
							   'quantity' => $squantity,
							   'product_notes' => $sproduct_notes,
							   'product_sku' => $product[0]['product_sku'],
							   );
							   
				//insert products for invoice
				$this->db->insert('invoice_products', $sdata);
				
				//add up the amounts
				 $amount = $sunit_price * $squantity;
				 
				 $price['sub_total'] = $price['sub_total'] + $amount;
			}
			
			//update the subtotal of the invoice
			$this->db->where('invoice_id', $data['invoice_id']);
			$this->db->update('invoices', $price);
			
			//log success
			log_message('info', 'invoice '. $data['invoice_id'] . ' inserted into invoices table');
		}
		
		return $data;
	}
	
	// ------------------------------------------------------------------------
	
	function _delete_invoice($id = '')
	{
		//delete associated products
		$this->db->where('invoice_id', $id);
		$this->db->delete('invoice_products');
		
		//delete associated payments
		$this->db->where('invoice_id', $id);
		$this->db->delete('invoice_payments');
		
		//delete invoice
		$this->db->where('invoice_id', $id);
		if ($this->db->delete('invoices'))
		{
			
			//log success
			log_message('info', 'invoice ID #' . $id . ' deleted successfully');
		}
		else
		{
			show_error($this->lang->line('could_not_delete_invoice'));
			
			//log error
			log_message('error', 'invoice ID #' . $id . ' could not be deleted');
		}
		
		return true;
	}	
	
	// ------------------------------------------------------------------------
	
	function _get_payment_gateways($name = false)
	{
		$this->db->where('module_type', 'payment_gateway');
		$this->db->where('module_status', '1');
		$query = $this->db->get('modules');
		
		if ($query->num_rows() > 0)
		{
			$gateways = $query->result_array();
			
			if ($name == true)
			{
				$options = format_array($gateways, 'module_file_name', 'module_name');
			}
			else
			{
				$options = format_array($gateways, 'module_name', 'module_name');
			}
			
			return $options;
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _count_invoices($id = '')
	{
		$this->db->where('member_id', $id);
		$this->db->from('invoices');
		
		return $this->db->count_all_results();
	}
	
	// ------------------------------------------------------------------------
	
	function _get_payment($id, $col = 'id') 
	{
		$this->db->where($col, $id);
		$query = $this->db->get('invoice_payments');
		
		if ($query->num_rows() > 0)
		{
			return $query->row_array();
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _append_payment($id, $data)
	{
		$payment = $this->_get_payment($id);
		
		if ($payment != false)
		{
			$sdata = array('payment_notes' => $payment['payment_notes'] . "\n\n" . $data['jrox_payment_notes'],
						   'debug_info' => $payment['debug_info'] . "\n\n\n" . $data['jrox_debug_info']
						  );
			
			$this->db->where('id', $id);
			if ($this->db->update('invoice_payments', $sdata))
			{
				return true;
			}
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _update_payment($id = '')
	{
		//clean the data first
		$data = $this->db_validation_model->_clean_data($_POST);
		
		//set up dates
		$fdate = explode(':', $this->config->item('sts_admin_date_format'));
		switch ($fdate[0])
		{
			case 'mm/dd/yyyy':
					
				if (!empty($data['payment_date']))
				{
					//format date
					$pub = explode('/', $data['payment_date']);
					$data['payment_date'] = mktime(date('H'),date('i'),date('s'), $pub[0], $pub[1], $pub[2]);
				}
				else
				{
					$data['payment_date'] = _generate_timestamp();
				}

			break;
		}
		
		if ($data['payment_type'] == 'refund')
		{
			$amount = $data['payment_amount'];
			if ($amount[0]  != '-')
			{
				$data['payment_amount'] = '-' . $data['payment_amount'];
			}
		}
		
		$this->db->where('id', $id);
		
		if (!$this->db->update('invoice_payments', $data))
		{
			show_error($this->lang->line('could_not_update_invoice_payment'));
			
			//log error
			log_message('error', 'Could not update invoice payment ID ' . $id . 'in invoice_payments table');
			
			return false;
		}
		else
		{
			
			//log success
			log_message('info', 'invoice payment ID '. $id . ' updated in invoice_payments table');
		}
		
		return true;
	}
	
	// ------------------------------------------------------------------------
	
	function _check_payment_status ($id = '')
	{
		$invoice = $this->_get_invoice_totals($id);
		
		$payments = $this->_count_total_payments($id);
		
		if ($payments >= $invoice)
		{
			
			$this->db->where('invoice_id', $id);
			$this->db->update('invoices', array('payment_status' => '1'));
			
			//$this->db_validation_model->_change_status_field('invoices', 'invoice_id', $id, 'payment_status');
		}
	}
	
	// ------------------------------------------------------------------------
	
	function _get_invoice_totals($id = '')
	{
		//get the data from invoices table
		$sql = 'SELECT ROUND(sub_total+tax_amount+shipping_amount-discount_amount,2) as total_amount	
				FROM ' . $this->db->dbprefix('invoices') . '
				WHERE invoice_id = \'' . $id . '\'';
		
		
		$query = $this->db->query($sql);
		
		$a = $query->result_array();
		
		return $a[0]['total_amount'];
	}
	
	// ------------------------------------------------------------------------
	
	function _insert_payment($data = '')
	{
		//insert into db
		if (!$this->db->insert('invoice_payments', $data))
		{
			show_error($this->lang->line('could_not_add_payment'));
			
			//log error
			log_message('error', 'Could not insert invoice payment into invoice_payments table');
			
			return false;
		}
		
		$id = $this->db->insert_id();
		
		$this->_check_payment_status($data['invoice_id']);
		
		return $id;
	}

	
	// ------------------------------------------------------------------------
	
	function _add_payment($id = '', $payment_data = array())
	{
		$data = $this->db_validation_model->_clean_data($payment_data);
		
		$data['invoice_id'] = $id;
		
		unset ($data['generate_commission_for_invoice']);
		unset ($data['send_email']);
		
		//set up dates
		$fdate = explode(':', $this->config->item('sts_admin_date_format'));
		switch ($fdate[0])
		{
			case 'mm/dd/yyyy':
				
				if (!empty($data['payment_date']))
				{
					//format date
					$pub = explode('/', $data['payment_date']);
					$data['payment_date'] = mktime(date('H'),date('i'),date('s'), $pub[0], $pub[1], $pub[2]);
				}
				
			break;
		}
				
		//check if payment type is refund and add negative
		if ($data['payment_type'] == 'refund')
		{
			$amount = $data['payment_amount'];
			if ($amount[0]  != '-')
			{
				$data['payment_amount'] = '-' . $data['payment_amount'];
			}
		}
		
		
		$data['payment_id'] = $this->_insert_payment($data);
		
		//now get the invoice data for possible commission generation
		
		$invoice = $this->_get_invoice_details($id);
	
		//invoice data
		$data['inv'] = $invoice['inv'];
		$data['payments'] = $invoice['payments'];
		$data['prod'] = $invoice['prod'];
		$data['total_payments'] = $invoice['total_payments'];
		
		
		//check for credit
		if ($data['total_payments'] > $data['inv']['total_amount'])
		{
			$data['issue_credit'] = true;
		}
		
		log_message('info', 'payment '. $id . ' inserted into invoice_payments table');
		
		return $data;
	}
	
	// ------------------------------------------------------------------------
	
	function _delete_payment($id = '')
	{
	
		//delete payment
		$this->db->where('id', $id);
		if ($this->db->delete('invoice_payments'))
		{
			
			//log success
			log_message('info', 'invoice payment #' . $id . ' deleted successfully');
		}
		else
		{
			show_error($this->lang->line('could_not_delete_invoice_payment'));
			
			//log error
			log_message('error', 'invoice payment ID #' . $id . ' could not be deleted');
		}
		
		return true;
	}	
	
	// ------------------------------------------------------------------------
	
	function _check_product_id($id = '', $type = '')
	{
		$this->db->where('product_id', $id);
		
		if ($type == 'membership')
		{
			$this->db->where('product_type', $type);
		}
		
		$query = $this->db->get('products');
		
		if ($query->num_rows() > 0)
		{
			return true;
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------

	function _get_invoice_payment_details($id = '')
	{
		$sql = 'SELECT ' . $this->db->dbprefix('invoice_payments') . '.*, ' . $this->db->dbprefix('invoices') . '.*
				FROM ' . $this->db->dbprefix('invoice_payments') . '
				LEFT JOIN ' . $this->db->dbprefix('invoices') . ' ON ' .
				$this->db->dbprefix('invoice_payments') . '.invoice_id = ' . $this->db->dbprefix('invoices') . '.invoice_id
				WHERE id = \'' . $id .'\'';
	
		
		$query = $this->db->query($sql);
		
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		 
		return  false;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_total_payments($id ='')
	{
		//get the payments
		$this->db->where('invoice_id', $id);
		$this->db->order_by('payment_date', 'ASC');
		$query = $this->db->get('invoice_payments');
		
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _count_total_payments($id = '')
	{
		$sql = 'SELECT SUM(payment_amount) as total FROM ' . $this->db->dbprefix('invoice_payments') . '
				WHERE invoice_id = \'' . $id . '\'';
				
		$query = $this->db->query($sql);
		
		if ($query->num_rows() > 0)
		{
			$a = $query->result_array();
			
			return $a[0]['total'];
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_total_commissions($id = '')
	{
		$sql = 'SELECT ' . $this->db->dbprefix('affiliate_commissions') . '.*,
						(SELECT username from ' . $this->db->dbprefix('members') . ' 
						WHERE ' . $this->db->dbprefix('affiliate_commissions') . '.member_id = ' . $this->db->dbprefix('members') . '.member_id) as username
						FROM ' . $this->db->dbprefix('affiliate_commissions') . '
						WHERE invoice_id = \'' . $id . '\'';
			
		$query = $this->db->query($sql);
		
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
			
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_invoice_products($id = '')
	{
		//get the products			
		$this->db->where('invoice_id', $id);
		$this->db->join('products', 'invoice_products.product_id = products.product_id');
		$this->db->order_by('product_sort', 'ASC');
		$query2 = $this->db->get('invoice_products');
		
		if ($query2->num_rows() > 0)
		{
			$rows = array();

			foreach ($query2->result_array() as $row)
			{
				$row['product_price'] = sprintf('%1$.2f',$row['unit_price']);
				
				array_push($rows, $row);
			}
			
			return $rows;
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_invoice_basic($id = '')
	{
		$this->db->where('invoice_id', $id);
		$query = $this->db->get('invoices');
		
		if ($query->num_rows() > 0)
		{
			return $query->row_array();
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_invoice_details($id = '')
	{
		//get the data from invoices table
		$sql = 'SELECT ' . $this->db->dbprefix('invoices') . '.*,
					ROUND(sub_total+tax_amount+shipping_amount-discount_amount,2) as total_amount	
					FROM ' . $this->db->dbprefix('invoices') . '
					WHERE invoice_id = \'' . $id . '\'';
		
		
		$query = $this->db->query($sql);
		
		$data['total_payments'] = '';
		$data['total_commissions'] = '';
		$data['commissions'] = '';
		
		if ($query->num_rows() > 0)
		{
			$invoice = $query->result_array();
			
			$data['inv'] = $invoice[0];
			
			$data['prod'] = $this->_get_invoice_products($id);
			
			//calculate total payments
			$data['payments'] = $this->_get_total_payments($id);
	
			$data['total_payments'] = '0';
			
			if (!empty($data['payments']))
			{			
				foreach ($data['payments'] as $v)
				{
					$data['total_payments'] = $data['total_payments'] + $v['payment_amount'];
				}
			}
			
			
			if ($this->config->item('sts_affiliate_enable_affiliate_marketing') == 1)
			{
				//get any commissions
				$data['commissions'] = $this->_get_total_commissions($id);
					
				$data['total_commissions'] = '0';
					
				//calculate total commissions
				if (!empty($data['commissions']))
				{
					foreach ($data['commissions'] as $v)
					{
						$data['total_commissions'] = $data['total_commissions'] + $v['commission_amount'];
					}
				}
			}
			
			//get affiliate info
			$data['inv']['referrer_affiliate'] = '';
			
			if (!empty($data['inv']['referrer_id']))
			{
				$member = $this->db_validation_model->_get_details('members', 'username', 'member_id', $data['inv']['referrer_id']);
				
				$data['inv']['referrer_affiliate'] = $member[0]['username'];
			}
			
			//get custom fields for user
			$member = $this->db_validation_model->_get_details('members', '*', 'member_id', $data['inv']['member_id']);
			
			$data['inv']['jrox_custom_field_1'] = $member[0]['jrox_custom_field_1'];
			$data['inv']['jrox_custom_field_2'] = $member[0]['jrox_custom_field_2'];
			$data['inv']['jrox_custom_field_3'] = $member[0]['jrox_custom_field_3'];
			$data['inv']['jrox_custom_field_4'] = $member[0]['jrox_custom_field_4'];
			$data['inv']['jrox_custom_field_5'] = $member[0]['jrox_custom_field_5'];
			$data['inv']['jrox_custom_field_6'] = $member[0]['jrox_custom_field_6'];
			$data['inv']['jrox_custom_field_7'] = $member[0]['jrox_custom_field_7'];
			$data['inv']['jrox_custom_field_8'] = $member[0]['jrox_custom_field_8'];
			$data['inv']['jrox_custom_field_9'] = $member[0]['jrox_custom_field_9'];
			$data['inv']['jrox_custom_field_10'] = $member[0]['jrox_custom_field_10'];
			
			//get any member credits
			
			$sql = 'SELECT SUM(amount) as credits FROM ' . $this->db->dbprefix('members_credits') . '
					WHERE member_id = ' . $data['inv']['member_id'] . ' AND invoice_id = \'0\'';
					
			$query5 = $this->db->query($sql); 
			
			$data['total_credits'] = 0;
			
			if ($query5->num_rows() > 0)
			{	
				$credits = $query5->result_array();
				
				$data['total_credits'] = $credits[0]['credits'];
			}
			
			return $data;
		}
		else
		{
			return false;
		}
	}
	
	// ------------------------------------------------------------------------	
	
	function _get_unpaid_membership_invoices($id = '', $type = false)
	{
		$sql = 'SELECT ' . $this->db->dbprefix('invoices') . '.*,
						ROUND(sub_total+tax_amount+shipping_amount-discount_amount,2) as total
						FROM ' . $this->db->dbprefix('invoices') . '
						WHERE payment_status = \'0\' AND member_id = \'' . $id . '\'';
		
		if ($type == false)
		{
			$sql .= ' AND product_type = \'membership\'';
		}
		else
		{
			$sql .= ' AND product_type != \'membership\'';
		}
						
		$sql .= ' ORDER BY invoice_id ASC';
	
		
		$query = $this->db->query($sql);
		
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------	
	
	function _get_unpaid_invoices($mid = '')
	{
		$this->db->where('member_id', $mid);
		$this->db->where('payment_status', '0');
		
		$query = $this->db->get('invoices');
		
		$options = '';
		
		if ($query->num_rows() > 0)
		{	
			$invoices = $query->result_array();
			
			$keys = array();
			$values = array();
			
			$num_options = !$this->config->item('num_options') ? get_default_currency($this->config->item('sts_store_default_currency')) : $this->config->item('num_options');
			
			foreach ($invoices as $v)
			{
				array_push($keys, $v['invoice_id']);
				
				$amount = format_amounts($v['sub_total'] + $v['tax_amount'] + $v['shipping_amount'], $num_options);
				
				
				array_push($values, $this->config->item('sts_store_order_id_prefix') . $v['invoice_id'] . ' - ' . $amount);
			}

			$options = combine_array($keys, $values);		
		}
		
		return $options;
		
	}
	
	// ------------------------------------------------------------------------	
	
	function _change_status($data = '', $type = '0')
	{

		$status = $type;
		
		if ($type == 'order_processing_email')
		{
			$status = 'order_processing';
		}
		elseif ($type == 'order_completed_email')
		{
			$status = 'order_completed';
		}
		
		foreach ($data as $id)
		{
			
			$this->db->where('invoice_id', $id);
			
			if ($status == 'delete')
			{
				$this->_delete_invoice((int)($id));
			}
			else
			{
			
				//update invoice in db
				
				$data = array('order_status' => $status);
				
				if (!$this->db->update('invoices', $data))
				{
					show_error($this->lang->line('could_not_update_invoice'));
					
					//log error
					log_message('error', 'Could not update invoice ID #' . $id . ' in invoices table');
					return false;
				}
				
				//check if we are sending out status alerts
				if ($type == 'order_processing_email' || $type == 'order_completed_email')
				{
					
				} 
				
				//log success
				log_message('info', 'Status Changed for invoice ID# ' . $id);
			}
			
		}
		
		return true;		
	}
	
	// ------------------------------------------------------------------------
	
	function _get_invoice_payments($limit = 25, $offset = 0, $sort_column = '', $sort_order = '', $where_column = '', $where_value = '')
	{
		//get all the admins from db for list view
		if (!$sort_order) $sort_order = $this->config->item('dbs_ivp_order');
		if (!$sort_column) $sort_column = $this->config->item('dbs_ivp_column');
		
		if ($where_column == 'search')
		{			
			$sql = 'SELECT ' . $this->db->dbprefix('invoice_payments') . '.*, ' . $this->db->dbprefix('invoices') . '.*
					FROM ' . $this->db->dbprefix('invoice_payments') . '
					LEFT JOIN ' . $this->db->dbprefix('invoices') . ' ON ' .
					$this->db->dbprefix('invoice_payments') . '.invoice_id = ' . $this->db->dbprefix('invoices') . '.invoice_id
					WHERE transaction_id LIKE \'%' . $where_value .'%\'
					OR payment_amount LIKE \'%' . $where_value .'%\'
					ORDER BY ' . $sort_column . ' ' . $sort_order . ' LIMIT ' . $offset. ', ' . $limit;
		}
		else
		{
			$sql = 'SELECT ' . $this->db->dbprefix('invoice_payments') . '.*, ' . $this->db->dbprefix('invoices') . '.*
					FROM ' . $this->db->dbprefix('invoice_payments') . '
					LEFT JOIN ' . $this->db->dbprefix('invoices') . ' ON ' .
					$this->db->dbprefix('invoice_payments') . '.invoice_id = ' . $this->db->dbprefix('invoices') . '.invoice_id
					ORDER BY ' . $sort_column . ' ' . $sort_order . ' LIMIT ' . $offset. ', ' . $limit;
		}
		
		$query = $this->db->query($sql);
		
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		 
		return  false;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_invoices($limit = 25, $offset = 0, $sort_column = '', $sort_order = '', $where_column = '', $where_value = '')
	{
		//get all the admins from db for list view
		if (!$sort_order) $sort_order = $this->config->item('dbs_inv_order');
		if (!$sort_column) $sort_column = $this->config->item('dbs_inv_column');
		
		if ($where_column == 'search')
		{
			$sql = 'SELECT ' . $this->db->dbprefix('invoices') . '.*,
						ROUND(sub_total+tax_amount+shipping_amount-discount_amount,2) as total,
						(SELECT SUM(payment_amount) from ' . $this->db->dbprefix('invoice_payments') . ' 
						WHERE ' . $this->db->dbprefix('invoices') . '.invoice_id = ' . $this->db->dbprefix('invoice_payments') . '.invoice_id) as payments,
						(SELECT username from ' . $this->db->dbprefix('members') . ' 
						WHERE ' . $this->db->dbprefix('invoices') . '.referrer_id = ' . $this->db->dbprefix('members') . '.member_id) as username
						FROM ' . $this->db->dbprefix('invoices') . '
						WHERE (customers_name LIKE \'%' . $where_value .'%\'
						OR invoice_id LIKE \'%' . $where_value .'%\'
						OR customers_company LIKE \'%' . $where_value .'%\'
						OR shipping_name LIKE \'%' . $where_value .'%\'
						OR shipping_company LIKE \'%' . $where_value .'%\'
						OR customers_primary_email LIKE \'%' . $where_value .'%\')
						ORDER BY ' . $sort_column . ' ' . $sort_order . ' LIMIT ' . $offset. ', ' . $limit;

		}
		else
		{
			if (!empty($where_value))
			{
				$sql = 'SELECT ' . $this->db->dbprefix('invoices') . '.*,
						ROUND(sub_total+tax_amount+shipping_amount-discount_amount,2) as total,
						(SELECT SUM(payment_amount) from ' . $this->db->dbprefix('invoice_payments') . ' 
						WHERE ' . $this->db->dbprefix('invoices') . '.invoice_id = ' . $this->db->dbprefix('invoice_payments') . '.invoice_id) as payments,
						(SELECT username from ' . $this->db->dbprefix('members') . ' 
						WHERE ' . $this->db->dbprefix('invoices') . '.referrer_id = ' . $this->db->dbprefix('members') . '.member_id) as username
						FROM ' . $this->db->dbprefix('invoices') . '
						WHERE order_status = \'' . $where_value . '\'';
						
				if (!empty($where_column))
				{
					$sql .= ' AND member_id = \'' . $where_column . '\'';
				}
				
				$sql .= ' ORDER BY ' . $sort_column . ' ' . $sort_order . ' LIMIT ' . $offset. ', ' . $limit;
			}
			else
			{
				$sql = 'SELECT ' . $this->db->dbprefix('invoices') . '.*,
						ROUND(sub_total+tax_amount+shipping_amount-discount_amount,2) as total,
						(SELECT SUM(payment_amount) from ' . $this->db->dbprefix('invoice_payments') . ' 
						WHERE ' . $this->db->dbprefix('invoices') . '.invoice_id = ' . $this->db->dbprefix('invoice_payments') . '.invoice_id) as payments,
						(SELECT username from ' . $this->db->dbprefix('members') . ' 
						WHERE ' . $this->db->dbprefix('invoices') . '.referrer_id = ' . $this->db->dbprefix('members') . '.member_id) as username
						FROM ' . $this->db->dbprefix('invoices');
						
				if (!empty($where_column))
				{
					$sql .= ' WHERE member_id = \'' . $where_column . '\'';
				}
				
				$sql .= ' ORDER BY ' . $sort_column . ' ' . $sort_order . ' LIMIT ' . $offset. ', ' . $limit;
			}
		}
		$query = $this->db->query($sql);
		
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		 
		return  false;
	}

	// ------------------------------------------------------------------------
	
	function _get_user_invoices($id = '', $limit = 25, $offset = 0, $sort_column = '', $sort_order = '', $num_options = '', $where_value = '')
	{
		//get all the admins from db for list view
		if (!$sort_order) $sort_order = $this->config->item('dbs_inv_order');
		if (!$sort_column) $sort_column = $this->config->item('dbs_inv_column');
		
		$sql = 'SELECT ' . $this->db->dbprefix('invoices') . '.*,
						ROUND(sub_total+tax_amount+shipping_amount-discount_amount,2) as total,
						(SELECT SUM(payment_amount) from ' . $this->db->dbprefix('invoice_payments') . ' 
						WHERE ' . $this->db->dbprefix('invoices') . '.invoice_id = ' . $this->db->dbprefix('invoice_payments') . '.invoice_id) as payments
						FROM ' . $this->db->dbprefix('invoices') . '
						WHERE member_id = \'' . $id . '\'';
				
		if ($where_value == 'unpaid' || $where_value == 'paid')
		{
			$status = $where_value == 'unpaid' ? '0' : '1';
			
			$sql .= ' AND payment_status = \'' . $status . '\' ';
		}
				
		$sql .= ' ORDER BY ' . $sort_column . ' ' . $sort_order . ' LIMIT ' . $offset. ', ' . $limit;
		
		$query = $this->db->query($sql);
		
		if ($query->num_rows() > 0)
		{
		
			$a['invoices'] = array();
			
			foreach ($query->result_array() as $row)
			{
				$row['invoice_total'] = format_amounts($row['total'], $num_options);
				$row['invoice_payments'] = format_amounts($row['payments'], $num_options);
				$row['s_invoice_id'] = $this->config->item('sts_store_order_id_prefix') . $row['invoice_id'];
				$row['s_order_status'] = $this->lang->line($row['order_status']);
				$row['s_date_purchased'] = _show_date($row['date_purchased']);
				$row['s_due_date'] = _show_date($row['due_date']);
				$row['row_style'] = alternator('jroxRowStyle1', 'jroxRowStyle2');
				
				$row['s_payment_status'] = $row['payment_status'] == '1' ? 'tick' : 'warning1';
				
				if ($row['payment_status'] == '1')
				{
					$row['s_pay_link'] = '<a href="#" onclick="return false;" class="jroxMembersPaid jroxMembersImageLinks" title="' . $this->lang->line('paid') . '"><span>' . $this->lang->line('paid') . '</span></a>';
				}
				else
				{
				
					$row['s_pay_link'] = '<a href="' . $this->config->item('checkout_url_link') .  'checkout/pay_invoice/' . $row['invoice_id'] . '/' . $this->config->item('enc_id') . '" class="jroxMembersPay jroxMembersImageLinks" title="' . $this->lang->line('pay') . '"><span>' . $this->lang->line('pay') . '</span></a>';
				}
				
				array_push($a['invoices'], $row);
			}
			
			//get total rows
			$this->db->where('member_id', $id);
			
			if ($where_value == 'unpaid' || $where_value == 'paid')
			{
				$status = $where_value == 'unpaid' ? '0' : '1';
				
				$this->db->where('payment_status', $status);
			}
			
			
			$this->db->from('invoices');
			
			$a['total_rows'] = $this->db->count_all_results();
			
			return $a;
		}
		
		return false;
		
	}
	
	// ------------------------------------------------------------------------
	
	function _update_invoice($id = '')
	{
		$data = $this->db_validation_model->_clean_data($_POST);
		
		//get all products for the invoice
		$product_id = $data['product_id'];
		$invoice_product_name = $data['invoice_product_name'];
		$quantity = $data['quantity'];
		$unit_price = $data['unit_price'];
		$product_notes = $data['product_notes'];
		$referring_affiliate = $data['referring_affiliate'];
		$product_type = $data['product_type'];
		
		//unset it now cuz we don't need it
		unset ($data['product_id']);
		unset ($data['invoice_product_name']);
		unset ($data['quantity']);
		unset ($data['unit_price']);
		unset ($data['referring_affiliate']);
		unset ($data['product_notes']);
		
		//set up dates
		$fdate = explode(':', $this->config->item('sts_admin_date_format'));
		switch ($fdate[0])
		{
			case 'mm/dd/yyyy':
					
				if (!empty($data['date_purchased']))
				{
					//format date
					$pub = explode('/', $data['date_purchased']);
					$data['date_purchased'] = mktime(date('H'),date('i'),date('s'), $pub[0], $pub[1], $pub[2]);
				}
				
				if (!empty($data['due_date']))
				{
					//format date
					$pub = explode('/', $data['due_date']);
					$data['due_date'] = mktime(date('H'),date('i'),date('s'), $pub[0], $pub[1], $pub[2]);
				}
				
			break;
		}
				
		//get affiliate id if any and generate the commission
		if (!empty($referring_affiliate))
		{
			$member = $this->db_validation_model->_get_details('members', 'member_id', 'username', $referring_affiliate);
			$data['referrer_id'] = $member[0]['member_id'];
		}
		else
		{
			$data['referrer_id'] = '0';
		}
		
		//insert into db
		$this->db->where('invoice_id', $id);
		if (!$this->db->update('invoices', $data))
		{
			show_error($this->lang->line('could_not_add_invoice'));
			
			//log error
			log_message('error', 'Could not update invoice into invoices table');
			
			return false;
		}
		else
		{
			//first delete all invoice products
			$this->db->where('invoice_id', $id);
			$this->db->delete('invoice_products');
			
			//invoice total
			$price['sub_total'] = '';
			
			//check what the product type is
			if ($product_type == 'membership')
			{
				$products[0] = $product_id[0];
			}
			else
			{
				$products = $product_id;
			}
			
			//check each product
			foreach($products as $k =>$v)
			{
				if (!empty($v))
				{
					//get product names
					$product = $this->db_validation_model->_get_details('products', '*', 'product_id', $v);
	
					//check product name
					$sproduct_name = empty($invoice_product_name[$k]) ? $product[0]['product_name'] : $invoice_product_name[$k];
						
					//check quantity
					if ($product_type == 'membership')
					{
						$squantity = '1';
					}
					else
					{
						$squantity = empty($quantity[$k]) ? '1' : $quantity[$k];
					}
					
					$sproduct_notes = empty($product_notes[$k]) ? '' : $product_notes[$k];
					
					//check unit price
					$sunit_price = empty($unit_price[$k]) ? $product[0]['product_price'] : $unit_price[$k];
					
					//initialize the array
					$sdata = array('invoice_id' => $id,
								   'product_id' => $v,
								   'invoice_product_name' => $sproduct_name,
								   'unit_price' => $sunit_price,
								   'quantity' => $squantity,
								   'product_notes' => $sproduct_notes,
								   'product_sku' => $product[0]['product_sku'],
								   );
								   
					//insert products for invoice
					$this->db->insert('invoice_products', $sdata);
					
					//add up the amounts
					 $amount = $sunit_price * $squantity;
					 
					 $price['sub_total'] = $price['sub_total'] + $amount;
				 }
			}
			
			//update the subtotal of the invoice
			$this->db->where('invoice_id', $id);
			$this->db->update('invoices', $price);
			
			//log success
			log_message('info', 'invoice '. $id . ' update in invoices table');
		}
		
		return $data;
	}
	
	// ------------------------------------------------------------------------	
}
?>