<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - module_affiliate_payment_store_credits_model.php
| -------------------------------------------------------------------------     
| 
| This model handles the functions for store credits
|
*/

class Module_Affiliate_Payment_Store_Credits_Model extends Model {	
	
	function _generate_payments($data = '')
	{	
	
		$total = 0;
		
		foreach($data as $member)
		{
			
			$credit_note = $this->lang->line('affiliate_payment') . "; \n";
			$credit_note .= $this->lang->line('date') . ": " . date($this->config->item('sts_admin_time_format'), now()) . "; \n";
			$credit_note .= $member['affiliate_note'] . " \n";
			
			$credit_array = array('amount' => $member['payment_amount'],
								  'notes' => $credit_note,
								  'invoice_id' => '0',
								  );
								  
			$fdata = $this->credits_model->_add_credit($member['member_id'], $credit_array);	
			
			$this->affiliate_payments_model->_mark_commissions_paid($member['member_id'], $member['payment_amount'], $member['affiliate_note']);
			
			$total++;			
		}
		
		//set flash data
		$this->session->set_flashdata('success', $total . ' ' . $this->lang->line('members_credited'));
		
		//go back to the page
		redirect(ADMIN_ROUTE . '/affiliate_payments/make_affiliate_payments');
		
	}
	
	// ------------------------------------------------------------------------	
}
?>