<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - module_data_export_invoices_model.php
| -------------------------------------------------------------------------     
| 
| This controller file is for functions for exporting invoices
|
*/


class Module_Data_Export_Invoices_Model extends Model {

	function _install_jrox_module($id = '')
	{	
		//insert required config rows in settings table
		$config = array(
							'settings_key'	=>	'module_data_export_invoices_delimiter',
							'settings_value'	=>	',',
							'settings_module'	=>	'data_export',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'1',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_data_export_invoices_starting_date',
							'settings_value'	=>	'',
							'settings_module'	=>	'data_export',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'2',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_data_export_invoices_ending_date',
							'settings_value'	=>	'',
							'settings_module'	=>	'data_export',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'3',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		if ($this->db->insert('settings', $config))
		{
			return true;
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------
	
	function _get_invoices($delim = ',', $newline = "\r\n",  $enclosure = '"')
	{

		if ($this->config->item('module_data_export_invoices_starting_date') && $this->config->item('module_data_export_invoices_ending_date'))
		{
			//format start and end dates
			
			$a = explode('/' , $this->config->item('module_data_export_invoices_starting_date'));
			$start = mktime('0', '0', '01', $a[0], $a[1], $a[2]);
			
			$b = explode('/', $this->config->item('module_data_export_invoices_ending_date'));
			$end = mktime('23', '59', '59', $b[0], $b[1], $b[2]);
			
			
		}
		else //get invoices for current month
		{
			$start = mktime('0', '0', '01', date('m'), '1',  date('Y'));
			$end = mktime('23', '59', '59', date('m'), date('t'),  date('Y'));
		}
		

		$sql = 'SELECT ' . $this->db->dbprefix('invoices') . '.*,
				FROM_UNIXTIME(date_purchased) as purchase_date,
				FROM_UNIXTIME(due_date) as date_due
				FROM  ' . $this->db->dbprefix('invoices') . ' 
				WHERE date_purchased >= ' . $start . ' 
				AND date_purchased <= ' . $end . ' 
				ORDER BY ' . $this->db->dbprefix('invoices') . '.invoice_id ASC';
			
		$query = $this->db->query($sql);

		if ($query->num_rows() > 0)
		{
		
			$out = '';
			
			// First generate the headings from the table column names
			foreach ($query->list_fields() as $name)
			{				
				$out .= $enclosure.str_replace($enclosure, $enclosure.$enclosure, $name).$enclosure.$delim;
			}
					
			//add the product SKUs ordered

			$out .= $enclosure.str_replace($enclosure, $enclosure.$enclosure, 'product SKUs').$enclosure.$delim;
			$out = rtrim($out);
			$out .= $newline;
			
			// Next blast through the result array and build out the rows
			foreach ($query->result_array() as $row)
			{
				foreach ($row as $item)
				{
					$out .= $enclosure.str_replace($enclosure, $enclosure.$enclosure, $item).$enclosure.$delim;			
				}
				
				
				//get the SKUs for each invoice
				$this->db->where('invoice_id', $row['invoice_id']);
				$skus = $this->db->get('invoice_products');

				$product_skus = '';
				$sku_list = array();
				if ($skus->num_rows() > 0)
				{
					foreach ($skus->result_array() as $sku)
					{
						array_push($sku_list, $sku['product_sku']);
					}
					
					$product_skus = implode(';', $sku_list);
				}
				
				$out .= $enclosure.str_replace($enclosure, $enclosure.$enclosure, $product_skus).$enclosure.$delim;			
				
				$out = rtrim($out);
				$out .= $newline;
			}
			
			return $out;
		}
		 
		return  false;

	}
	
	// ------------------------------------------------------------------------
	
	
}
?>