<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - module_data_export_products_model.php
| -------------------------------------------------------------------------     
| 
| This controller file is for functions for exporting products
|
*/


class Module_Data_Export_Products_Model extends Model {

	function _install_jrox_module($id = '')
	{	
		//insert required config rows in settings table
		$config = array(
							'settings_key'	=>	'module_data_export_products_delimiter',
							'settings_value'	=>	',',
							'settings_module'	=>	'data_export',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'1',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		//insert required config rows in settings table
		$config = array(
							'settings_key'	=>	'module_data_export_products_total_rows',
							'settings_value'	=>	'1000',
							'settings_module'	=>	'data_export',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'2',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		
		$config = array(
							'settings_key'	=>	'module_data_export_products_starting_rows',
							'settings_value'	=>	'0',
							'settings_module'	=>	'data_export',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'3',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		if ($this->db->insert('settings', $config))
		{
			return true;
		}
		
		return false;
	}
	
	
	function _get_products()
	{
		$starting_row = $this->config->item('module_data_export_products_starting_rows') == '' ? '1' : $this->config->item('module_data_export_products_starting_rows');
		$total_rows = $this->config->item('module_data_export_products_total_rows') == '' ? '500' : $this->config->item('module_data_export_products_total_rows');
		
		$sql = 'SELECT ' . $this->db->dbprefix('products') . '.*
				FROM  ' . $this->db->dbprefix('products') . '
				ORDER BY ' . $this->db->dbprefix('products') . '.product_id ASC LIMIT ' . $starting_row . ', ' . $total_rows;

		$query = $this->db->query($sql);
		
		if ($query->num_rows() > 0)
		{
	
			$srow['head'] = array();
			$srow['rows'] = array();
			
			foreach ($query->list_fields() as $value)
			{
				array_push($srow['head'], $value);		
			}
	
			array_push($srow['head'], 'product_categories');
	
			foreach ($query->result_array() as $k => $value)
			{
				foreach ($value as $a => $b)
				{
					switch ($a)
					{
						case 'date_added';
						case 'date_modified';
						case 'date_available';
						case 'date_expires';
						
						$value[$a] = date('m/d/Y', $value[$a]);
						
						break;
					}
				}
				
				//get the categories for this product
				$this->db->where('product_id', $value['product_id']);
				$squery = $this->db->get('products_to_categories');
				
				if ($squery->num_rows() > 0)
				{
					$cat = '';
					foreach ($squery->result_array() as $c)
					{
						$cat .= $c['category_id'] .'|';
					}
				}
				
				$value['product_categories'] = substr($cat, 0, -1);
				
				array_push($srow['rows'], $value);	
			}
			//echo '<pre>'; print_r($srow); exit();
			return $srow;
		}
		 
		return  false;

	}
	
	// ------------------------------------------------------------------------
	
	function _generate_csv($query, $delim = ",", $newline = "\n", $enclosure = '"')
	{	
		$out = '';
		if ($delim == "tab") { $delim = "\t"; $enclosure = ''; } 
		
		// First generate the headings from the table column names

		foreach ($query['head'] as $name)
		{
			$out .= $enclosure.str_replace($enclosure, $enclosure.$enclosure, $name).$enclosure.$delim;
		}
		
		$out = rtrim($out);
		
		$out .= $newline;
		
		// Next blast through the result array and build out the rows
		foreach ($query['rows'] as $row)
		{
			foreach ($row as $item)
			{
				$out .= $enclosure.str_replace($enclosure, $enclosure.$enclosure, $item).$enclosure.$delim;			
			}
			$out = rtrim($out);
			$out .= $newline;
		}

		return $out;
	}
	
	
}
?>