<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2008 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - payment_gateway_authorize_net_sim_model.php
| -------------------------------------------------------------------------     
| 
| This model handles the functions for authoirze.net sim payments
|
*/

class Module_Payment_Gateway_Authorize_Net_Sim_Model extends Model {	
	
	function _install_jrox_module($id = '')
	{		
		//check admin session
		$this->security_model->_check_admin_session();
			
		$config = array(
							'settings_key'	=>	'module_payment_gateway_authorize_net_sim_url',
							'settings_value'	=>	'https://secure.authorize.net/gateway/transact.dll',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'1',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_authorize_net_sim_merchant_id',
							'settings_value'	=>	'',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'2',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_authorize_net_sim_transaction_key',
							'settings_value'	=>	'',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'3',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_authorize_net_sim_enable_testing',
							'settings_value'	=>	'1',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'4',
							'settings_function'	=>	'boolean',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);


		$config = array(
							'settings_key'	=>	'module_payment_gateway_authorize_net_sim_authorization_type',
							'settings_value'	=>	'1',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'5',
							'settings_function'	=>	'cc_auth_type',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_authorize_net_sim_header_html_payment_form',
							'settings_value'	=>	'',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'textarea',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'6',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_authorize_net_sim_footer_html_payment_form',
							'settings_value'	=>	'',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'textarea',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'7',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_authorize_net_sim_logo_url',
							'settings_value'	=>	'',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'8',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_authorize_net_sim_send_customer_notification',
							'settings_value'	=>	'1',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'9',
							'settings_function'	=>	'boolean',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_authorize_net_sim_send_merchant_notification',
							'settings_value'	=>	'1',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'10',
							'settings_function'	=>	'boolean',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_authorize_net_sim_enable_debug_email',
							'settings_value'	=>	'0',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'11',
							'settings_function'	=>	'boolean',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_authorize_net_sim_md5_hash',
							'settings_value'	=>	'',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'12',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		return true;
	}
	
	// ------------------------------------------------------------------------	
	
	function _check_gateway_options_authorize_net_sim($data = '')
	{
		
		$array['valid'] = '2'; //1 is to run an internal function; 2 is to forward to gateway
		$array['function'] = ''; //the function to run if needed for internal processing
		$array['module_name'] = 'authorize_net_sim';
		
		return $array; 
	}
	
		// ------------------------------------------------------------------------	
	
	function _validate_payment($trans_id = '', $amount = '', $hash = '')
	{
		$key = $this->config->item('module_payment_gateway_authorize_net_sim_md5_hash');
		
		//account is in demo mode
		if ($this->config->item('module_payment_gateway_authorize_net_sim_enable_testing') == 1)
		{
			$trans_id = '0';
		}
		
		if (!empty($key))
		{
			$c = md5 ( $key . $this->config->item('module_payment_gateway_authorize_net_sim_merchant_id') . $trans_id . $amount );
			
			if (strtoupper($c) != strtoupper($hash))
			{
				return false;
			}
		}
		
		return true;
	}
	
	// ------------------------------------------------------------------------	
	
	function _format_payment_data($post_data = array(), $order_data = array())
	{
		//set the debug info
		$debug = '';
		foreach ($post_data as $k => $v) { $debug .= $k . ': ' . $v . "\n"; }
		
		//get the payment method name
		$module_data = $this->modules->_get_module_column('module_file_name', 'authorize_net_sim');
		
		$data = array('jrox_error' 						=> 			false,
					  'jrox_error_message' 				=> 			'',
					  'jrox_payment_notes'				=>			'',
					  'jrox_payment_amount'				=>			$this->input->post('x_amount', true),
					  'jrox_debug_info'					=>			$debug,
					  'jrox_payment_method'				=>			$module_data['module_name'],
					  'jrox_trans_id'					=>			$this->input->post('x_trans_id', true),
					  'jrox_avs_code'					=>			'',
					  'jrox_membership_payment_type'	=> 			'authorize_net_sim',
					 );
	
		return $data;
	}
	
	// ------------------------------------------------------------------------	
	
	function _process($type = '', $data = array())
	{
		$results = array('jrox_error' => false);
		
		//run jrox verification first
		if ($this->_validate_payment($this->input->post('x_trans_id'), $this->input->post('x_amount'), $this->input->post('x_MD5_Hash')) == false)
		{
			$results['jrox_error'] = true;
			$a = md5( $this->config->item('module_payment_gateway_authorize_net_sim_md5_hash'). $this->config->item('module_payment_gateway_authorize_net_sim_merchant_id').$this->input->post('order_number'). $this->input->post('total'));
			$results['jrox_error_message'] = $a . ' != '. $this->input->post('x_MD5_Hash') . ' ' . $this->lang->line('invalid_security_code');
		}
		
		//check demo
		if ($this->input->post('x_test_request') == 'true')
		{
			if ($this->config->item('module_payment_gateway_authorize_net_sim_enable_testing') == 0)
			{
				$results['jrox_error'] = true;
				$results['jrox_error_message'] = $this->lang->line('invalid_demo_payment_sent');
			}
		}
		
		if ($results['jrox_error'] == false)
		{
			$results['jrox_payment_type'] = 'credit';
			$results['jrox_product_type'] = 'products';	
			$results['jrox_order_data'] = $this->security_model->_get_session_id($this->input->post('custom'));		
			
			if (!empty($results['jrox_order_data']))
			{
				$results['jrox_member_id'] = $results['jrox_order_data']['member_id'];
				
				$results['session_data'] = unserialize($results['jrox_order_data']['order_data']['session_data']);
				
				$results['jrox_payment_data'] = $this->_format_payment_data($data, $results['session_data']);
				
				$data['jrox_payment_data'] = $results['jrox_payment_data'];
			}
			else
			{
				$results['jrox_error'] = true;
			}
		}
		
		//check for debug info
		if ($this->config->item('module_payment_gateway_authorize_net_sim_enable_debug_email') == 1)
		{	
			$debug['post_data'] = $_POST;
			$debug['jrox_payment_data'] = $results['jrox_payment_data'];
			$this->security_model->_send_debug_email('Authorize.Net SIM Debug Email', $debug); 
		}
		
		return $results;
	}
	
	// ------------------------------------------------------------------------	
	
	function _format_fields($data = '', $type = '') 
	{
		$amount = $data['jrox_amount'];
		
		//check for membership
		if ($data['jrox_product_type'] == 'membership')
		{
			if ($data['jrox_enable_product_trial'] == 1)
			{
				$amount = $data['jrox_trial_amount'];
			}
		}
		
		$sequence	= rand(1, 1000);
		// a timestamp is generated
		$timeStamp	= time ();
		$fingerprint = hash_hmac("md5", $this->config->item('module_payment_gateway_authorize_net_sim_merchant_id') . "^" . $sequence . "^" . $timeStamp . "^" . $amount . "^", $this->config->item('module_payment_gateway_authorize_net_sim_transaction_key')); 
		
		$sdata = array(
								
				'x_login' => $this->config->item('module_payment_gateway_authorize_net_sim_merchant_id'), 
				'x_type' => $this->config->item('module_payment_gateway_authorize_net_sim_authorization_type'),
				'x_fp_sequence' => $sequence,
				'x_delim_data' => 'FALSE',
				'x_fp_timestamp' => $timeStamp,
				'x_fp_hash' => $fingerprint,
				'x_amount' => number_format($amount, 2),
				'x_description' => $this->config->item('sts_store_name') . ' ' . $this->lang->line('checkout_invoice'),
				'x_test_request' => $this->config->item('module_payment_gateway_authorize_net_sim_enable_testing') == 1 ? 'TRUE': 'FALSE',
				'x_show_form' => 'PAYMENT_FORM',
				'x_header_html_payment_form' => str_replace('"', '\'', $this->config->item('module_payment_gateway_authorize_net_sim_header_html_payment_form')),
				'x_footer_html_payment_form' => str_replace('"', '\'', $this->config->item('module_payment_gateway_authorize_net_sim_footer_html_payment_form')),
				'x_logo_url' => $this->config->item('module_payment_gateway_authorize_net_sim_logo_url'),
				'x_receipt_link_method' => 'POST',
				'x_receipt_link_url' => $this->config->item('checkout_url')  . 'checkout/redirect/products/authorize_net_sim',
				//'x_relay_response' => 'true',
				//'x_relay_url' =>  $this->config->item('checkout_url')  . 'checkout/redirect/products/authorize_net_sim',
				
				'x_email_customer' => $this->config->item('module_payment_gateway_authorize_net_sim_send_customer_notification') == 1 ? 'TRUE': 'FALSE',
				'x_email_merchant' => $this->config->item('module_payment_gateway_authorize_net_sim_send_merchant_notification') == 1 ? 'TRUE': 'FALSE',
				'x_cust_id' => $this->session->userdata('userid'),
				'x_invoice_num' => $data['jrox_invoice_id'],
				'x_first_name' => $data['fname'],
				'x_last_name' => $data['lname'],
				'x_company' => $data['company'],
				'x_address' => $data['billing_address_1'],
				'x_city' => $data['billing_city'],
				'x_state' => _get_region_name($data['billing_state'], 'region_code', 'region_name'),
				'x_zip' => $data['billing_postal_code'],
				'x_country' => _get_country_name($data['billing_country'], 'country_name', 'country_id'),
				'x_phone' => $data['home_phone'],
				'x_email' => $data['primary_email'],
				'x_ship_to_first_name' => $data['shipping_fname'],
				'x_ship_to_last_name' => $data['shipping_lname'],
				'x_ship_to_address' => $data['shipping_address_1'],
				'x_ship_to_city' => $data['shipping_city'],
				'x_ship_to_state' => _get_region_name($data['shipping_state'], 'region_code', 'region_name'),
				'x_ship_to_zip' => $data['shipping_postal_code'],
				'x_ship_to_country' => _get_country_name($data['shipping_country'], 'country_name', 'country_id'),
				
				// Merchant defined variables go here
				'Date' =>  date('M d, Y h:i:s A'),
				'IP' => $this->input->ip_address(),
				'custom'	=>		$this->session->userdata('session_id') . '-' . $data['member_id'],
				"x_customer_ip"			=> $this->input->ip_address(),

					);
		
		return $sdata;
	}

	// ------------------------------------------------------------------------	

	function _generate_form_transfer($data = '')
	{	
		$sdata['form_code'] = '<p><img src="images/misc/gateways/authorize_net.gif" alt="authorize.net"/></p>
		                      <p><img src="themes/main/' . $this->config->item('layout_design_site_theme') .'/images/gateway-loader.gif" alt="" onload="document.frm.submit();"/></p>
							  <form action="' . $this->config->item('module_payment_gateway_authorize_net_sim_url') . '" method="post" name="frm">';
		
		//format the fields
		$form_data = $this->_format_fields($data, $data['jrox_product_type']);
		
		//add each field to the form		
		foreach ($form_data as $k => $v)
		{
			$sdata['form_code'] .= form_hidden($k, $v) . "\n";
		}
		
		$sdata['form_code'] .= form_submit('Submit', $this->lang->line('click_here_forwarding'));						  
								  
		$sdata['form_code'] .= '</form>';
		
		return $sdata;
	}
	
	// ------------------------------------------------------------------------	
	
	function _generate_gateway_form_authorize_net_sim($data = '')
	{
		
		$data['gateway_form_image'] = '<img src="images/misc/gateways/authorize_net.gif" border="0" alt="" style="margin-bottom:1em"/>';
			
		return $data;
	
		return $data;
	}
	
}
?>