<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - payment_gateway_firstdata_connect_model.php
| -------------------------------------------------------------------------     
| 
| This model handles the functions for firstdata_connect IPN payments
|
*/

class Module_Payment_Gateway_Firstdata_Connect_Model extends Model {	
 	 
	function _install_jrox_module($id = '')
	{		
			
		//check admin session
		$this->security_model->_check_admin_session();
			
		$config = array(
							'settings_key'	=>	'module_payment_gateway_firstdata_connect_storename',
							'settings_value'	=>	'',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'1',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_firstdata_connect_url',
							'settings_value'	=>	'https://www.linkpointcentral.com/lpc/servlet/lppay',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'2',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_firstdata_connect_txntype',
							'settings_value'	=>	'sale',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'3',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_firstdata_connect_mode',
							'settings_value'	=>	'fullpay',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'4',
							'settings_function'	=>	'none',
							);
		
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_firstdata_connect_enable_debug',
							'settings_value'	=>	'0',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'5',
							'settings_function'	=>	'boolean',
							);
		
		
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_firstdata_connect_enable_debug_email',
							'settings_value'	=>	'0',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'6',
							'settings_function'	=>	'boolean',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		return true;
	}
	
	// ------------------------------------------------------------------------	
	
	function _check_gateway_options_firstdata_connect($data = '')
	{
		
		$array['valid'] = '2'; //1 is to run an internal function; 2 is to forward to gateway
		$array['function'] = ''; //the function to run if needed for internal processing
		$array['module_name'] = 'firstdata_connect';
		
		return $array; 
	}
	
	// ------------------------------------------------------------------------	
	
	function _validate_payment()
	{
		if ($this->input->post('status') == 'APPROVED' || $this->input->post('status') == 'SUBMITTED')
		{
			return true;
		}
		elseif ($this->input->post('status') == 'FRAUD')
		{
			show_error('invalid transaction');
		}
		else
		{
			redirect_301($this->config->item('checkout_url') . $this->config->slash_item('checkout_index_page') . 'payment', true, false);
			exit();
		}
	}
	
	// ------------------------------------------------------------------------	
	
	function _format_payment_data($post_data = array(), $order_data = array())
	{
		//set the debug info
		$debug = '';
		foreach ($post_data as $k => $v) { $debug .= $k . ': ' . $v . "\n"; }
		
		//get the payment method name
		$module_data = $this->modules->_get_module_column('module_file_name', 'firstdata_connect');
		
		$trans_id = $post_data['OID'];
		
		//parse the approval code
		if (!empty($post_data['OID']))
		{
			$avs_code = '';
		}
		else
		{
			$approval_code = explode(':', $post_data['approval_code']);
			$avs_code = $approval_code[2];
		}
		
		$data = array('jrox_error' 						=> 			false,
					  'jrox_error_message' 				=> 			'',
					  'jrox_payment_notes'				=>			'',
					  'jrox_payment_amount'				=>			$this->input->post('chargetotal', true),
					  'jrox_debug_info'					=>			$debug,
					  'jrox_payment_method'				=>			$module_data['module_name'],
					  'jrox_trans_id'					=>			$trans_id,
					  'jrox_avs_code'					=>			$avs_code,
					  'jrox_membership_payment_type'	=> 			'firstdata_connect',
					 );
	
		return $data;
	}
	
	// ------------------------------------------------------------------------	
	
	function _process($type = '', $data = array()) //$type is product or membership ; $data is the $_POST array
	{
		$this->_validate_payment();
		
		switch ($type)
		{
			case 'products':
			
				$results['jrox_product_type'] = 'products';
			
				$results['jrox_payment_type'] = 'credit';
						
				$results['jrox_order_data'] = $this->security_model->_get_session_id($data['order_id'] . '-' . $data['userid']);		
				
				if (!empty($results['jrox_order_data']))
				{
					$results['jrox_member_id'] = $results['jrox_order_data']['member_id'];
					
					$results['session_data'] = unserialize($results['jrox_order_data']['order_data']['session_data']);
					
					$results['jrox_payment_data'] = $this->_format_payment_data($data, $results['session_data']);
					
					$data['jrox_payment_data'] = $results['jrox_payment_data'];
				}
				else
				{
					$results['check_credit'] = true;
					
					$results['jrox_member_id'] = $data['userid'];
					$order_data['invoice_notes'] = '';
					$results['jrox_payment_data'] = $this->_format_payment_data($data, $order_data);
				}
				
			break;
			
			case 'membership':
				
				$results['jrox_product_type'] = 'membership';
				$results['jrox_member_id'] = $this->input->post('userid');
				$results['jrox_product_id'] = $this->input->post('item_number');
				$results['invoice_id'] = $this->input->post('invoice_number');
				
				if (!empty($results['jrox_member_id']))
				{
					$results['jrox_payment_type'] = 'credit';
					$results['jrox_subscription_id'] = $this->input->post('txn_id');
					$order_data['invoice_notes'] = '';
					$results['jrox_payment_data'] = $this->_format_payment_data($data, $order_data);
				}
				else
				{
					$results['jrox_error'] = true;
				}
				
				
			break;
		}
		
		//check for debug info
		if ($this->config->item('module_payment_gateway_firstdata_connect_enable_debug_email') == 1)
		{	
			$debug['post_data'] = $_POST;
			$debug['jrox_payment_data'] = $results['jrox_payment_data'];
			$this->security_model->_send_debug_email('FirstData_Connect Debug Email', $debug); 
		}
		
		return $results;
	}
	
	
	// ------------------------------------------------------------------------	
	
	function _format_fields($data = '', $type = '') 
	{
		$sdata = array(
								
				'storename'				=>		$this->config->item('module_payment_gateway_firstdata_connect_storename'),
				'txntype'				=>		$this->config->item('module_payment_gateway_firstdata_connect_txntype'),
				'mode'					=>		$this->config->item('module_payment_gateway_firstdata_connect_mode'),
				'responseSuccessURL'	=>		$this->config->item('checkout_url_link') . $this->config->slash_item('checkout_index_page') . 'checkout/redirect/' . $type . '/firstdata_connect',
				'responseFailURL'		=>		$this->config->item('checkout_url_link') . $this->config->slash_item('checkout_index_page') . 'checkout/payment',
				'chargetotal'			=>		$data['jrox_amount'],
				'company'				=>		$data['company'],
				'bname'					=>		$data['fname'] . ' ' . $data['lname'],
				'baddr1'				=>		$data['billing_address_1'],
				'baddr2'				=>		$data['billing_address_2'],	
				'bcity'					=>		$data['billing_city'],
				'bstate'				=>		_get_region_name($data['billing_state'], 'region_code', 'region_name'),
				'bzip'					=>		$data['billing_postal_code'],
				'bcountry'				=>		_get_country_name($data['billing_country'], 'country_iso_code_2', 'country_id'),
				
				'sname'					=>		$data['fname'] . ' ' . $data['lname'],
				'saddr1'				=>		$data['shipping_address_1'],
				'saddr2'				=>		$data['shipping_address_2'],	
				'scity'					=>		$data['shipping_city'],
				'sstate'				=>		_get_region_name($data['shipping_state'], 'region_code', 'region_name'),
				'szip'					=>		$data['shipping_postal_code'],
				'scountry'				=>		_get_country_name($data['shipping_country'], 'country_iso_code_2', 'country_id'),
				
				
				'invoice_number'		=>		$data['payment_invoice_id'],	
				'email'					=>		$data['primary_email'],
				'userid'				=>		$data['member_id'],
				'order_id'				=>		$this->session->userdata('session_id'),
				'jrox_product_type'		=>		$data['jrox_product_type'],

					);
		
		if ($type == 'membership')
		{
			if (!empty($data['jrox_enable_product_trial']))
			{
				$sdata['chargetotal'] = $data['jrox_trial_amount'];
			}
			
			$sdata['item_number'] =	$data['pid'];
			$sdata['submode'] = 'periodic';
			$sdata['startdate'] = date('Ymd', mktime(12, 0, 0, date('m'),   date('d') + 1,   date('Y')));//date('Ymd');
			$sdata['installments'] = $data['jrox_recurring_interval_ends'];
			$sdata['threshold'] = '3';
			
			switch( $data['jrox_recurring_interval_type'])
			{
				case 'day':
				
					$sdata['periodicity'] = 'd' . $data['jrox_recurring_interval'];
					
				break;
				
				case 'week':
				
					$sdata['periodicity'] = 'w' . $data['jrox_recurring_interval'];
				
				break;
				
				case 'month':
				
					$sdata['periodicity'] = 'm' . $data['jrox_recurring_interval'];
					
				break;
				
				case 'year':
				
					$sdata['periodicity'] = 'y' . $data['jrox_recurring_interval'];
					
				break;

			}
			
		}
		
		if ($this->config->item('module_payment_gateway_firstdata_connect_enable_debug') == 1)
		{
			$sdata['debug'] = true;
		}
					
		return $sdata;
	}
	
	// ------------------------------------------------------------------------	
	
	function _generate_form_transfer($data = '')
	{	
		$sdata['form_code'] = '<p><img src="images/misc/gateways/firstdata.gif" alt="firstdata_connect"/></p>
		                      <p><img src="themes/main/' . $this->config->item('layout_design_site_theme') .'/images/gateway-loader.gif" alt="" onload="document.frm.submit();"/></p>
							  <form action="' . $this->config->item('module_payment_gateway_firstdata_connect_url') . '" method="post" name="frm">';
		
		//format the fields
		$form_data = $this->_format_fields($data, $data['jrox_product_type']);
		
		//add each field to the form		
		foreach ($form_data as $k => $v)
		{
			$sdata['form_code'] .= form_hidden($k, $v) . "\n";
		}
		
		$sdata['form_code'] .= form_submit('Submit', $this->lang->line('click_here_forwarding'));						  
								  
		$sdata['form_code'] .= '</form>';
		
		return $sdata;
	}
	
	// ------------------------------------------------------------------------	
	
	function _generate_gateway_form_firstdata_connect($data = '')
	{
		$data['gateway_form_image'] = '<a href="http://www.firstdata.com/" target="_blank"><img src="images/misc/gateways/firstdata.gif" border="0" alt=""/></a>';
			
		return $data;
	}
	
	
	
}
?>