<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - payment_gateway_offline_payment_model.php
| -------------------------------------------------------------------------     
| 
| This model handles the functions for offline payments
|
*/

class Module_Payment_Gateway_Offline_Payment_Model extends Model {	
	
	function _install_jrox_module($id = '')
	{		
		//check admin session
		$this->security_model->_check_admin_session();
			
		$config = array(
							'settings_key'	=>	'module_payment_gateway_offline_payment_message',
							'settings_value'	=>	'thank you for your order',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'textarea',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'1',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_offline_payment_download_link',
							'settings_value'	=>	'',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'2',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		return true;
	}
	
	// ------------------------------------------------------------------------	
	
	function _check_gateway_options_offline_payment($data = '')
	{
		
		$array['valid'] = '3'; //1 is to run an internal function; 2 is to forward to gateway; 3 is offline payment
		$array['function'] = '';
		$array['module_name'] = 'offline_payment';
		
		return $array; 
	}
	
	// ------------------------------------------------------------------------	
	
	function _generate_gateway_form_offline_payment($data = '')
	{
		
		$data['gateway_form_image'] = '<img src="images/misc/gateways/offline_payment.gif" alt=""/>';
			
		return $data;
	}
	
}
?>