<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - payment_gateway_paypal_standard_model.php
| -------------------------------------------------------------------------     
| 
| This model handles the functions for paypal IPN payments
|
*/

class Module_Payment_Gateway_Paypal_Standard_Model extends Model {	
 	 
	function _install_jrox_module($id = '')
	{		
			
		//check admin session
		$this->security_model->_check_admin_session();
			
		$config = array(
							'settings_key'	=>	'module_payment_gateway_paypal_standard_email',
							'settings_value'	=>	'',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'1',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_paypal_standard_url',
							'settings_value'	=>	'https://www.paypal.com/cgi-bin/webscr',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'2',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_paypal_standard_currency_code',
							'settings_value'	=>	'USD',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'3',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_paypal_standard_disable_verification',
							'settings_value'	=>	'0',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'4',
							'settings_function'	=>	'boolean',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_paypal_standard_header_image',
							'settings_value'	=>	'',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'5',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_payment_gateway_paypal_standard_enable_debug_email',
							'settings_value'	=>	'0',
							'settings_module'	=>	'payment_gateway',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'5',
							'settings_function'	=>	'boolean',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		return true;
	}
	
	// ------------------------------------------------------------------------	
	
	function _check_gateway_options_paypal_standard($data = '')
	{
		
		$array['valid'] = '2'; //1 is to run an internal function; 2 is to forward to gateway
		$array['function'] = ''; //the function to run if needed for internal processing
		$array['module_name'] = 'paypal_standard';
		
		return $array; 
	}
	
	// ------------------------------------------------------------------------	
	
	function _validate_ipn()
	{
		if ($this->config->item('module_payment_gateway_paypal_standard_disable_verification') == 1)
		{
			$url_parsed=parse_url($this->config->item('module_payment_gateway_paypal_standard_url'));     
			
			$req = 'cmd=_notify-validate';
	
			foreach ($_POST as $key => $value) 
			{
				$value = urlencode(stripslashes($value));
				$req .= "&$key=$value";
			}
		
			$header = "POST " . $url_parsed['path'] . " webscr HTTP/1.0\r\n";
			$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
			$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
			$fp = fsockopen ($url_parsed['host'], 80, $errno, $errstr, 30);
			
			if (!$fp) 
			{
				exit();
			} 
			else 
			{
				fputs ($fp, $header . $req);
				while (!feof($fp)) 
				{
					$res = fgets ($fp, 1024);
					if (strcmp ($res, "VERIFIED") == 0) 
					{
						return true;
					}
					else if (strcmp ($res, "INVALID") == 0) 
					{
						exit();
					}
				}
				
				fclose ($fp);
			}
		}
		
		return true;
	}
	
	// ------------------------------------------------------------------------	
	
	function _format_payment_data($post_data = array(), $order_data = array())
	{
		//set the debug info
		$debug = '';
		foreach ($post_data as $k => $v) { $debug .= $k . ': ' . $v . "\n"; }
		
		//get the payment method name
		$module_data = $this->modules->_get_module_column('module_file_name', 'paypal_standard');
		
		$data = array('jrox_error' 						=> 			false,
					  'jrox_error_message' 				=> 			'',
					  'jrox_payment_notes'				=>			$order_data['invoice_notes'],
					  'jrox_payment_amount'				=>			$this->input->post('mc_gross', true),
					  'jrox_debug_info'					=>			$debug,
					  'jrox_payment_method'				=>			$module_data['module_name'],
					  'jrox_trans_id'					=>			$this->input->post('txn_id', true),
					  'jrox_avs_code'					=>			'',
					  'jrox_membership_payment_type'	=> 			'paypal_standard',
					 );
	
		return $data;
	}
	
	// ------------------------------------------------------------------------	
	
	function _ipn($type = '', $data = array())
	{
		$results = array('ipn_error' => false);
		
		//run ipn verification first
		$this->_validate_ipn();
		
		switch ($type)
		{
			case 'products':
			
				$results['jrox_product_type'] = 'products';
			
				switch ($this->input->post('payment_status'))
				{
					case 'Completed':
					
						$results['jrox_payment_type'] = 'credit';
						
						$results['jrox_order_data'] = $this->security_model->_get_session_id($this->input->post('custom'));		
						
						if (!empty($results['jrox_order_data']))
						{
							$results['jrox_member_id'] = $results['jrox_order_data']['member_id'];
							
							$results['session_data'] = unserialize($results['jrox_order_data']['order_data']['session_data']);
							
							$results['jrox_payment_data'] = $this->_format_payment_data($data, $results['session_data']);
							
							$data['jrox_payment_data'] = $results['jrox_payment_data'];
						}
						else
						{
							$results['check_credit'] = true;
							
							$user = explode('-', $this->input->post('custom'));
							
							$results['jrox_member_id'] = $user[1];
							$order_data['invoice_notes'] = '';
							$results['jrox_payment_data'] = $this->_format_payment_data($data, $order_data);
						}
					
					break;
					
					case 'Refunded':
					
						//process refund
						$results['jrox_orig_trans_id'] = $this->input->post('parent_txn_id');
						$results['jrox_trans_id'] = $this->input->post('txn_id');
						$results['jrox_payment_type'] = 'refund';
						
						$order_data['invoice_notes'] = '';
						$results['jrox_payment_data'] = $this->_format_payment_data($data, $order_data);
							
						$results['data'] = $_POST;
						
					break;
					
				}
				
			break;
			
			case 'membership':
				
				$results['jrox_product_type'] = 'membership';
				$results['jrox_member_id'] = $this->input->post('custom');
				$results['jrox_product_id'] = $this->input->post('item_number');
				
				//payment
				switch ($this->input->post('payment_status'))
				{
					case 'Completed':		
						
						if (!empty($results['jrox_member_id']))
						{
							$results['jrox_payment_type'] = 'credit';
							$results['jrox_subscription_id'] = $this->input->post('txn_id');
							$order_data['invoice_notes'] = '';
							$results['jrox_payment_data'] = $this->_format_payment_data($data, $order_data);
						}
						else
						{
							$results['ipn_error'] = true;
						}
					
					break;
					
					case 'Refunded':
					
						//process refund
						$results['jrox_orig_trans_id'] = $this->input->post('parent_txn_id');
						$results['jrox_trans_id'] = $this->input->post('txn_id');
						$results['jrox_payment_type'] = 'refund';
						
						$order_data['invoice_notes'] = '';
						$results['jrox_payment_data'] = $this->_format_payment_data($data, $order_data);
						$results['data'] = $_POST;
						
					break;
				}
				
				
			break;
		}
		
		//check for debug info
		if ($this->config->item('module_payment_gateway_paypal_standard_enable_debug_email') == 1)
		{	
			$debug['post_data'] = $_POST;
			$debug['jrox_payment_data'] = $results['jrox_payment_data'];
			$this->security_model->_send_debug_email('Paypal Standard (IPN) Debug Email', $debug); 
		}
		
		return $results;
	}
	
	// ------------------------------------------------------------------------	
	
	function _format_fields($data = '', $type = '') 
	{
		if ($type != 'membership')
		{
			$sdata = array(
								
				'business'			=>		$this->config->item('module_payment_gateway_paypal_standard_email'),
				'return'			=>		$this->config->item('checkout_url') . $this->config->slash_item('checkout_index_page') . 'thankyou/index/' . $data['payment_invoice_id'],
				'cancel_return'		=>		base_url(),
				'shopping_url'		=>		base_url() . 'cart',
				'notify_url'		=>		base_url() . $this->config->slash_item('checkout_index_page') . 'checkout/ipn/products/paypal_standard',
				
				'lc'				=>		'US',
				'page_style'		=>		'Primary',
				'redirect_cmd'		=>		'_xclick',
				'cmd'				=>		'_ext-enter',
				'rm'				=>		'2',
				'bn'				=>		'JEM',
				'pal'				=>		'8RVF5K2SPSRDG',
				'no_shipping'		=>		'1',
				'upload'			=>		'1',
				
				'first_name'		=>		$data['fname'],
				'last_name'			=>		$data['lname'],
				'address1'			=>		$data['billing_address_1'],
				'city'				=>		$data['billing_city'],
				'state'				=>		_get_region_name($data['billing_state'], 'region_code', 'region_name'),
				'zip'				=>		$data['billing_postal_code'],
				'country'			=>		_get_country_name($data['billing_country'], 'country_iso_code_2', 'country_id'),
				'email'				=>		$data['primary_email'],
				'currency_code'		=>		$this->config->item('module_payment_gateway_paypal_standard_currency_code'),
				'item_name'			=>		$this->config->item('sts_store_name') . ' ' . $this->lang->line('checkout_invoice'),
				'invoice'			=>		$data['payment_invoice_id'],
				'item_number'		=>		$this->lang->line('store_receipt'),
				'amount'			=>		$data['jrox_amount'],
				'custom'			=>		$this->session->userdata('session_id') . '-' . $data['member_id']							
						  );
						  
		}
		else //set for memberships
		{
			$sdata = array(
								
				'business'			=>		$this->config->item('module_payment_gateway_paypal_standard_email'),
				'return'			=>		$this->config->item('checkout_url') . $this->config->slash_item('checkout_index_page') . 'thankyou/membership/' . $data['pid'] . '/' . $data['payment_invoice_id'],
				'cancel_return'		=>		base_url(),
				'notify_url'		=>		base_url() . $this->config->slash_item('checkout_index_page') . 'checkout/ipn/membership/paypal_standard/' . $data['pid'],
				
				'lc'				=>		'US',
				'page_style'		=>		'Primary',
				'cmd'				=>		'_xclick-subscriptions',
				'rm'				=>		'2',
				'bn'				=>		'JEM',
				'pal'				=>		'8RVF5K2SPSRDG',
				'no_shipping'		=>		'1',
				
				'first_name'		=>		$data['fname'],
				'last_name'			=>		$data['lname'],
				'address1'			=>		$data['billing_address_1'],
				'city'				=>		$data['billing_city'],
				'state'				=>		_get_region_name($data['billing_state'], 'region_code', 'region_name'),
				'zip'				=>		$data['billing_postal_code'],
				'country'			=>		_get_country_name($data['billing_country'], 'country_iso_code_2', 'country_id'),
				'email'				=>		$data['primary_email'],
				'currency_code'		=>		$this->config->item('module_payment_gateway_paypal_standard_currency_code'),
				'item_name'			=>		$data['product_name'],
				'item_number'		=>		$data['pid'],
				
				'invoice'			=>		$data['payment_invoice_id'],
				'custom'			=>		$data['member_id']					
			
					  );
			
			
			//pricing variables
			//trial periods
			
			if ($data['jrox_enable_product_trial'] == 1)
			{
				
				$sdata['a1'] = $data['jrox_trial_amount'];
				$sdata['p1'] = $data['jrox_product_trial_interval'];
				
				switch ($data['jrox_product_trial_interval_type'])
				{
					case 'day':
					
						$sdata['t1'] = 'D';
						
					break;
					
					case 'week':
					
						$sdata['t1'] = 'W';
					
					break;
					
					case 'month':
					
						$sdata['t1'] = 'M';
						
					break;
					
					case 'year':
					
						$sdata['t1'] = 'Y';
						
					break;
				}
			}
			
			//regular amount
			$sdata['a3']	= $data['jrox_amount'];
			$sdata['p3']	= $data['jrox_recurring_interval'];
			
			switch( $data['jrox_recurring_interval_type'])
			{
				case 'day':
				
					$sdata['t3'] = 'D';
					
				break;
				
				case 'week':
				
					$sdata['t3'] = 'W';
				
				break;
				
				case 'month':
				
					$sdata['t3'] = 'M';
					
				break;
				
				case 'year':
				
					$sdata['t3'] = 'Y';
					
				break;

			}

			$sdata['src'] = '1';
			//number of intervals
			if ($data['recurring_onetime'] == '1') //1 is enabled 0 is disabled
			{
				$sdata['src'] = '0'; //enable one time recurring
			}
			
			//$sdata['srt'] = '0';
			if (!empty($data['jrox_recurring_interval_ends']))
			{
				$sdata['srt'] = $data['jrox_recurring_interval_ends'];
			}
			
			//reattempt on failure
			$sdata['sra'] = '1'	;
			$sdata['no_note'] = '1';
			
		}
		
		return $sdata;
	}
	
	// ------------------------------------------------------------------------	
	
	function _generate_form_transfer($data = '')
	{	
		$sdata['form_code'] = '<p><img src="images/misc/gateways/paypal_standard_180x113.jpg" alt="paypal"/></p>
		                      <p><img src="themes/main/' . $this->config->item('layout_design_site_theme') .'/images/gateway-loader.gif" alt="" onload="document.frm.submit();"/></p>
							  <form action="' . $this->config->item('module_payment_gateway_paypal_standard_url') . '" method="post" name="frm">';
		
		//format the fields
		$form_data = $this->_format_fields($data, $data['jrox_product_type']);
		
		//add each field to the form		
		foreach ($form_data as $k => $v)
		{
			$sdata['form_code'] .= form_hidden($k, $v) . "\n";
		}
		
		if ($this->config->item('module_payment_gateway_paypal_standard_header_image'))
		{
			$sdata['form_code'] .= form_hidden('cpp_header_image', $this->config->item('module_payment_gateway_paypal_standard_header_image'));
		}
		
		$sdata['form_code'] .= form_submit('Submit', $this->lang->line('click_here_forwarding'));						  
								  
		$sdata['form_code'] .= '</form>';
		
		return $sdata;
	}
	
	// ------------------------------------------------------------------------	
	
	function _generate_gateway_form_paypal_standard($data = '')
	{
		$data['gateway_form_image'] = '<a href="https://www.paypal.com/us/mrb/pal=8RVF5K2SPSRDG" target="_blank"><img src="images/misc/gateways/paypal_standard_150x60.gif" border="0" alt="" style="margin-bottom:1em"/></a>';
			
		return $data;
	}
	
	
	
}
?>