<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - module_shipping_fedex_model.php
| -------------------------------------------------------------------------     
| 
| This model handles the functions for fedex shipping
|
*/

/*
module_shipping_fedex_server_url
module_shipping_fedex_account_number
module_shipping_fedex_meter_number
module_shipping_fedex_carrier_code
module_shipping_fedex_dropoff_type
module_shipping_fedex_packaging
module_shipping_fedex_handling_fee
module_shipping_fedex_enable_tax_zone
module_shipping_fedex_tax_zone
module_shipping_fedex_shipping_types
*/

class Module_Shipping_fedex_Model extends Model {
	
	function _install_jrox_module($id = '')
	{	
		//check admin session
		$this->security_model->_check_admin_session();
		
		$config = array(
							'settings_key'	=>	'module_shipping_fedex_server_url',
							'settings_value'	=>	'https://gateway.fedex.com/GatewayDC',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'1',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);

		$config = array(
							'settings_key'	=>	'module_shipping_fedex_account_number',
							'settings_value'	=>	'',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'2',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_shipping_fedex_meter_number',
							'settings_value'	=>	'',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'3',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_shipping_fedex_carrier_code',
							'settings_value'	=>	'FDXE',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'4',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);

		$config = array(
							'settings_key'	=>	'module_shipping_fedex_dropoff_type',
							'settings_value'	=>	'REGULARPICKUP',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'5',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_shipping_fedex_packaging',
							'settings_value'	=>	'YOURPACKAGING',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'6',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		//charge a handling fee for this shipping module
		$config = array(
							'settings_key'	=>	'module_shipping_fedex_handling_fee',
							'settings_value'	=>	'0.00',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'7',
							'settings_function'	=>	'none',
							);
							
		//insert into settings table
		$this->db->insert('settings', $config);
		
		//enable or disable use of tax zones for this shipping module
		$config = array(
							'settings_key'	=>	'module_shipping_fedex_enable_tax_zone',
							'settings_value'	=>	'0',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'8',
							'settings_function'	=>	'enable',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		//which tax zone to use for charging shipping taxes
		$config = array(
							'settings_key'	=>	'module_shipping_fedex_tax_zone',
							'settings_value'	=>	'1',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'9',
							'settings_function'	=>	'tax_zone',
							);
							
		//insert into settings table
		$this->db->insert('settings', $config);

		//fedex shipping types
		$config = array(
							'settings_key'	=>	'module_shipping_fedex_shipping_types',
							'settings_value'	=>	'PRIORITYOVERNIGHT,STANDARDOVERNIGHT,INTERNATIONALECONOMY',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'10',
							'settings_function'	=>	'none',
					);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		//fedex shipping types
		$config = array(
							'settings_key'	=>	'module_shipping_fedex_enable_debug',
							'settings_value'	=>	'0',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'11',
							'settings_function'	=>	'boolean',
					);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		return true;

	}

	// ------------------------------------------------------------------------	
	
	function _update_shipping()
	{
		//clean the data first
		
		$data = $this->db_validation_model->_clean_data($_POST);
		
		//change shipping types to CSV
		$types = implode(',',$data['module_shipping_fedex_shipping_types']);
		$data['module_shipping_fedex_shipping_types'] = $types;
		
		
		if ($this->db_validation_model->_update_db_settings($data))
		{
			//log success
			log_message('info', 'settings table updated successfully');
		}
		else
		{
			show_error($this->lang->line('could_not_update_settings'));
			
			//log error
			log_message('error', 'Could not update settings table');
			
			return false;		
		}
		
		return true;
	}	
	
	// ------------------------------------------------------------------------	
	
	function _generate_fedex_form_field($v= '', $value = '')
	{
	
		switch ($v['settings_key'])
		{
		
			case 'module_shipping_fedex_carrier_code':
			
				//$options = array('FDXE' => 'Fedex Express', 'FDXG' => 'Fedex Ground');
				$options = array('FDXE' => 'Fedex Express');
				return form_dropdown($v['settings_key'], $options, $value);
				
			break;
			
			case 'module_shipping_fedex_dropoff_type':
				
				$options = array('REGULARPICKUP' => 'Regular Pickup', 
								 'REQUESTCOURIER' => 'Request Courier', 
								 'DROPBOX' => 'Drop Box', 
								 'BUSINESSSERVICE CENTER' => 'Business Service Center', 
								 'STATION' => 'Station'
								 );
				return form_dropdown($v['settings_key'], $options, $value);
				
			break;
			
			case 'module_shipping_fedex_packaging':
				
				$options = array('FEDEXENVELOPE' => 'Fedex Envelope', 
								 'FEDEXPAK' => 'FedexPak',
								 'FEDEXBOX' => 'Fedex Box',
								 'FEDEXTUBE' => 'Fedex Tube',
								 'FEDEX10KGBOX' => 'Fedex 10KG Box',
								 'FEDEX25KGBOX' => 'Fedex 25KG Box',
								 'YOURPACKAGING' => 'Your Packaging',
								 );
				return form_dropdown($v['settings_key'], $options, $value);
			
			break;

			case 'module_shipping_fedex_shipping_types':

				$types = array(
								'PRIORITYOVERNIGHT' => 'FedEx Priority Overnight',
								 'STANDARDOVERNIGHT' => 'FedEx Standard Overnight',
								 'FIRSTOVERNIGHT' => 'FedEx First Overnight',
								 'FEDEX2DAY' => 'FedEx 2 Day',
								 'FEDEXEXPRESSSAVER' => 'FedEx Express Saver',
								 'INTERNATIONALPRIORITY' => 'FedEx International Priority',
								 'INTERNATIONALECONOMY' => 'FedEx International Economy',
								 'INTERNATIONALFIRST' => 'FedEx International First',
								 'FEDEX1DAYFREIGHT' => 'FedEx Overnight Freight',
								 'FEDEX2DAYFREIGHT' => 'FedEx 2 day Freight',
								 'FEDEX3DAYFREIGHT' => 'FedEx 3 day Freight',
								 //'FEDEXGROUND' => 'FedEx Ground',
								 //'GROUNDHOMEDELIVERY' => 'FedEx Home Delivery',								
								);
				$selected = explode(',', $v['settings_value']);
				
				$result = form_dropdown($v['settings_key'].'[]', $types, $selected, 'multiple="multiple" id="module_shipping_fedex_shipping_types" class="list-menu2 text-upper"');
				
				return $result;
			
			break;
			
			default:
				
				return _generate_settings_field($v, $value);
				
			break;
		
		}
		
	}
	
	// ------------------------------------------------------------------------	
	
	function _generate_shipping_amount_fedex($array = '', $type = '', $num_options = '')
	{

		$ship_array = array();
		
		$types = explode(',', $this->config->item('module_shipping_fedex_shipping_types'));
		//sts_store_shipping_zip
		//sts_shipping_use_vendor_zip
		
		//format the zip code
		$array['postal_code'] = _format_zip($array['postal_code']);
		
		if (count($types) > 0 )
		{
			$origin_zip = $this->config->item('sts_store_shipping_zip');
			$origin_state = $this->config->item('sts_store_shipping_state');
			$origin_country = _get_country_name($this->config->item('sts_store_shipping_country'), 'country_iso_code_2');
			
			
			$data['amount'] = '';
			
			//check if international
			if ($array['country_data']['country_iso_code_2'] == 'US') 
			{
				if ($code == 'INTERNATIONALPRIORITY' || $code == 'INTERNATIONALECONOMY' || $code == 'INTERNATIONALFIRST')
				{
					continue;
				}
			}
			
			//set the amounts for each shipping option
			$type_options = array();
			foreach ($types as $a)
			{
				$type_options[$a] = '0';
			}
			
			//check if we are using vendor specific shipping
			if ($this->config->item('sts_shipping_use_vendor_zip') == 1)
			{
				//loop through each product
				foreach ($this->cart_items as $v)
				{
					if (!empty($v['vendor_zip']))
					{
						$origin_zip = $v['vendor_zip'];
						$origin_state = $v['vendor_state'];
						$origin_country = _get_country_name($v['vendor_country'], 'country_iso_code_2');
						$weight = ($v['product_weight'] * $v['quantity']);
					}
					else
					{
						
						$weight = $array['weight'];
					}
					
					$sdata = array(
							   'service' => $code,
							   'weight' => $weight,
							   'origin_state' => $origin_state,
							   'origin_zip' => $origin_zip,
							   'origin_country' => $origin_country,
							   'dest_state' => $array['state'],
							   'dest_zip' => $array['postal_code'],
							   'dest_country' => $array['country_data']['country_iso_code_2'],
							   );
				
					$rates = $this->getQuote($sdata);
	
					if (!empty($rates))
					{
						foreach ($rates as $srv => $rate)
						{
							if (in_array($srv, $types))
							{					
								if ($rate > '0')
								{
									$type_amount = $type_options[$srv];
									$new_amount = $type_amount + $rate;
									$type_options[$srv] = $new_amount;
								}
							}	
						}
					}
				}

				//now set each amount
				foreach ($type_options as $k => $v)
				{
					$b = array();
					$b['amount'] = $v + $this->config->item('module_shipping_fedex_handling_fee') + $array['per_prod_shipping'];
					$b['error'] = false; 
					$b['taxes'] = '0';
					$b['type'] = $k;
					
					//check if we are using tax zones
					if ($this->config->item('module_shipping_fedex_enable_tax_zone') == 1)
					{
						$zone = $this->db_validation_model->_get_details('tax_zones', '*', 'tax_zone_id', $this->config->item('module_shipping_fedex_tax_zone'));
						
						if (!empty($zone[0]['tax_amount']))
						{
							$taxes = $b['amount'] * $zone[0]['tax_amount'];
							$b['taxes'] = round($taxes, 2);
						}
					}

					$b['name'] = $this->lang->line($type['module_name'] . '_' . $k) . ' - ' . format_amounts($b['amount'], $num_options);
					
					if (count($b) > 0 && !empty($b['amount']))
					{
						array_push($ship_array, $b);
					}
				}
			}
			else
			{
				
				$sdata = array(
							   'service' => $code,
							   'weight' => $array['weight'],
							   'origin_state' => $this->config->item('sts_store_shipping_state'),
							   'origin_zip' => $this->config->item('sts_store_shipping_zip'),
							   'origin_country' => $origin_country,
							   'dest_state' => $array['state'],
							   'dest_zip' => $array['postal_code'],
							   'dest_country' => $array['country_data']['country_iso_code_2'],
							   );
				
				$rates = $this->getQuote($sdata);
				
				if (!empty($rates))
				{
					foreach ($rates as $srv => $rate)
					{
						if (in_array($srv, $types))
						{
							$b = array();
							if ($rate > '0')
							{
								$b['amount'] = $rate + $this->config->item('module_shipping_fedex_handling_fee') + $array['per_prod_shipping'];
								$b['error'] = false; 
								$b['taxes'] = '0';
								$b['type'] = $this->lang->line($type['module_name'] . '_' . $srv);
								
								//check if we are using tax zones
								if ($this->config->item('module_shipping_fedex_enable_tax_zone') == 1)
								{
									$zone = $this->db_validation_model->_get_details('tax_zones', '*', 'tax_zone_id', $this->config->item('module_shipping_fedex_tax_zone'));
									
									if (!empty($zone[0]['tax_amount']))
									{
										$taxes = $b['amount'] * $zone[0]['tax_amount'];
										$b['taxes'] = round($taxes, 2);
									}
								}
	
								//$b['name']  = $type['module_name'] . ' ' . $type . ' - ' . format_amounts($b['amount'], $num_options);
								$b['name'] = $this->lang->line($type['module_name'] . '_' . $srv) . ' - ' . format_amounts($b['amount'], $num_options);
							}
							
							if (count($b) > 0 && !empty($b['amount']))
							{
								array_push($ship_array, $b);
							}
						}
					}
				}
			}	

			return $ship_array;
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------	
	
	function getQuote($data = '')
	{
		
		$str = '<?xml version="1.0" encoding="UTF-8" ?>';
        $str .= '    <FDXRateAvailableServicesRequest xmlns:api="http://www.fedex.com/fsmapi" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="FDXRateAvailableServicesRequest.xsd">';
        $str .= '        <RequestHeader>';
        $str .= '            <CustomerTransactionIdentifier>Express Rate</CustomerTransactionIdentifier>';
        $str .= '            <AccountNumber>' . $this->config->item('module_shipping_fedex_account_number') . '</AccountNumber>';
        $str .= '            <MeterNumber>' . $this->config->item('module_shipping_fedex_meter_number') . '</MeterNumber>';
        $str .= '            <CarrierCode>' . $this->config->item('module_shipping_fedex_carrier_code') . '</CarrierCode>';
        $str .= '        </RequestHeader>';
        $str .= '        <DropoffType>' . $this->config->item('module_shipping_fedex_dropoff_type') . '</DropoffType>';
        //$str .= '        <Service>' . $data['service'] . '</Service>';
        $str .= '        <Packaging>' . $this->config->item('module_shipping_fedex_packaging') . '</Packaging>';
        $str .= '        <WeightUnits>' . strtoupper($this->config->item('sts_store_default_weight')) . '</WeightUnits>';
        $str .= '        <Weight>'.number_format($data['weight'], 1, '.', '').'</Weight>';
        $str .= '        <OriginAddress>';
        $str .= '            <StateOrProvinceCode>'.$data['origin_state'].'</StateOrProvinceCode>';
        $str .= '            <PostalCode>'.$data['origin_zip'].'</PostalCode>';
        $str .= '            <CountryCode>'.$data['origin_country'].'</CountryCode>';
        $str .= '        </OriginAddress>';
        $str .= '        <DestinationAddress>';
        
		if ($data['dest_country'] == 'US' || $data['dest_country'] == 'CA')
		{
			$str .= '            <StateOrProvinceCode>'.$data['dest_state'].'</StateOrProvinceCode>';
		}
		
		$str .= '            <PostalCode>'.$data['dest_zip'].'</PostalCode>';
        $str .= '            <CountryCode>'.$data['dest_country'].'</CountryCode>';
        $str .= '        </DestinationAddress>';
        $str .= '        <Payment>';
        $str .= '            <PayorType>SENDER</PayorType>';
        $str .= '        </Payment>';
        $str .= '        <PackageCount>'.$data['weight'].'</PackageCount>';
		$str .= '		 <Value>50</Value>';
        $str .= '    </FDXRateAvailableServicesRequest>';
		
		$resp = connect_curl($this->config->item('module_shipping_fedex_server_url'), true, $str);
		
		$array = $this->GetXMLTree($resp);
		
		if ($this->config->item('module_shipping_fedex_enable_debug') == 1)
		{
			echo $resp;	
		}
		//$this->printa($array); exit();
		if(!empty($array['FDXRATEREPLY'][0]['ERROR'])) { // If it is error
			$error = new fedexError();
			$error->number = $array['FDXRATEREPLY'][0]['ERROR'][0]['CODE'][0]['VALUE'];
			$error->description = $array['FDXRATEREPLY'][0]['ERROR'][0]['MESSAGE'][0]['VALUE'];
			$error->response = $array;
		
			//show_error($array['FDXRATEREPLY'][0]['ERROR'][0]['MESSAGE'][0]['VALUE']);
		} else {
			
			$a = count ($array['FDXRATEAVAILABLESERVICESREPLY'] [0] ['ENTRY']);
			
			$rates = array();
			for ($i=0; $i<$a; $i++)
			{
				$service = $array['FDXRATEAVAILABLESERVICESREPLY'] [0] ['ENTRY'] [$i] ['SERVICE'] [0] ['VALUE'];
				$rate = $array['FDXRATEAVAILABLESERVICESREPLY'] [0] ['ENTRY'] [$i] ['ESTIMATEDCHARGES'] [0] ['DISCOUNTEDCHARGES'] [0] ['NETCHARGE'] [0] ['VALUE'];
				$rates[$service] = $rate;																																		 
			}
   
		}
		//print_r($this);
		return ((sizeof($rates) > 0) ? $rates : false);
	}
	
	// ------------------------------------------------------------------------	
	
	function GetChildren($vals, &$i) 
    {
        $children = array(); 
    
    
        if (isset($vals[$i]['value'])) 
            $children['VALUE'] = $vals[$i]['value']; 
    
    
        while (++$i < count($vals))
        { 
            switch ($vals[$i]['type']) 
            { 
                case 'cdata': 
                    if (isset($children['VALUE']))
                        $children['VALUE'] .= $vals[$i]['value']; 
                    else
                        $children['VALUE'] = $vals[$i]['value']; 
                    break;
    
                case 'complete': 
                    if (isset($vals[$i]['attributes'])) {
                        $children[$vals[$i]['tag']][]['ATTRIBUTES'] = $vals[$i]['attributes'];
                        $index = count($children[$vals[$i]['tag']])-1;
    
                        if (isset($vals[$i]['value'])) 
                            $children[$vals[$i]['tag']][$index]['VALUE'] = $vals[$i]['value']; 
                        else
                            $children[$vals[$i]['tag']][$index]['VALUE'] = ''; 
                    } else {
                        if (isset($vals[$i]['value'])) 
                            $children[$vals[$i]['tag']][]['VALUE'] = $vals[$i]['value']; 
                        else
                            $children[$vals[$i]['tag']][]['VALUE'] = ''; 
    		}
                    break; 
    
                case 'open': 
                    if (isset($vals[$i]['attributes'])) {
                        $children[$vals[$i]['tag']][]['ATTRIBUTES'] = $vals[$i]['attributes'];
                        $index = count($children[$vals[$i]['tag']])-1;
                        $children[$vals[$i]['tag']][$index] = array_merge($children[$vals[$i]['tag']][$index],$this->GetChildren($vals, $i));
                    } else {
                        $children[$vals[$i]['tag']][] = $this->GetChildren($vals, $i);
                    }
                    break; 
    
                case 'close': 
                    return $children; 
            } 
        } 
    } 
	
	// ------------------------------------------------------------------------	
	
    function GetXMLTree($xml) 
    { 
        $data = $xml;
       
        $parser = xml_parser_create();
        xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1); 
        xml_parse_into_struct($parser, $data, $vals, $index); 
        xml_parser_free($parser);
        
        //print_r($index);
    
        $tree = array(); 
        $i = 0; 
        
        if (isset($vals[$i]['attributes'])) {
    	$tree[$vals[$i]['tag']][]['ATTRIBUTES'] = $vals[$i]['attributes']; 
    	$index = count($tree[$vals[$i]['tag']])-1;
    	$tree[$vals[$i]['tag']][$index] =    array_merge($tree[$vals[$i]['tag']][$index], $this->GetChildren($vals, $i));
        }
        else
            $tree[$vals[$i]['tag']][] = $this->GetChildren($vals, $i); 
        
        return $tree; 
    } 
    
	// ------------------------------------------------------------------------	
	
    function printa($obj) {
        global $__level_deep;
        if (!isset($__level_deep)) $__level_deep = array();
    
        if (is_object($obj))
            print '[obj]';
        elseif (is_array($obj)) {
            foreach(array_keys($obj) as $keys) {
                array_push($__level_deep, "[".$keys."]");
                $this->printa($obj[$keys]);
                array_pop($__level_deep);
            }
        }
        else print implode(" ",$__level_deep)." = $obj\n";
    }
}

class fedexError
{
    var $number;
    var $description;
    var $response;
}
class fedexPrice
{
    var $service;
    var $rate;
    var $response;
}
?>