<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - shipping_free_shipping_model.php
| -------------------------------------------------------------------------     
| 
| This model handles the functions for percent shipping
|
*/

class Module_Shipping_Free_Shipping_Model extends Model {	
	
	function _install_jrox_module($id = '')
	{	
		//check admin session
		$this->security_model->_check_admin_session();
		
		//insert required config rows in settings table
		$config = array(
							'settings_key'	=>	'module_shipping_free_shipping_quantity_type',
							'settings_value'	=>	'0.10',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'1',
							'settings_function'	=>	'zone_calc',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_shipping_free_shipping_required_amount',
							'settings_value'	=>	'0',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'2',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_shipping_free_shipping_enable_tax_zone',
							'settings_value'	=>	'0',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'3',
							'settings_function'	=>	'enable',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_shipping_free_shipping_handling_fee',
							'settings_value'	=>	'0.00',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'5',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_shipping_free_shipping_tax_zone',
							'settings_value'	=>	'1',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'4',
							'settings_function'	=>	'tax_zone',
							);
		
		//insert into settings table
		if ($this->db->insert('settings', $config))
		{
			return true;
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------	
	
	function _generate_shipping_amount_free_shipping($array = '', $type = '', $num_options = '')
	{
		//check if limit has been reached for free shipping
		
		if ($array['amount'] >= $this->config->item('module_shipping_free_shipping_required_amount'))
		{
			$data['amount'] = $this->config->item('module_shipping_free_shipping_handling_fee');
			$data['taxes'] = '';
			
			$data['name'] = _check_language_translation($type['module_name']) . ' - ' . format_amounts($data['amount'], $num_options);
			$data['type'] = $type['module_name'];
			
			$ship_array[0] = $data;
			return $ship_array;
		}
		
		
		return false;
	}
	
	// ------------------------------------------------------------------------	
}
?>