<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - shipping_per_item_model.php
| -------------------------------------------------------------------------     
| 
| This model handles the functions for per item shipping
|
*/

class Module_Shipping_Per_Item_Model extends Model {	
	
	function _install_jrox_module($id = '')
	{	
		//check admin session
		$this->security_model->_check_admin_session();
		
		//insert required config rows in settings table
		$config = array(
							'settings_key'	=>	'module_shipping_per_item_amount',
							'settings_value'	=>	'1.00',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'1',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_shipping_per_item_enable_tax_zone',
							'settings_value'	=>	'0',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'2',
							'settings_function'	=>	'enable',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_shipping_per_item_handling_fee',
							'settings_value'	=>	'0.00',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'5',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_shipping_per_item_tax_zone',
							'settings_value'	=>	'1',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'3',
							'settings_function'	=>	'tax_zone',
							);
		
		//insert into settings table
		if ($this->db->insert('settings', $config))
		{
			return true;
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------	
	
	function _generate_shipping_amount_per_item($array = '', $type = '', $num_options = '')
	{
		$data['amount'] = ($this->config->item('module_shipping_per_item_amount') * $array['quantity']) + $this->config->item('module_shipping_per_item_handling_fee');
		$data['amount'] = $data['amount'] + $array['per_prod_shipping'];
		$data['amount'] = round($data['amount'], 2);
		$data['taxes'] = '';
		
		//check if we are using tax zones
		if ($this->config->item('module_shipping_per_item_enable_tax_zone') == 1)
		{
			$zone = $this->db_validation_model->_get_details('tax_zones', '*', 'tax_zone_id', $this->config->item('module_shipping_per_item_tax_zone'));
			
			$data['taxes'] = $data['amount'] * $zone[0]['tax_amount'];
			$data['taxes'] = round($data['taxes'], 2);
		}
		
		$data['name'] = _check_language_translation($type['module_name']) . ' - ' . format_amounts($data['amount'], $num_options);
		$data['type'] = $type['module_name'];
		
		$ship_array[0] = $data;
		return $ship_array;
	}
	
	// ------------------------------------------------------------------------	
}
?>