<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - shipping_USPS_model.php
| -------------------------------------------------------------------------     
| 
| This model handles the functions for USPS shipping
|
*/

class Module_Shipping_USPS_Model extends Model {
	
	function _install_jrox_module($id = '')
	{	
		//check admin session
		$this->security_model->_check_admin_session();
		
		//the type of pickup method to use 
		$config = array(
							'settings_key'	=>	'module_shipping_USPS_gateway_url',
							'settings_value'	=>	'http://production.shippingapis.com/ShippingAPI.dll',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'1',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);


		$config = array(
							'settings_key'	=>	'module_shipping_USPS_userid',
							'settings_value'	=>	'',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'2',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		
		$config = array(
							'settings_key'	=>	'module_shipping_USPS_container',
							'settings_value'	=>	'VARIABLE',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'3',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_shipping_USPS_size',
							'settings_value'	=>	'REGULAR',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'4',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		$config = array(
							'settings_key'	=>	'module_shipping_USPS_machinable',
							'settings_value'	=>	'1',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'5',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		
		$config = array(
							'settings_key'	=>	'module_shipping_USPS_max_weight',
							'settings_value'	=>	'70',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'6',
							'settings_function'	=>	'none',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
	
		//charge a handling fee for this shipping module
		$config = array(
							'settings_key'	=>	'module_shipping_USPS_handling_fee',
							'settings_value'	=>	'0.00',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'text',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'7',
							'settings_function'	=>	'none',
							);
							
		//insert into settings table
		$this->db->insert('settings', $config);
		
		//enable or disable use of tax zones for this shipping module
		$config = array(
							'settings_key'	=>	'module_shipping_USPS_enable_tax_zone',
							'settings_value'	=>	'0',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'8',
							'settings_function'	=>	'enable',
							);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		//which tax zone to use for charging shipping taxes
		$config = array(
							'settings_key'	=>	'module_shipping_USPS_tax_zone',
							'settings_value'	=>	'1',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'9',
							'settings_function'	=>	'tax_zone',
							);
							
		//insert into settings table
		$this->db->insert('settings', $config);


		//USPS shipping types
		$config = array(
							'settings_key'	=>	'module_shipping_USPS_domestic_shipping_types',
							'settings_value'	=>	'Priority Mail,First-Class Mail Flat',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'10',
							'settings_function'	=>	'none',
					);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		//USPS shipping types
		$config = array(
							'settings_key'	=>	'module_shipping_USPS_international_shipping_types',
							'settings_value'	=>	'Priority Mail International,Priority Mail International Medium Flat Rate Box',
							'settings_module'	=>	'shipping',
							'settings_type'	=>	'dropdown',
							'settings_group'	=>	$id,
							'settings_sort_order'	=>	'11',
							'settings_function'	=>	'none',
					);
		
		//insert into settings table
		$this->db->insert('settings', $config);
		
		return true;

	}
	
	// ------------------------------------------------------------------------	
	
	function _update_shipping()
	{
		//clean the data first
		
		$data = $this->db_validation_model->_clean_data($_POST);
		
		//change shipping types to CSV
		$types = implode(',',$data['module_shipping_USPS_domestic_shipping_types']);
		$data['module_shipping_USPS_domestic_shipping_types'] = $types;
		
		$types = implode(',',$data['module_shipping_USPS_international_shipping_types']);
		$data['module_shipping_USPS_international_shipping_types'] = $types;
		
		
		if ($this->db_validation_model->_update_db_settings($data))
		{
			//log success
			log_message('info', 'settings table updated successfully');
		}
		else
		{
			show_error($this->lang->line('could_not_update_settings'));
			
			//log error
			log_message('error', 'Could not update settings table');
			
			return false;		
		}
		
		return true;
	}	
	
	// ------------------------------------------------------------------------	
	
	function _generate_USPS_form_field($v= '', $value = '')
	{
	
		switch ($v['settings_key'])
		{
		
			case 'module_shipping_USPS_container':
			
				$options = array('VARIABLE' => 'Variable', 
								 'FLAT RATE BOX' => 'Flat Rate Box', 
								 'FLAT RATE ENVELOPE' => 'Flat Rate Envelope', 
								 'RECTANGULAR' => 'Rectangular', 
								 'NONRECTANGULAR' => 'Non-Rectangular');
				
				return form_dropdown($v['settings_key'], $options, $value);
				
			break;
			
			case 'module_shipping_USPS_size':
				
				$options = array('REGULAR' => 'Regular', 
								 'LARGE' => 'Large', 
								 'OVERSIZE' => 'Oversize');
				
				return form_dropdown($v['settings_key'], $options, $value);
				
			break;
			
			case 'module_shipping_USPS_machinable':
				
				$options = array('true' => 'true', 'false' => 'false');
				
				return form_dropdown($v['settings_key'], $options, $value);
				
			break;
			
			case 'module_shipping_USPS_domestic_shipping_types':
				
				$types = array(
								'Express Mail Hold For Pickup' => 'Express Mail Hold For Pickup',
								 'Express Mail Flat Rate Envelope Hold For Pickup' => 'Express Mail Flat Rate Envelope Hold For Pickup',
								 'Express Mail' => 'Express Mail',
								 'Express Mail Flat Rate Envelope' => 'Express Mail Flat Rate Envelope',
								 'Priority Mail' => 'Priority Mail',
								 'Priority Mail Flat Rate Envelope' => 'Priority Mail Flat Rate Envelope',
								 'Priority Mail Small Flat Rate Box' => 'Priority Mail Small Flat Rate Box',
								 'Priority Mail Medium Flat Rate Box' => 'Priority Mail Medium Flat Rate Box',
								 'Priority Mail Large Flat Rate Box' => 'Priority Mail Large Flat Rate Box',
								 'First-Class Mail Flat' => 'First-Class Mail Flat',
								 'First-Class Mail Parcel' => 'First-Class Mail Parcel',
								 'Parcel Post' => 'Parcel Post',
								 'Bound Printed Matter' => 'Bound Printed Matter',
								 'Media Mail' => 'Media Mail',
								 'Library Mail' => 'Library Mail',
								
								);
				$selected = explode(',', $v['settings_value']);
				
				$result = form_dropdown($v['settings_key'].'[]', $types, $selected, 'multiple="multiple" id="module_shipping_UPS_shipping_types" class="list-menu2 text-upper"');
			
				return $result;
				
			break;

			case 'module_shipping_USPS_international_shipping_types':
			
				$types = array(
								'Global Express Guaranteed (GXG)' => 'Global Express Guaranteed (GXG)',
								 'Global Express Guaranteed Non-Document Rectangular' => 'Global Express Guaranteed Non-Document Rectangular',
								 'Global Express Guaranteed Non-Document Non-Rectangular' => 'Global Express Guaranteed Non-Document Non-Rectangular',
								 'USPS GXG Envelopes' => 'USPS GXG Envelopes',
								 'Express Mail International' => 'Express Mail International',								 
								 'Express Mail International Flat Rate Envelope' => 'Express Mail International Flat Rate Envelope',
								 'Priority Mail International' => 'Priority Mail International',
								 'Priority Mail International Large Flat Rate Box' => 'Priority Mail International Large Flat Rate Box',
                				 'Priority Mail International Medium Flat Rate Box' => 'Priority Mail International Medium Flat Rate Box',
								 'Priority Mail International Small Flat Rate Box' => 'Priority Mail International Small Flat Rate Box',
								 'Priority Mail International Flat Rate Envelope' => 'Priority Mail International Flat Rate Envelope',
								 'First-Class Mail International Package' => 'First-Class Mail International Package',
								 'First-Class Mail International Large Envelope' => 'First-Class Mail International Large Envelope',
								);
				$selected = explode(',', $v['settings_value']);
				
				$result = form_dropdown($v['settings_key'].'[]', $types, $selected, 'multiple="multiple" id="module_shipping_UPS_shipping_types" class="list-menu2 text-upper"');
				
				return $result;
			
			break;
			
			default:
				
				return _generate_settings_field($v, $value);
				
			break;
		
		}
		
	}
	
	// ------------------------------------------------------------------------	
	
	function _generate_shipping_amount_usps($array = '', $type = '', $num_options = '')
	{
		
		$ship_array = array();
		
		$this->countries = $this->country_list();
		
		//sts_store_shipping_zip
		//sts_shipping_use_vendor_zip
		
		if ($array['country'] == $this->config->item('sts_store_shipping_country'))
		{
			$types = explode(',', $this->config->item('module_shipping_USPS_domestic_shipping_types'));
			$qdata['api'] = 'RateV3';
		}
		else
		{
			$types = explode(',', $this->config->item('module_shipping_USPS_international_shipping_types'));
			$qdata['api'] = 'IntlRate';
		}
		
		if ($array['weight'] > $this->config->item('module_shipping_USPS_max_weight')) return false;
		
		if (count($types) > 0 )
		{	
			$data['amount'] = '';
			$data['error'] = false;
			
			//$qdata['service'] = $code;
			$qdata['country'] = $array['country_data']['country_iso_code_2'];
			
			//set the amounts for each shipping option
			$type_options = array();
			foreach ($types as $a)
			{
				$type_options[$a] = '0';
			}
			
			//check if we are using vendor specific shipping
			if ($this->config->item('sts_shipping_use_vendor_zip') == 1)
			{
				//loop through each product
				foreach ($this->cart_items as $v)
				{
					//calculate weight
					$weight = $v['product_weight'] * $v['quantity'];
					$qdata['lbs'] = floor($weight);
					$qdata['oz'] = ceil(($weight - $qdata['lbs']) * 16);
					
					if (!empty($v['vendor_zip']))
					{
						$qdata['zip_origin'] = $v['vendor_zip'];
						$qdata['weight'] = $v['product_weight'] * $v['quantity'];
					}
					else
					{
						$qdata['zip_origin'] = $this->config->item('sts_store_shipping_zip');
						$qdata['weight'] = $weight  * $v['quantity'];
					}
					
					$qdata['zip_destination'] = $array['postal_code'];
					$qdata['country_destination'] = $array['country_data']['country_iso_code_2'];
		
					$rates = $this->get_rate($qdata);
					
					if (!empty($rates))
					{
						foreach ($rates as $rate)
						{
							foreach ($rate as $c => $amount)
							{
								if (in_array($c, $types))
								{
						
									if ($rate > '0')
									{
										$type_amount = $type_options[$c];
										$new_amount = $type_amount + $amount;
										$type_options[$c] = $new_amount;
									}
								}
							}
						}
					}
				}
				
				//now set each amount
				foreach ($type_options as $k => $v)
				{
					$b = array();
					$b['amount'] = $v + $this->config->item('module_shipping_USPS_handling_fee') + $array['per_prod_shipping'];
					$b['error'] = false; 
					$b['taxes'] = '0';
					$b['type'] = $k;
					
					//check if we are using tax zones
					if ($this->config->item('module_shipping_USPS_enable_tax_zone') == 1)
					{
						$zone = $this->db_validation_model->_get_details('tax_zones', '*', 'tax_zone_id', $this->config->item('module_shipping_USPS_tax_zone'));
						
						if (!empty($zone[0]['tax_amount']))
						{
							$taxes = $b['amount'] * $zone[0]['tax_amount'];
							$b['taxes'] = round($taxes, 2);
						}
					}

					$b['name']  = $type['module_name'] . ' ' . $k . ' - ' . format_amounts($b['amount'], $num_options);
					
					if (count($b) > 0 && !empty($b['amount']))
					{
						array_push($ship_array, $b);
					}
				}
			}
			else
			{
				
				//calculate weight
				$qdata['lbs'] = floor($array['weight']);
				$qdata['oz'] = ceil(($array['weight'] - $qdata['lbs']) * 16);
	
				$qdata['zip_origin'] = $this->config->item('sts_store_shipping_zip');
				$qdata['weight'] = $array['weight'];
				$qdata['zip_destination'] = $array['postal_code'];
				$qdata['country_destination'] = $array['country_data']['country_iso_code_2'];
				
				$rates = $this->get_rate($qdata);
				
				if (is_array($rates))
				{
					foreach ($rates as $rate)
					{
						foreach ($rate as $c => $amount)
						{
							if (in_array($c, $types))
							{
								$b = array();
								if ($rate > '0')
								{
									$b['amount'] = $amount + $this->config->item('module_shipping_USPS_handling_fee') + $array['per_prod_shipping'];
									$b['error'] = false; 
									$b['taxes'] = '0';
									$b['type'] = $c;
									
									//check if we are using tax zones
									if ($this->config->item('module_shipping_USPS_enable_tax_zone') == 1)
									{
										$zone = $this->db_validation_model->_get_details('tax_zones', '*', 'tax_zone_id', $this->config->item('module_shipping_USPS_tax_zone'));
										
										if (!empty($zone[0]['tax_amount']))
										{
											$taxes = $b['amount'] * $zone[0]['tax_amount'];
											$b['taxes'] = round($taxes, 2);
										}
									}
	
									$b['name']  = $type['module_name'] . ' ' . $c . ' - ' . format_amounts($b['amount'], $num_options);
								}
								
								if (count($b) > 0 && !empty($b['amount']))
								{
									array_push($ship_array, $b);
								}
							}
						}
					}
				}
			}
			
			return $ship_array;
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------	
	
	function get_rate($data = array()) 
	{
		
		$userName = $this->config->item('module_shipping_USPS_userid'); 
	
		$url = $this->config->item('module_shipping_USPS_gateway_url');
		
		//format the destination zip code
		//$data['zip_destination'] = _format_zip($data['zip_destination']);
		
		//first class can only be 13 ounces or less
		/*
		if ($data['service'] == 'FIRST CLASS')
		{
			if ($data['lbs'] > '0' || $data['oz'] > '16')
			{
				return false;
			}
		}
		*/
		
		$call = 'API=' . $data['api'];
		
		if ($data['api'] == 'RateV3')
		{
			$call .= '&XML=<RateV3Request USERID="' . $userName . '">';
			$call .= '<Package ID="1ST">';
			$call .= '<Service>ALL</Service>';
			
			if ($data['service'] == 'FIRST CLASS')
			{
				$call .= '<FirstClassMailType>PARCEL</FirstClassMailType>';
			}
			
			$call .= '<ZipOrigination>' . $data['zip_origin'] . '</ZipOrigination>';
			$call .= '<ZipDestination>' . $data['zip_destination'] . '</ZipDestination>';
			//$call .= '<Container>' . $this->config->item('module_shipping_USPS_container') . '</Container>';
			$call .= '<Pounds>' . $data['lbs'] . '</Pounds>';
			$call .= '<Ounces>' . $data['oz'] . '</Ounces>';
			$call .= '<Size>' . $this->config->item('module_shipping_USPS_size') . '</Size>';
			$call .= '<Machinable>' . $this->config->item('module_shipping_USPS_machinable') . '</Machinable>';
			$call .= '</Package>';
			$call .= '</RateV3Request>';
		}
		else
		{
			$call .= '&XML=<IntlRateRequest USERID="' . $userName . '">';
			$call .= '<Package ID="1ST">';
			$call .= '<Pounds>' . $data['lbs'] . '</Pounds>';
			$call .= '<Ounces>' . $data['oz'] . '</Ounces>';
			$call .= '<Machinable>' . $this->config->item('module_shipping_USPS_machinable') . '</Machinable>';
			$call .= '<MailType>Package</MailType>';
			$call .= '<GXG>';
		    $call .= '<Length>12</Length><Width>12</Width><Height>12</Height>';
		   $call .=  '<POBoxFlag>N</POBoxFlag><GiftFlag>N</GiftFlag>';
		    $call .= '</GXG>';
		    $call .= '<ValueOfContents>50</ValueOfContents>';
			$call .= '<Country>' . $this->countries[$data['country']] . '</Country>';
			$call .= '</Package>';
			$call .= '</IntlRateRequest>';
		}
		
		
		$sdata = connect_curl($url, true, $call, 1,  $this->config->item('sts_store_set_curl_timeout'));
		
		//$sdata = strstr($result, '<?');
		$msg = str_replace("\n", " ", $sdata); 
		$msg = str_replace("<", "&lt;", $msg);
		$msg = str_replace(">", "&gt;", $msg);
		
		if(preg_match("/Authorization failure/",$sdata))
		{
			//log error
			log_message('error', __CLASS__ . ':' . __FUNCTION__ . ':' . $msg);
			
			show_error('Authorization Error connecting to United States Postal Service Server:</strong>' . $url .'<p>Please register at <a href="http://www.usps.com/webtools/">http://www.usps.com/webtools/</a> and enter the correct username in your admin area.</p>');
			
		
		} 
		elseif(preg_match("/error/",$sdata))
		{
			log_message('error', __CLASS__ . ':' . __FUNCTION__ . ':' . $msg);
			//show_error(nl2br(htmlspecialchars($sdata)));
			
			return 'error';
		}
		
		$body = $sdata;
		$response = array();
		while (true) 
		{
			if ($start = strpos($body, '<Package ID=')) 
			{
			  $body = substr($body, $start);
			  $end = strpos($body, '</Package>');
			  $response[] = substr($body, 0, $end+10);
			  $body = substr($body, $end+9);
			} 
			else 
			{
			  break;
			}
		}
		
		if ($data['api'] == 'RateV3')
		{
		  $body = $response[0];	
		  $n = sizeof($response);
		  for ($i=0; $i<$n; $i++) 
		  {
		  	$resp = $response[$i];
		  	$pos = 0;
		  	while (1) 
			{
				  $pos = strpos($response[$i], '<Postage', $pos);
				  if ($pos === FALSE) break;
				  $end = strpos($response[$i], '</Postage>', $pos);
				  if ($end === FALSE) break;
				  $resp = substr($response[$i], $pos, $end-$pos);
				  $service = ereg('<MailService>(.*)</MailService>', $resp, $regs);
				  $service = $regs[1];
				  $postage = ereg('<Rate>(.*)</Rate>', $resp, $regs);
				  $postage = $regs[1];
				  $pos = $end;
				  $rates[] = array($service => $postage);
			}
		  }
		}
		else
		{
		  		  
		  $body = $response[0];
		  $services = array();
			while (true) 
			{
			  if ($start = strpos($body, '<Service ID=')) {
				$body = substr($body, $start);
				$end = strpos($body, '</Service>');
				$services[] = substr($body, 0, $end+10);
				$body = substr($body, $end+9);
			  } else {
				break;
			  }
			}
		  
			$size = sizeof($services);
			for ($i=0, $n=$size; $i<$n; $i++) {
			  if (strpos($services[$i], '<Postage>')) {
				$service = ereg('<SvcDescription>(.*)</SvcDescription>', $services[$i], $regs);
				$service = $regs[1];
				$postage = ereg('<Postage>(.*)</Postage>', $services[$i], $regs);
				$postage = $regs[1];
		  
				if (isset($this->service) && ($service != $this->service) ) {
				  continue;
				}
		  
				$rates[] = array($service => $postage);
			  }
			}
		}
		
		return ((sizeof($rates) > 0) ? $rates : false);
	}
	
	// ------------------------------------------------------------------------	
	
	function country_list() 
	{
		$list = array('AF' => 'Afghanistan',
		'AL' => 'Albania',
		'DZ' => 'Algeria',
		'AD' => 'Andorra',
		'AO' => 'Angola',
		'AI' => 'Anguilla',
		'AG' => 'Antigua and Barbuda',
		'AR' => 'Argentina',
		'AM' => 'Armenia',
		'AW' => 'Aruba',
		'AU' => 'Australia',
		'AT' => 'Austria',
		'AZ' => 'Azerbaijan',
		'BS' => 'Bahamas',
		'BH' => 'Bahrain',
		'BD' => 'Bangladesh',
		'BB' => 'Barbados',
		'BY' => 'Belarus',
		'BE' => 'Belgium',
		'BZ' => 'Belize',
		'BJ' => 'Benin',
		'BM' => 'Bermuda',
		'BT' => 'Bhutan',
		'BO' => 'Bolivia',
		'BA' => 'Bosnia-Herzegovina',
		'BW' => 'Botswana',
		'BR' => 'Brazil',
		'VG' => 'British Virgin Islands',
		'BN' => 'Brunei Darussalam',
		'BG' => 'Bulgaria',
		'BF' => 'Burkina Faso',
		'MM' => 'Burma',
		'BI' => 'Burundi',
		'KH' => 'Cambodia',
		'CM' => 'Cameroon',
		'CA' => 'Canada',
		'CV' => 'Cape Verde',
		'KY' => 'Cayman Islands',
		'CF' => 'Central African Republic',
		'TD' => 'Chad',
		'CL' => 'Chile',
		'CN' => 'China',
		'CX' => 'Christmas Island (Australia)',
		'CC' => 'Cocos Island (Australia)',
		'CO' => 'Colombia',
		'KM' => 'Comoros',
		'CG' => 'Congo (Brazzaville),Republic of the',
		'ZR' => 'Congo, Democratic Republic of the',
		'CK' => 'Cook Islands (New Zealand)',
		'CR' => 'Costa Rica',
		'CI' => 'Cote d\'Ivoire (Ivory Coast)',
		'HR' => 'Croatia',
		'CU' => 'Cuba',
		'CY' => 'Cyprus',
		'CZ' => 'Czech Republic',
		'DK' => 'Denmark',
		'DJ' => 'Djibouti',
		'DM' => 'Dominica',
		'DO' => 'Dominican Republic',
		'TP' => 'East Timor (Indonesia)',
		'EC' => 'Ecuador',
		'EG' => 'Egypt',
		'SV' => 'El Salvador',
		'GQ' => 'Equatorial Guinea',
		'ER' => 'Eritrea',
		'EE' => 'Estonia',
		'ET' => 'Ethiopia',
		'FK' => 'Falkland Islands',
		'FO' => 'Faroe Islands',
		'FJ' => 'Fiji',
		'FI' => 'Finland',
		'FR' => 'France',
		'GF' => 'French Guiana',
		'PF' => 'French Polynesia',
		'GA' => 'Gabon',
		'GM' => 'Gambia',
		'GE' => 'Georgia, Republic of',
		'DE' => 'Germany',
		'GH' => 'Ghana',
		'GI' => 'Gibraltar',
		'GB' => 'Great Britain and Northern Ireland',
		'GR' => 'Greece',
		'GL' => 'Greenland',
		'GD' => 'Grenada',
		'GP' => 'Guadeloupe',
		'GT' => 'Guatemala',
		'GN' => 'Guinea',
		'GW' => 'Guinea-Bissau',
		'GY' => 'Guyana',
		'HT' => 'Haiti',
		'HN' => 'Honduras',
		'HK' => 'Hong Kong',
		'HU' => 'Hungary',
		'IS' => 'Iceland',
		'IN' => 'India',
		'ID' => 'Indonesia',
		'IR' => 'Iran',
		'IQ' => 'Iraq',
		'IE' => 'Ireland',
		'IL' => 'Israel',
		'IT' => 'Italy',
		'JM' => 'Jamaica',
		'JP' => 'Japan',
		'JO' => 'Jordan',
		'KZ' => 'Kazakhstan',
		'KE' => 'Kenya',
		'KI' => 'Kiribati',
		'KW' => 'Kuwait',
		'KG' => 'Kyrgyzstan',
		'LA' => 'Laos',
		'LV' => 'Latvia',
		'LB' => 'Lebanon',
		'LS' => 'Lesotho',
		'LR' => 'Liberia',
		'LY' => 'Libya',
		'LI' => 'Liechtenstein',
		'LT' => 'Lithuania',
		'LU' => 'Luxembourg',
		'MO' => 'Macao',
		'MK' => 'Macedonia, Republic of',
		'MG' => 'Madagascar',
		'MW' => 'Malawi',
		'MY' => 'Malaysia',
		'MV' => 'Maldives',
		'ML' => 'Mali',
		'MT' => 'Malta',
		'MQ' => 'Martinique',
		'MR' => 'Mauritania',
		'MU' => 'Mauritius',
		'YT' => 'Mayotte (France)',
		'MX' => 'Mexico',
		'MD' => 'Moldova',
		'MC' => 'Monaco (France)',
		'MN' => 'Mongolia',
		'MS' => 'Montserrat',
		'MA' => 'Morocco',
		'MZ' => 'Mozambique',
		'NA' => 'Namibia',
		'NR' => 'Nauru',
		'NP' => 'Nepal',
		'NL' => 'Netherlands',
		'AN' => 'Netherlands Antilles',
		'NC' => 'New Caledonia',
		'NZ' => 'New Zealand',
		'NI' => 'Nicaragua',
		'NE' => 'Niger',
		'NG' => 'Nigeria',
		'KP' => 'North Korea (Korea, Democratic People\'s Republic of)',
		'NO' => 'Norway',
		'OM' => 'Oman',
		'PK' => 'Pakistan',
		'PA' => 'Panama',
		'PG' => 'Papua New Guinea',
		'PY' => 'Paraguay',
		'PE' => 'Peru',
		'PH' => 'Philippines',
		'PN' => 'Pitcairn Island',
		'PL' => 'Poland',
		'PT' => 'Portugal',
		'QA' => 'Qatar',
		'RE' => 'Reunion',
		'RO' => 'Romania',
		'RU' => 'Russia',
		'RW' => 'Rwanda',
		'SH' => 'Saint Helena',
		'KN' => 'Saint Kitts (St. Christopher and Nevis)',
		'LC' => 'Saint Lucia',
		'PM' => 'Saint Pierre and Miquelon',
		'VC' => 'Saint Vincent and the Grenadines',
		'SM' => 'San Marino',
		'ST' => 'Sao Tome and Principe',
		'SA' => 'Saudi Arabia',
		'SN' => 'Senegal',
		'YU' => 'Serbia-Montenegro',
		'SC' => 'Seychelles',
		'SL' => 'Sierra Leone',
		'SG' => 'Singapore',
		'SK' => 'Slovak Republic',
		'SI' => 'Slovenia',
		'SB' => 'Solomon Islands',
		'SO' => 'Somalia',
		'ZA' => 'South Africa',
		'GS' => 'South Georgia (Falkland Islands)',
		'KR' => 'South Korea (Korea, Republic of)',
		'ES' => 'Spain',
		'LK' => 'Sri Lanka',
		'SD' => 'Sudan',
		'SR' => 'Suriname',
		'SZ' => 'Swaziland',
		'SE' => 'Sweden',
		'CH' => 'Switzerland',
		'SY' => 'Syrian Arab Republic',
		'TW' => 'Taiwan',
		'TJ' => 'Tajikistan',
		'TZ' => 'Tanzania',
		'TH' => 'Thailand',
		'TG' => 'Togo',
		'TK' => 'Tokelau (Union) Group (Western Samoa)',
		'TO' => 'Tonga',
		'TT' => 'Trinidad and Tobago',
		'TN' => 'Tunisia',
		'TR' => 'Turkey',
		'TM' => 'Turkmenistan',
		'TC' => 'Turks and Caicos Islands',
		'TV' => 'Tuvalu',
		'UG' => 'Uganda',
		'UA' => 'Ukraine',
		'AE' => 'United Arab Emirates',
		'UY' => 'Uruguay',
		'UZ' => 'Uzbekistan',
		'VU' => 'Vanuatu',
		'VA' => 'Vatican City',
		'VE' => 'Venezuela',
		'VN' => 'Vietnam',
		'WF' => 'Wallis and Futuna Islands',
		'WS' => 'Western Samoa',
		'YE' => 'Yemen',
		'ZM' => 'Zambia',
		'ZW' => 'Zimbabwe');
	
		return $list;
	}
}
?>