<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2010 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - shipping_zone_based_model.php
| -------------------------------------------------------------------------     
| 
| This model handles the functions for zone based shipping
|
*/

class Module_Shipping_Zone_Based_Model extends Model {	
	
	function _install_jrox_module($id = '')
	{		
		//check admin session
		$this->security_model->_check_admin_session();
			
		$sql = '
			INSERT INTO jroxdemo_jem.jem_settings (
				settings_key ,
				settings_value ,
				settings_module ,
				settings_type ,
				settings_group ,
				settings_sort_order ,
				settings_function
			)
			VALUES 
				(\'module_shipping_zone_based_calculation_type\', \'weight\', \'shipping\', \'dropdown\', \'' . $id . '\', \'1\', \'zone_calc\'),
				(\'module_shipping_zone_based_enable_tax_zone\', \'0\', \'shipping\', \'dropdown\', \'' . $id . '\', \'2\', \'enable\'), 
				(\'module_shipping_zone_based_tax_zone\', \'1\', \'shipping\', \'dropdown\', \'' . $id . '\', \'3\', \'tax_zone\'),
				(\'module_shipping_zone_based_zone_1_countries\', \'\', \'shipping\', \'textarea\', \'' . $id . '\', \'6\', \'none\'), 
				(\'module_shipping_zone_based_zone_1_table\', \'\', \'shipping\', \'textarea\', \'' . $id . '\', \'7\', \'none\'), 
				(\'module_shipping_zone_based_zone_1_handling_fee\', \'\', \'shipping\', \'text\', \'' . $id . '\', \'8\', \'none\'),
				(\'module_shipping_zone_based_zone_2_countries\', \'\', \'shipping\', \'textarea\', \'' . $id . '\', \'9\', \'none\'), 
				(\'module_shipping_zone_based_zone_2_table\', \'\', \'shipping\', \'textarea\', \'' . $id . '\', \'10\', \'none\'), 
				(\'module_shipping_zone_based_zone_2_handling_fee\', \'\', \'shipping\', \'text\', \'' . $id . '\', \'11\', \'none\'),
				(\'module_shipping_zone_based_zone_3_countries\', \'\', \'shipping\', \'textarea\', \'' . $id . '\', \'12\', \'none\'), 
				(\'module_shipping_zone_based_zone_3_table\', \'\', \'shipping\', \'textarea\', \'' . $id . '\', \'13\', \'none\'), 
				(\'module_shipping_zone_based_zone_3_handling_fee\', \'\', \'shipping\', \'text\', \'' . $id . '\', \'14\', \'none\'),
				(\'module_shipping_zone_based_zone_4_table\', \'\', \'shipping\', \'textarea\', \'' . $id . '\', \'15\', \'none\'), 
				(\'module_shipping_zone_based_zone_4_handling_fee\', \'\', \'shipping\', \'text\', \'' . $id . '\', \'16\', \'none\');
';
			
		
		
			
		//insert into settings table
		if ($this->db->query($sql))
		{
			return true;
		}
		
		return false;
	}
	
	// ------------------------------------------------------------------------	
	
	function _generate_shipping_amount_zone_based($array = '', $type = '', $num_options = '')
	{
	
		//first find out which zone the country is in
		$zones['1'] = explode(",",$this->config->item('module_shipping_zone_based_zone_1_countries'));
		$zones['2'] = explode(",",$this->config->item('module_shipping_zone_based_zone_2_countries'));
		$zones['3'] = explode(",",$this->config->item('module_shipping_zone_based_zone_3_countries'));
		
		$zone = '';
		
		// find the country
		foreach ($zones as $k => $v)
		{
			foreach($zones[$k] as $num => $value)
			{
				
				if(trim($value) == trim(strtoupper($array['country_data']['country_iso_code_2'])))
				{
					$zone = $k;
				}
			}
		}
		
		if (empty($zone))
		{
			$zone = '4';
		}
		
		//set the calculation type (weight, price, item)
		switch ($this->config->item('module_shipping_zone_based_calculation_type'))
		{
			case 'weight':
				
				$qty = $array['weight'];

			break;
			
			case 'item':
			
				$qty = $array['quantity'];
			
			break;
			
			case 'price':
			
				$qty = $array['amount'];
				
			break;
		}
		
		//now get the zone table
		$data['amount'] = '';
		
		$rates = explode(",",$this->config->item('module_shipping_zone_based_zone_' . $zone . '_table'));
	
		if(count($rates) > 0)
		{
			foreach ($rates as $row)
			{
				$ship_rate = explode(':', $row);
				
				if ($qty <= $ship_rate[0])
				{
					$data['amount'] = $ship_rate[1] +  $this->config->item('module_shipping_zone_based_zone_' . $zone . '_handling_fee') + $array['per_prod_shipping'];
					break;
				}
			}
		}

		$data['taxes'] = '';
		
		//check if we are using tax zones
		if ($this->config->item('module_shipping_zone_based_enable_tax_zone') == 1)
		{
			$zone = $this->db_validation_model->_get_details('tax_zones', '*', 'tax_zone_id', $this->config->item('module_shipping_zone_based_tax_zone'));
			
			$data['taxes'] = $data['amount'] * $zone[0]['tax_amount'];
		}
		
		$data['est_amount'] =  $data['amount'] . '_' . $data['taxes'];
		$data['name'] = _check_language_translation($type['module_name']) . ' - ' . format_amounts($data['amount'], $num_options);
		$data['type'] = $type['module_name'];
		
		$ship_array[0] = $data;
		return $ship_array;
	}
	
	// ------------------------------------------------------------------------	
	
}
?>