<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| COPYRIGHT NOTICE                                                     
| Copyright 2008 JROX Technologies, Inc.  All Rights Reserved.    
| -------------------------------------------------------------------------                                                                        
| This script may be only used and modified in accordance to the license      
| agreement attached (license.txt) except where expressly noted within      
| commented areas of the code body. This copyright notice and the  
| comments above and below must remain intact at all times.  By using this 
| code you agree to indemnify JROX Technologies, Inc, its corporate agents   
| and affiliates from any liability that might arise from its use.                                                        
|                                                                           
| Selling the code for this program without prior written consent is       
| expressly forbidden and in violation of Domestic and International 
| copyright laws.  
|	
| -------------------------------------------------------------------------
| FILENAME - flv_image_rotator_pi.php
| -------------------------------------------------------------------------     
| 
| This plugin loads the JavaScript HTML editor
|
*/


function encodeHTML($sHTML)
{
	$sHTML=str_replace("&","&amp;",$sHTML);
	$sHTML=str_replace("<","&lt;",$sHTML);
	$sHTML=str_replace(">","&gt;",$sHTML);
	
	return $sHTML;
}

function HTML_Editor($module = '', $type = '1', $toolbar = 'basic', $content = '', $height = '300', $textarea = 'txtContent')
{
	
	$CI =& get_instance();
	
	if ($type == '1')
	{
		require_once($CI->config->item('base_physical_path').'/js/fckeditor/fckeditor.php');

		$sBasePath = base_url() . '/js/fckeditor/';
		$oFCKeditor = new FCKeditor($textarea);
		$oFCKeditor->BasePath = $sBasePath;
		$oFCKeditor->Config['CustomConfigurationsPath'] = $sBasePath.'myconfig.js';
		$oFCKeditor->Height = $height;
		$oFCKeditor->ToolbarSet = $toolbar;
		$oFCKeditor->Value = encodeHTML($content);

		$data = $oFCKeditor->CreateHtml() ;
				
	}
	else
	{
		$data = '<div align="center"><textarea id="' . $textarea . '" name="' . $textarea . '" rows=20 cols=80>' . encodeHTML($content) . '</textarea></div>';
	}
	
	//setup dynamic tags
	$data .= '<div style="float:left; margin-top: 1em;">';
	$data .= '<select id="allowed_tags" class="select" name="allowed_tags" style="font-size: 10px; color: #666;">';
	$data .= '<option>' . $CI->lang->line('allowed_tags') . '</option>';		
	$data .= '<option value="{store_name}">' . $CI->lang->line('store_name') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {store_name}&nbsp;&nbsp;&nbsp; </option>';
	$data .= '<option value="{login_url}">' . $CI->lang->line('login_url') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {login_url}&nbsp;&nbsp;&nbsp; </option>';
	
	switch ($module)
	{
		case 'send_member_email':			
		
			$data .= '<option value="{username}">' . $CI->lang->line('username') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {username}&nbsp;&nbsp;&nbsp; </option>';
			$data .= '<option value="{fname}">' . $CI->lang->line('first_name') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {fname}&nbsp;&nbsp;&nbsp; </option>';
			$data .= '<option value="{lname}">' . $CI->lang->line('last_name') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {lname}&nbsp;&nbsp;&nbsp; </option>';
			
		break;
		
		case 'product_overview':
		case 'product_description_1':
		case 'product_description_2':
		
			$data .= '<option value="{product_name}">' . $CI->lang->line('product_name') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {product_name}&nbsp;&nbsp;&nbsp; </option>';
			$data .= '<option value="{product_price}">' . $CI->lang->line('product_price') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {product_price}&nbsp;&nbsp;&nbsp; </option>';
			$data .= '<option value="{product_type}">' . $CI->lang->line('product_type') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {product_type}&nbsp;&nbsp;&nbsp; </option>';
			$data .= '<option value="{product_sku}">' . $CI->lang->line('product_sku') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {product_sku}&nbsp;&nbsp;&nbsp; </option>';
			$data .= '<option value="{product_weight}">' . $CI->lang->line('product_weight') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {product_weight}&nbsp;&nbsp;&nbsp; </option>';
			$data .= '<option value="{product_inventory}">' . $CI->lang->line('product_inventory') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {product_inventory}&nbsp;&nbsp;&nbsp; </option>';
			$data .= '<option value="{min_quantity_ordered}">' . $CI->lang->line('min_quantity_ordered') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {min_quantity_ordered}&nbsp;&nbsp;&nbsp; </option>';
			$data .= '<option value="{max_quantity_ordered}">' . $CI->lang->line('max_quantity_ordered') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {max_quantity_ordered}&nbsp;&nbsp;&nbsp; </option>';
			
			for ($i = 1; $i<=$CI->config->item('sts_affiliate_commission_levels'); $i ++)
			{
			$data .= '<option value="{custom_commission_value_'.$i.'}">' . $CI->lang->line('custom_commission_value_'.$i.'') . ' &nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp; {custom_commission_value_'.$i.'}&nbsp;&nbsp;&nbsp; </option>';
			}
						
		break;
	}
	
	$data .= '</select>';
			
	$data .= '</div>';
	
	return $data;

}

?>